        program cylindre

c	versnio de main avec splitting x,y,z du transport/remesh de rho
c	le poussuer/remaille de om et rho sont dissocies
c	comma main_full, mais avec cfl 0.5 pour advection de rho
c	(et  possibilite de sous-ite pour advection de rho avec dt3 < dt)

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension xp1(npm),yp1(npm),zp1(npm),dv1(npm)
        dimension xp2(npm),yp2(npm),zp2(npm)
        dimension omx(npm),omy(npm),omz(npm)
        dimension vx1(npm),vy1(npm),vz1(npm)
        dimension vx2(npm),vy2(npm),vz2(npm)
        dimension strx(npm),stry(npm),strz(npm)
	dimension phip(npm)
c       tableuax supplementaries pour RK
      dimension xp10(npm),yp10(npm),zp10(npm)
      dimension xp20(npm),yp20(npm),zp20(npm)
      dimension om1(npm),om2(npm),om3(npm)
      dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
      dimension vxv1(4,npm),vyv1(4,npm),vzv1(4,npm)
      dimension vxv2(4,npm),vyv2(4,npm),vzv2(4,npm)

      dimension para(4)
      dimension enstrophy(0:10000),energy(0:10000),divergence(0:10000)  

      data (para(i),i=1,4)/0.5,0.5,1.,0./

        character*30 filerho,fileomx,fileomy,fileomz


        pi=3.1415926
        pi2=2.*pi

        OPEN(1,file='C_IN.DAT',status='OLD')
        READ(1,*)
        read(1,*) nx1
        READ(1,*)
        read(1,*) nx2
        READ(1,*)
        read(1,*)nit
        READ(1,*)
        read(1,*)anu
        READ(1,*)
        read(1,*)anu_rho
        READ(1,*)
        read(1,*)coef_les
        READ(1,*)
        read(1,*)korder
        READ(1,*)
        read(1,*)tstop
        close(1)
        idif=1
		iper=0

	drho=10.
	drho=0.

        xmin=0.
        ymin=0.
        zmin=0.
        xmax=pi2
	xmax=1.
        ymax=xmax
        dx1=xmax/float(nx1)
        dx2=xmax/float(nx2)
        zmax=xmax

	nx=nx2
	dx=dx2

        t1=0.5
	dtcompt=0.05
        t2=0.15
	t3=0.2
	t4=0.25
	t5=0.3
        
c	resolution pour rho
c	et initalisation des comptuer utlise pour 
c	avoir des pas de temps distincts en rho et omega

	nx3=32
c	cas ou on utilise veloxax_v2 (filtre en spectral
c	puis on padde avec des 0 puis on fftinverse sur une
c	grille 128 ou 256:
	nx3=nx1

	dx3=xmax/float(nx3)
	ic=0
	k_delt3=1
 
        dy1=dx1
        dz1=dx1
        ny1=nint(float(nx1)*ymax/xmax)
        nz1=nint(float(nx1)*zmax/xmax)
        ymax=float(ny1)*dy1
        zmax=float(nz1)*dz1
        dy2=dx2
        dz2=dx2
        ny2=nint(float(nx2)*ymax/xmax)
        nz2=nint(float(nx2)*zmax/xmax)

	print*, nx1,ny1,nz1,xmax,ymax,zmax


c	dt max pour diffusion
	dtmax=0.5*dx1*dx1/anu
	delt0=1.5*dx1
	delt0=0.0001
	delt=delt0
	delt3=delt
c	delt=0.0

c	call readfield(npart1,xp1,yp1,zp1,
c     1                 omx,omy,omz,dv1)
	call bubble(npart1,xp1,yp1,zp1,
     1                 omx,omy,omz,dv1)

	print*,'npart1 ',npart1

        OPEN(33,file='DIAG1',status='unknown')
        OPEN(34,file='DIAG2',status='unknown')

c       debut des iterations

	time=0.
	tcompt=0.
	omax=0.
	istep=0

        do 20 kk=1,nit
	
	time=time+delt

	call velox(vmax1)
	call veloxaux(vmax,dvmax)

c	seuil de omax et dvmax pour eviter les trop gros dt:
	omax=amax1(omax,10.)
	dvmax=amax1(dvmax,10.)

c	determination pas de temps:
	if ((ic.eq.0)) then
        delt=.1/abs(omax)
	if (vmax1.gt.0.) delt=amax1(delt,0.5*dx1/vmax1)
	delt=amin1(delt,dtmax)
c	delt=0.5*dx2/vmax
c        delt3=2.*dx3/vmax
c        delt3=0.5*dx2/vmax
       delt3=1.*delt
        if (dvmax.ne.0.) delt3=amax1(delt3,0.25/dvmax)
c        if ((dvmax.ne.0.).and.(korder.eq.2)) 
c     1              delt3=amax1(delt3,0.5/dvmax)
c       delt3=delt
        print*, ' TIME, Pas de temps omega et rho ', time,delt,delt3
        print*, ' LCFL ',dvmax*delt3
        k_delt3=int(delt3/delt)
	if (k_delt3.eq.0) then
	k_delt=int(delt/delt3)
	k_delt3=1
	k_delt=k_delt+1
	delt3=delt/float(k_delt)
	else
        delt3=float(k_delt3)*delt
	k_delt=1
	endif
        print*,' CFLs ',delt3*vmax/dx3,delt3*vmax/dx2
	endif

        deltconv=delt

        delt1=deltconv/6.  

c	ADVECTION particules de vorticite

c     on fait les sous-iterations R.K.

        do i=1,npart1
          xp10(i)=xp1(i)
          yp10(i)=yp1(i)
          zp10(i)=zp1(i)
          om1(i)=omx(i)
          om2(i)=omy(i)
          om3(i)=omz(i)
        enddo

      do  550 ll=1,4     

        if (ll.eq.1) then

        print*,'TIME ',time

        call stretch_freeb(drho)
	tau=0.001
	tau=0.01
	tau=0.1
	jc=2
	call stension(tau,jc)

	endif

	nx4=nx1
	
       call intervm4(npart1,vx1,vy1,vz1,xp1,yp1,zp1)
       call intersm4(npart1,strx,stry,strz,xp1,yp1,zp1)


c       increment des positions et poids correspondant aux sous-ite
c       RK
c **********************

        vxmax=-10000.
        vxmin=10000.
        vymax=-10000.
        vymin=10000.
        vzmax=-10000.
        vzmin=10000.
        do 520 i=1,npart1
         vxv1(ll,i)=vx1(i)
         vyv1(ll,i)=vy1(i)
         vzv1(ll,i)=vz1(i)
         strxv(ll,i)=dv1(i)*strx(i)
         stryv(ll,i)=dv1(i)*stry(i)
         strzv(ll,i)=dv1(i)*strz(i)
         xp1(i)=xp10(i)+para(ll)*deltconv*vx1(i)
         if (xp1(i).lt.xmin) xp1(i)=xp1(i)+xmax-xmin
         if (xp1(i).gt.xmax) xp1(i)=xp1(i)-xmax+xmin
         yp1(i)=yp10(i)+para(ll)*deltconv*vy1(i)
         if (yp1(i).lt.ymin) yp1(i)=yp1(i)+ymax-ymin
         if (yp1(i).gt.ymax) yp1(i)=yp1(i)-ymax+ymin
         zp1(i)=zp10(i)+para(ll)*deltconv*vz1(i)
         if (zp1(i).lt.zmin) zp1(i)=zp1(i)+zmax-zmin
         if (zp1(i).gt.zmax) zp1(i)=zp1(i)-zmax+zmin
         omx(i)=om1(i)+para(ll)*deltconv*dv1(i)*strx(i)
         omy(i)=om2(i)+para(ll)*deltconv*dv1(i)*stry(i)
         omz(i)=om3(i)+para(ll)*deltconv*dv1(i)*strz(i)
        vxmax=amax1(vxmax,(vx1(i)))
        vxmin=amin1(vxmin,(vx1(i)))
        vymax=amax1(vymax,(vy1(i)))
        vymin=amin1(vymin,(vy1(i)))
        vzmax=amax1(vzmax,(vz1(i)))
        vzmin=amin1(vzmin,(vz1(i)))
520   continue

550   continue

c       FIN des sous-ite RK pour transport de vorticite
c **********************

	xpmin=10.
	ypmin=10.
	xpmax=0.
	ypmax=0.
	yleft=1000.
	yright=-1000.

       do i=1,npart1
          xp1(i)=xp10(i)+delt1*
     1           (vxv1(1,i)+2.*vxv1(2,i)+2.*vxv1(3,i)+vxv1(4,i))
          yp1(i)=yp10(i)+delt1*
     1           (vyv1(1,i)+2.*vyv1(2,i)+2.*vyv1(3,i)+vyv1(4,i))
          zp1(i)=zp10(i)+delt1*
     1           (vzv1(1,i)+2.*vzv1(2,i)+2.*vzv1(3,i)+vzv1(4,i))
         if (xp1(i).lt.xmin) xp1(i)=xp1(i)+xmax-xmin
         if (xp1(i).gt.xmax) xp1(i)=xp1(i)-xmax+xmin
         if (yp1(i).lt.ymin) yp1(i)=yp1(i)+ymax-ymin
         if (yp1(i).gt.ymax) yp1(i)=yp1(i)-ymax+ymin
         if (zp1(i).lt.zmin) zp1(i)=zp1(i)+zmax-zmin
         if (zp1(i).gt.zmax) zp1(i)=zp1(i)-zmax+zmin
       omx(i)=om1(i)+delt1*(strxv(1,i)+2.*strxv(2,i)+
     1            2.*strxv(3,i)+strxv(4,i))
       omy(i)=om2(i)+delt1*(stryv(1,i)+2.*stryv(2,i)+
     1            2.*stryv(3,i)+stryv(4,i))
       omz(i)=om3(i)+delt1*(strzv(1,i)+2.*strzv(2,i)+
     1            2.*strzv(3,i)+strzv(4,i))
	enddo

700    continue

c	fin d'adection de particules de vorticite


c

c     Remesh des particules de vorticite
C	puis diffusion de vorticite
c ********************** 

	circlim=+0.0001
c	circlim=0.
	
	call  remesh_om(npart1,omx,omy,omz,
     1              xp1,yp1,zp1,dv1)
	print*,' npart OM apres remeshing ', kk,npart1
        call dif_om(npart1,omx,omy,omz,
     1              xp1,yp1,zp1,dv1,anu,delt,coef_les,omax)
4444	continue
 
c	icrementation du comptuer pour decider ou non d
c	d'advecter/remailler en rho (pas de temps disticnts)
	ic=ic+1
	do 111 ksubite=1,k_delt
	print*,ic,k_delt3
	if ((ic.eq.k_delt3)) then
	
	np_bl=3
	dx=dx2
	nx=nx2
        dt=delt3
        dt2=delt3/2.
        dt3=delt3/2.

        if (korder.eq.2) then
        call y_advect(dt2,np_bl,ntagy)
        call x_advect(dt3,np_bl,npart_rho,ntagx)
        call z_advect(dt2,np_bl,ntagz)
        call z_advect(dt2,np_bl,ntagz)
        call x_advect(dt3,np_bl,npart_rho,ntagx)
        call y_advect(dt2,np_bl,ntagy)
        else
        call x_advect(dt,np_bl,npart_rho,ntagx)
        call y_advect(dt,np_bl,ntagy)
        call z_advect(dt,np_bl,ntagz)
	endif


	ntag=max(ntagx,ntagy)
	ntag=max(ntag,ntagz)
	
	call dif_rho(anu_rho,dt)

c	Fin de push / remesh rho /dif rho
	ic=0

c	quelques diagnostiques
	call diag(ener,enstro,div,omax,rhomax,width,VOL1,VOL2)
	write(33,*) time,npart_rho,ntag,vmax*CFL,enstro
	write(34,*) time,width,VOL1,VOL2

        endif
111	continue

        tcompt=tcompt+delt
	if ((time.ge.t1).and.(tcompt.ge.dtcompt)) then
	tcompt=0.
c       if (((time.gt.t1).and.(time.le.t1+1.5*delt3)).
c     1  or.((time.gt.t2).and.(time.le.t2+1.5*delt3)).
c     1  or.((time.gt.t4).and.(time.le.t4+1.5*delt3)).
c     1  or.((time.gt.t5).and.(time.le.t5+1.5*delt3)).
c     1  or.((time.gt.t3).and.(time.le.t3+1.5*delt3))) then
        istep=istep+1
        print*, ' ****** IMPRESSION des RESULTATS: ', istep, '*'
        write(filerho,140)istep
140     format('rho',i1)
        write(fileomx,141)istep
141     format('omx',i1)
        write(fileomy,142)istep
142     format('omy',i1)
        write(fileomz,143)istep
143     format('omz',i1)

	goto 222
      open(20,file=filerho,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(2,file=fileomx,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(3,file=fileomy,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')
      open(4,file=fileomz,form='unformatted',
     1       convert='big_endian',
     1       status='unknown')


        write(20)  (((ug(i,j,k),
     1                i=1,nx2),j=1,ny2),k=1,nz2)
        write(2)  ((((omg1(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        write(3)  ((((omg2(i,j,k)),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        write(4)  (((omg3(i,j,k),
     1                i=1,nx1),j=1,ny1),k=1,nz1)
        close(20)
        close(2)
        close(3)
        close(4)  
	goto 223
222	continue

                      open(24,file=filerho)
	umax=0.
            WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx2," ",nx2," ",nx2
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx2," ",dx2," ",dx2
        WRITE(24,*) "POINT_DATA ",nx2*nx2*nx2
        WRITE(24,'(A)') "SCALARS omg float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nx2
        do j=1,nx2
        do i=1,nx2
                umax=amax1(umax,abs(ug(i,j,k)))
                write(24,*) amax1(0.00001,ug(i,j,k))
        enddo
        enddo
        enddo
	close(24)
                print*,'**** RHO MAX = ',umax

223	continue

        endif

	if (time.gt.tstop) goto 202

20	continue

202	continue


201	continue
	stop
	end

