C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE  interho(npart,g1,g2,g3,xp,yp,zp)

C
C   Interpolation routine with M'4 
C
! geometry=unit box, periodic in x and y
! last ponits in z direction assume extension by continuity
! that is gg(i,j,0)=gg(i,j,1) gg(i,j,m+1)=gg(i,j,m)


c----------------------------------------------------------------

	include 'param.i'
	include 'param.h'

	dimension g1(*),g2(*),g3(*),xp(*),yp(*),zp(*)

        COMMON/GRID/     omg1(npgx,npgy,npgz),
     &  omg2(npgx,npgy,npgz),omg3(npgx,npgy,npgz),
     &  vxg(npgx,npgy,npgz),vyg(npgx,npgy,npgz),vzg(npgx,npgy,npgz),
     &  gg1(npgx,npgy,npgz),gg2(npgx,npgy,npgz),gg3(npgx,npgy,npgz),
     &  strg1(npgx,npgy,npgz),strg2(npgx,npgy,npgz),
     &  strg3(npgx,npgy,npgz),rhog(npg,npg,npg)


	do 10 i=1,npart
	g1(i)=0.
	g2(i)=0.
	g3(i)=0.
10	continue

	ny3=nx3
	nz3=nx3
	dx3=xmax/float(nx3)
        dy3=dx3
        dz3=dx3

        dxinv=1./dx3
        dyinv=1./dy3
        dzinv=1./dz3
        dh3=dx3*dy3*dz3
        dhinv3=1./dh3  


c-------------------------------------------------------------------- 
c- PART II : Determination of  the  circulation  of each particle
c-------------------------------------------------------------------- 

	x0=xmin
	y0=ymin
	z0=zmin


	 DO 20 i = 1,npart

            x = XP(i)
            y = YP(i)
            z = ZP(i)

            ip1 = int((x-x0)*dxinv) 
            jp1 = int((y-y0)*dyinv) 
            kp1 = int((z-z0)*dzinv) 

            ip2 = ip1 + 1
	    jp2 = jp1 + 1
	    kp2 = kp1 + 1



C get the circulations from the nine neighboring cells

	   xx1 = (x - float(ip1)*dx3-x0)*dxinv
	   yy1 = (y - float(jp1)*dy3-y0)*dyinv
	   zz1 = (z - float(kp1)*dz3-z0)*dzinv

	   xx2=1-xx1
	   yy2=1-yy1
	   zz2=1-zz1

C
C 	on repositionne les points de grille par periodicite
! entre 0 et m-1, puis on numerote de 1 a m
C
	ip1=mod(ip1+nx3,nx3) +1
	ip2=mod(ip2+nx3,nx3) +1


	jp1=mod(jp1+ny3,ny3) +1
	jp2=mod(jp2+ny3,ny3) +1

	kp1=mod(kp1+nz3,nz3) +1
	kp2=mod(kp2+nz3,nz3) +1

C
C The M'4 scheme
C

           a1 = xx2
           b1 = yy2
           c1 = zz2

           a2 = xx1
           b2 = yy1
           c2 = zz1

	   g1(i)= g1(i) +  gg1(ip1,jp1,kp1)*a1*b1*c1 
	   g1(i)= g1(i) +  gg1(ip1,jp2,kp1)*a1*b2*c1 

	   g2(i)= g2(i) + gg2(ip1,jp1,kp1)*a1*b1*c1 
	   g2(i)= g2(i) + gg2(ip1,jp2,kp1)*a1*b2*c1 

	   g3(i)= g3(i) + gg3(ip1,jp1,kp1)*a1*b1*c1 
	   g3(i)= g3(i) + gg3(ip1,jp2,kp1)*a1*b2*c1 
c
	   g1(i)= g1(i) +  gg1(ip2,jp1,kp1)*a2*b1*c1 
	   g1(i)= g1(i) +  gg1(ip2,jp2,kp1)*a2*b2*c1 

	   g2(i)= g2(i) + gg2(ip2,jp1,kp1)*a2*b1*c1 
	   g2(i)= g2(i) + gg2(ip2,jp2,kp1)*a2*b2*c1 

	   g3(i)= g3(i) + gg3(ip2,jp1,kp1)*a2*b1*c1 
	   g3(i)= g3(i) + gg3(ip2,jp2,kp1)*a2*b2*c1 
c
	   g1(i)= g1(i) +  gg1(ip1,jp1,kp2)*a1*b1*c2
	   g1(i)= g1(i) +  gg1(ip1,jp2,kp2)*a1*b2*c2 

	   g2(i)= g2(i) + gg2(ip1,jp1,kp2)*a1*b1*c2 
	   g2(i)= g2(i) + gg2(ip1,jp2,kp2)*a1*b2*c2 

	   g3(i)= g3(i) + gg3(ip1,jp1,kp2)*a1*b1*c2 
	   g3(i)= g3(i) + gg3(ip1,jp2,kp2)*a1*b2*c2 
c
	   g1(i)= g1(i) +  gg1(ip2,jp1,kp2)*a2*b1*c2 
	   g1(i)= g1(i) +  gg1(ip2,jp2,kp2)*a2*b2*c2 

	   g2(i)= g2(i) + gg2(ip2,jp1,kp2)*a2*b1*c2 
	   g2(i)= g2(i) + gg2(ip2,jp2,kp2)*a2*b2*c2 

	   g3(i)= g3(i) + gg3(ip2,jp1,kp2)*a2*b1*c2 
	   g3(i)= g3(i) + gg3(ip2,jp2,kp2)*a2*b2*c2 
c

20      CONTINUE



	RETURN
	END
