C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE  remesh_rho(npart,phip,
     1              xp2,yp2,zp2)



C
C   This subroutine asssigns vorticity on a grid
C

c----------------------------------------------------------------

	include 'param.i'
	include 'param.h'
	include 'arrays.h'



	dimension xp2(*),yp2(*),zp2(*)
	dimension phip(*)


        do 10 i=1,nx2
        do 10 j=1,ny2
        do 10 k=1,nz2
        ug(i,j,k)=0.
10      continue

	dy2=dx2
	dz2=dx2

        dxinv=1./(dx2)
        dyinv=dxinv
        dzinv=dxinv



c-------------------------------------------------------------------- 
c- PART II : Determination of  the  circulation  of each particle
c-------------------------------------------------------------------- 

	x0=0.
	y0=0.
	z0=0.
	
	vol=1.

	 DO 20 n = 1,npart

            g1 = phip(n)/vol

            x = xp2(n)
            y = yp2(n)
            z = zp2(n)

            ip1 = int((x-x0)*dxinv) 
            jp1 = int((y-y0)*dyinv) 
            kp1 = int((z-z0)*dzinv)

            ip0 = ip1 - 1
            jp0 = jp1 - 1
            kp0 = kp1 - 1

            ip2 = ip1 + 1
	    jp2 = jp1 + 1
	    kp2 = kp1 + 1

            ip3 = ip1 + 2
	    jp3 = jp1 + 2
	    kp3 = kp1 + 2

C Assign the circulations to the nine neighboring cells

	   xx1 = (x - float(ip1)*dx2-x0)*dxinv
	   yy1 = (y - float(jp1)*dy2-y0)*dyinv
	   zz1 = (z - float(kp1)*dz2-z0)*dzinv

	   xx0=xx1+1.
	   yy0=yy1+1.
	   zz0=zz1+1.

	   xx2=1.-xx1
	   yy2=1.-yy1
	   zz2=1.-zz1

	   xx3=2.-xx1
	   yy3=2.-yy1
	   zz3=2.-zz1


C
C 	on repositionne les points de grille par periodicite
! entre 0 et npx-1, puis on numerote de 1 a npx
C

	ip1=mod(ip1+nx2,nx2) +1 
	ip0=mod(ip0+nx2,nx2) +1
	ip2=mod(ip2+nx2,nx2) +1
	ip3=mod(ip3+nx2,nx2) +1

	jp1=mod(jp1+ny2,ny2) +1 
	jp0=mod(jp0+ny2,ny2) +1
	jp2=mod(jp2+ny2,ny2) +1
	jp3=mod(jp3+ny2,ny2) +1

	kp1=mod(kp1+nz2,nz2) +1 
	kp0=mod(kp0+nz2,nz2) +1
	kp2=mod(kp2+nz2,nz2) +1
	kp3=mod(kp3+nz2,nz2) +1

C The M'4 scheme
C
           a0 = .5*((2.-xx0)**2)*(1.-xx0)
           b0 = .5*((2.-yy0)**2)*(1.-yy0)
           c0 = .5*((2.-zz0)**2)*(1.-zz0)

           a1 = 1.-2.5*xx1*xx1 +  1.5*xx1*xx1*xx1
           b1 = 1.-2.5*yy1*yy1 +  1.5*yy1*yy1*yy1
           c1 = 1.-2.5*zz1*zz1 +  1.5*zz1*zz1*zz1

           a2 = 1.-2.5*xx2*xx2 +  1.5*xx2*xx2*xx2
           b2 = 1.-2.5*yy2*yy2 +  1.5*yy2*yy2*yy2
           c2 = 1.-2.5*zz2*zz2 +  1.5*zz2*zz2*zz2

           a3 = .5*((2.-xx3)**2)*(1.-xx3)
           b3 = .5*((2.-yy3)**2)*(1.-yy3)
           c3 = .5*((2.-zz3)**2)*(1.-zz3)

	   coef=a0*b0*c0
	   ug(ip0,jp0,kp0) = ug(ip0,jp0,kp0) + g1*coef

	   coef=a0*b0*c1
	   ug(ip0,jp0,kp1) = ug(ip0,jp0,kp1) + g1*coef

	   coef=a0*b0*c2
	   ug(ip0,jp0,kp2) = ug(ip0,jp0,kp2) + g1*coef

	   coef=a0*b0*c3
	   ug(ip0,jp0,kp3) = ug(ip0,jp0,kp3) + g1*coef

ccc

           coef=a0*b1*c0
           ug(ip0,jp1,kp0) = ug(ip0,jp1,kp0) + g1*coef

           coef=a0*b1*c1
           ug(ip0,jp1,kp1) = ug(ip0,jp1,kp1) + g1*coef

           coef=a0*b1*c2
           ug(ip0,jp1,kp2) = ug(ip0,jp1,kp2) + g1*coef

           coef=a0*b1*c3
           ug(ip0,jp1,kp3) = ug(ip0,jp1,kp3) + g1*coef

ccc

           coef=a0*b2*c0
           ug(ip0,jp2,kp0) = ug(ip0,jp2,kp0) + g1*coef

           coef=a0*b2*c1
           ug(ip0,jp2,kp1) = ug(ip0,jp2,kp1) + g1*coef

           coef=a0*b2*c2
           ug(ip0,jp2,kp2) = ug(ip0,jp2,kp2) + g1*coef


           coef=a0*b2*c3
           ug(ip0,jp2,kp3) = ug(ip0,jp2,kp3) + g1*coef

ccc

           coef=a0*b3*c0
           ug(ip0,jp3,kp0) = ug(ip0,jp3,kp0) + g1*coef

           coef=a0*b3*c1
           ug(ip0,jp3,kp1) = ug(ip0,jp3,kp1) + g1*coef

           coef=a0*b3*c2
           ug(ip0,jp3,kp2) = ug(ip0,jp3,kp2) + g1*coef

           coef=a0*b3*c3
           ug(ip0,jp3,kp3) = ug(ip0,jp3,kp3) + g1*coef

ccc
           coef=a1*b0*c0
           ug(ip1,jp0,kp0) = ug(ip1,jp0,kp0) + g1*coef

           coef=a1*b0*c1
           ug(ip1,jp0,kp1) = ug(ip1,jp0,kp1) + g1*coef

           coef=a1*b0*c2
           ug(ip1,jp0,kp2) = ug(ip1,jp0,kp2) + g1*coef

           coef=a1*b0*c3
           ug(ip1,jp0,kp3) = ug(ip1,jp0,kp3) + g1*coef

ccc

           coef=a1*b1*c0
           ug(ip1,jp1,kp0) = ug(ip1,jp1,kp0) + g1*coef

           coef=a1*b1*c1
           ug(ip1,jp1,kp1) = ug(ip1,jp1,kp1) + g1*coef

           coef=a1*b1*c2
           ug(ip1,jp1,kp2) = ug(ip1,jp1,kp2) + g1*coef

           coef=a1*b1*c3
           ug(ip1,jp1,kp3) = ug(ip1,jp1,kp3) + g1*coef

ccc

           coef=a1*b2*c0
           ug(ip1,jp2,kp0) = ug(ip1,jp2,kp0) + g1*coef

           coef=a1*b2*c1
           ug(ip1,jp2,kp1) = ug(ip1,jp2,kp1) + g1*coef

           coef=a1*b2*c2
           ug(ip1,jp2,kp2) = ug(ip1,jp2,kp2) + g1*coef

           coef=a1*b2*c3
           ug(ip1,jp2,kp3) = ug(ip1,jp2,kp3) + g1*coef

ccc

           coef=a1*b3*c0
           ug(ip1,jp3,kp0) = ug(ip1,jp3,kp0) + g1*coef

           coef=a1*b3*c1
           ug(ip1,jp3,kp1) = ug(ip1,jp3,kp1) + g1*coef

           coef=a1*b3*c2
           ug(ip1,jp3,kp2) = ug(ip1,jp3,kp2) + g1*coef

           coef=a1*b3*c3
           ug(ip1,jp3,kp3) = ug(ip1,jp3,kp3) + g1*coef

ccc
           coef=a2*b0*c0
           ug(ip2,jp0,kp0) = ug(ip2,jp0,kp0) + g1*coef

           coef=a2*b0*c1
           ug(ip2,jp0,kp1) = ug(ip2,jp0,kp1) + g1*coef

           coef=a2*b0*c2
           ug(ip2,jp0,kp2) = ug(ip2,jp0,kp2) + g1*coef

           coef=a2*b0*c3
           ug(ip2,jp0,kp3) = ug(ip2,jp0,kp3) + g1*coef

ccc

           coef=a2*b1*c0
           ug(ip2,jp1,kp0) = ug(ip2,jp1,kp0) + g1*coef

           coef=a2*b1*c1
           ug(ip2,jp1,kp1) = ug(ip2,jp1,kp1) + g1*coef

           coef=a2*b1*c2
           ug(ip2,jp1,kp2) = ug(ip2,jp1,kp2) + g1*coef

           coef=a2*b1*c3
           ug(ip2,jp1,kp3) = ug(ip2,jp1,kp3) + g1*coef

ccc

           coef=a2*b2*c0
           ug(ip2,jp2,kp0) = ug(ip2,jp2,kp0) + g1*coef

           coef=a2*b2*c1
           ug(ip2,jp2,kp1) = ug(ip2,jp2,kp1) + g1*coef

           coef=a2*b2*c2
           ug(ip2,jp2,kp2) = ug(ip2,jp2,kp2) + g1*coef

           coef=a2*b2*c3
           ug(ip2,jp2,kp3) = ug(ip2,jp2,kp3) + g1*coef

ccc

           coef=a2*b3*c0
           ug(ip2,jp3,kp0) = ug(ip2,jp3,kp0) + g1*coef

           coef=a2*b3*c1
           ug(ip2,jp3,kp1) = ug(ip2,jp3,kp1) + g1*coef

           coef=a2*b3*c2
           ug(ip2,jp3,kp2) = ug(ip2,jp3,kp2) + g1*coef

           coef=a2*b3*c3
           ug(ip2,jp3,kp3) = ug(ip2,jp3,kp3) + g1*coef

ccc

           coef=a3*b0*c0
           ug(ip3,jp0,kp0) = ug(ip3,jp0,kp0) + g1*coef

           coef=a3*b0*c1
           ug(ip3,jp0,kp1) = ug(ip3,jp0,kp1) + g1*coef

           coef=a3*b0*c2
           ug(ip3,jp0,kp2) = ug(ip3,jp0,kp2) + g1*coef

           coef=a3*b0*c3
           ug(ip3,jp0,kp3) = ug(ip3,jp0,kp3) + g1*coef

ccc

           coef=a3*b1*c0
           ug(ip3,jp1,kp0) = ug(ip3,jp1,kp0) + g1*coef

           coef=a3*b1*c1
           ug(ip3,jp1,kp1) = ug(ip3,jp1,kp1) + g1*coef

           coef=a3*b1*c2
           ug(ip3,jp1,kp2) = ug(ip3,jp1,kp2) + g1*coef

           coef=a3*b1*c3
           ug(ip3,jp1,kp3) = ug(ip3,jp1,kp3) + g1*coef

ccc

          coef=a3*b2*c0
           ug(ip3,jp2,kp0) = ug(ip3,jp2,kp0) + g1*coef

           coef=a3*b2*c1
           ug(ip3,jp2,kp1) = ug(ip3,jp2,kp1) + g1*coef

           coef=a3*b2*c2
           ug(ip3,jp2,kp2) = ug(ip3,jp2,kp2) + g1*coef

           coef=a3*b2*c3
           ug(ip3,jp2,kp3) = ug(ip3,jp2,kp3) + g1*coef

ccc

           coef=a3*b3*c0
           ug(ip3,jp3,kp0) = ug(ip3,jp3,kp0) + g1*coef

           coef=a3*b3*c1
           ug(ip3,jp3,kp1) = ug(ip3,jp3,kp1) + g1*coef

           coef=a3*b3*c2
           ug(ip3,jp3,kp2) = ug(ip3,jp3,kp2) + g1*coef

           coef=a3*b3*c3
           ug(ip3,jp3,kp3) = ug(ip3,jp3,kp3) + g1*coef

ccc

20      CONTINUE

! goto 1111

	npart=0

	do k=1,nz2
	z=z0+(k-1)*dz2
	do j=1,ny2
	y=y0+(j-1)*dy2
	do i=1,nx2
	x=x0+(i-1)*dx2
        strength=abs(ug(i,j,k))
	if ((strength.gt.circlim)) then
        npart=npart+1
        xp2(npart)=x
        yp2(npart)=y
        zp2(npart)=z
	phip(npart)=ug(i,j,k)*vol
	endif
	enddo
	enddo
	enddo

1111	continue

	RETURN
	END
