	    subroutine tag_particles(npart,npart_aux,ntag,np_bl,
     1    icfl,itype,itype_aux,itag,
     1    xp_aux,up_aux,vx_aux,sl,sl1,sl2)

        include 'param.i'
        include 'param.h'

         common/remesh/xp(npg),xp1(npg),up(npg),vx(npg)

        integer icfl(*),itype(*),itype_aux(*),itag(*)
        dimension xp_aux(*),up_aux(*),vx_aux(*)
        dimension sl(*),sl1(*),sl2(*)

        integer ntype(npg),ncfl(npg),npart_bl(npg),i_nbl(npg)
        dimension amin_lambda(npg)

        
c    ntype(nbl) : type de bloc (1=centre ou 0=left) pour choix de la formule
c            remaillage
c    itype(npart) : idem pour les particules de ces blocks
c    ncfl(nbl)=cfl-nint ou cfl-int selon le type
c    icfl(npart) : idem pour particules de cs blocks
c    xp_aux(npart_aux): particles inside the blocks, for plain remeshing
c    itype_aux(npart_aux) : type de block pour ces particules
c    ntag: number of tagged particles, for special remeshing
c    itag(ntag): pointer for tagged particles
c    i_nbl(nbl) indice de la derniere particule du bloc nbl

      x0=xmin
    
      dh=dx

      m=np_bl+1
      nblock=nx/(m)
      dx_bl=float(m)*dh
      dx_bl_inv=1./dx_bl
    
c        on range les partucles par block
c        et on calcule lambda moyen pour chaque block

      do nbl=1,nblock
        amin_lambda(nbl)=111.
        npart_bl(nbl)=0
        i_nbl(nbl)=0
      enddo
    
      do i=1,npart
        nbl=1+int((xp(i)-x0+0.00001)*dx_bl_inv)
        amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(i)*cfl)
        npart_bl(nbl)=npart_bl(nbl)+1
        i_nbl(nbl)=i
      enddo
    
c    on ajoute la particule a droite du bloc (si elle existe) pour calculer
c    le amin_lambda, pour eviter pbms a l'interface entre blocs de meme type
c   (a corriger: pour l'instant je ne regarde pas le dernier bloc avec xp(1)

      do nbl=1,nblock-1
         if (i_nbl(nbl).ne.0) then
            ii=i_nbl(nbl)
            if ((ii.lt.npart).and.(xp(ii+1).lt.xp(ii)+1.5*dh)) then
            amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(ii+1)*cfl)
            endif
         endif
      enddo
    
c     le dernier bloc (a la main ..)

      nbl=nblock
      if (i_nbl(nbl).ne.0) then
         if ((xp(npart).ge.xmax-1.5*dh).and.(xp(1).lt.xmin+0.5*dh)) then
         amin_lambda(nbl)=amin1(amin_lambda(nbl),vx(1)*cfl)
         endif
      endif

    
c        et on en deduit type de block (1=centre vs 0=left) et l'indice du bloc
            

      do nbl=1,nblock
         if (amin_lambda(nbl).lt.nint(amin_lambda(nbl))+0.00001) then
            ntype(nbl)=1
            ncfl(nbl)=nint(amin_lambda(nbl))
         else
            ntype(nbl)=0
            ncfl(nbl)=int(amin_lambda(nbl))
            if (amin_lambda(nbl).lt.0) ncfl(nbl)=int(amin_lambda(nbl))-1
         endif

c        print*,'nbl et type',nbl, ntype(nbl),amin_lambda(nbl)
      enddo
c
c        on affecte le type et l'indice cfl du bloc sur ses particules 


      do i=1,npart
         nbl=1+int((xp(i)-x0+0.00001)*dx_bl_inv)
         itype(i)=ntype(nbl)
         icfl(i)=ncfl(nbl)
c        print*,'nbl et type',nbl,i, itype(i),icfl(i)
      enddo
    
    
c    on tagge les particules entre les blocs successifs non vides qui:
c    sont de type et indice cfl differents 
c    (cases b,c,b',c' du papier)

      ntag=0
      npart_aux=0
      j=2
      jc=0
      do i=2,npart-1
         j=j+jc
         if (j.ge.npart) go to 111
         jj=j+1
c        print*,j,icfl(j),icfl(jj),itype(j),itype(jj)
         if ((icfl(j).ne.icfl(jj)).and.(itype(j).ne.itype(jj))
     1        .and.(xp(jj).le.xp(j)+1.5*dh)) then
            ntag=ntag+1
            itag(ntag)=j
            ntag=ntag+1
            itag(ntag)=j+1
c            print*,' **** TAGGED ',j,xp(j),itype(j),icfl(j),vx(j)*delt/dh,
c      1     nint(vx(j)*delt/dh)
c            print*,' **** TAGGED ',jj,xp(jj),itype(jj),icfl(jj),vx(jj)*delt/dh,
c      1     nint(vx(jj)*delt/dh)
            jc=2
         else
            npart_aux=npart_aux+1
            xp_aux(npart_aux)=xp(j)
            up_aux(npart_aux)=up(j)
            vx_aux(npart_aux)=vx(j)
            sl1(npart_aux)=sl(j)
            sl2(npart_aux)=sl(j-1)
            itype_aux(npart_aux)=itype(j)
c    print*,'REGULAR',npart_aux,xp_aux(npart_aux),up_aux(npart_aux)
c   1     ,vx_aux(j)*delt/dh,icfl(j)
            jc=1
         endif
      enddo
    
111    continue
    
c    on regarde a part la premiere et la derniere particule 
c    (je ne sais pas faire autrement pour l'instant)

        if (npart.ge.1) then

        if ((icfl(1).ne.icfl(npart)).and.(itype(1).ne.itype(npart))
     1        .and.(xp(npart).ge.xp(1)+(float(nx)-1.5)*dh)
     1        .and.(itag(ntag).ne.npart)) then
c     1        ) then
            ntag=ntag+1
            itag(ntag)=npart
            ntag=ntag+1
            itag(ntag)=1
c            print*,' TAGGED ',j,xp(j),icfl(j)
        else
            npart_aux=npart_aux+1
            xp_aux(npart_aux)=xp(1)
            up_aux(npart_aux)=up(1)
            vx_aux(npart_aux)=vx(1)
            sl1(npart_aux)=sl(1)
            sl2(npart_aux)=sl(npart)
            itype_aux(npart_aux)=itype(1)
c            print*, ' REGULAR ',npart_aux,up_aux(npart_aux),xp_aux(npart_aux)
            if (npart.gt.1) then
            npart_aux=npart_aux+1
            xp_aux(npart_aux)=xp(npart)
            up_aux(npart_aux)=up(npart)
            vx_aux(npart_aux)=vx(npart)
            sl1(npart_aux)=sl(npart)
            sl2(npart_aux)=sl(npart-1)
            itype_aux(npart_aux)=itype(npart)
	    endif
c        print*, ' REGULAR ',npart_aux,up_aux(npart_aux),xp_aux(npart_aux)
        endif
	
	endif
    
! print*,'npart,NTAG, NPART_AUX = ',npart,ntag,npart_aux
    
    
       return
       end
