	subroutine x_advect(dt,np_bl,npart,ntag_total)
	
        include 'param.i'
        include 'param.h'
        include 'arrays.h'
        
		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)
		
c	routine d'advection en x :
c	parcours des lignes horozontales
c	intilisation de particules
c	calcul des vitesses par RK2
c	tag des particules en focntion des varaitions de cfl
c	push and remesh

c	cfl=dt/dx utilisee pour calucls de blocs /corrections
	cfl=dt/dx

	tm=0.
	npart=0
	ntag_total=0
	
	m=np_bl+1

c	 1) on balaie le tableau ug par lignes horizontales

	do k=1,nx
		zz=xmin+float(k-1)*dx
	do j=1,nx
		yy=xmin+float(j-1)*dx
		np=0
	        jj=3
	        ic=0
		do i=3,nx+2
        jj=jj+ic
        if (jj.gt.nx+2) go to 111
        j1=mod(jj-1,nx)+1
        j2=mod(jj,nx)+1
        j3=mod(jj+1,nx)+1
        j4=mod(jj+2,nx)+1
        if ((mod(j1,m).eq.m-1).and.
     1      (abs(ug(j1,j,k))+abs(ug(j2,j,k))+abs(ug(j3,j,k))
     1   +abs(ug(j4,j,k)).ge.circlim)) then
        np=np+1
        up(np)=ug(j1,j,k)
	tm=tm+ug(j1,j,k)
        xp(np)=xmin+float(j1-1)*dx
        np=np+1
        up(np)=ug(j2,j,k)
	tm=tm+ug(j2,j,k)
        xp(np)=xmin+float(j2-1)*dx
        np=np+1
        up(np)=ug(j3,j,k)
	tm=tm+ug(j3,j,k)
        xp(np)=xmin+float(j3-1)*dx
        np=np+1
        up(np)=ug(j4,j,k)
	tm=tm+ug(j4,j,k)
        xp(np)=xmin+float(j4-1)*dx
        ic=4
        elseif ((abs(ug(j1,j,k)).ge.circlim)) then
        np=np+1
        up(np)=ug(j1,j,k)
	tm=tm+ug(j1,j,k)
        xp(np)=xmin+float(j1-1)*dx
        ic=1
        else
        ic=1
        endif
                enddo
111     continue

c	 tag, push and remesh sur la ligne
		if (np.ne.0) then

c	evaluation des vitesse pour RK2

                call velox_x(np,j,k)
                do n=1,np
                xp0(n)=xp(n)
                xp(n)=xp(n)+0.5*dt*vx(n)
                if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
                if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
                enddo
                call velox_x(np,j,k)

		call tag_particles(np,np_aux,ntag,np_bl,
	1   icfl,itype,itype_aux,itag,
	1	xp_aux,up_aux,vx_aux)
	if (ntag+np_aux.ne.np) print*, ntag,np_aux,np
	
		if (ntag.ne.0) then
		do n=1,ntag
			ii=itag(n)
			xp(ii)=xp0(ii)+dt*vx(ii)
			if (xp(ii).gt.xmax) xp(ii)=xp(ii)-xmax+xmin
			if (xp(ii).lt.xmin) xp(ii)=xp(ii)+xmax-xmin
		enddo
		endif
	
		do n=1,np_aux
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
	    if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		jr=j
		kr=k
		call remeshx(np_aux,xp_aux,up_aux,itype_aux,jr,kr)
		if (ntag.ne.0) call remeshx_tag(ntag,itag,itype,icfl,jr,kr)
	
c	fin de ligne j,k:
	npart=npart+np
	ntag_total=ntag_total+ntag
		endif
	enddo
	enddo

	print*, 'TM debut de x_advect', tm*dx*dx*dx
        print*, 'NPART, NTAG selon x ', npart,ntag_total


	return
	end
