	subroutine x_advect(dt,np_bl,npart,ntag_total)
	
        include 'param.i'
        include 'param.h'
        include 'arrays.h'
        
		integer icfl(npg),itype(npg),itype_aux(npg),itag(npg)
		dimension xp_aux(npg),up_aux(npg),vx_aux(npg)

		
! routine d'advection en x :
! parcours des lignes horozontales
! intilisation de particules
! calcul des vitesses par RK2
! tag des particules en focntion des varaitions de cfl
! push and remesh

! cfl=dt/dx utilisee pour calucls de blocs /corrections
	cfl=dt/dx

	npart=0
	ntag_total=0
	
	
!  1) on balaie le tableau ug par lignes horizontales

	do k=1,nx
		zz=xmin+float(k-1)*dx
	do j=1,nx
		np=0
		yy=xmin+float(j-1)*dx
		do i=1,nx
! initiliasation particules sur la ligne j,k
		if (abs(ug(i,j,k)).gt.circlim) then
		np=np+1
		up(np)=ug(i,j,k)
		xp(np)=xmin+float(i-1)*dx
                up_aux(np)=ug(i,j,k)
                xp_aux(np)=xmin+float(i-1)*dx
		endif
		enddo
!  tag, push and remesh sur la ligne
		if (np.ne.0) then

! evaluation des vitesse pour RK2

		call velox_x(np,j,k)
		do n=1,np
		xp0(n)=xp(n)
		xp(n)=xp(n)+0.5*dt*vx(n)
		if (xp(n).gt.xmax) xp(n)=xp(n)-xmax+xmin
		if (xp(n).lt.xmin) xp(n)=xp(n)+xmax-xmin
		enddo
		call velox_x(np,j,k)
		do n=1,np
	        xp_aux(n)=xp0(n)
	        vx_aux(n)=vx(n)
	        itype(n)=1
	        enddo
			
222	continue
		do n=1,np
		xp_aux(n)=xp_aux(n)+dt*vx_aux(n)
	    if (xp_aux(n).gt.xmax) xp_aux(n)=xp_aux(n)-xmax+xmin
	    if (xp_aux(n).lt.xmin) xp_aux(n)=xp_aux(n)+xmax-xmin
		enddo
		jr=j
		kr=k
		call remeshx(np,xp_aux,up_aux,itype,jr,kr)
	
! fin de ligne j,k:
	npart=npart+np
		endif
	enddo
	enddo

	print*, 'NPART, NTAG ', npart,ntag_total
	return
	end
