!
	SUBROUTINE  intersm4(npart,g1,g2,g3,xp,yp,zp)

!
!   Interpolation routine with M'4 
!
! geometry=unit box, periodic in x and y
! last ponits in z direction assume extension by continuity
! that is gg(i,j,0)=gg(i,j,1) gg(i,j,m+1)=gg(i,j,m)

	include 'param.i'
	include 'param.h'
	dimension g1(*),g2(*),g3(*),xp(*),yp(*),zp(*)

        COMMON/GRID/     omg1(npgx,npgy,npgz),
     &  omg2(npgx,npgy,npgz),omg3(npgx,npgy,npgz),
     &  vxg(npgx,npgy,npgz),vyg(npgx,npgy,npgz),vzg(npgx,npgy,npgz),
     &  psi1(npgx,npgy,npgz),psi2(npgx,npgy,npgz),psi3(npgx,npgy,npgz),
     &  gg1(npgx,npgy,npgz),gg2(npgx,npgy,npgz),gg3(npgx,npgy,npgz),
     &  ug(npg,npg,npg)


        dy1=dx1
        dz1=dx1

	do 10 i=1,npart
	g1(i)=0.
	g2(i)=0.
	g3(i)=0.
10	continue

        dxinv=1./dx1
        dyinv=1./dy1
        dzinv=1./dz1
        dh3=dx1*dy1*dz1
        dhinv3=1./dh3
                         

!--------------------------------------------------------------------
!- PART II : Determination of  the  circulation  of each particle
!--------------------------------------------------------------------

        x0=xmin
        y0=ymin
        z0=zmin     

	 DO 20 i = 1,npart

            x = XP(i)
            y = YP(i)
            z = ZP(i)

            ip1 = int((x-x0)*dxinv) 
            jp1 = int((y-y0)*dyinv) 
            kp1 = int((z-z0)*dzinv) 

            ip0 = ip1 - 1
            jp0 = jp1 - 1
            kp0 = kp1 - 1

            ip2 = ip1 + 1
	    jp2 = jp1 + 1
	    kp2 = kp1 + 1

            ip3 = ip1 + 2
	    jp3 = jp1 + 2
	    kp3 = kp1 + 2


! get the circulations from the nine neighboring cells

           xx1 = (x - float(ip1)*dx1-x0)*dxinv
           yy1 = (y - float(jp1)*dy1-y0)*dyinv
           zz1 = (z - float(kp1)*dz1-z0)*dzinv                                             
	   xx0=xx1+1
	   yy0=yy1+1
	   zz0=zz1+1

	   xx2=1-xx1
	   yy2=1-yy1
	   zz2=1-zz1

	   xx3=2-xx1
	   yy3=2-yy1
	   zz3=2-zz1


!
! 	on repositionne les points de grille par periodicite
! entre 0 et m-1, puis on numerote de 1 a m
C
        ip1=mod(ip1+nx1,nx1) +1
        ip0=mod(ip0+nx1,nx1) +1
        ip2=mod(ip2+nx1,nx1) +1
        ip3=mod(ip3+nx1,nx1) +1

!       print*,ip0,ip1,ip2,ip3

        jp1=mod(jp1+ny1,ny1) +1
        jp0=mod(jp0+ny1,ny1) +1
        jp2=mod(jp2+ny1,ny1) +1
        jp3=mod(jp3+ny1,ny1) +1

        kp1=mod(kp1+nz1,nz1) +1
        kp0=mod(kp0+nz1,nz1) +1
        kp2=mod(kp2+nz1,nz1) +1
        kp3=mod(kp3+nz1,nz1) +1       
C
! The M'4 scheme
!
           a0 = .5*((2.-xx0)**2)*(1.-xx0)
           b0 = .5*((2.-yy0)**2)*(1.-yy0)
           c0 = .5*((2.-zz0)**2)*(1.-zz0)

           a1 = 1.-2.5*xx1*xx1 +  1.5*xx1*xx1*xx1
           b1 = 1.-2.5*yy1*yy1 +  1.5*yy1*yy1*yy1
           c1 = 1.-2.5*zz1*zz1 +  1.5*zz1*zz1*zz1

           a2 = 1.-2.5*xx2*xx2 +  1.5*xx2*xx2*xx2
           b2 = 1.-2.5*yy2*yy2 +  1.5*yy2*yy2*yy2
           c2 = 1.-2.5*zz2*zz2 +  1.5*zz2*zz2*zz2

           a3 = .5*((2.-xx3)**2)*(1.-xx3)
           b3 = .5*((2.-yy3)**2)*(1.-yy3)
           c3 = .5*((2.-zz3)**2)*(1.-zz3)

	    g1(i)= g1(i) +  GG1(ip0,jp0,kp0)*a0*b0*c0
	    g1(i)= g1(i) +  GG1(ip0,jp1,kp0)*a0*b1*c0
	    g1(i)= g1(i) +  GG1(ip0,jp2,kp0)*a0*b2*c0
	    g1(i)= g1(i) +  GG1(ip0,jp3,kp0)*a0*b3*c0

	    g2(i)= g2(i) + GG2(ip0,jp0,kp0)*a0*b0*c0
	    g2(i)= g2(i) + GG2(ip0,jp1,kp0)*a0*b1*c0
	    g2(i)= g2(i) + GG2(ip0,jp2,kp0)*a0*b2*c0
	    g2(i)= g2(i) + GG2(ip0,jp3,kp0)*a0*b3*c0

	    g3(i)= g3(i) + GG3(ip0,jp0,kp0)*a0*b0*c0
	    g3(i)= g3(i) + GG3(ip0,jp1,kp0)*a0*b1*c0
	    g3(i)= g3(i) + GG3(ip0,jp2,kp0)*a0*b2*c0
	    g3(i)= g3(i) + GG3(ip0,jp3,kp0)*a0*b3*c0

	   g1(i)= g1(i) +  GG1(ip1,jp0,kp0)*a1*b0*c0
	   g1(i)= g1(i) +  GG1(ip1,jp1,kp0)*a1*b1*c0 
	   g1(i)= g1(i) +  GG1(ip1,jp2,kp0)*a1*b2*c0 
	   g1(i)= g1(i) +  GG1(ip1,jp3,kp0)*a1*b3*c0 

	   g2(i)= g2(i) + GG2(ip1,jp0,kp0)*a1*b0*c0 
	   g2(i)= g2(i) + GG2(ip1,jp1,kp0)*a1*b1*c0 
	   g2(i)= g2(i) + GG2(ip1,jp2,kp0)*a1*b2*c0 
	   g2(i)= g2(i) + GG2(ip1,jp3,kp0)*a1*b3*c0 

	   g3(i)= g3(i) + GG3(ip1,jp0,kp0)*a1*b0*c0 
	   g3(i)= g3(i) + GG3(ip1,jp1,kp0)*a1*b1*c0 
	   g3(i)= g3(i) + GG3(ip1,jp2,kp0)*a1*b2*c0 
	   g3(i)= g3(i) + GG3(ip1,jp3,kp0)*a1*b3*c0 

	   g1(i)= g1(i) +  GG1(ip2,jp0,kp0)*a2*b0*c0 
	   g1(i)= g1(i) +  GG1(ip2,jp1,kp0)*a2*b1*c0 
	   g1(i)= g1(i) +  GG1(ip2,jp2,kp0)*a2*b2*c0 
	   g1(i)= g1(i) +  GG1(ip2,jp3,kp0)*a2*b3*c0 

	   g2(i)= g2(i) + GG2(ip2,jp0,kp0)*a2*b0*c0 
	   g2(i)= g2(i) + GG2(ip2,jp1,kp0)*a2*b1*c0 
	   g2(i)= g2(i) + GG2(ip2,jp2,kp0)*a2*b2*c0 
	   g2(i)= g2(i) + GG2(ip2,jp3,kp0)*a2*b3*c0 

	   g3(i)= g3(i) + GG3(ip2,jp0,kp0)*a2*b0*c0 
	   g3(i)= g3(i) + GG3(ip2,jp1,kp0)*a2*b1*c0 
	   g3(i)= g3(i) + GG3(ip2,jp2,kp0)*a2*b2*c0 
	   g3(i)= g3(i) + GG3(ip2,jp3,kp0)*a2*b3*c0 

	   g1(i)= g1(i) + GG1(ip3,jp0,kp0)*a3*b0*c0 
	   g1(i)= g1(i) + GG1(ip3,jp1,kp0)*a3*b1*c0 
	   g1(i)= g1(i) + GG1(ip3,jp2,kp0)*a3*b2*c0 
	   g1(i)= g1(i) + GG1(ip3,jp3,kp0)*a3*b3*c0 

	   g2(i)= g2(i) + GG2(ip3,jp0,kp0)*a3*b0*c0 
	   g2(i)= g2(i) + GG2(ip3,jp1,kp0)*a3*b1*c0 
	   g2(i)= g2(i) + GG2(ip3,jp2,kp0)*a3*b2*c0 
	   g2(i)= g2(i) + GG2(ip3,jp3,kp0)*a3*b3*c0 

	   g3(i)= g3(i) + GG3(ip3,jp0,kp0)*a3*b0*c0 
	   g3(i)= g3(i) + GG3(ip3,jp1,kp0)*a3*b1*c0 
	   g3(i)= g3(i) + GG3(ip3,jp2,kp0)*a3*b2*c0 
	   g3(i)= g3(i) + GG3(ip3,jp3,kp0)*a3*b3*c0 

	    g1(i)= g1(i) +  GG1(ip0,jp0,kp1)*a0*b0*c1
	    g1(i)= g1(i) +  GG1(ip0,jp1,kp1)*a0*b1*c1
	    g1(i)= g1(i) +  GG1(ip0,jp2,kp1)*a0*b2*c1
	    g1(i)= g1(i) +  GG1(ip0,jp3,kp1)*a0*b3*c1

	    g2(i)= g2(i) + GG2(ip0,jp0,kp1)*a0*b0*c1
	    g2(i)= g2(i) + GG2(ip0,jp1,kp1)*a0*b1*c1
	    g2(i)= g2(i) + GG2(ip0,jp2,kp1)*a0*b2*c1
	    g2(i)= g2(i) + GG2(ip0,jp3,kp1)*a0*b3*c1

	    g3(i)= g3(i) + GG3(ip0,jp0,kp1)*a0*b0*c1
	    g3(i)= g3(i) + GG3(ip0,jp1,kp1)*a0*b1*c1
	    g3(i)= g3(i) + GG3(ip0,jp2,kp1)*a0*b2*c1
	    g3(i)= g3(i) + GG3(ip0,jp3,kp1)*a0*b3*c1

	   g1(i)= g1(i) +  GG1(ip1,jp0,kp1)*a1*b0*c1 
	   g1(i)= g1(i) +  GG1(ip1,jp1,kp1)*a1*b1*c1 
	   g1(i)= g1(i) +  GG1(ip1,jp2,kp1)*a1*b2*c1 
	   g1(i)= g1(i) +  GG1(ip1,jp3,kp1)*a1*b3*c1 

	   g2(i)= g2(i) + GG2(ip1,jp0,kp1)*a1*b0*c1 
	   g2(i)= g2(i) + GG2(ip1,jp1,kp1)*a1*b1*c1 
	   g2(i)= g2(i) + GG2(ip1,jp2,kp1)*a1*b2*c1 
	   g2(i)= g2(i) + GG2(ip1,jp3,kp1)*a1*b3*c1 

	   g3(i)= g3(i) + GG3(ip1,jp0,kp1)*a1*b0*c1 
	   g3(i)= g3(i) + GG3(ip1,jp1,kp1)*a1*b1*c1 
	   g3(i)= g3(i) + GG3(ip1,jp2,kp1)*a1*b2*c1 
	   g3(i)= g3(i) + GG3(ip1,jp3,kp1)*a1*b3*c1 

	   g1(i)= g1(i) +  GG1(ip2,jp0,kp1)*a2*b0*c1 
	   g1(i)= g1(i) +  GG1(ip2,jp1,kp1)*a2*b1*c1 
	   g1(i)= g1(i) +  GG1(ip2,jp2,kp1)*a2*b2*c1 
	   g1(i)= g1(i) +  GG1(ip2,jp3,kp1)*a2*b3*c1 

	   g2(i)= g2(i) + GG2(ip2,jp0,kp1)*a2*b0*c1 
	   g2(i)= g2(i) + GG2(ip2,jp1,kp1)*a2*b1*c1 
	   g2(i)= g2(i) + GG2(ip2,jp2,kp1)*a2*b2*c1 
	   g2(i)= g2(i) + GG2(ip2,jp3,kp1)*a2*b3*c1 

	   g3(i)= g3(i) + GG3(ip2,jp0,kp1)*a2*b0*c1 
	   g3(i)= g3(i) + GG3(ip2,jp1,kp1)*a2*b1*c1 
	   g3(i)= g3(i) + GG3(ip2,jp2,kp1)*a2*b2*c1 
	   g3(i)= g3(i) + GG3(ip2,jp3,kp1)*a2*b3*c1 

	   g1(i)= g1(i) + GG1(ip3,jp0,kp1)*a3*b0*c1 
	   g1(i)= g1(i) + GG1(ip3,jp1,kp1)*a3*b1*c1 
	   g1(i)= g1(i) + GG1(ip3,jp2,kp1)*a3*b2*c1 
	   g1(i)= g1(i) + GG1(ip3,jp3,kp1)*a3*b3*c1 

	   g2(i)= g2(i) + GG2(ip3,jp0,kp1)*a3*b0*c1 
	   g2(i)= g2(i) + GG2(ip3,jp1,kp1)*a3*b1*c1 
	   g2(i)= g2(i) + GG2(ip3,jp2,kp1)*a3*b2*c1 
	   g2(i)= g2(i) + GG2(ip3,jp3,kp1)*a3*b3*c1 

	   g3(i)= g3(i) + GG3(ip3,jp0,kp1)*a3*b0*c1 
	   g3(i)= g3(i) + GG3(ip3,jp1,kp1)*a3*b1*c1 
	   g3(i)= g3(i) + GG3(ip3,jp2,kp1)*a3*b2*c1 
	   g3(i)= g3(i) + GG3(ip3,jp3,kp1)*a3*b3*c1 

	    g1(i)= g1(i) +  GG1(ip0,jp0,kp2)*a0*b0*c2
	    g1(i)= g1(i) +  GG1(ip0,jp1,kp2)*a0*b1*c2
	    g1(i)= g1(i) +  GG1(ip0,jp2,kp2)*a0*b2*c2
	    g1(i)= g1(i) +  GG1(ip0,jp3,kp2)*a0*b3*c2

	    g2(i)= g2(i) + GG2(ip0,jp0,kp2)*a0*b0*c2
	    g2(i)= g2(i) + GG2(ip0,jp1,kp2)*a0*b1*c2
	    g2(i)= g2(i) + GG2(ip0,jp2,kp2)*a0*b2*c2
	    g2(i)= g2(i) + GG2(ip0,jp3,kp2)*a0*b3*c2

	    g3(i)= g3(i) + GG3(ip0,jp0,kp2)*a0*b0*c2
	    g3(i)= g3(i) + GG3(ip0,jp1,kp2)*a0*b1*c2
	    g3(i)= g3(i) + GG3(ip0,jp2,kp2)*a0*b2*c2
	    g3(i)= g3(i) + GG3(ip0,jp3,kp2)*a0*b3*c2

	   g1(i)= g1(i) +  GG1(ip1,jp0,kp2)*a1*b0*c2
	   g1(i)= g1(i) +  GG1(ip1,jp1,kp2)*a1*b1*c2
	   g1(i)= g1(i) +  GG1(ip1,jp2,kp2)*a1*b2*c2 
	   g1(i)= g1(i) +  GG1(ip1,jp3,kp2)*a1*b3*c2 

	   g2(i)= g2(i) + GG2(ip1,jp0,kp2)*a1*b0*c2 
	   g2(i)= g2(i) + GG2(ip1,jp1,kp2)*a1*b1*c2 
	   g2(i)= g2(i) + GG2(ip1,jp2,kp2)*a1*b2*c2 
	   g2(i)= g2(i) + GG2(ip1,jp3,kp2)*a1*b3*c2 

	   g3(i)= g3(i) + GG3(ip1,jp0,kp2)*a1*b0*c2 
	   g3(i)= g3(i) + GG3(ip1,jp1,kp2)*a1*b1*c2 
	   g3(i)= g3(i) + GG3(ip1,jp2,kp2)*a1*b2*c2 
	   g3(i)= g3(i) + GG3(ip1,jp3,kp2)*a1*b3*c2 

	   g1(i)= g1(i) +  GG1(ip2,jp0,kp2)*a2*b0*c2 
	   g1(i)= g1(i) +  GG1(ip2,jp1,kp2)*a2*b1*c2 
	   g1(i)= g1(i) +  GG1(ip2,jp2,kp2)*a2*b2*c2 
	   g1(i)= g1(i) +  GG1(ip2,jp3,kp2)*a2*b3*c2 

	   g2(i)= g2(i) + GG2(ip2,jp0,kp2)*a2*b0*c2 
	   g2(i)= g2(i) + GG2(ip2,jp1,kp2)*a2*b1*c2 
	   g2(i)= g2(i) + GG2(ip2,jp2,kp2)*a2*b2*c2 
	   g2(i)= g2(i) + GG2(ip2,jp3,kp2)*a2*b3*c2 

	   g3(i)= g3(i) + GG3(ip2,jp0,kp2)*a2*b0*c2 
	   g3(i)= g3(i) + GG3(ip2,jp1,kp2)*a2*b1*c2 
	   g3(i)= g3(i) + GG3(ip2,jp2,kp2)*a2*b2*c2 
	   g3(i)= g3(i) + GG3(ip2,jp3,kp2)*a2*b3*c2 

	   g1(i)= g1(i) +  GG1(ip3,jp0,kp2)*a3*b0*c2 
	   g1(i)= g1(i) +  GG1(ip3,jp1,kp2)*a3*b1*c2 
	   g1(i)= g1(i) +  GG1(ip3,jp2,kp2)*a3*b2*c2 
	   g1(i)= g1(i) +  GG1(ip3,jp3,kp2)*a3*b3*c2 

	   g2(i)= g2(i) + GG2(ip3,jp0,kp2)*a3*b0*c2 
	   g2(i)= g2(i) + GG2(ip3,jp1,kp2)*a3*b1*c2 
	   g2(i)= g2(i) + GG2(ip3,jp2,kp2)*a3*b2*c2 
	   g2(i)= g2(i) + GG2(ip3,jp3,kp2)*a3*b3*c2 

	   g3(i)= g3(i) + GG3(ip3,jp0,kp2)*a3*b0*c2 
	   g3(i)= g3(i) + GG3(ip3,jp1,kp2)*a3*b1*c2 
	   g3(i)= g3(i) + GG3(ip3,jp2,kp2)*a3*b2*c2 
	   g3(i)= g3(i) + GG3(ip3,jp3,kp2)*a3*b3*c2 

	    g1(i)= g1(i) +  GG1(ip0,jp0,kp3)*a0*b0*c3
	    g1(i)= g1(i) +  GG1(ip0,jp1,kp3)*a0*b1*c3
	    g1(i)= g1(i) +  GG1(ip0,jp2,kp3)*a0*b2*c3
	    g1(i)= g1(i) +  GG1(ip0,jp3,kp3)*a0*b3*c3

	    g2(i)= g2(i) + GG2(ip0,jp0,kp3)*a0*b0*c3
	    g2(i)= g2(i) + GG2(ip0,jp1,kp3)*a0*b1*c3
	    g2(i)= g2(i) + GG2(ip0,jp2,kp3)*a0*b2*c3
	    g2(i)= g2(i) + GG2(ip0,jp3,kp3)*a0*b3*c3

	    g3(i)= g3(i) + GG3(ip0,jp0,kp3)*a0*b0*c3
	    g3(i)= g3(i) + GG3(ip0,jp1,kp3)*a0*b1*c3
	    g3(i)= g3(i) + GG3(ip0,jp2,kp3)*a0*b2*c3
	    g3(i)= g3(i) + GG3(ip0,jp3,kp3)*a0*b3*c3

	   g1(i)= g1(i) +  GG1(ip1,jp0,kp3)*a1*b0*c3
	   g1(i)= g1(i) +  GG1(ip1,jp1,kp3)*a1*b1*c3
	   g1(i)= g1(i) +  GG1(ip1,jp2,kp3)*a1*b2*c3
	   g1(i)= g1(i) +  GG1(ip1,jp3,kp3)*a1*b3*c3 

	   g2(i)= g2(i) + GG2(ip1,jp0,kp3)*a1*b0*c3 
	   g2(i)= g2(i) + GG2(ip1,jp1,kp3)*a1*b1*c3 
	   g2(i)= g2(i) + GG2(ip1,jp2,kp3)*a1*b2*c3 
	   g2(i)= g2(i) + GG2(ip1,jp3,kp3)*a1*b3*c3 

	   g3(i)= g3(i) + GG3(ip1,jp0,kp3)*a1*b0*c3 
	   g3(i)= g3(i) + GG3(ip1,jp1,kp3)*a1*b1*c3 
	   g3(i)= g3(i) + GG3(ip1,jp2,kp3)*a1*b2*c3 
	   g3(i)= g3(i) + GG3(ip1,jp3,kp3)*a1*b3*c3 

	   g1(i)= g1(i) +  GG1(ip2,jp0,kp3)*a2*b0*c3 
	   g1(i)= g1(i) +  GG1(ip2,jp1,kp3)*a2*b1*c3 
	   g1(i)= g1(i) +  GG1(ip2,jp2,kp3)*a2*b2*c3 
	   g1(i)= g1(i) +  GG1(ip2,jp3,kp3)*a2*b3*c3 

	   g2(i)= g2(i) + GG2(ip2,jp0,kp3)*a2*b0*c3 
	   g2(i)= g2(i) + GG2(ip2,jp1,kp3)*a2*b1*c3 
	   g2(i)= g2(i) + GG2(ip2,jp2,kp3)*a2*b2*c3 
	   g2(i)= g2(i) + GG2(ip2,jp3,kp3)*a2*b3*c3 

	   g3(i)= g3(i) + GG3(ip2,jp0,kp3)*a2*b0*c3 
	   g3(i)= g3(i) + GG3(ip2,jp1,kp3)*a2*b1*c3 
	   g3(i)= g3(i) + GG3(ip2,jp2,kp3)*a2*b2*c3 
	   g3(i)= g3(i) + GG3(ip2,jp3,kp3)*a2*b3*c3 

	   g1(i)= g1(i) +  GG1(ip3,jp0,kp3)*a3*b0*c3 
	   g1(i)= g1(i) +  GG1(ip3,jp1,kp3)*a3*b1*c3 
	   g1(i)= g1(i) +  GG1(ip3,jp2,kp3)*a3*b2*c3 
	   g1(i)= g1(i) +  GG1(ip3,jp3,kp3)*a3*b3*c3 

	   g2(i)= g2(i) + GG2(ip3,jp0,kp3)*a3*b0*c3 
	   g2(i)= g2(i) + GG2(ip3,jp1,kp3)*a3*b1*c3 
	   g2(i)= g2(i) + GG2(ip3,jp2,kp3)*a3*b2*c3 
	   g2(i)= g2(i) + GG2(ip3,jp3,kp3)*a3*b3*c3 

	   g3(i)= g3(i) + GG3(ip3,jp0,kp3)*a3*b0*c3 
	   g3(i)= g3(i) + GG3(ip3,jp1,kp3)*a3*b1*c3 
	   g3(i)= g3(i) + GG3(ip3,jp2,kp3)*a3*b2*c3 
	   g3(i)= g3(i) + GG3(ip3,jp3,kp3)*a3*b3*c3 

20      CONTINUE



	RETURN
	END
