      subroutine fftw3d(r,c,nx,ny,nz,nxs2,nys2,nzs2,wk,irc)
c
c Ce programme calcul la transformee de fourier rapide
c
C---------------------------------------------------------------------- 
C TRANSFORMATION DE FOURIER REELLE<--->COMPLEXE TRI-DIMENSIONNELLE       
C    X  : VECTEUR REEL DE DIMENSION (nx,ny,nz)             
C    C  : VECTEUR COMPLEXE DE DIMENSION (0:nx/2,-ny/2+1:ny/2,-nz/2+1:nz/2)   
C    WK   : Vecteur de travail pour les fftw de dimension (0:nx/2,0:ny-1,0:nz-1)
C    IRC  :  =0: REELLE   ---> COMPLEXE  (X-->C)  Directe               
C           <>0: COMPLEXE ---> REELLE    (C-->X)  inverse               
C                                                                       
C REMARQUE:                                                             
C    CALCULE LA TRANSFORMATION SUIVANTE:                                
C                                                                       
C  X(J,K,L)  J(1..nx),K(1..ny),L(1..Nz) <--->  C(J,K,L)  J=0..nx/2 K=-ny/2+1,...,ny/2, 
C                                           L=-nz/2+1,...,nz/2
C                                                                       
C---------------------------------------------------------------------- 
c 
c    Declaration pour utiliser les routines fftw 
c
c     This file contains PARAMETER statements for various constants
c     that can be passed to FFTW routines.  You should include
c     this file in any FORTRAN program that calls the fftw_f77
c     routines (either directly or with an #include statement
c     if you use the C preprocessor).
c
      INTEGER FFTW_FORWARD,FFTW_BACKWARD
      PARAMETER (FFTW_FORWARD=-1,FFTW_BACKWARD=1)
c
      INTEGER FFTW_REAL_TO_COMPLEX,FFTW_COMPLEX_TO_REAL
      PARAMETER (FFTW_REAL_TO_COMPLEX=-1,FFTW_COMPLEX_TO_REAL=1)
c
      INTEGER FFTW_ESTIMATE,FFTW_MEASURE
      PARAMETER (FFTW_ESTIMATE=0,FFTW_MEASURE=1)
c
      INTEGER FFTW_IN_PLACE,FFTW_USE_WISDOM
      PARAMETER (FFTW_IN_PLACE=8,FFTW_USE_WISDOM=16)   
c
      integer plan,nx,ny,nz,nxs2,nys2,nzs2,irc,i,j,k
c
      complex c,wk
      dimension c(0:nxs2,1-nys2:nys2,1-nzs2:nzs2),wk(nxs2+1,ny,nz)
c
      real r
      dimension r(nx,ny,nz)
c
c	print*,nx,ny,nz,nxs2,nys2,nzs2,r(2,5,1)
      do k=1,nz
         do j=1,ny
            do i=1,nxs2+1
               wk(i,j,k)=cmplx(0.0,0.0)
            enddo
         enddo
       enddo   
c
          if (irc.eq.0) then
c
      call rfftw3d_f77_create_plan(plan,nx,ny,nz,FFTW_FORWARD,
     1     FFTW_ESTIMATE)
c     1     FFTW_MEASURE)
c
      call rfftwnd_f77_one_real_to_complex(plan,r,wk)
c
c      print*,'coucou',wk(2,5,1)	
      call rfftwnd_f77_destroy_plan(plan)
c
      do k=1,nz
         do j=1,ny
            do i=1,nxs2+1
               wk(i,j,k)=wk(i,j,k)/nx/ny/nz
            enddo
         enddo
      enddo  
c      print*,wk(2,5,1) 
c
      do k=1,nzs2+1
         do j=1,nys2+1
            do i=1,nxs2+1
               c(i-1,j-1,k-1)=wk(i,j,k)
            enddo
         enddo
      enddo
c
      do k=1,nzs2+1
         do j=1,nys2-1
            do i=1,nxs2+1
               c(i-1,j-nys2,k-1)=wk(i,j+nys2+1,k)
            enddo
         enddo
      enddo
c
      do k=1,nzs2-1
         do j=1,nys2+1
            do i=1,nxs2+1
               c(i-1,j-1,k-nzs2)=wk(i,j,k+nzs2+1)
            enddo
         enddo
      enddo
c
      do k=1,nzs2-1
         do j=1,nys2-1
            do i=1,nxs2+1
               c(i-1,j-nys2,k-nzs2)=wk(i,j+nys2+1,k+nzs2+1)
            enddo
         enddo
      enddo
c
      else
c
      do k=1,nzs2+1
         do j=1,nys2+1
            do i=1,nxs2+1
               wk(i,j,k)=c(i-1,j-1,k-1)
            enddo
         enddo
      enddo
c
      do k=1,nzs2+1
         do j=1,nys2-1
            do i=1,nxs2+1
               wk(i,j+nys2+1,k)=c(i-1,j-nys2,k-1)
            enddo
         enddo
      enddo
c
      do k=1,nzs2-1
         do j=1,nys2+1
            do i=1,nxs2+1
               wk(i,j,k+nzs2+1)=c(i-1,j-1,k-nzs2)
            enddo
         enddo
      enddo
c
      do k=1,nzs2-1
         do j=1,nys2-1
            do i=1,nxs2+1
               wk(i,j+nys2+1,k+nzs2+1)=c(i-1,j-nys2,k-nzs2)
            enddo
         enddo
      enddo
c
      call rfftw3d_f77_create_plan(plan,nx,ny,nz,FFTW_BACKWARD,
     1     FFTW_ESTIMATE)
c     1     FFTW_MEASURE)
c
      call rfftwnd_f77_one_complex_to_real(plan,wk,r)
c
      call rfftwnd_f77_destroy_plan(plan)
c
      endif
c
      return
      end
