	subroutine velox_fft

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

        dimension aux3(npg,npg,npg),aux1(npg,npg,npg),aux2(npg,npg,npg)

	parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

	complex cfx,cfy,cfz,cux,cuy,cuz,wk
	common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cux(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             cuz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),
     1             wk(ngx2+1,npgy,npgz)

        pi=3.1415926
	dxinv=0.5/dx
	dyinv=dxinv
	dzinv=dxinv

c	calucl de fonction courants 3d

	nx2=nx/2
	ny2=ny/2
	nz2=nz/2


      call fftw3d(omg1,cfx,nx,ny,nz,nx2,ny2,nz2,wk,0)
      call fftw3d(omg2,cfy,nx,ny,nz,nx2,ny2,nz2,wk,0)
      call fftw3d(omg3,cfz,nx,ny,nz,nx2,ny2,nz2,wk,0)


c 	coeff de normalisation pour laplacien en spectral

	ai=2.*pi/(xmax-xmin)	
	aj=2.*pi/(ymax-ymin)	
	ak=2.*pi/(zmax-zmin)	
	
	ai2=ai**2
	aj2=aj**2
	ak2=ak**2

      do 10 k=1-nz2,nz2
         rk=float(k)*ak
         do 10 j=1-ny2,ny2
            rj=float(j)*aj
            do 10 i=0,nx2
               ri=float(i)*ai
	       r2=ri**2+rj**2+rk**2
	cux(i,j,k)=cmplx(0.0,0.0)
	cuy(i,j,k)=cmplx(0.0,0.0) 
	cuz(i,j,k)=cmplx(0.0,0.0) 
	if (r2.ne.0.) then
c
      cux(i,j,k)=cmplx(0.0,1.0)*(-rj*cfz(i,j,k)+rk*cfy(i,j,k))/r2
      cuy(i,j,k)=cmplx(0.0,1.0)*(-rk*cfx(i,j,k)+ri*cfz(i,j,k))/r2
      cuz(i,j,k)=cmplx(0.0,1.0)*(-ri*cfy(i,j,k)+rj*cfx(i,j,k))/r2
        endif
10    continue   


      call fftw3d(aux1,cux,nx,ny,nz,nx2,ny2,nz2,wk,1)
      call fftw3d(aux2,cuy,nx,ny,nz,nx2,ny2,nz2,wk,1)
      call fftw3d(aux3,cuz,nx,ny,nz,nx2,ny2,nz2,wk,1)

	goto 111

        do k=1,nz
        do j=1,ny
        do i=1,nx
        dvx(i,j,k)=(-aux1(i,j,k)-vxg(i,j,k))/delt
        dvy(i,j,k)=(-aux2(i,j,k)-vyg(i,j,k))/delt
        dvz(i,j,k)=(-aux2(i,j,k)-vzg(i,j,k))/delt

        vxg(i,j,k)=-aux1(i,j,k)
        vyg(i,j,k)=-aux2(i,j,k)
        vzg(i,j,k)=-aux3(i,j,k)
        enddo
        enddo
        enddo

c       pour terme barotrope : du/dt+(u\nabla)u - g =
        do k=1,nz
        kt=mod(k+nz,nz)+1
        kb=mod(k-2+nz,nz)+1
        do j=1,ny
        jt=mod(j+ny,ny)+1
        jb=mod(j-2+ny,ny)+1
        do i=1,nx
        it=mod(i+nx,nx)+1
        ib=mod(i-2+nx,nx)+1
        dvx(i,j,k)=dvx(i,j,k)+vxg(i,j,k)*(vxg(it,j,k)-vxg(ib,j,k))*dxinv
        dvx(i,j,k)=dvx(i,j,k)+vyg(i,j,k)*(vxg(i,jt,k)-vxg(i,jb,k))*dyinv
        dvx(i,j,k)=dvx(i,j,k)+vzg(i,j,k)*(vxg(i,j,kt)-vxg(i,j,kb))*dyinv
        dvy(i,j,k)=dvy(i,j,k)+vxg(i,j,k)*(vyg(it,j,k)-vyg(ib,j,k))*dxinv
        dvy(i,j,k)=dvy(i,j,k)+vyg(i,j,k)*(vyg(i,jt,k)-vyg(i,jb,k))*dyinv
        dvy(i,j,k)=dvy(i,j,k)+vzg(i,j,k)*(vyg(i,j,kt)-vyg(i,j,kb))*dyinv
        dvz(i,j,k)=dvz(i,j,k)+vxg(i,j,k)*(vzg(it,j,k)-vzg(ib,j,k))*dxinv
        dvz(i,j,k)=dvz(i,j,k)+vyg(i,j,k)*(vzg(i,jt,k)-vzg(i,jb,k))*dyinv
        dvz(i,j,k)=dvz(i,j,k)+vzg(i,j,k)*(vzg(i,j,kt)-vzg(i,j,kb))*dyinv

        enddo
        enddo
        enddo

111	continue

	do k=1,nx
	do j=1,ny
	do i=1,nz
	vxg(i,j,k)=-aux1(i,j,k)
	vyg(i,j,k)=-aux2(i,j,k)
	vzg(i,j,k)=-aux3(i,j,k)
	enddo
	enddo
	enddo




	return
	end

