subroutine diff_fft(npart,anu,delt,xp1,yp1,zp1,om1,om2,om3,dv1,omax2)

  !	calcul fft pour vitesses ET diffusion

  include 'param.i'
  include 'param.h'
  include 'arrays.h'

  dimension xp1(*),yp1(*),zp1(*),dv1(*)
  dimension om1(*),om2(*),om3(*)

  dimension aux3(npg,npg,npg),aux1(npg,npg,npg),aux2(npg,npg,npg)

  parameter(ngx2=npgx/2,ngy2=npgy/2,ngz2=npgz/2)

  complex cfx,cfy,cfz,cux,cuy,cuz,cox,coy,coz,wk
  common/fft/cfx(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  cfy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  cfz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  cox(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  coy(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  coz(0:ngx2,1-ngy2:ngy2,1-ngz2:ngz2),&
  wk(ngx2+1,npgy,npgz)

  pi=3.1415926
  dxinv=0.5/dx
  dyinv=dxinv
  dzinv=dxinv

  !	calucl de fonction courants 3d

  nx2=nx/2
  ny2=ny/2
  nz2=nz/2


  call fftw3d(omg1,cfx,nx,ny,nz,nx2,ny2,nz2,wk,0)
  call fftw3d(omg2,cfy,nx,ny,nz,nx2,ny2,nz2,wk,0)
  call fftw3d(omg3,cfz,nx,ny,nz,nx2,ny2,nz2,wk,0)


  !	coeff de normalisation pour laplacien en spectral

  anudt=anu*delt

  ai=2.*pi/(xmax-xmin)	
  aj=2.*pi/(ymax-ymin)	
  ak=2.*pi/(zmax-zmin)	

  ai2=ai**2
  aj2=aj**2
  ak2=ak**2

  do 10 k=1-nz2,nz2
     rk=float(k)*ak
     do 10 j=1-ny2,ny2
        rj=float(j)*aj
        do 10 i=0,nx2
           ri=float(i)*ai
	       r2=ri**2+rj**2+rk**2
	       r2b=(1.+r2*anudt)
        !	diffusion en fourier
           cox(i,j,k)=cfx(i,j,k)/r2b
           coy(i,j,k)=cfy(i,j,k)/r2b
           coz(i,j,k)=cfz(i,j,k)/r2b
10         continue   


           !	fourier inverse pour vorticite apres difusion
           !	 et creation de particules

           call fftw3d(aux1,cox,nx,ny,nz,nx2,ny2,nz2,wk,1)
           call fftw3d(aux2,coy,nx,ny,nz,nx2,ny2,nz2,wk,1)
           call fftw3d(aux3,coz,nx,ny,nz,nx2,ny2,nz2,wk,1)


           circlim=0.0001
           npart=0
           vol=dx**3
           omax1=0.
           omax2=0.
           do k=1,nx
              do j=1,ny
                 do i=1,nz
                    omg1(i,j,k)=aux1(i,j,k)
                    omg2(i,j,k)=aux2(i,j,k)
                    omg3(i,j,k)=aux3(i,j,k)
                    strength=abs(omg2(i,j,k))+abs(omg1(i,j,k))+abs(omg3(i,j,k))
                    if ((strength.gt.circlim)) then
                       x=xmin+float(i-1)*dx        
                       y=xmin+float(j-1)*dx
                       z=xmin+float(k-1)*dx
                       npart=npart+1
                       xp1(npart)=x
                       yp1(npart)=y
                       zp1(npart)=z
                       dv1(npart)=dx**3
                       om1(npart)=omg1(i,j,k)*vol
                       om2(npart)=omg2(i,j,k)*vol
                       om3(npart)=omg3(i,j,k)*vol
                    endif
                    omax2=amax1(omax2,abs(omg1(i,j,k)))
                    omax2=amax1(omax2,abs(omg2(i,j,k)))
                    omax2=amax1(omax2,abs(omg3(i,j,k)))
                 enddo
              enddo
           enddo
           
           print*, 'OMAX avant et apres DIFF ',omax1,omax2
           return


end subroutine diff_fft

