subroutine drag_surface(drag,anu,j1,j2)

! calcul de force selon x (pour drag)
! termes de surfaces en y= j1 et y=j2 pour la fromule de noca 
!  poru le drag, en supposant omega = O sur le faces z=+-h
! par rapport a noca : facteur 1/2 a mettre en facteur du tout

        include 'param.i'
        include 'param.h'
        include 'arrays.h'

	pi=3.1415926

        j1t=mod(j1+ny,ny)+1
        j1b=mod(j1-2+ny,ny)+1
        j2t=mod(j2+ny,ny)+1
        j2b=mod(j2-2+ny,ny)+1
	y1=ymin+float(j1-1)*dx
	y2=ymin+float(j2-1)*dx
	drag1=0.
	drag2=0.
	drag3=0.
	drag4=0.
	drag5=0.
! faces y=cste (j1 ou j2)
        do i=1,nx
        ii=mod(i-1+nx,nx)+1
        it=mod(i+nx,nx)+1
        ib=mod(i-2+nx,nx)+1
	x=xmin+float(i-1)*dx
        DO k=1,nz
        kk=mod(k-1+nz,nz)+1
        kt=mod(k+nz,nz)+1
        kb=mod(k-2+nz,nz)+1
	z=xmin+float(k-1)*dx
! queqlues derivees aparaissant dans certines integrales
! de surface
	dux1dy=vxg(ii,j1t,kk)-vxg(ii,j1b,kk)
	duy1dx=vyg(it,j1,kk)-vyg(ib,j1,kk)
	dux2dy=vxg(ii,j2t,kk)-vxg(ii,j2b,kk)
	duy2dx=vyg(it,j2,kk)-vyg(ib,j2,kk)
	deltaux1=vxg(it,j1,kk)+vxg(ib,j1,kk)+vxg(ii,j1t,kk)+&
      vxg(ii,j1b,kk)+vxg(ii,j1,kt)+vxg(ii,j1,kb)-6.*vxg(ii,j1,kk)
	deltaux2=vxg(it,j2,kk)+vxg(ib,j2,kk)+vxg(ii,j2t,kk)+&
      vxg(ii,j2b,kk)+vxg(ii,j2,kt)+vxg(ii,j2,kb)-6.*vxg(ii,j2,kk)
! 1ere
	drag1=drag1+2.*vyg(ii,j1,kk)*vxg(ii,j1,kk)
	drag1=drag1-2.*vyg(ii,j2,kk)*vxg(ii,j2,kk)
! 2e
	drag2=drag2+vyg(ii,j1,kk)*&
      (y1*omg3(ii,j1,kk)-z*omg2(ii,j1,kk))
	drag2=drag2-vyg(ii,j2,kk)*&
      (y2*omg3(ii,j2,kk)-z*omg2(ii,j2,kk))
! 3e
	drag3=drag3-omg2(ii,j1,kk)*&
      (y1*vzg(ii,j1,kk)-z*vyg(ii,j1,kk))
	drag3=drag3+omg2(ii,j2,kk)*&
      (y2*vzg(ii,j2,kk)-z*vyg(ii,j2,kk))
! 4e
	drag4=drag4+y1*anu*deltaux1/(dx**2)
	drag4=drag4-y2*anu*deltaux2/(dx**2)
! 5e (attention facteur 2 par raport aux autres -> 2dx devient dx)
	drag5=drag5-anu*(dux1dy+duy1dx)/(dx) 
	drag5=drag5+anu*(dux2dy+duy2dx)/(dx) 
	enddo
	enddo

!  faces z=0 et z=1 pour 2e,3e et4e integrale
	drag2b=0.
	drag3b=0.
	drag4b=0.
        do i=1,nx
        ii=mod(i-1+nx,nx)+1
        it=mod(i+nx,nx)+1
        ib=mod(i-2+nx,nx)+1
        x=xmin+float(i-1)*dx
        do j=j1,j2-1
        jt=mod(j+nz,nz)+1
        jb=mod(j-2+nz,nz)+1
!       queqlues derivees aparaissant dans certines integrales
!       de surface
        deltaux1=vxg(it,j,1)+vxg(ib,j,1)+vxg(ii,jt,1)+&
             vxg(ii,jb,1)+vxg(ii,j,2)+vxg(ii,j,nx)-6.*vxg(ii,j,1)
! 2e integrale
	drag2b=drag2b+(xmax-xmin)*vzg(ii,j,1)*omg2(ii,j,1)
! 3e intergral
	drag3b=drag3b-(xmax-xmin)*vyg(ii,j,1)*omg3(ii,j,1)
! 4e
        drag4b=drag4b-(xmax-xmin)*anu*deltaux1/(dx**2)
	enddo
	enddo

	drag=drag1+drag2+drag3+drag4+drag5+drag2b+drag3b+drag4b

	drag=drag*dx*dx

        cc=4.*dx*dx/(pi*0.2422*0.2422)

	print*,'DRAGSSS ',cc*drag1,cc*drag2,cc*drag3,cc*drag4,cc*drag5
	print*,'DRAGSSS ',cc*drag2b,cc*drag3b,cc*drag4b

	return
	end

