program cylindre

  include 'param.i'
  include 'param.h'
  include 'arrays.h'

  dimension xp(npm),yp(npm),zp(npm),dv(npm)
  dimension omx(npm),omy(npm),omz(npm)
  dimension vx(npm),vy(npm),vz(npm) 
  dimension strx(npm),stry(npm),strz(npm)

  dimension domx(npm),domy(npm),domz(npm)
  !       tableuax supplementaries pour RK
  dimension xp0(npm),yp0(npm),zp0(npm)
  dimension om1(npm),om2(npm),om3(npm)
  dimension strxv(4,npm),stryv(4,npm),strzv(4,npm)
  dimension vxv(4,npm),vyv(4,npm),vzv(4,npm)  
  dimension para(4)
  dimension enstrophy(0:1000),energy(0:1000),divergence(0:1000)  

  data (para(i),i=1,4)/0.5,0.5,1.,0./

  character*30 filevelx,filevely,filevelz


  pi=3.1415926
  pi2=2.*pi



  OPEN(1,file='C_IN.DAT',status='OLD')
  READ(1,*)
  read(1,*) nx
  READ(1,*)
  read(1,*)tstop
  READ(1,*)
  read(1,*)coef_pen
  READ(1,*)
  read(1,*)reynolds
  READ(1,*)
  read(1,*)coef_les
  READ(1,*)
  read(1,*)tvisu
  READ(1,*)
  read(1,*) width


  anu=0.5*0.4844/reynolds
  coef_drag=8./(pi*0.2422*0.2422)
  nit=50000

  close(1)
  tvisu=0.3
  idif=1

  xmin=-0.
  xmax=1.
  ymin=0.
  ymax=1.
  zmin=xmin
  zmax=xmax

  !	dialetre de la spher selon Folke
  diam=(xmax-xmin)*0.2422

  ny=nx
  nz=nx
  dx=(xmax-xmin)/(nx)
  dy=(ymax-ymin)/(ny)
  dz=(zmax-zmin)/(nz)

  delt=0.01


  call init(npart,xp,yp,zp,omx,omy,omz,dv)
  time=0.
  go to 222
  call reinit(npart,xp,yp,zp,omx,omy,omz,dv)
  time=10.
  call velox_fft
  call vfix
  call stretch
222 continue

  OPEN(35,file='DRAGd',status='unknown')

  !      debut des iterations

  tcompt=0.
  istep=0

  do 20 kk=1,nit

     if (kk.gt.1) delt=amin1(0.01,0.25/omax2)
     time=time+delt

     j1=16
     if (nx.eq.256) j1=32
     j2=nx-j1
     call drag(drag1,drag2,drag3,j1,j2)
     call drag_surface(drag4,anu,j1,j2)
     if (kk.gt.1) then
        drag_dudt=(drag1-drag1_0)/delt
        drag_dwdt=0.5*coef_drag*(drag2-drag2_0)/delt
        print*,'DRAGdwdt ',drag_dwdt
        drag_dwdt=drag_dwdt+0.5*coef_drag*drag4
        drag_poreux=2.*coef_pen*drag3/diam
     endif
     print*,' time,  DRAGs ',kk,time,drag_dwdt,drag_poreux
     write(35,*) time,drag_dwdt
     drag2_0=drag2

     deltconv=delt
     delt1=delt/6.

     !    on fait les sous-iterations R.K.

     do 10 i=1,npart
        xp0(i)=xp(i)
        yp0(i)=yp(i)
        zp0(i)=zp(i)
        om1(i)=omx(i)
        om2(i)=omy(i)
        om3(i)=omz(i)
10      continue  

        do  550 ll=1,4     

           call intervm4(npart,vx,vy,vz,xp,yp,zp)
           call intersm4(npart,strx,stry,strz,xp,yp,zp)   

           !      increment des positions et poids correspondant aux sous-ite
           !      RK
           !**********************

           vxmax=0.
           vxmax=-10000.
           vxmin=10000.
           vymax=-10000.
           vymin=10000.
           vzmax=-10000.
           vzmin=10000.
           vzmax=0.
           do 520 i=1,npart
              vxv(ll,i)=vx(i)
              vyv(ll,i)=vy(i)
              vzv(ll,i)=vz(i)
              strxv(ll,i)=dv(i)*strx(i)
              stryv(ll,i)=dv(i)*stry(i)
              strzv(ll,i)=dv(i)*strz(i)
              xp(i)=xp0(i)+para(ll)*deltconv*vx(i)
              if (xp(i).lt.xmin) xp(i)=xp(i)+xmax-xmin
              if (xp(i).gt.xmax) xp(i)=xp(i)-xmax+xmin
              yp(i)=yp0(i)+para(ll)*deltconv*vy(i)
              if (yp(i).lt.ymin) yp(i)=yp(i)+ymax-ymin
              if (yp(i).gt.ymax) yp(i)=yp(i)-ymax+ymin
              zp(i)=zp0(i)+para(ll)*deltconv*vz(i)
              if (zp(i).lt.zmin) zp(i)=zp(i)+zmax-zmin
              if (zp(i).gt.zmax) zp(i)=zp(i)-zmax+zmin
              omx(i)=om1(i)+para(ll)*deltconv*dv(i)*strx(i)
              omy(i)=om2(i)+para(ll)*deltconv*dv(i)*stry(i)
              omz(i)=om3(i)+para(ll)*deltconv*dv(i)*strz(i)
              vxmax=amax1(vxmax,(vx(i)))
              vxmin=amin1(vxmin,(vx(i)))
              vymax=amax1(vymax,(vy(i)))
              vymin=amin1(vymin,(vy(i)))
              vzmax=amax1(vzmax,(vz(i)))
              vzmin=amin1(vzmin,(vz(i)))
520           continue
              !      print*,' vitesses max ',vxmax,vxmin,vymax,vymin,vzmax,vzmin

550           continue

              !      FIN des sous-ite RK
              !**********************

              !      Increments des positions et poids pour
              !      la partie transport-deformation du tourbillon


              xleft=xmax
              xright=xmin
              yleft=ymax
              yright=ymin
              zleft=zmax
              zright=zmin
              do 900 i=1,npart
                 xp(i)=xp0(i)+delt1*(vxv(1,i)+2.*vxv(2,i)+2.*vxv(3,i)+vxv(4,i))
                 yp(i)=yp0(i)+delt1*(vyv(1,i)+2.*vyv(2,i)+2.*vyv(3,i)+vyv(4,i))
                 zp(i)=zp0(i)+delt1*(vzv(1,i)+2.*vzv(2,i)+2.*vzv(3,i)+vzv(4,i))
                 if (xp(i).lt.xmin) xp(i)=xp(i)+xmax-xmin
                 if (xp(i).gt.xmax) xp(i)=xp(i)-xmax+xmin  
                 if (yp(i).lt.ymin) yp(i)=yp(i)+ymax-ymin
                 if (yp(i).gt.ymax) yp(i)=yp(i)-ymax+ymin
                 if (zp(i).lt.zmin) zp(i)=zp(i)+zmax-zmin
                 if (zp(i).gt.zmax) zp(i)=zp(i)-zmax+zmin 
                 omx(i)=om1(i)+delt1*(strxv(1,i)+2.*strxv(2,i)+&
                      2.*strxv(3,i)+strxv(4,i))
                 omy(i)=om2(i)+delt1*(stryv(1,i)+2.*stryv(2,i)+&
                      2.*stryv(3,i)+stryv(4,i))                
                 omz(i)=om3(i)+delt1*(strzv(1,i)+2.*strzv(2,i)+&
                      2.*strzv(3,i)+strzv(4,i))
900              continue




                 !    Remshing +  Diffusion
                 !********************** 

                 ! circlim=0.0001
                 ! circulation mimimum pour troncature de la vorticite dans remaillage
                 circlim=-10.

                 call  remesh_om(npart,omx,omy,omz,xp,yp,zp,dv)

                 call velox_fft
                 call vfix

                 if (time.ge.tstop) then
                    OPEN(33,file='SPEEDz',status='unknown')
                    OPEN(34,file='SPEEDy',status='unknown')
                    do k=1,nx
                       write(33,*) (k-1)*dx,vxg(nx/2,nx/2,k),vxg(1,k,1)
                       write(34,*) (k-1)*dx,vxg(nx/2,k,nx/2),vxg(1,k,nx/2),vxg(1,k,1)
                    enddo
                 endif


                 !       call pen(coef_pen,delt)
                 call pen_diff_fft(coef_pen,npart,anu,delt,xp,yp,zp,omx,omy,omz,dv,omax2)

                 call stretch

                 !       call dif_om(npart,omx,omy,omz,
                 !    1              xp,yp,zp,dv,anu,delt,omax2)

                 ! call diff_fft(npart,anu,delt,
                 !    1                       xp,yp,zp,omx,omy,omz,dv,omax2)

                 print *,' Npart ',npart


                 if (time.ge.tstop) then

                    !       OPEN(33,file='SPEEDz',status='unknown')
                    !       OPEN(34,file='SPEEDy',status='unknown')
                    ! do k=1,nx
                    ! write(33,*) (k-1)*dx,vxg(nx/2,nx/2,k),vxg(1,k,1)
                    ! write(34,*) (k-1)*dx,vxg(nx/2,k,nx/2),vxg(1,k,nx/2),
                    !    1             vxg(1,k,1)
                    ! enddo
                    open(24,file='fileom')
                    umax=0.
                    WRITE(24,'(A)') "# vtk DataFile Version 3.0"
                    WRITE(24,'(A)') "Scalar"
                    WRITE(24,'(A)') "ASCII"
                    WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
                    WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx," ",nx," ",nx
                    WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
                    WRITE(24,*) "SPACING"," ",dx," ",dx," ",dx
                    WRITE(24,*) "POINT_DATA ",nx*nx*nx
                    WRITE(24,'(A)') "SCALARS omg float"
                    WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
                    do k=1,nx
                       do j=1,nx
                          do i=1,nx
                             strength=sqrt(omg1(i,j,k)**2+omg2(i,j,k)**2+omg3(i,j,k)**2)
                             !       strength=sqrt(vxg(i,j,k)**2+vyg(i,j,k)**2+vzg(i,j,k)**2)
                             !               umax=amax1(umax,abs(ug(i,j,k)))
                             write(24,*) amax1(0.00001,strength)
                          enddo
                       enddo
                    enddo
                    close(24)
                    close(33)
                    close(34)
                    ! goto 201
                    ! endif

                    open(2,file='fileomx',form='unformatted',convert='big_endian',status='unknown')
                    open(3,file='fileomy',form='unformatted',convert='big_endian',status='unknown')
                    open(4,file='fileomz',form='unformatted',convert='big_endian',status='unknown')

                    write(2)  ((((omg1(i,j,k)),i=1,nx),j=1,ny),k=1,nz)
                    write(3)  ((((omg2(i,j,k)),i=1,nx),j=1,ny),k=1,nz)
                    write(4)  (((omg3(i,j,k),i=1,nx),j=1,ny),k=1,nz)
                    close(2)
                    close(3)
                    close(4)
                    goto 201

                 endif
                 
20               continue
                 
201              continue
                 stop

end program cylindre
