subroutine reinit(npart,xp,yp,zp,omx,omy,omz,dv)


  include 'param.i'
  include 'param.h'
  include 'arrays.h'



  dimension xp(*),yp(*),zp(*),dv(*)
  dimension omx(*),omy(*),omz(*)

  character*30 rota

  pi=3.1415926
  piinv = 1./( pi)
  pi2=2.*pi      

  xc=(xmin+xmax)/2.
  yc=xc
  zc=xc
  !       rc1=0.1
  rc1=(xmax-xmin)*0.1211

  open(2,file='fileomx',form='unformatted',convert='big_endian',status='unknown')
  open(3,file='fileomy',form='unformatted',convert='big_endian',status='unknown')
  open(4,file='fileomz',form='unformatted',convert='big_endian',status='unknown')

  read(2,*) (((omg1(i,j,k),i=1,nx),j=1,ny),k=1,nz)
  read(3,*) (((omg2(i,j,k),i=1,nx),j=1,ny),k=1,nz)
  read(4,*) (((omg3(i,j,k),i=1,nx),j=1,ny),k=1,nz)
  close(2)
  close(3)
  close(4)

  eps=dx*width
  vol=dx**3
  circlim=0.0001

  npart=0.
  do i=1,nx
     xx=xmin+(float(i)-1.)*dx
     DO j=1,ny
        yy=ymin+(float(j)-1.)*dy     
        DO k=1,nz
           zz=zmin+(float(k)-1.)*dz     
           r1 =sqrt((xx-xc)**2+(yy-yc)**2+(zz-zc)**2)-rc1
           strength=abs(omg2(i,j,k))+abs(omg1(i,j,k))+abs(omg3(i,j,k))
           if ((strength.gt.circlim)) then
              npart=npart+1
              xp(npart)=xx
              yp(npart)=yy
              zp(npart)=zz
              dv(npart)=dx**3
              omx(npart)=omg1(i,j,k)*vol
              omy(npart)=omg2(i,j,k)*vol
              omz(npart)=omg3(i,j,k)*vol
           endif
           phig(i,j,k)=amin1(1.,amax1(1.-r1/eps,0.))
           if ((j.le.4).or.(j.ge.nx-3)) phig(i,j,k)=1.
        end DO
     end DO
  end do
  print*, 'NPART =', npart
  return
end subroutine reinit


