	SUBROUTINE  remeshdif(npart,circlim,om1,om2,om3,xp,yp,zp,dv,anu,delt)

!   This subroutine asssigns vorticity on a grid
!----------------------------------------------------------------

	include 'param.i'
	include 'param.h'
	include 'arrays.h'



	dimension om1(*),om2(*),om3(*),xp(*),yp(*),zp(*),dv(*)
        dimension dom1(npm),dom2(npm),dom3(npm)
	integer indx(npm),indy(npm),indz(npm)



	pi=3.1415926

	do 10 k=1,nz
	do 10 j=1,ny
	do 10 i=1,nx
	omg1(i,j,k)=0.
	omg2(i,j,k)=0.
	omg3(i,j,k)=0.
10	continue

	dxinv=1./dx
	dyinv=1./dy
	dzinv=1./dz



!-------------------------------------------------------------------- 
!- PART II : Determination of  the  circulation  of each particle
!-------------------------------------------------------------------- 

!x0=xmin-.5*dx
!y0=ymin-.5*dy
!z0=zmin-.5*dz

	x0=xmin
	y0=ymin
	z0=zmin
	
	xm=xmax-xmin
	ym=ymax-ymin
	zm=zmax-zmin

	 DO 20 n = 1,npart

            g1 = om1(n)
            g2 = om2(n)
            g3 = om3(n)
            x = xp(n)
            y = yp(n)
            z = zp(n)

            ip1 = int((x-x0)*dxinv) 
            jp1 = int((y-y0)*dyinv) 
            kp1 = int((z-z0)*dzinv)

            ip0 = ip1 - 1
            jp0 = jp1 - 1
            kp0 = kp1 - 1

            ip2 = ip1 + 1
	    jp2 = jp1 + 1
	    kp2 = kp1 + 1

            ip3 = ip1 + 2
	    jp3 = jp1 + 2
	    kp3 = kp1 + 2

!Assign the circulations to the nine neighboring cells

	   xx1 = (x - float(ip1)*dx-x0)*dxinv
	   yy1 = (y - float(jp1)*dy-y0)*dyinv
	   zz1 = (z - float(kp1)*dz-z0)*dzinv

	   xx0=xx1+1.
	   yy0=yy1+1.
	   zz0=zz1+1.

	   xx2=1.-xx1
	   yy2=1.-yy1
	   zz2=1.-zz1

	   xx3=2.-xx1
	   yy3=2.-yy1
	   zz3=2.-zz1


!	on repositionne les points de grille par periodicite
!entre 0 et npx-1, puis on numerote de 1 a npx

	ip1=mod(ip1+nx,nx) +1 
	ip0=mod(ip0+nx,nx) +1
	ip2=mod(ip2+nx,nx) +1
	ip3=mod(ip3+nx,nx) +1

	jp1=mod(jp1+ny,ny) +1 
	jp0=mod(jp0+ny,ny) +1
	jp2=mod(jp2+ny,ny) +1
	jp3=mod(jp3+ny,ny) +1

	kp1=mod(kp1+nz,nz) +1 
	kp0=mod(kp0+nz,nz) +1
	kp2=mod(kp2+nz,nz) +1
	kp3=mod(kp3+nz,nz) +1

!The M'4 scheme
 
           a0 = .5*((2.-xx0)**2)*(1.-xx0)
           b0 = .5*((2.-yy0)**2)*(1.-yy0)
           c0 = .5*((2.-zz0)**2)*(1.-zz0)

           a1 = 1.-2.5*xx1*xx1 +  1.5*xx1*xx1*xx1
           b1 = 1.-2.5*yy1*yy1 +  1.5*yy1*yy1*yy1
           c1 = 1.-2.5*zz1*zz1 +  1.5*zz1*zz1*zz1

           a2 = 1.-2.5*xx2*xx2 +  1.5*xx2*xx2*xx2
           b2 = 1.-2.5*yy2*yy2 +  1.5*yy2*yy2*yy2
           c2 = 1.-2.5*zz2*zz2 +  1.5*zz2*zz2*zz2

           a3 = .5*((2.-xx3)**2)*(1.-xx3)
           b3 = .5*((2.-yy3)**2)*(1.-yy3)
           c3 = .5*((2.-zz3)**2)*(1.-zz3)

	   coef=a0*b0*c0
	   omg1(ip0,jp0,kp0) = omg1(ip0,jp0,kp0) + g1*coef
	   omg2(ip0,jp0,kp0) = omg2(ip0,jp0,kp0) + g2*coef
	   omg3(ip0,jp0,kp0) = omg3(ip0,jp0,kp0) + g3*coef

	   coef=a0*b0*c1
	   omg1(ip0,jp0,kp1) = omg1(ip0,jp0,kp1) + g1*coef
	   omg2(ip0,jp0,kp1) = omg2(ip0,jp0,kp1) + g2*coef
	   omg3(ip0,jp0,kp1) = omg3(ip0,jp0,kp1) + g3*coef

	   coef=a0*b0*c2
	   omg1(ip0,jp0,kp2) = omg1(ip0,jp0,kp2) + g1*coef
	   omg2(ip0,jp0,kp2) = omg2(ip0,jp0,kp2) + g2*coef
	   omg3(ip0,jp0,kp2) = omg3(ip0,jp0,kp2) + g3*coef

	   coef=a0*b0*c3
	   omg1(ip0,jp0,kp3) = omg1(ip0,jp0,kp3) + g1*coef
	   omg2(ip0,jp0,kp3) = omg2(ip0,jp0,kp3) + g2*coef
	   omg3(ip0,jp0,kp3) = omg3(ip0,jp0,kp3) + g3*coef


           coef=a0*b1*c0
           omg1(ip0,jp1,kp0) = omg1(ip0,jp1,kp0) + g1*coef
           omg2(ip0,jp1,kp0) = omg2(ip0,jp1,kp0) + g2*coef
           omg3(ip0,jp1,kp0) = omg3(ip0,jp1,kp0) + g3*coef

           coef=a0*b1*c1
           omg1(ip0,jp1,kp1) = omg1(ip0,jp1,kp1) + g1*coef
           omg2(ip0,jp1,kp1) = omg2(ip0,jp1,kp1) + g2*coef
           omg3(ip0,jp1,kp1) = omg3(ip0,jp1,kp1) + g3*coef

           coef=a0*b1*c2
           omg1(ip0,jp1,kp2) = omg1(ip0,jp1,kp2) + g1*coef
           omg2(ip0,jp1,kp2) = omg2(ip0,jp1,kp2) + g2*coef
           omg3(ip0,jp1,kp2) = omg3(ip0,jp1,kp2) + g3*coef

           coef=a0*b1*c3
           omg1(ip0,jp1,kp3) = omg1(ip0,jp1,kp3) + g1*coef
           omg2(ip0,jp1,kp3) = omg2(ip0,jp1,kp3) + g2*coef
           omg3(ip0,jp1,kp3) = omg3(ip0,jp1,kp3) + g3*coef

           coef=a0*b2*c0
           omg1(ip0,jp2,kp0) = omg1(ip0,jp2,kp0) + g1*coef
           omg2(ip0,jp2,kp0) = omg2(ip0,jp2,kp0) + g2*coef
           omg3(ip0,jp2,kp0) = omg3(ip0,jp2,kp0) + g3*coef

           coef=a0*b2*c1
           omg1(ip0,jp2,kp1) = omg1(ip0,jp2,kp1) + g1*coef
           omg2(ip0,jp2,kp1) = omg2(ip0,jp2,kp1) + g2*coef
           omg3(ip0,jp2,kp1) = omg3(ip0,jp2,kp1) + g3*coef

           coef=a0*b2*c2
           omg1(ip0,jp2,kp2) = omg1(ip0,jp2,kp2) + g1*coef
           omg2(ip0,jp2,kp2) = omg2(ip0,jp2,kp2) + g2*coef
           omg3(ip0,jp2,kp2) = omg3(ip0,jp2,kp2) + g3*coef

           coef=a0*b2*c3
           omg1(ip0,jp2,kp3) = omg1(ip0,jp2,kp3) + g1*coef
           omg2(ip0,jp2,kp3) = omg2(ip0,jp2,kp3) + g2*coef
           omg3(ip0,jp2,kp3) = omg3(ip0,jp2,kp3) + g3*coef

           coef=a0*b3*c0
           omg1(ip0,jp3,kp0) = omg1(ip0,jp3,kp0) + g1*coef
           omg2(ip0,jp3,kp0) = omg2(ip0,jp3,kp0) + g2*coef
           omg3(ip0,jp3,kp0) = omg3(ip0,jp3,kp0) + g3*coef

           coef=a0*b3*c1
           omg1(ip0,jp3,kp1) = omg1(ip0,jp3,kp1) + g1*coef
           omg2(ip0,jp3,kp1) = omg2(ip0,jp3,kp1) + g2*coef
           omg3(ip0,jp3,kp1) = omg3(ip0,jp3,kp1) + g3*coef

           coef=a0*b3*c2
           omg1(ip0,jp3,kp2) = omg1(ip0,jp3,kp2) + g1*coef
           omg2(ip0,jp3,kp2) = omg2(ip0,jp3,kp2) + g2*coef
           omg3(ip0,jp3,kp2) = omg3(ip0,jp3,kp2) + g3*coef

           coef=a0*b3*c3
           omg1(ip0,jp3,kp3) = omg1(ip0,jp3,kp3) + g1*coef
           omg2(ip0,jp3,kp3) = omg2(ip0,jp3,kp3) + g2*coef
           omg3(ip0,jp3,kp3) = omg3(ip0,jp3,kp3) + g3*coef

           coef=a1*b0*c0
           omg1(ip1,jp0,kp0) = omg1(ip1,jp0,kp0) + g1*coef
           omg2(ip1,jp0,kp0) = omg2(ip1,jp0,kp0) + g2*coef
           omg3(ip1,jp0,kp0) = omg3(ip1,jp0,kp0) + g3*coef

           coef=a1*b0*c1
           omg1(ip1,jp0,kp1) = omg1(ip1,jp0,kp1) + g1*coef
           omg2(ip1,jp0,kp1) = omg2(ip1,jp0,kp1) + g2*coef
           omg3(ip1,jp0,kp1) = omg3(ip1,jp0,kp1) + g3*coef

           coef=a1*b0*c2
           omg1(ip1,jp0,kp2) = omg1(ip1,jp0,kp2) + g1*coef
           omg2(ip1,jp0,kp2) = omg2(ip1,jp0,kp2) + g2*coef
           omg3(ip1,jp0,kp2) = omg3(ip1,jp0,kp2) + g3*coef

           coef=a1*b0*c3
           omg1(ip1,jp0,kp3) = omg1(ip1,jp0,kp3) + g1*coef
           omg2(ip1,jp0,kp3) = omg2(ip1,jp0,kp3) + g2*coef
           omg3(ip1,jp0,kp3) = omg3(ip1,jp0,kp3) + g3*coef

           coef=a1*b1*c0
           omg1(ip1,jp1,kp0) = omg1(ip1,jp1,kp0) + g1*coef
           omg2(ip1,jp1,kp0) = omg2(ip1,jp1,kp0) + g2*coef
           omg3(ip1,jp1,kp0) = omg3(ip1,jp1,kp0) + g3*coef

           coef=a1*b1*c1
           omg1(ip1,jp1,kp1) = omg1(ip1,jp1,kp1) + g1*coef
           omg2(ip1,jp1,kp1) = omg2(ip1,jp1,kp1) + g2*coef
           omg3(ip1,jp1,kp1) = omg3(ip1,jp1,kp1) + g3*coef

           coef=a1*b1*c2
           omg1(ip1,jp1,kp2) = omg1(ip1,jp1,kp2) + g1*coef
           omg2(ip1,jp1,kp2) = omg2(ip1,jp1,kp2) + g2*coef
           omg3(ip1,jp1,kp2) = omg3(ip1,jp1,kp2) + g3*coef

           coef=a1*b1*c3
           omg1(ip1,jp1,kp3) = omg1(ip1,jp1,kp3) + g1*coef
           omg2(ip1,jp1,kp3) = omg2(ip1,jp1,kp3) + g2*coef
           omg3(ip1,jp1,kp3) = omg3(ip1,jp1,kp3) + g3*coef


           coef=a1*b2*c0
           omg1(ip1,jp2,kp0) = omg1(ip1,jp2,kp0) + g1*coef
           omg2(ip1,jp2,kp0) = omg2(ip1,jp2,kp0) + g2*coef
           omg3(ip1,jp2,kp0) = omg3(ip1,jp2,kp0) + g3*coef

           coef=a1*b2*c1
           omg1(ip1,jp2,kp1) = omg1(ip1,jp2,kp1) + g1*coef
           omg2(ip1,jp2,kp1) = omg2(ip1,jp2,kp1) + g2*coef
           omg3(ip1,jp2,kp1) = omg3(ip1,jp2,kp1) + g3*coef

           coef=a1*b2*c2
           omg1(ip1,jp2,kp2) = omg1(ip1,jp2,kp2) + g1*coef
           omg2(ip1,jp2,kp2) = omg2(ip1,jp2,kp2) + g2*coef
           omg3(ip1,jp2,kp2) = omg3(ip1,jp2,kp2) + g3*coef

           coef=a1*b2*c3
           omg1(ip1,jp2,kp3) = omg1(ip1,jp2,kp3) + g1*coef
           omg2(ip1,jp2,kp3) = omg2(ip1,jp2,kp3) + g2*coef
           omg3(ip1,jp2,kp3) = omg3(ip1,jp2,kp3) + g3*coef

           coef=a1*b3*c0
           omg1(ip1,jp3,kp0) = omg1(ip1,jp3,kp0) + g1*coef
           omg2(ip1,jp3,kp0) = omg2(ip1,jp3,kp0) + g2*coef
           omg3(ip1,jp3,kp0) = omg3(ip1,jp3,kp0) + g3*coef

           coef=a1*b3*c1
           omg1(ip1,jp3,kp1) = omg1(ip1,jp3,kp1) + g1*coef
           omg2(ip1,jp3,kp1) = omg2(ip1,jp3,kp1) + g2*coef
           omg3(ip1,jp3,kp1) = omg3(ip1,jp3,kp1) + g3*coef

           coef=a1*b3*c2
           omg1(ip1,jp3,kp2) = omg1(ip1,jp3,kp2) + g1*coef
           omg2(ip1,jp3,kp2) = omg2(ip1,jp3,kp2) + g2*coef
           omg3(ip1,jp3,kp2) = omg3(ip1,jp3,kp2) + g3*coef

           coef=a1*b3*c3
           omg1(ip1,jp3,kp3) = omg1(ip1,jp3,kp3) + g1*coef
           omg2(ip1,jp3,kp3) = omg2(ip1,jp3,kp3) + g2*coef
           omg3(ip1,jp3,kp3) = omg3(ip1,jp3,kp3) + g3*coef

           coef=a2*b0*c0
           omg1(ip2,jp0,kp0) = omg1(ip2,jp0,kp0) + g1*coef
           omg2(ip2,jp0,kp0) = omg2(ip2,jp0,kp0) + g2*coef
           omg3(ip2,jp0,kp0) = omg3(ip2,jp0,kp0) + g3*coef

           coef=a2*b0*c1
           omg1(ip2,jp0,kp1) = omg1(ip2,jp0,kp1) + g1*coef
           omg2(ip2,jp0,kp1) = omg2(ip2,jp0,kp1) + g2*coef
           omg3(ip2,jp0,kp1) = omg3(ip2,jp0,kp1) + g3*coef

           coef=a2*b0*c2
           omg1(ip2,jp0,kp2) = omg1(ip2,jp0,kp2) + g1*coef
           omg2(ip2,jp0,kp2) = omg2(ip2,jp0,kp2) + g2*coef
           omg3(ip2,jp0,kp2) = omg3(ip2,jp0,kp2) + g3*coef

           coef=a2*b0*c3
           omg1(ip2,jp0,kp3) = omg1(ip2,jp0,kp3) + g1*coef
           omg2(ip2,jp0,kp3) = omg2(ip2,jp0,kp3) + g2*coef
           omg3(ip2,jp0,kp3) = omg3(ip2,jp0,kp3) + g3*coef

           coef=a2*b1*c0
           omg1(ip2,jp1,kp0) = omg1(ip2,jp1,kp0) + g1*coef
           omg2(ip2,jp1,kp0) = omg2(ip2,jp1,kp0) + g2*coef
           omg3(ip2,jp1,kp0) = omg3(ip2,jp1,kp0) + g3*coef

           coef=a2*b1*c1
           omg1(ip2,jp1,kp1) = omg1(ip2,jp1,kp1) + g1*coef
           omg2(ip2,jp1,kp1) = omg2(ip2,jp1,kp1) + g2*coef
           omg3(ip2,jp1,kp1) = omg3(ip2,jp1,kp1) + g3*coef

           coef=a2*b1*c2
           omg1(ip2,jp1,kp2) = omg1(ip2,jp1,kp2) + g1*coef
           omg2(ip2,jp1,kp2) = omg2(ip2,jp1,kp2) + g2*coef
           omg3(ip2,jp1,kp2) = omg3(ip2,jp1,kp2) + g3*coef

           coef=a2*b1*c3
           omg1(ip2,jp1,kp3) = omg1(ip2,jp1,kp3) + g1*coef
           omg2(ip2,jp1,kp3) = omg2(ip2,jp1,kp3) + g2*coef
           omg3(ip2,jp1,kp3) = omg3(ip2,jp1,kp3) + g3*coef

           coef=a2*b2*c0
           omg1(ip2,jp2,kp0) = omg1(ip2,jp2,kp0) + g1*coef
           omg2(ip2,jp2,kp0) = omg2(ip2,jp2,kp0) + g2*coef
           omg3(ip2,jp2,kp0) = omg3(ip2,jp2,kp0) + g3*coef

           coef=a2*b2*c1
           omg1(ip2,jp2,kp1) = omg1(ip2,jp2,kp1) + g1*coef
           omg2(ip2,jp2,kp1) = omg2(ip2,jp2,kp1) + g2*coef
           omg3(ip2,jp2,kp1) = omg3(ip2,jp2,kp1) + g3*coef

           coef=a2*b2*c2
           omg1(ip2,jp2,kp2) = omg1(ip2,jp2,kp2) + g1*coef
           omg2(ip2,jp2,kp2) = omg2(ip2,jp2,kp2) + g2*coef
           omg3(ip2,jp2,kp2) = omg3(ip2,jp2,kp2) + g3*coef

           coef=a2*b2*c3
           omg1(ip2,jp2,kp3) = omg1(ip2,jp2,kp3) + g1*coef
           omg2(ip2,jp2,kp3) = omg2(ip2,jp2,kp3) + g2*coef
           omg3(ip2,jp2,kp3) = omg3(ip2,jp2,kp3) + g3*coef

           coef=a2*b3*c0
           omg1(ip2,jp3,kp0) = omg1(ip2,jp3,kp0) + g1*coef
           omg2(ip2,jp3,kp0) = omg2(ip2,jp3,kp0) + g2*coef
           omg3(ip2,jp3,kp0) = omg3(ip2,jp3,kp0) + g3*coef

           coef=a2*b3*c1
           omg1(ip2,jp3,kp1) = omg1(ip2,jp3,kp1) + g1*coef
           omg2(ip2,jp3,kp1) = omg2(ip2,jp3,kp1) + g2*coef
           omg3(ip2,jp3,kp1) = omg3(ip2,jp3,kp1) + g3*coef

           coef=a2*b3*c2
           omg1(ip2,jp3,kp2) = omg1(ip2,jp3,kp2) + g1*coef
           omg2(ip2,jp3,kp2) = omg2(ip2,jp3,kp2) + g2*coef
           omg3(ip2,jp3,kp2) = omg3(ip2,jp3,kp2) + g3*coef

           coef=a2*b3*c3
           omg1(ip2,jp3,kp3) = omg1(ip2,jp3,kp3) + g1*coef
           omg2(ip2,jp3,kp3) = omg2(ip2,jp3,kp3) + g2*coef
           omg3(ip2,jp3,kp3) = omg3(ip2,jp3,kp3) + g3*coef

           coef=a3*b0*c0
           omg1(ip3,jp0,kp0) = omg1(ip3,jp0,kp0) + g1*coef
           omg2(ip3,jp0,kp0) = omg2(ip3,jp0,kp0) + g2*coef
           omg3(ip3,jp0,kp0) = omg3(ip3,jp0,kp0) + g3*coef

           coef=a3*b0*c1
           omg1(ip3,jp0,kp1) = omg1(ip3,jp0,kp1) + g1*coef
           omg2(ip3,jp0,kp1) = omg2(ip3,jp0,kp1) + g2*coef
           omg3(ip3,jp0,kp1) = omg3(ip3,jp0,kp1) + g3*coef

           coef=a3*b0*c2
           omg1(ip3,jp0,kp2) = omg1(ip3,jp0,kp2) + g1*coef
           omg2(ip3,jp0,kp2) = omg2(ip3,jp0,kp2) + g2*coef
           omg3(ip3,jp0,kp2) = omg3(ip3,jp0,kp2) + g3*coef

           coef=a3*b0*c3
           omg1(ip3,jp0,kp3) = omg1(ip3,jp0,kp3) + g1*coef
           omg2(ip3,jp0,kp3) = omg2(ip3,jp0,kp3) + g2*coef
           omg3(ip3,jp0,kp3) = omg3(ip3,jp0,kp3) + g3*coef

           coef=a3*b1*c0
           omg1(ip3,jp1,kp0) = omg1(ip3,jp1,kp0) + g1*coef
           omg2(ip3,jp1,kp0) = omg2(ip3,jp1,kp0) + g2*coef
           omg3(ip3,jp1,kp0) = omg3(ip3,jp1,kp0) + g3*coef

           coef=a3*b1*c1
           omg1(ip3,jp1,kp1) = omg1(ip3,jp1,kp1) + g1*coef
           omg2(ip3,jp1,kp1) = omg2(ip3,jp1,kp1) + g2*coef
           omg3(ip3,jp1,kp1) = omg3(ip3,jp1,kp1) + g3*coef

           coef=a3*b1*c2
           omg1(ip3,jp1,kp2) = omg1(ip3,jp1,kp2) + g1*coef
           omg2(ip3,jp1,kp2) = omg2(ip3,jp1,kp2) + g2*coef
           omg3(ip3,jp1,kp2) = omg3(ip3,jp1,kp2) + g3*coef

           coef=a3*b1*c3
           omg1(ip3,jp1,kp3) = omg1(ip3,jp1,kp3) + g1*coef
           omg2(ip3,jp1,kp3) = omg2(ip3,jp1,kp3) + g2*coef
           omg3(ip3,jp1,kp3) = omg3(ip3,jp1,kp3) + g3*coef

          coef=a3*b2*c0
           omg1(ip3,jp2,kp0) = omg1(ip3,jp2,kp0) + g1*coef
           omg2(ip3,jp2,kp0) = omg2(ip3,jp2,kp0) + g2*coef
           omg3(ip3,jp2,kp0) = omg3(ip3,jp2,kp0) + g3*coef

           coef=a3*b2*c1
           omg1(ip3,jp2,kp1) = omg1(ip3,jp2,kp1) + g1*coef
           omg2(ip3,jp2,kp1) = omg2(ip3,jp2,kp1) + g2*coef
           omg3(ip3,jp2,kp1) = omg3(ip3,jp2,kp1) + g3*coef

           coef=a3*b2*c2
           omg1(ip3,jp2,kp2) = omg1(ip3,jp2,kp2) + g1*coef
           omg2(ip3,jp2,kp2) = omg2(ip3,jp2,kp2) + g2*coef
           omg3(ip3,jp2,kp2) = omg3(ip3,jp2,kp2) + g3*coef

           coef=a3*b2*c3
           omg1(ip3,jp2,kp3) = omg1(ip3,jp2,kp3) + g1*coef
           omg2(ip3,jp2,kp3) = omg2(ip3,jp2,kp3) + g2*coef
           omg3(ip3,jp2,kp3) = omg3(ip3,jp2,kp3) + g3*coef

           coef=a3*b3*c0
           omg1(ip3,jp3,kp0) = omg1(ip3,jp3,kp0) + g1*coef
           omg2(ip3,jp3,kp0) = omg2(ip3,jp3,kp0) + g2*coef
           omg3(ip3,jp3,kp0) = omg3(ip3,jp3,kp0) + g3*coef

           coef=a3*b3*c1
           omg1(ip3,jp3,kp1) = omg1(ip3,jp3,kp1) + g1*coef
           omg2(ip3,jp3,kp1) = omg2(ip3,jp3,kp1) + g2*coef
           omg3(ip3,jp3,kp1) = omg3(ip3,jp3,kp1) + g3*coef

           coef=a3*b3*c2
           omg1(ip3,jp3,kp2) = omg1(ip3,jp3,kp2) + g1*coef
           omg2(ip3,jp3,kp2) = omg2(ip3,jp3,kp2) + g2*coef
           omg3(ip3,jp3,kp2) = omg3(ip3,jp3,kp2) + g3*coef

           coef=a3*b3*c3
           omg1(ip3,jp3,kp3) = omg1(ip3,jp3,kp3) + g1*coef
           omg2(ip3,jp3,kp3) = omg2(ip3,jp3,kp3) + g2*coef
           omg3(ip3,jp3,kp3) = omg3(ip3,jp3,kp3) + g3*coef

20      CONTINUE

	npart=0

	do k=1,nz
	z=amod(z0-zmin+(k-1)*dz+zm,zm)+zmin 
	do j=1,ny
	y=amod(y0-ymin+(j-1)*dy+ym,ym)+ymin 
	do i=1,nx
	x=amod(x0-xmin+(i-1)*dx+xm,xm)+xmin 
	vol=dx*dy*dz
        strength=abs(omg1(i,j,k))+abs(omg2(i,j,k))+abs(omg3(i,j,k))
	if ((strength.ge.circlim*vol)) then
        npart=npart+1
        indx(npart)=i
        indy(npart)=j
        indz(npart)=k
        xp(npart)=x
        yp(npart)=y
        zp(npart)=z
        dv(npart)=vol
	om1(npart)=omg1(i,j,k)
	om2(npart)=omg2(i,j,k)
	om3(npart)=omg3(i,j,k)
	endif
	enddo
	enddo
	enddo


!      goto 310


!      dans la foulee on fiat la diffusion dans l'espace
!      mappee avec formules de diffusion anisotropes

!      pas de temps de diffusion pour CFL

!      coeff aspect ratio pour se mettre dans une grille
!      totalement isotrope et coeff de normalisation
!	pour kernel 1/(1+r**2)
        dzdx=(dz/dx)**2
        dzdy=(dz/dy)**2
	trace=dzdx+dzdy+1.

        alpha=3.333333
        beta=5.666667
        alambda=2./(beta-alpha)
        amu=-2.*alpha/((beta-alpha)*(2.*alpha+beta))       
                                    
!      boucle sur les receveurs


        tot=0.

        do i=1,npart
        dom1(i)=0.
        dom2(i)=0.
        dom3(i)=0.
        tot2=0.

        ii=indx(i)
        jj=indy(i)
        kk=indz(i)
        gammarcv1=om1(i)
        gammarcv2=om2(i)
        gammarcv3=om3(i)
	vxrcv=vxg(ii,jj,kk)
	vyrcv=vyg(ii,jj,kk)
	vzrcv=vzg(ii,jj,kk)

!      boucle sur les 27 sources
           do lx=-1,1
           do ly=-1,1
           do lz=-1,1
        i2=mod(ii+lx+nx-1,nx)+1
        j2=mod(jj+ly+ny-1,ny)+1
        k2=mod(kk+lz+nz-1,nz)+1
           gammasrc1=omg1(i2,j2,k2)
           gammasrc2=omg2(i2,j2,k2)
           gammasrc3=omg3(i2,j2,k2)
	   vxsrc=vxg(i2,j2,k2)
	   vysrc=vyg(i2,j2,k2)
	   vzsrc=vzg(i2,j2,k2)
           r=lx**2+ly**2+lz**2
        am1=alambda*dzdx+amu*trace
        am2=alambda*dzdy+amu*trace
        am3=alambda+amu*trace
        akernel=((lx**2)*am1+(ly**2)*am2+(lz**2)*am3)/(1.+r)
        factor=akernel/(dz*dz)
        tot2=tot2+akernel
        dom1(i)=dom1(i)+(gammasrc1-gammarcv1)*(anu*factor)
        dom2(i)=dom2(i)+(gammasrc2-gammarcv2)*(anu*factor)
        dom3(i)=dom3(i)+(gammasrc3-gammarcv3)*(anu*factor)

        enddo
        enddo
        enddo
        tot=amax1(tot,tot2*dy*dx*dz/dv(i))

!      enddo pour caluc de dom sur les particules
        enddo
                                                               
                                    

        omax0=0.
        omax1=0.

        do i=1,npart
        omax0=amax1(omax0,abs(om1(i))/dv(i))
       omax0=amax1(omax0,abs(om2(i))/dv(i))
       omax0=amax1(omax0,abs(om3(i))/dv(i))
        om1(i)=om1(i)+delt*dom1(i)
        om2(i)=om2(i)+delt*dom2(i)
        om3(i)=om3(i)+delt*dom3(i)
       omax1=amax1(omax1,abs(om1(i))/dv(i))
       omax1=amax1(omax1,abs(om2(i))/dv(i))
       omax1=amax1(omax1,abs(om3(i))/dv(i))
        enddo

        print*, 'OMAX avant et apres diff ', omax0,omax1
        if (omax1.gt.omax0) print*, '****** ATTENTION DIFFUSION'


310	continue

	RETURN
	END
