module init_mod
  !
  !initialisation des valeurs sur la grille
  !
contains
  subroutine init_grille
    use donnees_mod
    use tab_mod
    implicit none
    integer        :: i,j
    real(kind=8)   :: x,y,xt,yt,beta,t1,t2,t3,r

    !---gaussienne---------
    !-----------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=(1.-(x**2+y**2))**6
!!$          if ((x**2+y**2)>1.) qg(i,j)=0.   
!!$        
!!$         
!!$       end do
!!$    end do

    !---gaussienne pour Staniford sur [0,1]^2-----------
    !----------------------------------------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=0.
!!$
!!$          qg(i,j)=(1.-((x-0.5)**2+(y-0.5)**2))**6
!!$          if (((x-0.5)**2+(y-0.5)**2)>1.) qg(i,j)=0.
!!$         
!!$       end do
!!$    end do
!!$
!!$    !---test sur [0,1]^2-----------
!!$    !----------------------------------------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=0.
!!$
!!$          qg(i,j)=(1.-((x-0.5)**2+(y-0.5)**2))**2
!!$          if (((x-0.5)**2+(y-0.5)**2)>1.) qg(i,j)=0.
!!$         
!!$       end do
!!$    end do
!!$
    !---constante-----------
    !-----------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=1.
!!$          if ((x**2+y**2)>1.) qg(i,j)=0.
!!$       end do
!!$    end do
!!$
!!$    !---gaussienne pour filaments sur [0,1]^2-----------
!!$    !----------------------------------------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=0.
!!$
!!$          qg(i,j)=(1.-((x-0.5)**2+(y-0.8)**2))**6
!!$          if (((x-0.5)**2+(y-0.5)**2)>1.) qg(i,j)=0.
!!$         
!!$       end do
!!$    end do


    !---cercle pour filaments sur [0,1]^2-----------
    !----------------------------------------------------
    
!!$    do j=1,ny
!!$       do i=1,nx
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=0.
!!$
!!$          if (sqrt((x-0.5)**2+(y-0.75)**2)<=0.15) qg(i,j)=1.  
!!$         
!!$       end do
!!$    end do


    !-----------Analytique en cos--------------------------
    !------------------------------------------------------
!!$    t1=1.
!!$    t2=1.
!!$    t3=0.2
!!$    do j=1,ny
!!$       do i=1,nx
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          qg(i,j)=cos(pi*time/t3)*cos(2.*pi*x/t1)*cos(2.*pi*y/t2)         
!!$       end do
!!$    end do

    !---anneau-----------
    !-----------------------
!!$    do i=1,nx
!!$       do j=1,ny
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          r=sqrt(x**2+y**2)
!!$          qg(i,j)=0.
!!$          !if ( (r>0.5).and.(r<1.4) ) qg(i,j)=1.
!!$          !if ( (r>0.).and.(r<0.8) ) qg(i,j)=1.
!!$          !if ( (r>=1.).and.(r<1.5) ) qg(i,j)=1.
!!$          if ( (r>0.5).and.(r<1.) ) qg(i,j)=1.
!!$       end do
!!$    end do

    !---anneau- regulier----------
    !-----------------------
    do i=1,nx
       do j=1,ny
          x=xtab(i,j)
          y=ytab(i,j)
          r=sqrt(x**2+y**2)
          qg(i,j)=0.
          if ( (r>0.4).and.(r<0.6) ) qg(i,j)=-512.+5400.*r-22500.*r**2+46250*r**3-46875*r**4+18750*r**5
          if ( (r>=0.6).and.(r<=0.8) ) qg(i,j)=1.
          if ( (r>0.8).and.(r<1.) ) qg(i,j)=10625.-60000*r+135000*r**2-151250*r**3+84375*r**4-18750*r**5

          !if ( (r>0.4).and.(r<1.) ) qg(i,j)=1.
       end do
    end do


  end subroutine init_grille



end module init_mod
