program split
  !--------------------------------------------------------------------------
  !etude de l'ordre pour splitting
  !
  !--------------------------------------------------------------------------
  use donnees_mod         ! donnees 
  use tab_mod             ! donnees dans tableaux 
  use init_mod            ! init_grille
  use advection_mod       ! crea_part,advection
  use remaillage_mod      ! remaill_4m_centre (formules de remaillage)
  use interpolation_mod   ! formules d'interpolation (pour range kutta)
  use resultats_mod       ! res_grille_tps,res_grille_freq
  use utile_mod           ! fonctions en tout genre

  real(kind=8)        :: x,y,dt_deb,dt_boucle,dtsauv,maxv
  character(len=50)   :: name_err,name_coupe
  integer             :: i,j,cpt_ite,ib,jb,nx_boucle

  real(kind=8)        :: deb,masse,t1,t2,t3


  !lecture données
  !---------------
  open(unit=10,file="parameter",form="formatted")
  read(10,*) xg,xd,yb,yh   
  read(10,*) tfin   
  read(10,*) cutoff
  read(10,*) type_b
  read(10,*) long_bloc
  read(10,*) int_limit
  read(10,*) nom_fich_vtk
  read(10,*) name_err,name_coupe
  close(10)


  erreur:do nx_boucle=201,201
  !erreur:do nx_boucle=10,5000,30   
  !erreur:do nx_boucle=10,5000,100   
     !nx=(long_bloc+1)*k+1 => bloc bord de bonne taille

     open(unit=10,file="parameter",form="formatted")
     read(10,*) xg,xd,yb,yh 
     close (10)

     nx=nx_boucle
     ny=nx_boucle

     !nx_gro=nx/2
     nx_gro=nx
     ny_gro=nx_gro

     dx=(xd-xg)/(nx-1.)
     dy=(yh-yb)/(ny-1.)

     dx_gro=(xd-xg)/(nx_gro-1.)
     dy_gro=(yh-yb)/(ny_gro-1.)

     maxv=1.
     !maxv=2.
     cfl=3.

     dt=cfl*dx/maxv
     !dt=0.0001
     dt_deb=dt


!!$
!!$
!!$
!!$ erreur:do dt_b=0.2,0.01,-0.01   
!!$     !nx=(long_bloc+1)*k+1 => bloc bord de bonne taille
!!$
!!$     open(unit=10,file="parameter",form="formatted")
!!$     read(10,*) xg,xd,yb,yh 
!!$     close (10)
!!$
!!$     nx_boucle=400
!!$
!!$     nx=nx_boucle
!!$     ny=nx_boucle
!!$
!!$     !nx_gro=nx/2
!!$     nx_gro=nx
!!$     ny_gro=nx_gro
!!$
!!$     dx=(xd-xg)/(nx-1.)
!!$     dy=(yh-yb)/(ny-1.)
!!$
!!$     dx_gro=(xd-xg)/(nx_gro-1.)
!!$     dy_gro=(yh-yb)/(ny_gro-1.)
!!$
!!$
!!$     dt=dt_b





     !
     !calcul init
     !-----------
     cpt_ite=0
     time=0.


     npart=nx*ny
    
     xd_f=xd-dx !pour conditions periodiques
     yh_f=yh-dy 

     xd_g=xd-dx_gro
     yh_g=yh-dy_gro 

     nx=nx-1
     ny=ny-1

     nx_gro=nx_gro-1
     ny_gro=ny_gro-1


     pi=4.*atan(1.)





     !
     !alloc tableaux: ici npart est une taille maximale, on pourrait rallouer apres la creation des part.
     !--------------
     allocate (exa(1:nx,1:ny),qg(1:nx,1:ny),vxg(1:nx_gro,1:ny_gro),vyg(1:nx_gro,1:ny_gro))           
     allocate (xtab(1:nx,1:ny),ytab(1:nx,1:ny))
     allocate (numpg(1:nx,1:ny)) 
     !allocate (Nblocg(1:max(nx,ny))) 

     allocate (xp(1:npart),qp(1:npart),vx(1:npart),yp(1:npart),vy(1:npart)) 
     allocate (blocg(0:npart),blocd(0:npart),Nbloc(0:npart)) 
     
     open(unit=29,file=name_err,form="formatted")
     open(unit=30,file=name_coupe,form="formatted") 

     call cpu_time(t1)

     !
     !initialisation
     !--------------
     call make_grille
     call init_grille()
     masse=dx*dy*sum(qg)
    
     call def_v_advec(vxg,vyg,time) 

     !
     !boucle temps
     !------------
     temps: do while(time<tfin)

        !print*,"cflmax:",dt*max(maxval(vxg),maxval(vyg))/dx

        if ((time+dt)>tfin) dt=tfin-time

        if (time<=2.*dt) dt_deb=dt


        !call def_v_advec(vxg,vyg,time)        !inutile de le garder dans la boucle quand depend pas du temps.

        call crea_part_x()          




        !================================
        !si remaillage tenso en espace
        !================================

!!$        !champ de vitesse
!!$        !-----------------
!!$        !allocate(vxg1(1:nx_gro,1:ny_gro),vyg1(1:nx_gro,1:ny_gro))
!!$        !rk2
!!$        !call def_v_advec(vxg1,vyg1,time+0.5*dt)                                                 
!!$        !vxg1=vxg
!!$        !vyg1=vyg
!!$
!!$        !rk3
!!$        !allocate(vxg2(1:nx_gro,1:ny_gro),vyg2(1:nx_gro,1:ny_gro))
!!$        !call def_v_advec(vxg1,vyg1,time+0.5*dt)
!!$        !call def_v_advec(vxg2,vyg2,time+dt) 
!!$        !vxg2=vxg
!!$        !vyg2=vyg
!!$
!!$        !rk4
!!$        !allocate(vxg3(1:nx_gro,1:ny_gro),vyg3(1:nx_gro,1:ny_gro))
!!$        !vxg3=vxg
!!$        !vyg3=vyg
!!$
!!$
!!$        !t source:rk4
!!$        !------------
!!$        !call source_rk4
!!$
!!$        !advection
!!$        !---------
!!$        !call ad_tenso_euler  
!!$        call ad_tenso_rk2        
!!$        !call ad_tenso_rk3
!!$        !call ad_tenso_rk4
!!$
!!$       
!!$
!!$        !remaillage
!!$        !----------         
!!$        !call remaill_l2(qp,xp,yp,qg) 
!!$        call remaill_l3(qp,xp,yp,qg) 
!!$        !call remaill_l4(qp,xp,yp,qg) 
!!$        !call remaill_l6(qp,xp,yp,qg) 
!!$        !call remaill_mp4(qp,xp,yp,qg) 
!!$        !call remaill_mppp6(qp,xp,yp,qg)  
!!$       
!!$        !deallocate(vxg1,vyg1)
!!$        !deallocate(vxg2,vyg2)
!!$        !deallocate(vxg3,vyg3)

  !=====================
  !splitting en espace
  !=====================

        !champ de vitesse
        !-----------------
        !allocate(vxg1(1:nx_gro,1:ny_gro),vyg1(1:nx_gro,1:ny_gro))
        !rk2
        !call def_v_advec(vxg1,vyg1,time+0.5*dt)        
        !vxg1=vxg
        !vyg1=vyg ! attention sinon modifier dans les update vitesses d'advection

        !rk3
        !allocate(vxg2(1:nx_gro,1:ny_gro),vxg3(1:nx_gro,1:ny_gro),vyg2(1:nx_gro,1:ny_gro),vyg3(1:nx_gro,1:ny_gro))
        !call def_v_advec(vxg1,vyg1,time+dt/3.)
        !call def_v_advec(vxg2,vyg2,time+2.*dt/3.)
        !call def_v_advec(vxg3,vyg3,time+dt) !que le vyg3 qui nous interesse
        !vxg2=vxg;vxg3=vxg
        !vyg2=vyg;vyg3=vyg


        !t source
        !---------
        !call source_split_1
        
        !update v
        !--------
        !call update_vx_2
        call update_vx_3


        !test cfl
        !--------
        !print*,"test cfl en x "
        !print*,"cfl part, cfl",dt/dx*maxval(abs(vx)),dt/dx*maxval(abs(vxg))

        !print*,"max vx",maxval(vx)

!        ainf=0.                 
!        do j=1,ny
!           do i=1,nx-1      
!              if ( (numpg(i+1,j)/=0).and.(numpg(i,j)/=0) )  ainf=max(ainf,abs(vx(numpg(i+1,j))-vx(numpg(i,j))))  
!           end do
!        end do
!        if (dt>(0.5*dx/(ainf))) then
!           print*,""
!           print*,"cfl l2 viole" ,dt,0.5*dx/(ainf),0.5*dx/(2.*ainf)
!           print*,""
!        end if
!        if (dt>(0.5*dx/(2.*ainf))) then
!           print*,""
!           print*,"cfl l4 viole" ,dt,0.5*dx/(ainf),0.5*dx/(2.*ainf) 
!           print*,"dx,dt",dx,dt
!           print*,""
!        end if
!        if (dt>(dx/(2.*ainf/(sqrt(3.)-1.)))) then
!           print*,""
!           print*,"TSC gauche pas TVD (l2)" ,dt,dx/(2.*ainf/(sqrt(3.)-1.))
!           print*,""
!        end if
!        if (dt>(dx/(5.4641*ainf))) then
!           print*,""
!           print*,"TSC gauche pas TVD (l4)" ,dt,dx/(2.*ainf/(sqrt(3.)-1.))
!           print*,""
!        end if
!        print*,"ainf",ainf/dx
!        print*,"max",maxval(vx)
       !fin test
       !--------


       !bloc x
        !-------
        if ((type_b==2).or.(type_b==4)) then
           !call make_bloc(1)
           call make_bloc_v2(1)   
        else
           blocg=0
           blocd=0
        end if

        !advection
        !----------
        call ad_euler_x        

     
        !remaillage
        !----------              
        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
        if (type_b==70)call remaill_mp4_x(qp,xp,yp,qg) 
        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
        if (type_b==2) then
           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
        end if
        if (type_b==4) then
           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
        end if

        if (type_b==200)call remaill_l2_limit_x(qp,xp,yp,qg) 
        if (type_b==400)call remaill_l4_limit_x(qp,xp,yp,qg)

        !y
        !-- 
        call crea_part_y()

        !update v
        !--------
        !call update_vy_2
        call update_vy_3


        !test cfl
        !--------
        !print*,"test cfl en y "
        !print*,"cfl part, cfl",dt/dy*maxval(abs(vy)),dt/dy*maxval(abs(vyg))
!        ainf=0.                 
!        do j=1,ny-1
!           do i=1,nx      
!              if ( (numpg(i,j+1)/=0).and.(numpg(i,j)/=0) )  ainf=max(ainf,abs(vy(numpg(i,j+1))-vy(numpg(i,j))))  
!           end do
!        end do
!        if (dt>(0.5*dy/(ainf))) then
!           print*,""
!           print*,"cfl l2 viole" ,dt,0.5*dy/(ainf),0.5*dy/(2.*ainf)
!           print*,""
!        end if
!        if (dt>(0.5*dy/(2.*ainf))) then
!           print*,""
!           print*,"cfl l4 viole" ,dt,0.5*dy/(ainf),0.5*dy/(2.*ainf)       
!           print*,""
!        end if
        !fin test
        !--------

        !bloc y
        !-------     
        if ((type_b==2).or.(type_b==4)) then
           !call make_bloc(2)
           call make_bloc_v2(2)  
        else
           blocg=0
           blocd=0
        end if

        !advection
        !----------
        call ad_euler_y 



!-------test----------------------------------------
!        if (cpt_ite <=1) then
!
!        !trace la position des particules
!        open(unit=28,file="RES/pos_part.deb",form="formatted")
!        open(unit=29,file="RES/pos_part_2.deb",form="formatted")
!        do ib=1,nx
!           x=xg+(ib-1)*dx
!           if ( (x>0.8).and.(x<0.81) ) then
!              do jb=1,(ny+10)
!                 y=yb+(jb-1)*dy          
!                 write(28,'(2(f35.20,2x))') y,0.5        
!              end do
!           end if
!        end do
!
!        do ib=1,npart    
!           if ((xp(ib)>0.8).and.(xp(ib)<0.81)) then
!              write(29,'(4(f35.20,2x))') yp(ib),0.5,blocg(ib)*0.1 ,blocd(ib)*0.1        
!           end if
!        end do       
!
!        close (28)
!        close (29)
!
!     end if
!-------test----------------------------------------
             
!!$
        !remaillage
        !----------      
        if (type_b==30)call remaill_l3_y(qp,xp,yp,qg)
        if (type_b==40)call remaill_l4_y(qp,xp,yp,qg)
        if (type_b==20)call remaill_l2_y(qp,xp,yp,qg)
        if (type_b==50)call remaill_l5_y(qp,xp,yp,qg)
        if (type_b==60)call remaill_l6_y(qp,xp,yp,qg)
        if (type_b==70)call remaill_mp4_y(qp,xp,yp,qg) 
        !if (type_b==2)call remaill_l2_bloc_y(qp,xp,yp,qg)        
        !if (type_b==4)call remaill_l4_bloc_y(qp,xp,yp,qg)        
        if (type_b==2) then
           if (int_limit==0)call remaill_l2_bloc_v2_y(qp,xp,yp,qg) 
           if (int_limit==1)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
        end if
        if (type_b==4) then
           if (int_limit==0)call remaill_l4_bloc_v2_y(qp,xp,yp,qg)
           if (int_limit==1)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg) 
        end if

        if (type_b==200)call remaill_l2_limit_y(qp,xp,yp,qg) 
        if (type_b==400)call remaill_l4_limit_y(qp,xp,yp,qg) 

        !t source
        !---------
        !call source_split_2

     
        !deallocate(vxg1,vyg1)
        !deallocate(vxg2,vxg3,vyg2,vyg3)



        !=================
        !splitting strang
        !=================
!!$
!!$        !champ de vitesse:      
!!$        !-----------------
!!$        allocate(vxg1(1:nx_gro,1:ny_gro),vyg1(1:nx_gro,1:ny_gro))
!!$        !call def_v_advec(vxg1,vyg1,time+0.5*dt)
!!$        vxg1=vxg
!!$        vyg1=vyg
!!$      
!!$        !t source
!!$        !--------
!!$        !call source_split_1
!!$
!!$        dt_sauv=dt
!!$        dt=0.5*dt
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_strang
!!$      
!!$
!!$        !bloc x
!!$        !-------
!!$        !call make_bloc_x
!!$        blocg=0
!!$        blocd=0
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------
!!$        call remaill_l3_x(qp,xp,yp,qg) 
!!$        !call remaill_l5_x(qp,xp,yp,qg) 
!!$        !call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2)call remaill_l2_bloc_x(qp,xp,yp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_x(qp,xp,yp,qg)  
!!$
!!$        !y
!!$        !--
!!$        call crea_part_y()
!!$      
!!$
!!$        dt=dt_sauv
!!$        !update v
!!$        !--------
!!$        call update_vy_strang
!!$
!!$        !test cfl
!!$        !--------
!!$        !ainf=0.                 
!!$        !do i=1,nx
!!$        !   do j=1,ny-1        
!!$        !      ainf=max(ainf,abs(vyg(i,j+1)-vyg(i,j)))          
!!$        !   end do
!!$        !end do
!!$        !print*,"dt,limit vg",dt,dy/(4.*ainf),dy/(6.*ainf)
!!$        !ainf=0.                 
!!$        !do i=1,nx
!!$        !   do j=1,ny-1        
!!$        !      ainf=max(ainf,abs(vy(numpg(i,j+1))-vy(numpg(i,j))))          
!!$        !   end do
!!$        !end do
!!$        !print*,"dt,limit v",dt,dy/(4.*ainf),dy/(6.*ainf)
!!$
!!$
!!$        !bloc y
!!$        !-------      
!!$        !call make_bloc_y
!!$        blocg=0
!!$        blocd=0
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------
!!$        call remaill_l3_y(qp,xp,yp,qg) 
!!$        !call remaill_l5_y(qp,xp,yp,qg) 
!!$        !call remaill_l6_y(qp,xp,yp,qg) 
!!$        !if (type_b==2)call remaill_l2_bloc_y(qp,xp,yp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_y(qp,xp,yp,qg)  
!!$
!!$        !x
!!$        !--
!!$        call crea_part_x()
!!$
!!$        dt_sauv=dt
!!$        dt=0.5*dt
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_strang
!!$     
!!$        !bloc x
!!$        !-------
!!$        !call make_bloc_x
!!$        blocg=0
!!$        blocd=0
!!$
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x            
!!$
!!$        !remaillage
!!$        !----------
!!$        call remaill_l3_x(qp,xp,yp,qg)
!!$        !call remaill_l5_x(qp,xp,yp,qg)
!!$        !call remaill_l6_x(qp,xp,yp,qg)
!!$        !if (type_b==2)call remaill_l2_bloc_x(qp,xp,yp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_x(qp,xp,yp,qg)  
!!$
!!$        dt=dt_sauv
!!$        !t source
!!$        !---------
!!$        !call source_split_2
!!$
!!$        
!!$        deallocate(vxg1,vyg1)       








  !=============================
  !splitting ordre 4 en temps
  !==============================
!!$        allocate(qg_init(1:nx,1:ny),qg_tmp(1:nx,1:ny))
!!$        qg_init=qg
!!$!====================
!!$!        x: dt/4           
!!$!====================
!!$
!!$        dt_sauv=dt
!!$        dt=0.25*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_4     
!!$      
!!$
!!$
!!$        !test cfl
!!$        !--------
!!$        !print*,"test cfl en x "
!!$        !ainf=0.                 
!!$        !do j=1,ny
!!$        !   do i=1,nx-1      
!!$        !      if ( (numpg(i+1,j)/=0).and.(numpg(i,j)/=0) )  ainf=max(ainf,abs(vx(numpg(i+1,j))-vx(numpg(i,j))))  
!!$        !   end do
!!$        !end do
!!$        !print*,"ainf",ainf
!!$       !fin test
!!$
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        y: dt/2           
!!$!==================== 
!!$        call crea_part_y()
!!$
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vy_4     
!!$
!!$        !test cfl
!!$        !--------
!!$        !print*,"test cfl en y "
!!$        !ainf=0.                 
!!$        !do i=1,nx
!!$        !   do j=1,ny-1      
!!$        !      if ( (numpg(i,j+1)/=0).and.(numpg(i,j)/=0) )  ainf=max(ainf,abs(vy(numpg(i,j+1))-vy(numpg(i,j))))  
!!$        !   end do
!!$        !end do
!!$        !print*,"ainf",ainf
!!$       !fin test
!!$      
!!$        !bloc 
!!$        !-----
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(2)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_y(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_y(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_y(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_y(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_y(qp,xp,yp,qg) 
!!$        
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_y(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_y(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        x: dt/2           
!!$!==================== 
!!$        call crea_part_x()
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_4     
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        y: dt/2           
!!$!==================== 
!!$        call crea_part_y()
!!$
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vy_4     
!!$      
!!$        !bloc 
!!$        !-----
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(2)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_y(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_y(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_y(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_y(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_y(qp,xp,yp,qg) 
!!$        
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_y(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_y(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg)
!!$!====================
!!$!        x: dt/4           
!!$!==================== 
!!$        call crea_part_x()
!!$        dt=0.25*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_4     
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$
!!$        qg_tmp=qg
!!$        qg=qg_init
!!$
!!$
!!$!====================
!!$!        x: dt/2           
!!$!==================== 
!!$        call crea_part_x()
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_4     
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        y: dt           
!!$!==================== 
!!$        call crea_part_y()
!!$
!!$        dt=dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vy_4     
!!$      
!!$        !bloc 
!!$        !-----
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(2)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_y(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_y(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_y(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_y(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_y(qp,xp,yp,qg) 
!!$        
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_y(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_y(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        x: dt/2           
!!$!==================== 
!!$        call crea_part_x()
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_4     
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$        qg=(-qg+4.*qg_tmp)/3.
!!$
!!$
!!$        dt=dt_sauv
!!$        deallocate(qg_init,qg_tmp)
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
!!$
  !=============================
  !    STRANG
  !==============================
!!$        allocate(qg_init(1:nx,1:ny),qg_tmp(1:nx,1:ny))
!!$        qg_init=qg
!!$!====================
!!$!        x: dt/2          
!!$!====================
!!$
!!$        dt_sauv=dt
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        !call update_vx_4  
!!$        call update_vx_strang
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        y: dt         
!!$!==================== 
!!$        call crea_part_y()
!!$
!!$        dt=dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        !call update_vy_4     
!!$        call update_vy_strang
!!$      
!!$        !bloc 
!!$        !-----
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(2)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_y(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_y(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_y(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_y(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_y(qp,xp,yp,qg) 
!!$        
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_y(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_y(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_y(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_y(qp,xp,yp,qg)
!!$
!!$!====================
!!$!        x: dt/2           
!!$!==================== 
!!$        call crea_part_x()
!!$        dt=0.5*dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        !call update_vx_4  
!!$        call update_vx_strang
!!$      
!!$        !bloc x
!!$        !-------
!!$        if ((type_b==2).or.(type_b==4)) then          
!!$           call make_bloc_v2(1)   
!!$        else
!!$           blocg=0
!!$           blocd=0
!!$        end if
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------              
!!$        if (type_b==30) call remaill_l3_x(qp,xp,yp,qg) 
!!$        if (type_b==40) call remaill_l4_x(qp,xp,yp,qg) 
!!$        if (type_b==20) call remaill_l2_x(qp,xp,yp,qg) 
!!$        if (type_b==50)call remaill_l5_x(qp,xp,yp,qg) 
!!$        if (type_b==60)call remaill_l6_x(qp,xp,yp,qg) 
!!$        !if (type_b==2) call remaill_l2_bloc_x(qp,xp,yp,qg) 
!!$        !if (type_b==4) call remaill_l4_bloc_x(qp,xp,yp,qg) 
!!$        if (type_b==2) then
!!$           if (int_limit==0)call remaill_l2_bloc_v2_x(qp,xp,yp,qg) 
!!$           if (int_limit==1)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$        if (type_b==4) then
!!$           if (int_limit==0)call remaill_l4_bloc_v2_x(qp,xp,yp,qg)
!!$           if (int_limit==1)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        end if
!!$
!!$        if (type_b==200)call remaill_l2_bloc_v2_limit_x(qp,xp,yp,qg) 
!!$        if (type_b==400)call remaill_l4_bloc_v2_limit_x(qp,xp,yp,qg)
!!$
!!$
!!$
!!$        dt=dt_sauv
!!$        deallocate(qg_init,qg_tmp)













        time=time+dt
        cpt_ite=cpt_ite+1


     end do temps

     !------------------------------
     !sol exacte: 
     !--------------------------------

     !erreur pour sol init gaussienne
     !--------------------------------         
!!$     do i=1,nx
!!$        do j=1,ny
!!$           x=xtab(i,j)
!!$           y=ytab(i,j)
!!$           exa(i,j)=0.
!!$           
!!$           !exa(i,j)=(1.-((x-0.5)**2+(y-0.5)**2))**6
!!$           !if (((x-0.5)**2+(y-0.5)**2)>1.) exa(i,j)=0.
!!$
!!$           exa(i,j)=(1.-((x)**2+(y)**2))**6
!!$           if (((x)**2+(y)**2)>1.) exa(i,j)=0.
!!$
!!$           !exa(i,j)=1.
!!$
!!$           
!!$        end do
!!$     end do
!!$
!!$     !-----------Analytique en cos--------------------------
!!$    !------------------------------------------------------
!!$    t1=1.
!!$    t2=1.
!!$    t3=0.2
!!$    do j=1,ny
!!$       do i=1,nx
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          exa(i,j)=cos(pi*time/t3)*cos(2.*pi*x/t1)*cos(2.*pi*y/t2)                         
!!$       end do
!!$    end do

    !---cercle pour filaments sur [0,1]^2-----------
    !----------------------------------------------------
!!$    
!!$    do j=1,ny
!!$       do i=1,nx
!!$          x=xtab(i,j)
!!$          y=ytab(i,j)
!!$          exa(i,j)=0.
!!$
!!$          if (sqrt((x-0.5)**2+(y-0.75)**2)<=0.15) exa(i,j)=1.  
!!$         
!!$       end do
!!$    end do


   !write(29,'(4(e18.10,2x))') dt_deb,dx,dx*dy*sum(abs(exa-qg)),sqrt(dx*dy*sum((exa-qg)**2)) 
     
     !COUPE en y=1.5
     !--------------
     j=(1.5-yb)/dy+1    
     do i=1,nx     
        write(30,'(2(e18.10,2x))') xg+(i-1)*dx,qg(i,j)
     end do
     
  
  end do erreur
  call cpu_time(t2)

  !resultat final
  !--------------  
  print*,"tps final",time
  print*,"nbre d'ite",cpt_ite
  print*,"nart final",npart
  print*,"dt,dx,dy",dt_deb,dx,dy
  print*,"max vx",maxval(abs(vxg)),maxloc(abs(vxg))
  print*,"max vy",maxval(abs(vyg)),maxloc(abs(vxg))
  print*,"perte masse",masse-dx*dy*sum(qg)
  print*,"tps dexecution",t2-t1



  call res_vtk("RES/vtk/"//nom_fich_vtk)



  !
  !dealloc fermeture
  !-----------------
  close(50)
  close(51)
  close(52)
  close(53)
  close(66)
  close(67)
  close(29)
  close(30)

  deallocate (xp,qp,vx,vy,yp)
  deallocate (qg,vxg,vyg,exa)
  deallocate (xtab,ytab)
  deallocate (blocg,blocd)
  deallocate (numpg,Nbloc)
  !deallocate (Nblocg)



end program split







