module resultats_mod
  use donnees_mod
  use tab_mod
  contains 

    subroutine res_qg (nom_fich)
      use donnees_mod
      use tab_mod
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j
      real(kind=8)                 :: x,y

      open(unit=11,file=nom_fich,form="formatted")
      do i=1,nx
         do j=1,ny
            x=xg+(i-1)*dx
            y=yb+(j-1)*dy
            write(11,'(3(f35.20,2x))') x,y,qg(i,j)
         end do
      end do
      write(11,*) ""
      write(11,*) ""
      close (11)
    end subroutine res_qg

    subroutine res_vxg (nom_fich)
      use donnees_mod
      use tab_mod
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j
      real(kind=8)                 :: x,y

      open(unit=11,file=nom_fich,form="formatted")
      do i=1,nx
         do j=1,ny
            x=xg+(i-1)*dx
            y=yb+(j-1)*dy
            write(11,'(3(f35.20,2x))') x,y,vxg(i,j)
         end do
      end do
      write(11,*) ""
      write(11,*) ""
      close (11)
    end subroutine res_vxg

    subroutine res_vyg (nom_fich)
      use donnees_mod
      use tab_mod
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j
      real(kind=8)                 :: x,y

      open(unit=11,file=nom_fich,form="formatted")
      do i=1,nx
         do j=1,ny
            x=xg+(i-1)*dx
            y=yb+(j-1)*dy
            write(11,'(3(f35.20,2x))') x,y,vyg(i,j)
         end do
      end do
      write(11,*) ""
      write(11,*) ""
      close (11)
    end subroutine res_vyg

    subroutine res_brut (nom_fich)
      use donnees_mod
      use tab_mod
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j
      real(kind=8)                 :: x,y

      open(unit=11,file=nom_fich,form="formatted")
      do i=1,nx
         do j=1,ny
            x=xg+(i-1)*dx
            y=yb+(j-1)*dy
            write(11,'(1(f35.20,2x))') qg(i,j)
         end do
      end do
      write(11,*) ""
      write(11,*) ""
      close (11)
    end subroutine res_brut

   
!!$    subroutine res_qg_freq (dossier,nom_fich)     
!!$      implicit none
!!$      character(len=*),intent(in)     :: dossier
!!$      character(len=*),intent(in)     :: nom_fich
!!$      integer                         :: i,j,cpt_num
!!$
!!$      if ((time<=cpt_fich_sauv).and.(time+dt>cpt_fich_sauv))then                      
!!$         cpt_fich_sauv=cpt_fich_sauv+frequ_fich_sauv
!!$        
!!$         if (int(time)==0)  call res_vtk_q(dossier//nom_fich//char(48)//"_"//char(int(time*10.)+48)//".vtk")    
!!$         do i=1,9
!!$            if (int(time)==i) call res_vtk_q(dossier//nom_fich//char(48+i)//"_"//char(int(mod(time,float(i))*10.)+48)//".vtk")
!!$         end do        
!!$         cpt_num=49
!!$         do j=10,80,10
!!$            do i=j,j+9
!!$               if (int(time)==i) call res_vtk_q(dossier//nom_fich//char(cpt_num)//char(48+i-j)//"_"//char(int(mod(time,float(i))*10.)+48)//".vtk")
!!$            end do
!!$            cpt_num=cpt_num+1
!!$         end do
!!$      end if
!!$      
!!$    end subroutine res_qg_freq

   

   


    subroutine res_vtk_q (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')"scalaire"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,1
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,0
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,0
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny
      write(11,'(A15)') "SCALARS Q FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      do j=1,ny
         do i=1,nx              
            write(11,'(f20.9)') real(qg(i,j))
         end do
      end do

      close (11)
    end subroutine res_vtk_q



    subroutine res_vtk_tab (nom_fich,tab)  
      implicit none
      character(len=*),intent(in)            :: nom_fich
      real(kind=8),dimension(:,:),intent(in) :: tab
      integer                                :: i,j,k
      real(kind=8)                           :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')"scalaire"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,1
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,0
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,0
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny
      write(11,'(A15)') "SCALARS Q FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      do j=1,ny
         do i=1,nx              
            write(11,'(f20.9)') real(tab(i,j))
         end do
      end do

      close (11)
     
    end subroutine res_vtk_tab

    subroutine res_vtk_v (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,1
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,0
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,0
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny
      write(11,'(A21)') "VECTORS VITESSE FLOAT" 

      do j=1,ny
         do i=1,nx              
            write(11,'(3(f20.9))') real(vxg(i,j)),real(vyg(i,j)),0.
         end do
      end do
      close (11)
    end subroutine res_vtk_v

    subroutine res_vtk (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')""
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,1
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,0
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,0
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny
      write(11,'(A15)') "SCALARS U FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      do j=1,ny
         do i=1,nx              
            write(11,'(f20.9)') real(qg(i,j))
         end do
      end do

      write(11,'(A21)') ""
      write(11,'(A21)') "VECTORS VITESSE FLOAT" 

      do j=1,ny
         do i=1,nx              
            write(11,'(3(f20.9))') real(vxg(i,j)),real(vyg(i,j)),0.
         end do
      end do

      close (11)

    end subroutine res_vtk



end module resultats_mod

