module advection_mod
  use donnees_mod
  use tab_mod
  use remaillage_mod
  use interpolation_mod
contains

  subroutine def_v_advec  (vitx,vity,vitz,tps)  
    implicit none

    real(kind=8),intent(in)                                        :: tps
    real(kind=8),dimension(1:nx_gro,1:ny_gro,1:nz_gro),intent(out) :: vitx,vity,vitz 
    integer                                                        :: i,j,k
    real(kind=8)                                                   :: x,y,z,r2,tmp,r,per,t3
    real,dimension(1:nx_gro,1:ny_gro,1:nz_gro)                     :: tvitx,tvity,tvitz 


    !-------------------
    !deformation sphere: 
    !--------------------
!!$    do k=1,nz_gro
!!$       z=zd+(k-1)*dz_gro
!!$       do j=1,ny_gro
!!$          y=yb+(j-1)*dy_gro
!!$          do i=1,nx_gro
!!$             x=xg+(i-1)*dx_gro
!!$
!!$             !t3=0.3
!!$             !t3=3.
!!$             !t3=1.
!!$
!!$             if (tps<=1.) then
!!$                vitx(i,j,k)=2.*sin(pi*x)**2*sin(2.*pi*y)*sin(2.*pi*z) !*cos(pi*tps/t3)
!!$                vity(i,j,k)=-sin(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z) !*cos(pi*tps/t3)
!!$                vitz(i,j,k)=-sin(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2 !*cos(pi*tps/t3)
!!$             else
!!$                vitx(i,j,k)=-2.*sin(pi*x)**2*sin(2.*pi*y)*sin(2.*pi*z)
!!$                vity(i,j,k)=sin(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z) 
!!$                vitz(i,j,k)=sin(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2 
!!$             end if
!!$
!!$          end do
!!$       end do
!!$    end do


    !----------------------------------
    !deformation sphere: test tps
    !----------------------------------

!!$ do k=1,nz_gro
!!$       z=zd+(k-1)*dz_gro
!!$       do j=1,ny_gro
!!$          y=yb+(j-1)*dy_gro
!!$          do i=1,nx_gro
!!$             x=xg+(i-1)*dx_gro
!!$
!!$           
!!$             vitx(i,j,k)=2.*sin(pi*x)**2*sin(2.*pi*y)*sin(2.*pi*z) *cos(2.*pi*tps)
!!$             vity(i,j,k)=-sin(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z)*cos(2.*pi*tps)
!!$             vitz(i,j,k)=-sin(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2*cos(2.*pi*tps)
!!$
!!$          end do
!!$       end do
!!$    end do
!!$
!!$    !----------------------------------
!!$    !deformation sphere: calta
!!$    !----------------------------------
!!$
!!$   
!!$ do k=1,nz_gro
!!$       z=zd+(k-1)*dz_gro
!!$       do j=1,ny_gro
!!$          y=yb+(j-1)*dy_gro
!!$          do i=1,nx_gro
!!$             x=xg+(i-1)*dx_gro
!!$ 
!!$             !calta: pas à div=0
!!$             !--------------------
!!$             !vitx(i,j,k)=2.*sin(pi*x)**2*sin(2.*pi*y)**2*sin(2.*pi*z)**2 *cos(pi*tps/3.) 
!!$             !vity(i,j,k)=-sin(2.*pi*x)**2*sin(pi*y)**2*sin(2.*pi*z)**2    *cos(pi*tps/3.) 
!!$             !vitz(i,j,k)=-2.*sin(2.*pi*x)**2*sin(2.*pi*y)**2*sin(pi*z)**2     *cos(pi*tps/3.) 
!!$
!!$            
!!$             !Petros + terme en temps
!!$             !------------------------
!!$             vitx(i,j,k)=2.*sin(pi*x)**2*sin(2.*pi*y)*sin(2.*pi*z) *cos(pi*tps/3.)
!!$             vity(i,j,k)=-sin(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z) *cos(pi*tps/3.)
!!$             vitz(i,j,k)=-sin(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2 *cos(pi*tps/3.)
!!$
!!$          end do
!!$       end do
!!$    end do
!!$    
!!$   
    !----------------------------------
    !champ turbulent de gh
    !----------------------------------
   

    open(20,file='datavelx',form='unformatted',convert='big_endian',status='unknown')             
    read(20)  (((tvitx(i,j,k),i=1,nx_gro),j=1,nx_gro),k=1,nx_gro)             
    close(20)
    
    open(20,file='datavely',form='unformatted',convert='big_endian',status='unknown')             
    read(20)  (((tvity(i,j,k),i=1,nx_gro),j=1,nx_gro),k=1,nx_gro)             
    close(20)
    
    open(20,file='datavelz',form='unformatted',convert='big_endian',status='unknown')             
    read(20)  (((tvitz(i,j,k),i=1,nx_gro),j=1,nx_gro),k=1,nx_gro)             
    close(20)

    vitx=tvitx
    vity=tvity
    vitz=tvitz



  end subroutine def_v_advec




  
  
  subroutine evalv (vitx,vity,vitz,tps,x,y,z)    
    implicit none
    real(kind=8),intent(in)     :: tps,x,y,z
    real(kind=8),intent(out)    :: vitx,vity,vitz
    integer                           :: i,j,k
    real(kind=8)                      :: t3


    t3=0.3
           
    vitx=2.*sin(pi*x)**2*sin(2.*pi*y)*sin(2.*pi*z) *cos(pi*tps/t3)
    vity=-sin(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z) *cos(pi*tps/t3)
    vitz=-sin(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2 *cos(pi*tps/t3)

  end subroutine evalv







  subroutine crea_part_x
    implicit none
    integer                  :: i,j,k
    real(kind=8)             :: x,y,z,m     

    m=cutoff!*maxval(abs(qg))
    npart=0  
    numpg=0
    do k=1,nz
       z=ztab(k)
       do j=1,ny
          y=ytab(j)
          do i=1,nx
             x=xtab(i) 

             if (abs(qg(i,j,k))>=m) then
                npart=npart+1 
                numpg(i,j,k)=npart
                xp(npart)=x
                yp(npart)=y
                zp(npart)=z
                vx(npart)=vxg(i,j,k)
                vy(npart)=vyg(i,j,k)
                vz(npart)=vzg(i,j,k)
                !vx(npart)=interpol_v_l5(vxg,x,y,z)
                !vy(npart)=interpol_v_l5(vyg,x,y,z) 
                !vz(npart)=interpol_v_l5(vzg,x,y,z) 
                qp(npart)=qg(i,j,k)    
             end if
          end do
       end do
    end do

  end subroutine crea_part_x

  subroutine crea_part_y
    implicit none
    integer                  :: i,j,k
    real(kind=8)             :: x,y,z,m     

    m=cutoff!*maxval(abs(qg))
    npart=0  
    numpg=0
    do k=1,nz
       z=ztab(k)        
       do i=1,nx
          x=xtab(i) 
          do j=1,ny
             y=ytab(j)

             if (abs(qg(i,j,k))>=m) then
                npart=npart+1   
                numpg(i,j,k)=npart           
                xp(npart)=x
                yp(npart)=y
                zp(npart)=z
                vx(npart)=vxg(i,j,k)
                vy(npart)=vyg(i,j,k)
                vz(npart)=vzg(i,j,k)
                !vx(npart)=interpol_v_l5(vxg,x,y,z)
                !vy(npart)=interpol_v_l5(vyg,x,y,z) 
                !vz(npart)=interpol_v_l5(vzg,x,y,z) 
                qp(npart)=qg(i,j,k)    
             end if
          end do
       end do
    end do

  end subroutine crea_part_y

  subroutine crea_part_z
    implicit none
    integer                  :: i,j,k
    real(kind=8)             :: x,y,z,m     

    m=cutoff!*maxval(abs(qg))
    npart=0    
    numpg=0

    do j=1,ny
       y=ytab(j)
       do i=1,nx
          x=xtab(i) 
          do k=1,nz
             z=ztab(k)

             if (abs(qg(i,j,k))>=m) then
                npart=npart+1 
                numpg(i,j,k)=npart             
                xp(npart)=x
                yp(npart)=y
                zp(npart)=z
                vx(npart)=vxg(i,j,k)
                vy(npart)=vyg(i,j,k)
                vz(npart)=vzg(i,j,k)
                !vx(npart)=interpol_v_l5(vxg,x,y,z)
                !vy(npart)=interpol_v_l5(vyg,x,y,z) 
                !vz(npart)=interpol_v_l5(vzg,x,y,z) 
                qp(npart)=qg(i,j,k)    
             end if
          end do
       end do
    end do

  end subroutine crea_part_z

  
    !==================
    !TENSORIEL
    !==================

    subroutine ad_tenso_euler     
      implicit none

      integer                  :: i,j,k
      real(kind=8)             :: x,y,z

      do i=1,npart         
         xp(i)=xp(i)+dt*vx(i)                              
         yp(i)=yp(i)+dt*vy(i)   
         zp(i)=zp(i)+dt*vz(i)   
      end do

    end subroutine ad_tenso_euler

    subroutine ad_tenso_rk2
       implicit none
       integer              :: ib
       !allocate (xp1(1:npart),yp1(1:npart),zp1(1:npart))                 
       do ib=1,npart         
          xp1(ib)=xp(ib)+0.5*dt*vx(ib)                                                           
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)      
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)                                                           
       end do
       
       !call interpo_l3_3d(vxg1,xp1,yp1,zp1,vx)
       !call interpo_l3_3d(vyg1,xp1,yp1,zp1,vy)
       !call interpo_l3_3d(vzg1,xp1,yp1,zp1,vz)

       !call interpo_l3_3d(vxg,xp1,yp1,zp1,vx)
       !call interpo_l3_3d(vyg,xp1,yp1,zp1,vy)
       !call interpo_l3_3d(vzg,xp1,yp1,zp1,vz)

       call interpo_l2_3d(vxg,xp1,yp1,zp1,vx)
       call interpo_l2_3d(vyg,xp1,yp1,zp1,vy)
       call interpo_l2_3d(vzg,xp1,yp1,zp1,vz)
      
       do ib=1,npart
          xp(ib)=xp(ib)+dt*vx(ib)
          yp(ib)=yp(ib)+dt*vy(ib)
          zp(ib)=zp(ib)+dt*vz(ib)
       end do

       !deallocate(xp1,yp1,zp1)
     end subroutine ad_tenso_rk2


     subroutine ad_tenso_rk3
       implicit none
       integer              :: ib


       !allocate (xp1(1:npart),xp2(1:npart),yp1(1:npart),yp2(1:npart),zp1(1:npart),zp2(1:npart)) 
       !allocate (vx1(1:npart),vx2(1:npart),vy1(1:npart),vy2(1:npart),vz1(1:npart),vz2(1:npart))           

       do ib=1,npart
          xp1(ib)=xp(ib)+0.5*dt*vx(ib)
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)
       end do

       call interpo_l3_3d(vxg,xp1,yp1,zp1,vx1)
       call interpo_l3_3d(vyg,xp1,yp1,zp1,vy1)      
       call interpo_l3_3d(vzg,xp1,yp1,zp1,vz1)      

       do ib=1,npart         
          xp2(ib)=xp(ib)+dt*(-vx(ib)+2.*vx1(ib))                                          
          yp2(ib)=yp(ib)+dt*(-vy(ib)+2.*vy1(ib))                                          
          zp2(ib)=zp(ib)+dt*(-vz(ib)+2.*vz1(ib))                                          
       end do
      
       call interpo_l3_3d(vxg,xp2,yp2,zp2,vx2)
       call interpo_l3_3d(vyg,xp2,yp2,zp2,vy2)
       call interpo_l3_3d(vzg,xp2,yp2,zp2,vz2)

       do ib=1,npart                  
          xp(ib)=xp(ib)+dt*(vx(ib)/6.+2.*vx1(ib)/3.+vx2(ib)/6.)
          yp(ib)=yp(ib)+dt*(vy(ib)/6.+2.*vy1(ib)/3.+vy2(ib)/6.)
          zp(ib)=zp(ib)+dt*(vz(ib)/6.+2.*vz1(ib)/3.+vz2(ib)/6.)
       end do

    !   deallocate (xp1,xp2,yp1,yp2,zp1,zp2)  
    !   deallocate (vx1,vx2,vy1,vy2,vz1,vz2)


     end subroutine ad_tenso_rk3

     subroutine ad_tenso_rk4
       implicit none
       integer              :: ib
      
       do ib=1,npart
          xp1(ib)=xp(ib)+0.5*dt*vx(ib)
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)
       end do

       call interpo_l4_3d(vxg,xp1,yp1,zp1,vx1)
       call interpo_l4_3d(vyg,xp1,yp1,zp1,vy1)      
       call interpo_l4_3d(vzg,xp1,yp1,zp1,vz1)      

       do ib=1,npart         
          xp2(ib)=xp(ib)+0.5*dt*vx1(ib)                                          
          yp2(ib)=yp(ib)+0.5*dt*vy1(ib)   
          zp2(ib)=zp(ib)+0.5*dt*vz1(ib)                                          
       end do
      
       call interpo_l4_3d(vxg,xp2,yp2,zp2,vx2)
       call interpo_l4_3d(vyg,xp2,yp2,zp2,vy2)      
       call interpo_l4_3d(vzg,xp2,yp2,zp2,vz2)

       do ib=1,npart         
          xp3(ib)=xp(ib)+dt*vx2(ib)                                          
          yp3(ib)=yp(ib)+dt*vy2(ib)          
          zp3(ib)=zp(ib)+dt*vz2(ib)                                          
       end do
      
       call interpo_l4_3d(vxg,xp3,yp3,zp3,vx3)
       call interpo_l4_3d(vyg,xp3,yp3,zp3,vy3)      
       call interpo_l4_3d(vzg,xp3,yp3,zp3,vz3)

       do ib=1,npart                  
          xp(ib)=xp(ib)+dt*(vx(ib)+2.*vx1(ib)+2.*vx2(ib)+vx3(ib))/6.
          yp(ib)=yp(ib)+dt*(vy(ib)+2.*vy1(ib)+2.*vy2(ib)+vy3(ib))/6.
          zp(ib)=zp(ib)+dt*(vz(ib)+2.*vz1(ib)+2.*vz2(ib)+vz3(ib))/6.
       end do

  
     end subroutine ad_tenso_rk4

    

     subroutine ad_euler_x           
      implicit none

      integer                  :: i,j
      real(kind=8)             :: x,y

      do i=1,npart         
         xp(i)=xp(i)+dt*vx(i)                               
      end do

    end subroutine ad_euler_x

    subroutine ad_euler_y           
      implicit none
     
      integer                  :: i,j
      real(kind=8)             :: x,y

      do i=1,npart         
         yp(i)=yp(i)+dt*vy(i)   
      end do

    end subroutine ad_euler_y

    subroutine ad_euler_z           
      implicit none
     
      integer                  :: i

      do i=1,npart         
         zp(i)=zp(i)+dt*vz(i)   
      end do

    end subroutine ad_euler_z


    !===============================
    !SPLITTING
    !calcul de la vitesse pour une advection d'euler à l'ordre 2 ou 3
    !===============================

     subroutine update_vx_2
       implicit none
       integer                  :: ib

       !allocate (xp1(1:npart),yp1(1:npart),zp1(1:npart))           
       do ib=1,npart         
          xp1(ib)=xp(ib)+0.5*dt*vx(ib)                                                           
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)                                                           
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)                                                           
       end do
       !call interpo_l3_3d(vxg1,xp1,yp1,zp1,vx)       
       !call interpo_l3_3d(vxg,xp1,yp1,zp1,vx)       
       call interpo_l2_3d(vxg,xp1,yp1,zp1,vx)       
       !deallocate(xp1,yp1,zp1)
     end subroutine update_vx_2

     subroutine update_vy_2
       implicit none
       integer                  :: ib

       !allocate (xp1(1:npart),yp1(1:npart),zp1(1:npart))           
       do ib=1,npart         
          xp1(ib)=xp(ib)-0.5*dt*vx(ib)                                                           
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)                                                           
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)                                                           
       end do
       !call interpo_l3_3d(vyg1,xp1,yp1,zp1,vy) 
       !call interpo_l3_3d(vyg,xp1,yp1,zp1,vy) 
       call interpo_l2_3d(vyg,xp1,yp1,zp1,vy)       
       !deallocate(xp1,yp1,zp1)
     end subroutine update_vy_2

     subroutine update_vz_2
       implicit none
       integer                  :: ib

       !allocate (xp1(1:npart),yp1(1:npart),zp1(1:npart))           
       do ib=1,npart         
          xp1(ib)=xp(ib)-0.5*dt*vx(ib)                                                           
          yp1(ib)=yp(ib)-0.5*dt*vy(ib)                                                           
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)                                                           
       end do
       !call interpo_l3_3d(vzg1,xp1,yp1,zp1,vz) 
       !call interpo_l3_3d(vzg,xp1,yp1,zp1,vz) 
       call interpo_l2_3d(vzg,xp1,yp1,zp1,vz)       
       !deallocate(xp1,yp1,zp1)
     end subroutine update_vz_2

   

      subroutine update_vx_3
       implicit none    
       integer                  :: ib
      

       !allocate (xp1(1:npart),xp2(1:npart),yp1(1:npart),yp2(1:npart),zp1(1:npart),zp2(1:npart)) 
       !allocate (vx1(1:npart),vx2(1:npart),vx3(1:npart),vx4(1:npart),vy1(1:npart),vz1(1:npart))           

       do ib=1,npart
          xp1(ib)=xp(ib)+2.*dt*vx(ib)/3.
          yp1(ib)=yp(ib)+2.*dt*vy(ib)/3.
          zp1(ib)=zp(ib)+2.*dt*vz(ib)/3.
       end do

       !call interpo_l3_3d(vxg1,xp1,yp1,zp1,vx1)
       !call interpo_l3_3d(vyg1,xp1,yp1,zp1,vy1)
       !call interpo_l3_3d(vzg1,xp1,yp1,zp1,vz1)

       call interpo_l3_3d(vxg,xp1,yp1,zp1,vx1)
       call interpo_l3_3d(vyg,xp1,yp1,zp1,vy1)
       call interpo_l3_3d(vzg,xp1,yp1,zp1,vz1)     

       do ib=1,npart         
          xp2(ib)=xp(ib)+dt*(-vx(ib)+vx1(ib))                                          
          yp2(ib)=yp(ib)+dt*(-vy(ib)+vy1(ib)) 
          zp2(ib)=zp(ib)+dt*(-vz(ib)+vz1(ib))                                          
       end do   
      
       call interpo_l3_3d(vxg,xp2,yp,zp,vx2)
       call interpo_l3_3d(vxg,xp,yp2,zp,vx3) 
       call interpo_l3_3d(vxg,xp,yp,zp2,vx4)     

       do ib=1,npart                  
          vx(ib)=-0.5*vx(ib)+3.*vx1(ib)/4.+vx2(ib)/4.+vx3(ib)/4.+vx4(ib)/4.
       end do

       !deallocate (xp1,xp2,yp1,yp2,zp1,zp2)  
       !deallocate (vx1,vx2,vx3,vx4,vy1,vz1)


     end subroutine update_vx_3

     subroutine update_vy_3
       implicit none      
       integer                          :: ib,i,j
      
       !allocate (xp0(1:npart),xp1(1:npart),xp2(1:npart),yp1(1:npart),yp2(1:npart),zp1(1:npart),zp2(1:npart))       
       !allocate (vx1(1:npart),vz1(1:npart),vy1(1:npart),vy2(1:npart),vy3(1:npart),vy4(1:npart),vy5(1:npart))
       
       do ib=1,npart
          xp1(ib)=xp(ib)-dt*vx(ib)/3.
          yp1(ib)=yp(ib)+2.*dt*vy(ib)/3.
          zp1(ib)=zp(ib)+2.*dt*vz(ib)/3.
          xp0(ib)=xp(ib)-4.*dt*vx(ib)/3.
       end do

       !call interpo_l3_3d(vxg1,xp1,yp1,zp1,vx1)
       !call interpo_l3_3d(vyg1,xp1,yp1,zp1,vy1)
       !call interpo_l3_3d(vyg1,xp0,yp1,zp1,vy2)
       !call interpo_l3_3d(vzg1,xp0,yp1,zp1,vz1)

       call interpo_l3_3d(vxg,xp1,yp1,zp1,vx1)
       call interpo_l3_3d(vyg,xp1,yp1,zp1,vy1)
       call interpo_l3_3d(vyg,xp0,yp1,zp1,vy2)
       call interpo_l3_3d(vzg,xp0,yp1,zp1,vz1)
     
       do ib=1,npart         
          xp2(ib)=xp(ib)+dt*(vx(ib)-2.*vx1(ib))                                          
          yp2(ib)=yp(ib)+dt*(-vy(ib)+vy2(ib))  
          zp2(ib)=zp(ib)+dt*(-vz(ib)/4.+vz1(ib)/4.)                                          
       end do
       
       call interpo_l3_3d(vyg,xp2,yp,zp,vy3)
       call interpo_l3_3d(vyg,xp,yp2,zp,vy4)
       call interpo_l3_3d(vyg,xp,yp,zp2,vy5)

       do ib=1,npart                  
          vy(ib)=-5.*vy(ib)/4.+3.*vy1(ib)/4.+vy3(ib)/4.+vy4(ib)/4.+vy5(ib)
       end do
     

       !deallocate (xp0,xp1,xp2,yp1,yp2,zp1,zp2)       
       !deallocate (vx1,vz1,vy1,vy2,vy3,vy4,vy5)

     end subroutine update_vy_3

     subroutine update_vz_3
       implicit none      
       integer                          :: ib,i,j,k
      
       !allocate (xp1(1:npart),xp2(1:npart),yp1(1:npart),yp2(1:npart),zp0(1:npart),zp1(1:npart),zp2(1:npart))       
       !allocate (vx1(1:npart),vy1(1:npart),vz1(1:npart),vz2(1:npart),vz3(1:npart),vz4(1:npart))
       
       do ib=1,npart
          xp1(ib)=xp(ib)-2.*dt*vx(ib)/3.
          yp1(ib)=yp(ib)-2.*dt*vy(ib)/3.
          zp1(ib)=zp(ib)+dt*vz(ib)/3.
          zp0(ib)=zp(ib)+4.*dt*vz(ib)/3.
       end do

       !call interpo_l3_3d(vzg1,xp1,yp1,zp1,vz1)
       !call interpo_l3_3d(vxg2,xp1,yp1,zp0,vx1)
       !call interpo_l3_3d(vyg2,xp1,yp1,zp0,vy1)

       call interpo_l3_3d(vzg,xp1,yp1,zp1,vz1)
       call interpo_l3_3d(vxg,xp1,yp1,zp0,vx1)
       call interpo_l3_3d(vyg,xp1,yp1,zp0,vy1)
     
       do ib=1,npart         
          xp2(ib)=xp(ib)+dt*(-vx(ib)+vx1(ib))                                          
          yp2(ib)=yp(ib)+dt*(vy(ib)-vy1(ib))  
          zp2(ib)=zp(ib)+dt*(-vz(ib)+2.*vz1(ib))                                          
       end do
       
       call interpo_l3_3d(vzg,xp2,yp,zp,vz2)
       call interpo_l3_3d(vzg,xp,yp2,zp,vz3)
       !call interpo_l3_3d(vzg3,xp,yp,zp2,vz4)
       call interpo_l3_3d(vzg,xp,yp,zp2,vz4)

       do ib=1,npart                  
          vz(ib)=3.*vz1(ib)/4.-vz2(ib)/4.+vz3(ib)/4.+vz4(ib)/4.
       end do
     

       !deallocate (xp1,xp2,yp1,yp2,zp0,zp1,zp2)       
       !deallocate (vx1,vy1,vz1,vz2,vz3,vz4)

     end subroutine update_vz_3





     !==================================
     !STRANG
     !==================================

      subroutine update_vx_strang
       implicit none
       integer                  :: ib

       !allocate (xp1(1:npart))           
       do ib=1,npart         
          xp1(ib)=xp(ib)+0.5*dt*vx(ib)
       end do
       !call interpo_l2_3d(vxg,xp1,yp,zp,vx)       
       call interpo_l2_1d_x(vxg,xp1,yp,zp,vx)       
       !deallocate(xp1)
     end subroutine update_vx_strang

     subroutine update_vy_strang
       implicit none
       integer                  :: ib

       !allocate (yp1(1:npart))           
       do ib=1,npart         
          yp1(ib)=yp(ib)+0.5*dt*vy(ib)
       end do
       !call interpo_l2_3d(vyg,xp,yp1,zp,vy)       
       call interpo_l2_1d_y(vyg,xp,yp1,zp,vy)             
       !deallocate(yp1)
     end subroutine update_vy_strang

     subroutine update_vz_strang
       implicit none
       integer                  :: ib

       !allocate (zp1(1:npart))           
       do ib=1,npart         
          zp1(ib)=zp(ib)+0.5*dt*vz(ib)
       end do
       !call interpo_l2_3d(vzg,xp,yp,zp1,vz)       
       call interpo_l2_1d_z(vzg,xp,yp,zp1,vz)       
       !deallocate(zp1)
     end subroutine update_vz_strang





end module advection_mod


