module init_mod
  !
  !initialisation des valeurs sur la grille
  !
contains
  subroutine init_grille
    use donnees_mod
    use tab_mod
    implicit none
    integer        :: i,j,k
    real(kind=8)   :: x,y,z,r,t2

    !------------
    !sphere
    !------------
!!$    do k=1,nz
!!$       z=ztab(k)
!!$       do j=1,ny
!!$          y=ytab(j)
!!$          do i=1,nx
!!$             x=xtab(i)
!!$
!!$             r=sqrt((x-0.35)**2+(y-0.35)**2+(z-0.35)**2)
!!$             qg(i,j,k)=0.
!!$             if (r<=0.15) qg(i,j,k)=1.
!!$
!!$          end do         
!!$       end do
!!$    end do


!!$    !---gaussienne  sur [0,1]^3-------------------------
!!$    !----------------------------------------------------
!!$
!!$    do k=1,nz
!!$       z=ztab(k)
!!$       do j=1,ny
!!$          y=ytab(j)
!!$          do i=1,nx
!!$             x=xtab(i)
!!$             
!!$             qg(i,j,k)=(1.-((x-0.5)**2+(y-0.5)**2+(z-0.5)**2))**6
!!$             if (((x-0.5)**2+(y-0.5)**2+(z-0.5)**2)>1.) qg(i,j,k)=0.
!!$         
!!$          end do
!!$       end do
!!$    end do
!!$    


!!$    !------------
!!$    !cos / sin
!!$    !------------
!!$    do k=1,nz
!!$       z=ztab(k)
!!$       do j=1,ny
!!$          y=ytab(j)
!!$          do i=1,nx
!!$             x=xtab(i)
!!$             
!!$             t2=0.2
!!$             qg(i,j,k)=cos(pi*time/t2)*cos(2.*pi*x)*cos(2.*pi*y)*cos(2.*pi*z)
!!$
!!$          end do         
!!$       end do
!!$    end do


    !------------
    !test
    !------------
    do k=1,nz
       z=ztab(k)
       do j=1,ny
          y=ytab(j)
          do i=1,nx
             x=xtab(i)
         
             qg(i,j,k)=1.

          end do         
       end do
    end do

  end subroutine init_grille



end module init_mod
