program split
  !--------------------------------------------------------------------------
  !etude de l'ordre pour splitting 3D
  !
  !--------------------------------------------------------------------------
  use donnees_mod         ! donnees 
  use tab_mod             ! donnees dans tableaux 
  use init_mod            ! init_grille
  use advection_mod       ! crea_part,advection
  use remaillage_mod      ! remaill_4m_centre (formules de remaillage)
  use interpolation_mod   ! formules d'interpolation (pour range kutta)
  use resultats_mod       ! res_grille_tps,res_grille_freq
  use utile_mod          


  real(kind=8)        :: x,y 
  integer             :: n 
  real(kind=8)        :: time1,time2,time3,time4,dt_deb,maxv

  !pour test
  integer             :: c,i,j,cpt_ite,ib,jb,k,cpt,nx_boucle
  real(kind=8)        :: t1,t2,t3,t4,t5,t6,t7,t8,t9,tmp,dt_boucle,r,grad,div


  !lecture données
  !---------------
  open(unit=10,file="parameter",form="formatted")
  read(10,*) xg,xd,yb,yh,zd,zf  
  read(10,*) tfin 
  read(10,*) cutoff
  read(10,*) type_b
  read(10,*) long_bloc      
  read(10,*) nom_fich_vtk
  read(10,*) name_err
  read(10,*) dossier
  read(10,*) nom_fich_tps_cpu
  close(10)


  name_err=trim(name_err)

  call cpu_time(t1)

  erreur:do nx_boucle=129,129

     open(unit=10,file="parameter",form="formatted")
     read(10,*) xg,xd,yb,yh,zd,zf 
     close (10)

     nx=nx_boucle
     ny=nx_boucle
     nz=nx_boucle

     nx_gro=nx
     ny_gro=nx_gro
     nz_gro=nx_gro

     dx=(xd-xg)/(nx-1.)
     dy=(yh-yb)/(ny-1.)
     dz=(zf-zd)/(nz-1.)

     dx_gro=(xd-xg)/(nx_gro-1.)
     dy_gro=(yh-yb)/(ny_gro-1.)
     dz_gro=(zf-zd)/(nz_gro-1.)


     maxv=2.
     !maxv=3.3
     !maxv=1.
     cfl=0.4
     !cfl=5.
     !cfl=14.
     !cfl=4.
!     cfl=8.
     
     !cfl=2.*0.025252525252525/dx! cfl5
     !cfl=2.*0.02424242520573163/dx !cfl 4.8
 


     !print*,"cfl=",cfl

     dt=cfl*dx/maxv
!     dt=2./150.

     dt=0.049

     print*,"dt",dt

     !
     !calcul init
     !-----------
     cpt_ite=0
     time=0.


     npart=nx*ny*nz


     xd=xd-1./nx !pour conditions periodiques
     yh=yh-1./ny
     zf=zf-1./nz

     nx=nx-1
     ny=ny-1
     nz=nz-1

     nx_gro=nx_gro-1
     ny_gro=ny_gro-1
     nz_gro=nz_gro-1


     pi=4.*atan(1.)

     !
     !alloc tableaux
     !--------------
     call alloc_sub

     open(unit=29,file=name_err,form="formatted") 
     call cpu_time(t2)

     !
     !initialisation
     !--------------
     call make_grille
     call init_grille()

     cutoff=cutoff*maxval(abs(qg))

 
     !=============================
     !champ de vitesse
     !=============================
     call def_v_advec (vxg,vyg,vzg,time) 


     !
     !boucle temps
     !------------
     temps: do while(time<tfin)

        !print*,"cflmax:",dt*max(maxval(vxg),maxval(vyg),maxval(vzg))/dx

        !if ((time+dt)>tfin) dt=tfin-time

        if (time<=2.*dt) dt_deb=dt

                   
        call crea_part_x()   

        if (time<dt) npart_init=npart
        if ((time<=1.).and.(time+dt>1.)) npart_t1=npart
        

        !================================
        !si remaillage tenso en espace
        !================================

!!$        !RK2
!!$        !allocate(vxg1(1:nx_gro,1:ny_gro,1:nz_gro),vyg1(1:nx_gro,1:ny_gro,1:nz_gro),vzg1(1:nx_gro,1:ny_gro,1:nz_gro))
!!$        !call def_v_advec (vxg1,vyg1,vzg1,time+0.5*dt)
!!$
!!$        !RK3
!!$        !allocate(vxg1(1:nx_gro,1:ny_gro,1:nz_gro),vyg1(1:nx_gro,1:ny_gro,1:nz_gro),vzg1(1:nx_gro,1:ny_gro,1:nz_gro))
!!$        !allocate(vxg2(1:nx_gro,1:ny_gro,1:nz_gro),vyg2(1:nx_gro,1:ny_gro,1:nz_gro),vzg2(1:nx_gro,1:ny_gro,1:nz_gro))
!!$        !call def_v_advec (vxg1,vyg1,vzg1,time+0.5*dt)
!!$        !call def_v_advec (vxg2,vyg2,vzg2,time+dt)
!!$
!!$
!!$        !t source:rk4
!!$        !------------
!!$        !call source_rk4
!!$
!!$        !advection
!!$        !---------                   
!!$        !call ad_tenso_euler        
!!$        call ad_tenso_rk2     
!!$        !call ad_tenso_rk3
!!$        !call ad_tenso_rk4
!!$
!!$        !remaillage
!!$        !----------       
!!$        call remaill_l2(qp,xp,yp,zp,qg)
!!$        !call remaill_l3(qp,xp,yp,zp,qg)
!!$        !call remaill_l4(qp,xp,yp,zp,qg)
!!$        !call remaill_l6(qp,xp,yp,zp,qg)  
!!$        !call remaill_l8(qp,xp,yp,zp,qg)
!!$        !call remaill_mp4(qp,xp,yp,zp,qg)  
!!$
!!$        !deallocate(vxg1,vyg1,vzg1)
!!$        !deallocate(vxg2,vyg2,vzg2)
!!$
  
        !=====================
        !splitting en espace
        !=====================
!!$
        !RK2
        !allocate(vxg1(1:nx_gro,1:ny_gro,1:nz_gro),vyg1(1:nx_gro,1:ny_gro,1:nz_gro),vzg1(1:nx_gro,1:ny_gro,1:nz_gro))
        !call def_v_advec (vxg1,vyg1,vzg1,time +0.5*dt)
        !vxg1=vxg
        !vyg1=vyg
        !vzg1=vzg

        !RK3
        !allocate(vxg1(1:nx_gro,1:ny_gro,1:nz_gro),vyg1(1:nx_gro,1:ny_gro,1:nz_gro),vzg1(1:nx_gro,1:ny_gro,1:nz_gro))
        !allocate(vxg2(1:nx_gro,1:ny_gro,1:nz_gro),vyg2(1:nx_gro,1:ny_gro,1:nz_gro),vzg2(1:nx_gro,1:ny_gro,1:nz_gro))
        !allocate(vxg3(1:nx_gro,1:ny_gro,1:nz_gro),vyg3(1:nx_gro,1:ny_gro,1:nz_gro),vzg3(1:nx_gro,1:ny_gro,1:nz_gro))
        !call def_v_advec (vxg1,vyg1,vzg1,time+2.*dt/3.)


        !t source
        !---------
        !call source_split_1

        !test v
        !-------
        !print*,"vmax grille",max(maxval(abs(vxg)),maxval(abs(vyg)),maxval(abs(vzg)))
        !print*,"vmax interpole",max(maxval(abs(vx)),maxval(abs(vy)),maxval(abs(vz)))


        !update v
        !--------
        !call update_vx_2
        !call update_vx_3

        !print*,"vmax interpole rk2",max(maxval(abs(vx)),maxval(abs(vy)),maxval(abs(vz)))
        !stop  

        !test cfl
        !========
        !print*,"test cfl en x "
        !print*,"cfl,cflpart en x",dt/dx*maxval(abs(vxg)),dt/dx*maxval(abs(vx))
!        ainf=0.  
!        do k=1,nz
!           do j=1,ny
!              do i=1,nx-1      
!                 if ( (numpg(i+1,j,k)/=0).and.(numpg(i,j,k)/=0) )  ainf=max(ainf,abs(vx(numpg(i+1,j,k))-vx(numpg(i,j,k))))  
!              end do
!           end do
!        end do
!        if (dt>(0.5*dx/(ainf))) then
!           print*,""
!           print*,"cfl l2 viole" ,dt,0.5*dx/(ainf),0.5*dx/(2.*ainf)
!           print*,""
!        end if
!        if (dt>(0.5*dx/(2.*ainf))) then
!           print*,""
!           print*,"cfl l4 viole" ,dt,0.5*dx/(ainf),0.5*dx/(2.*ainf)       
!           print*,""
!        end if
!        if (dt>(0.5*dx/(3.*ainf))) then
!           print*,""
!           print*,"cfl l4 papier viole" ,dt,0.5*dx/(2.*ainf),0.5*dx/(3.*ainf)       
!           print*,""
!        end if
        !fin test
        !--------


        !bloc x
        !-------
        !call make_bloc(1)
        call make_bloc_v2(1)
        !blocg=0
        !blocd=0

        !advection
        !----------
        call ad_euler_x                 


        !remaillage
        !----------       
        if (type_b==200) call remaill_l2_x(qp,xp,yp,zp,qg)
        if (type_b==400) call remaill_l4_x(qp,xp,yp,zp,qg)
        !call remaill_l5_x(qp,xp,yp,zp,qg)
        if (type_b==600) call remaill_l6_x(qp,xp,yp,zp,qg)
        !call remaill_l8_x(qp,xp,yp,zp,qg)
        if (type_b==2) call remaill_l2_bloc_x_v2(qp,xp,yp,zp,qg) 
        if (type_b==4) call remaill_l4_bloc_x_v2(qp,xp,yp,zp,qg) 
        if (type_b==20) call limit_l2_bloc_x(qp,xp,yp,zp,qg) 

        !contrainte cfl
        !--------------
     !   grad=0.   
     !   do k=1,nz_gro
     !      do j=1,ny_gro
     !         do i=1,nx_gro-1
     !            if ((numpg(i+1,j,k)/=0).and.(numpg(i,j,k)/=0)) grad=max(grad,abs(vx(numpg(i+1,j,k))-vx(numpg(i,j,k)))/dx)        
     !         end do
     !      end do
     !   end do




        !y
        !--
        call crea_part_y()
        !call crea_part_x()


        !update v
        !--------
        !call update_vy_2
        !call update_vy_3       

        !bloc y
        !-------              
        !call make_bloc(2)
        call make_bloc_v2(2)
        !blocg=0
        !blocd=0

        !advection
        !----------
        call ad_euler_y          
        !remaillage
        !----------
        if (type_b==200) call remaill_l2_y(qp,xp,yp,zp,qg)
        if (type_b==400) call remaill_l4_y(qp,xp,yp,zp,qg) 
        !call remaill_l5_y(qp,xp,yp,zp,qg) 
        if (type_b==600) call remaill_l6_y(qp,xp,yp,zp,qg)
        !call remaill_l8_y(qp,xp,yp,zp,qg)
        if (type_b==2)call remaill_l2_bloc_y_v2(qp,xp,yp,zp,qg)        
        if (type_b==4)call remaill_l4_bloc_y_v2(qp,xp,yp,zp,qg)    
        if (type_b==20) call limit_l2_bloc_y(qp,xp,yp,zp,qg)     

        !contrainte cfl
        !--------------
      !  do k=1,nz_gro
      !     do j=1,ny_gro-1
      !        do i=1,nx_gro
      !           if ((numpg(i,j+1,k)/=0).and.(numpg(i,j,k)/=0)) grad=max(grad,abs(vy(numpg(i,j+1,k))-vy(numpg(i,j,k)))/dy)        
      !        end do
      !     end do
      !  end do



        !z
        !--
        call crea_part_z()
        !call crea_part_x()

        !update v
        !--------
        !call update_vz_2
        !call update_vz_3

        !call def_v_advec (vxg1,vyg1,vzg1,time+dt/3.)
        !call def_v_advec (vxg2,vyg2,vzg2,time+4.*dt/3.)
        !call def_v_advec (vxg3,vyg3,vzg3,time+dt)
        !call update_vz_3

        !bloc z
        !-------      
        !call make_bloc(3)
        call make_bloc_v2(3)
        !blocg=0
        !blocd=0

        !advection
        !----------
        call ad_euler_z         

        !remaillage
        !----------
        if (type_b==200) call remaill_l2_z(qp,xp,yp,zp,qg) 
        if (type_b==400) call remaill_l4_z(qp,xp,yp,zp,qg) 
        !call remaill_l5_z(qp,xp,yp,zp,qg) 
        if (type_b==600) call remaill_l6_z(qp,xp,yp,zp,qg)
        !call remaill_l8_z(qp,xp,yp,zp,qg)
        if (type_b==2)call remaill_l2_bloc_z_v2(qp,xp,yp,zp,qg)        
        if (type_b==4)call remaill_l4_bloc_z_v2(qp,xp,yp,zp,qg)  
        if (type_b==20) call limit_l2_bloc_z(qp,xp,yp,zp,qg)       

        !contrainte cfl
        !--------------
      !  do k=1,nz_gro-1
      !     do j=1,ny_gro
      !        do i=1,nx_gro
      !            if ((numpg(i,j,k+1)/=0).and.(numpg(i,j,k)/=0)) grad=max(grad,abs(vz(numpg(i,j,k+1))-vz(numpg(i,j,k)))/dz)        
      !        end do
      !     end do
      !  end do

      !  print*,"t=0,dt,1/(4.*grad),1/(6.*grad)"
      !  print*,"(vitesse sur part)"
      !  print*,dt,1./(4.*grad),1./(6.*grad)  


        !t source
        !---------
        !call source_split_2


        !deallocate(vxg1,vyg1,vzg1)
        !deallocate(vxg2,vyg2,vzg2)
        !deallocate(vxg3,vyg3,vzg3)




        !=================
        !splitting strang
        !=================

!!$        !allocate(vxg1(1:nx_gro,1:ny_gro,1:nz_gro),vyg1(1:nx_gro,1:ny_gro,1:nz_gro),vzg1(1:nx_gro,1:ny_gro,1:nz_gro))
!!$        !call def_v_advec (vxg1,vyg1,vzg1,time+0.5*dt)
!!$
!!$        !t source
!!$        !--------
!!$        !call source_split_1
!!$
!!$        dt_sauv=dt
!!$        dt=0.5*dt
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_strang
!!$
!!$
!!$        !bloc x
!!$        !-------        
!!$        !call make_bloc_v2(1)
!!$        !blocg=0
!!$        !blocd=0
!!$
!!$      
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------       
!!$        !if (type_b==2)call remaill_l2_bloc_x_v2(qp,xp,yp,zp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_x_v2(qp,xp,yp,zp,qg)             
!!$        !call remaill_l2_x(qp,xp,yp,zp,qg) 
!!$        call remaill_l4_x(qp,xp,yp,zp,qg) 
!!$        !call remaill_l5_x(qp,xp,yp,zp,qg) 
!!$        !call remaill_l6_x(qp,xp,yp,zp,qg)
!!$        !call remaill_l8_x(qp,xp,yp,zp,qg)
!!$
!!$        !y
!!$        !--
!!$        call crea_part_y()
!!$
!!$        !update v
!!$        !--------
!!$        call update_vy_strang
!!$
!!$        !bloc y
!!$        !-------      
!!$        !call make_bloc_v2(2)
!!$        !blocg=0
!!$        !blocd=0
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !---------- 
!!$        !if (type_b==2)call remaill_l2_bloc_y_v2(qp,xp,yp,zp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_y_v2(qp,xp,yp,zp,qg) 
!!$        !call remaill_l2_y(qp,xp,yp,zp,qg) 
!!$        call remaill_l4_y(qp,xp,yp,zp,qg) 
!!$        !call remaill_l5_y(qp,xp,yp,zp,qg) 
!!$        !call remaill_l6_y(qp,xp,yp,zp,qg)
!!$        !call remaill_l8_y(qp,xp,yp,zp,qg)       
!!$
!!$
!!$        !z
!!$        !--
!!$        call crea_part_z()
!!$
!!$        dt=dt_sauv
!!$
!!$        !update v
!!$        !--------
!!$        call update_vz_strang
!!$
!!$        !bloc y
!!$        !-------      
!!$        !call make_bloc_v2(3)
!!$        !blocg=0
!!$        !blocd=0
!!$
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_z             
!!$
!!$        !remaillage
!!$        !----------
!!$        !if (type_b==2)call remaill_l2_bloc_z_v2(qp,xp,yp,zp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_z_v2(qp,xp,yp,zp,qg) 
!!$        !call remaill_l2_z(qp,xp,yp,zp,qg) 
!!$        call remaill_l4_z(qp,xp,yp,zp,qg) 
!!$        !call remaill_l5_z(qp,xp,yp,zp,qg) 
!!$        !call remaill_l6_z(qp,xp,yp,zp,qg)
!!$        !call remaill_l8_z(qp,xp,yp,zp,qg)       
!!$
!!$
!!$        !y
!!$        !--
!!$        call crea_part_y()
!!$        dt=0.5*dt
!!$
!!$        !update v
!!$        !--------
!!$        call update_vy_strang
!!$
!!$        !bloc y
!!$        !-------      
!!$        !call make_bloc_v2(2)
!!$        !blocg=0
!!$        !blocd=0
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------
!!$        !if (type_b==2)call remaill_l2_bloc_y_v2(qp,xp,yp,zp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_y_v2(qp,xp,yp,zp,qg) 
!!$        !call remaill_l2_y(qp,xp,yp,zp,qg) 
!!$        call remaill_l4_y(qp,xp,yp,zp,qg) 
!!$        !call remaill_l5_y(qp,xp,yp,zp,qg) 
!!$        !call remaill_l6_y(qp,xp,yp,zp,qg)
!!$        !call remaill_l8_y(qp,xp,yp,zp,qg)       
!!$
!!$
!!$        !x
!!$        !--
!!$        call crea_part_x()
!!$
!!$        !update v
!!$        !--------
!!$        call update_vx_strang
!!$
!!$        !bloc x
!!$        !-------
!!$        !call make_bloc_v2(1)
!!$        !blocg=0
!!$        !blocd=0
!!$      
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------
!!$        !if (type_b==2)call remaill_l2_bloc_x_v2(qp,xp,yp,zp,qg)        
!!$        !if (type_b==4)call remaill_l4_bloc_x_v2(qp,xp,yp,zp,qg) 
!!$        !call remaill_l2_x(qp,xp,yp,zp,qg) 
!!$        call remaill_l4_x(qp,xp,yp,zp,qg) 
!!$        !call remaill_l5_x(qp,xp,yp,zp,qg) 
!!$        !call remaill_l6_x(qp,xp,yp,zp,qg)
!!$        !call remaill_l8_x(qp,xp,yp,zp,qg)       
!!$
!!$      
!!$        dt=dt_sauv
!!$
!!$        !t source
!!$        !--------
!!$        !call source_split_2
!!$
!!$        !deallocate(vxg1,vyg1,vzg1)






        !==========================
        !splitting additif ordre 1
        !===========================
!!$       
!!$        !bloc x
!!$        !-------        
!!$        call make_bloc_v2(1)    
!!$      
!!$        !advection
!!$        !----------
!!$        call ad_euler_x             
!!$
!!$        !remaillage
!!$        !----------
!!$        !call remaill_l6_x(qp,xp,yp,zp,qg)         
!!$        if (type_b==2)call remaill_l2_bloc_x_v2(qp,xp,yp,zp,qg)        
!!$        if (type_b==4)call remaill_l4_bloc_x_v2(qp,xp,yp,zp,qg)             
!!$
!!$        !y
!!$        !--
!!$        call crea_part_y()      
!!$
!!$        !bloc y
!!$        !-------      
!!$        call make_bloc_v2(2)       
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_y             
!!$
!!$        !remaillage
!!$        !----------
!!$        !call remaill_l6_y(qp,xp,yp,zp,qg) 
!!$        if (type_b==2)call remaill_l2_bloc_y_v2(qp,xp,yp,zp,qg)        
!!$        if (type_b==4)call remaill_l4_bloc_y_v2(qp,xp,yp,zp,qg)        
!!$
!!$
!!$        !z
!!$        !--
!!$        call crea_part_z()
!!$            
!!$        !bloc y
!!$        !-------      
!!$        call make_bloc_v2(3)     
!!$
!!$        !advection
!!$        !----------
!!$        call ad_euler_z             
!!$
!!$        !remaillage
!!$        !----------
!!$        !call remaill_l6_z(qp,xp,yp,zp,qg) 
!!$        if (type_b==2)call remaill_l2_bloc_z_v2(qp,xp,yp,zp,qg)        
!!$        if (type_b==4)call remaill_l4_bloc_z_v2(qp,xp,yp,zp,qg)        






     !   write(29,'(3(e18.10,2x))') time,minval(qg),maxval(qg)



        time=time+dt
        cpt_ite=cpt_ite+1





     end do temps



     !  write(29,'(4(e18.10,2x))') dt_deb,dx,dx*dy*dz*sum(abs(exa-qg)),sqrt(dx*dy*dz*sum((exa-qg)**2))     


  end do erreur

  call cpu_time(t3)

  !resultat final
  !--------------
  print*,"tps final",time
  print*,"nbre d'ite",cpt_ite
  print*,"nart final",npart
  print*,"dt,dt_fin,dx,dy,dz",dt_deb,dt,dx,dy,dz
  print*,"temps cpu",nom_fich_vtk,t3-t1,t3-t2



  call res_vtk_q(trim(dossier)//trim(nom_fich_vtk))
  !call res_vtk("RES/vtk/"//nom_fich_vtk)

  open(unit=10,file=trim(dossier)//"tps/"//trim(nom_fich_tps_cpu),form="formatted") 
  write(10,*) t3-t1,t3-t2
  write(10,*) npart_init,npart_t1,npart

  !
  !dealloc fermeture
  !-----------------
  close(50)
  close(51)
  close(52)
  close(53)
  close(66)
  close(67)
  close(10)
  close(29)

  deallocate (xp,qp,vx,vy,yp,zp,vz)
  deallocate (qg,vxg,vyg,vzg)
  deallocate (xtab,ytab,ztab)
  deallocate (xp1,yp1,zp1)
  deallocate (xp2,yp2,zp2)
  deallocate (xp3,yp3,zp3)
  deallocate (numpg,blocg,blocd,Nbloc) 
  !deallocate (exa)


end program split



