program test_fft
  use nrtype 
  USE nrutil
  USE nr 
  implicit none



  !==============================
  !test aller/retour
  !==============================


!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec1,spec_exa1
!!$  complex(SPC),dimension(:,:),allocatable     :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz
!!$  real(SP),dimension(:,:,:),allocatable       :: psi,f,exa
!!$    
!!$  nx=4
!!$  ny=4
!!$  nz=4

!!$  allocate (donne_init(1:nx,1:ny,1:nz),donne_fin(1:nx,1:ny,1:nz), spec1(1:nx/2,1:ny,1:nz), spec2(1:ny,1:nz) )
!!$
!!$  donne_init=3.   
!!$  fac=2./(nx*ny*nz)
!!$
!!$  print*, "forward"
!!$  call rlft3(donne_init,spec1,spec2,1)
!!$  print*,"backward"
!!$  call rlft3(donne_fin,spec1,spec2,-1)
!!$
!!$  print*,"donne(1,1,1)",fac*donne_fin(1,1,1)
!!$
!!$  print*,"test"
!!$  do k=1,nz
!!$     do j=1,ny
!!$        do i=1,nx
!!$           if (abs((fac*donne_fin(i,j,k))-donne_init(i,j,k))>0.001) print*,i,j,k,fac*donne_fin(i,j,k),donne_init(i,j,k)
!!$        end do
!!$     end do
!!$  end do
!!$
!!$  deallocate (donne_init,donne_fin,spec1,spec2)




!!$
!!$
!!$  !===============================================================
!!$  !test laplacien 2D: discrétisation ordre2, utilisation de four2
!!$  !================================================================ 
!!$  integer(I4B)                                :: nx,ny
!!$  complex(SPC),dimension(:,:),allocatable     :: spec1,spec_exa1
!!$  complex(SPC),dimension(:),allocatable       :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,xg,xd,yb,yh,t1,t2,dx,dy,rn,rm
!!$  complex(SPC),dimension(:,:),allocatable     :: psi,f,exa
!!$
!!$  nx=32
!!$  ny=32
!!$
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$
!!$
!!$  dx=t1/(nx)
!!$  dy=t2/(ny)
!!$
!!$
!!$  allocate (psi(1:nx,1:ny),exa(1:nx,1:ny),f(1:nx,1:ny))
!!$  allocate (spec1(1:nx,1:ny),spec_exa1(1:nx,1:ny))
!!$
!!$  !nx+1 point mais le dernier = premier par sym
!!$
!!$  do j=1,ny
!!$     y=yb+(j-1)*dy
!!$     do i=1,nx
!!$        x=xg+(i-1)*dx
!!$
!!$        exa(i,j)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)
!!$        f(i,j)=-(4.*pi**2*exa(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$
!!$     end do
!!$  end do
!!$
!!$  spec1=f
!!$  spec_exa1=exa
!!$
!!$
!!$  !fft forward
!!$  call four2(spec1,1)
!!$  call four2(spec_exa1,1) 
!!$
!!$ 
!!$  !calcul de la solution dans l'espace des frequences 
!!$
!!$  do n=1,ny
!!$     do m=1,nx                 
!!$       
!!$        spec1(m,n)=dx**2*spec1(m,n)/(2.*(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)-2.))
!!$        ! le premier mode correspond à l'integrale de la masse: conservee pour un ecoulement periodique        
!!$        if ((m==1).and.(n==1)) spec1(m,n)=0. 
!!$        
!!$     end do
!!$  end do
!!$
!!$ 
!!$  print*,"erreur spectre"
!!$  print*,maxval(abs(spec_exa1-spec1)),maxloc(abs(spec_exa1-spec1))
!!$
!!$
!!$  !fft backward
!!$  fac=1./(nx*ny)
!!$  call four2(spec1,-1)
!!$  psi=fac*spec1
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa))
!!$  print*,"dx**2",dx**2
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1)




!!$  !===============================================================
!!$  !test laplacien 2D: discretisation ordre2, utilisation de rlft2
!!$  !================================================================ 
!!$  integer(I4B)                                :: nx,ny
!!$  real(SP),dimension(:,:),allocatable         :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:),allocatable     :: spec1,spec_exa1
!!$  complex(SPC),dimension(:),allocatable       :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,xg,xd,yb,yh,t1,t2,dx,dy
!!$  real(SP),dimension(:,:),allocatable         :: psi,f,exa
!!$
!!$  nx=256
!!$  ny=256
!!$
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$
!!$
!!$  dx=t1/(nx)
!!$  dy=t2/(ny)
!!$
!!$
!!$  allocate (psi(1:nx,1:ny),exa(1:nx,1:ny),f(1:nx,1:ny))
!!$  allocate (spec1(1:nx/2,1:ny), spec2(1:ny),spec_exa1(1:nx/2,1:ny), spec_exa2(1:ny) )
!!$
!!$  !nx+1 point mais le dernier = premier par sym
!!$
!!$  do j=1,ny
!!$     y=yb+(j-1)*dy
!!$     do i=1,nx
!!$        x=xg+(i-1)*dx
!!$
!!$        exa(i,j)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)
!!$        f(i,j)=-(4.*pi**2*exa(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft forward
!!$  call rlft2(f,spec1,spec2,1)
!!$  call rlft2(exa,spec_exa1,spec_exa2,1)
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1
!!$
!!$  !calcul de la solution dans l'espace des frequences (discretisation d'ordre2 du laplacien)
!!$  m=nx/2+1   
!!$  do n=1,ny
!!$     spec2(n)=0.5*dx**2*spec2(n)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)-2.)      
!!$  end do
!!$
!!$  do n=1,ny
!!$     do m=1,nx/2           
!!$
!!$        spec1(m,n)=0.5*dx**2*spec1(m,n)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)-2.)
!!$        if ((n==1).and.(m==1)) spec1(m,n)=0.
!!$
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny)
!!$  call rlft2(psi,spec1,spec2,-1)
!!$  psi=fac*psi
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa))
!!$  print*,"dx**2",dx**2
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1,spec2,spec_exa2)





!!$  !===============================================================
!!$  !test laplacien 3D: discretisation ordre2, utilisation de rlft3
!!$  !================================================================  
!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec1,spec_exa1
!!$  complex(SPC),dimension(:,:),allocatable     :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz
!!$  real(SP),dimension(:,:,:),allocatable       :: psi,f,exa
!!$
!!$  nx=64
!!$  ny=64
!!$  nz=64
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$  zd=-1.
!!$  zf=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$  t3=zf-zd
!!$
!!$
!!$  dx=t1/nx
!!$  dy=t2/ny
!!$  dz=t3/nz
!!$
!!$ if ((dx/=dy).or.(dx/=dz)) then
!!$     print*,"attention dx=dy=dz"
!!$     stop
!!$  end if
!!$
!!$  allocate (psi(1:nx,1:ny,1:nz),exa(1:nx,1:ny,1:nz),f(1:nx,1:ny,1:nz))
!!$  allocate (spec1(1:nx/2,1:ny,1:nz), spec2(1:ny,1:nz),spec_exa1(1:nx/2,1:ny,1:nz), spec_exa2(1:ny,1:nz) )
!!$
!!$  do k=1,nz
!!$     z=zd+(k-1)*dz
!!$     do j=1,ny
!!$        y=yb+(j-1)*dy
!!$        do i=1,nx
!!$           x=xg+(i-1)*dx
!!$
!!$           exa(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
!!$           f(i,j,k)=-(4.*pi**2*exa(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft forward
!!$  call rlft3(f,spec1,spec2,1)
!!$  call rlft3(exa,spec_exa1,spec_exa2,1)
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1 
!!$
!!$ !calcul de la solution dans l'espace des frequences (discretisation d'ordre2 du laplacien)
!!$  m=nx/2+1  
!!$  do p=1,nz
!!$     do n=1,ny        
!!$        spec2(n,p)=0.5*dx**2*spec2(n,p)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.)        
!!$     end do
!!$  end do
!!$
!!$  do p=1,nz
!!$     do n=1,ny
!!$        do m=1,nx/2           
!!$           spec1(m,n,p)=0.5*dx**2*spec1(m,n,p)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.)
!!$           if ((n==1).and.(m==1).and.(p==1)) spec1(m,n,p)=0.
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny*nz)
!!$  call rlft3(psi,spec1,spec2,-1)
!!$  psi=fac*psi
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa))
!!$  print*,"dx**2",dx**2
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1,spec2,spec_exa2)
!!$






!!$  !===============================================================
!!$  !test laplacien 2D:  utilisation de four2
!!$  !================================================================ 
!!$  integer(I4B)                                :: nx,ny
!!$  complex(SPC),dimension(:,:),allocatable     :: spec1,spec_exa1
!!$  complex(SPC),dimension(:),allocatable       :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,xg,xd,yb,yh,t1,t2,dx,dy,kx,ky
!!$  complex(SPC),dimension(:,:),allocatable     :: psi,f,exa
!!$
!!$  nx=8
!!$  ny=8
!!$
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$
!!$
!!$  dx=t1/(nx)
!!$  dy=t2/(ny)
!!$
!!$
!!$  allocate (psi(1:nx,1:ny),exa(1:nx,1:ny),f(1:nx,1:ny))
!!$  allocate (spec1(1:nx,1:ny),spec_exa1(1:nx,1:ny))
!!$
!!$  !nx+1 point mais le dernier = premier par sym
!!$
!!$  do j=1,ny
!!$     y=yb+(j-1)*dy
!!$     do i=1,nx
!!$        x=xg+(i-1)*dx
!!$
!!$        exa(i,j)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)
!!$        f(i,j)=-(4.*pi**2*exa(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$
!!$     end do
!!$  end do
!!$
!!$  spec1=f
!!$  spec_exa1=exa
!!$
!!$
!!$  !fft forward
!!$  call four2(spec1,1)
!!$  call four2(spec_exa1,1) 
!!$
!!$ 
!!$  !calcul de la solution dans l'espace des frequences 
!!$  do n=1,ny
!!$     do m=1,nx                 
!!$       
!!$        !attention au rangement des frequences: >0 puis 0 puis <0        
!!$
!!$        if ( (m-1)<=(nx/2) ) then
!!$           kx=(m-1)/t1
!!$        else
!!$           kx=(m-1-nx)/t1
!!$        end if
!!$
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$
!!$       
!!$        spec1(m,n)=-spec1(m,n)/(4.*pi**2*(kx**2+ky**2))
!!$        if ((kx==0).and.(ky==0)) spec1(m,n)=0.
!!$        
!!$     end do
!!$  end do
!!$ 
!!$
!!$ 
!!$  print*,"erreur spectre"
!!$  print*,maxval(abs(spec_exa1-spec1)),maxloc(abs(spec_exa1-spec1))
!!$
!!$
!!$  !fft backward
!!$  fac=1./(nx*ny)
!!$  call four2(spec1,-1)
!!$  psi=fac*spec1
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa))
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1)
!!$



!!$
!!$  !===============================================================
!!$  !test laplacien 2D:  utilisation de rlft2
!!$  !================================================================ 
!!$  integer(I4B)                                :: nx,ny
!!$  complex(SPC),dimension(:,:),allocatable     :: spec1,spec_exa1
!!$  complex(SPC),dimension(:),allocatable       :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,xg,xd,yb,yh,t1,t2,dx,dy,kx,ky
!!$  real(SP),dimension(:,:),allocatable         :: psi,f,exa
!!$
!!$  nx=8
!!$  ny=8
!!$
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$
!!$
!!$  dx=t1/(nx)
!!$  dy=t2/(ny)
!!$
!!$
!!$  allocate (psi(1:nx,1:ny),exa(1:nx,1:ny),f(1:nx,1:ny))
!!$  allocate (spec1(1:nx/2,1:ny), spec2(1:ny),spec_exa1(1:nx/2,1:ny), spec_exa2(1:ny) )
!!$
!!$  !nx+1 point mais le dernier = premier par sym
!!$
!!$  do j=1,ny
!!$     y=yb+(j-1)*dy
!!$     do i=1,nx
!!$        x=xg+(i-1)*dx
!!$
!!$        exa(i,j)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)
!!$        f(i,j)=-(4.*pi**2*exa(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$
!!$     end do
!!$  end do
!!$
!!$  !fft forward
!!$  call rlft2(f,spec1,spec2,1)
!!$  call rlft2(exa,spec_exa1,spec_exa2,1)
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1
!!$
!!$ 
!!$  !calcul de la solution dans l'espace des frequences 
!!$  do n=1,ny
!!$     do m=1,nx/2                              
!!$       
!!$        kx=(m-1)/t1
!!$        
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$
!!$        spec1(m,n)=-spec1(m,n)/(4.*pi**2*(kx**2+ky**2))
!!$        if ((kx==0).and.(ky==0)) spec1(m,n)=0.
!!$        
!!$     end do
!!$  end do
!!$
!!$  m=nx/2+1   
!!$  do n=1,ny
!!$
!!$     kx=(m-1)/t1
!!$     if ( (n-1)<=(ny/2) ) then
!!$        ky=(n-1)/t2
!!$     else
!!$        ky=(n-1-ny)/t2
!!$     end if
!!$
!!$     spec2(n)=-spec2(n)/(4.*pi**2*(kx**2+ky**2))
!!$     if ((kx==0).and.(ky==0)) spec2(n)=0.
!!$  end do
!!$
!!$ 
!!$  print*,"spec_exa"
!!$  print*,spec_exa1
!!$  print*,spec_exa2
!!$  print*,"spec"
!!$  print*,spec1
!!$  print*,spec2
!!$
!!$ 
!!$  print*,"erreur spectre"
!!$  print*,maxval(abs(spec_exa1-spec1)),maxloc(abs(spec_exa1-spec1))
!!$  print*,maxval(abs(spec_exa2-spec2)),maxloc(abs(spec_exa2-spec2))
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny)
!!$  call rlft2(psi,spec1,spec2,-1)
!!$  psi=fac*psi
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa))
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1)
!!$
!!$

!!$  !===============================================================
!!$  !test laplacien 3D:  utilisation de rlft3
!!$  !================================================================ 
!!$
!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec1,spec_exa1
!!$  complex(SPC),dimension(:,:),allocatable     :: spec2,spec_exa2
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz,kx,ky,kz
!!$  real(SP),dimension(:,:,:),allocatable       :: psi,f,exa
!!$  
!!$
!!$  nx=8
!!$  ny=64
!!$  nz=32
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$  zd=-1.
!!$  zf=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$  t3=zf-zd
!!$
!!$
!!$  dx=t1/nx
!!$  dy=t2/ny
!!$  dz=t3/nz
!!$
!!$
!!$  allocate (psi(1:nx,1:ny,1:nz),exa(1:nx,1:ny,1:nz),f(1:nx,1:ny,1:nz))
!!$  allocate (spec1(1:nx/2,1:ny,1:nz), spec2(1:ny,1:nz),spec_exa1(1:nx/2,1:ny,1:nz), spec_exa2(1:ny,1:nz) )
!!$
!!$  do k=1,nz
!!$     z=zd+(k-1)*dz
!!$     do j=1,ny
!!$        y=yb+(j-1)*dy
!!$        do i=1,nx
!!$           x=xg+(i-1)*dx
!!$
!!$           exa(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
!!$           f(i,j,k)=-(4.*pi**2*exa(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft forward
!!$  call rlft3(f,spec1,spec2,1)
!!$  call rlft3(exa,spec_exa1,spec_exa2,1)
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1 
!!$
!!$ !calcul de la solution dans l'espace des frequences (discretisation d'ordre2 du laplacien)
!!$  m=nx/2+1  
!!$  do p=1,nz
!!$     do n=1,ny        
!!$       
!!$        kx=(m-1)/t1
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$        if ( (p-1)<=(nz/2) ) then
!!$           kz=(p-1)/t3
!!$        else
!!$           kz=(p-1-nz)/t3
!!$        end if
!!$
!!$        spec2(n,p)=-spec2(n,p)/(4.*pi**2*(kx**2+ky**2+kz**2))
!!$        if ((kx==0).and.(ky==0).and.(kz==0)) spec2(n,p)=0.
!!$
!!$
!!$     end do
!!$  end do
!!$
!!$  do p=1,nz
!!$     do n=1,ny
!!$        do m=1,nx/2           
!!$          
!!$
!!$           kx=(m-1)/t1
!!$           if ( (n-1)<=(ny/2) ) then
!!$              ky=(n-1)/t2
!!$           else
!!$              ky=(n-1-ny)/t2
!!$           end if
!!$           if ( (p-1)<=(nz/2) ) then
!!$              kz=(p-1)/t3
!!$           else
!!$              kz=(p-1-nz)/t3
!!$           end if
!!$       
!!$
!!$           spec1(m,n,p)=-spec1(m,n,p)/(4.*pi**2*(kx**2+ky**2+kz**2))
!!$           if ((kx==0).and.(ky==0).and.(kz==0)) spec1(m,n,p)=0.
!!$        
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny*nz)
!!$  call rlft3(psi,spec1,spec2,-1)
!!$  psi=fac*psi
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psi-exa)),maxloc(abs(psi-exa)) 
!!$ 
!!$
!!$  deallocate (psi,exa,f)
!!$  deallocate(spec1,spec_exa1,spec2,spec_exa2)





  !===============================================================
  !test laplacien 2D:  utilisation de four2 calcul champ vitesse
  !================================================================ 
!!$  integer(I4B)                                :: nx,ny
!!$  complex(SPC),dimension(:,:),allocatable     :: spec1x,spec1y,spec1z
!!$  complex(SPC),dimension(:,:),allocatable     :: spec_exa1x,spec_exa1y,spec_exa1z
!!$  complex(SPC),dimension(:),allocatable       :: spec2x,spec2y,spec2z
!!$  complex(SPC),dimension(:),allocatable       :: spec_exa2x,spec_exa2y,spec_exa2z
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,xg,xd,yb,yh,t1,t2,dx,dy,kx,ky
!!$  complex(SPC),dimension(:,:),allocatable     :: psix,fx,exax,psiy,fy,exay,psiz,fz,exaz
!!$
!!$  nx=8
!!$  ny=8
!!$
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$
!!$
!!$  dx=t1/(nx)
!!$  dy=t2/(ny)
!!$
!!$
!!$  allocate (psix(1:nx,1:ny),exax(1:nx,1:ny),fx(1:nx,1:ny))
!!$  allocate (psiy(1:nx,1:ny),exay(1:nx,1:ny),fy(1:nx,1:ny))
!!$  allocate (spec1x(1:nx,1:ny),spec_exa1x(1:nx,1:ny))
!!$  allocate (spec1y(1:nx,1:ny),spec_exa1y(1:nx,1:ny))
!!$
!!$  !nx+1 point mais le dernier = premier par sym
!!$
!!$  do j=1,ny
!!$     y=yb+(j-1)*dy
!!$     do i=1,nx
!!$        x=xg+(i-1)*dx
!!$        
!!$        psix(i,j)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)
!!$        psiy(i,j)=sin(2.*pi*x/t1)*sin(2.*pi*y/t2)
!!$
!!$        fx(i,j)=-(4.*pi**2*psix(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$        fy(i,j)=-(4.*pi**2*psiy(i,j)*(t2**2+t1**2))/((t1*t2)**2)
!!$
!!$        exax(i,j)=2.*pi*cos(2.*pi*x/t1)*sin(2.*pi*y/t2)*(t1+t2)/(t1*t2)
!!$
!!$     end do
!!$  end do
!!$
!!$  spec1x=fx
!!$  spec1y=fy
!!$
!!$  !poisson
!!$  !spec_exa1x=psix
!!$  !spec_exa1y=psiy
!!$
!!$  !vitesse
!!$  spec_exa1x=exax
!!$  spec_exa1y=exax
!!$
!!$
!!$  !fft forward
!!$  call four2(spec1x,1)
!!$  call four2(spec_exa1x,1)
!!$  call four2(spec1y,1)
!!$  call four2(spec_exa1y,1) 
!!$
!!$ 
!!$  !calcul de la solution dans l'espace des frequences 
!!$  do n=1,ny
!!$     do m=1,nx                 
!!$       
!!$        !attention au rangement des frequences: >0 puis 0 puis <0        
!!$
!!$        if ( (m-1)<=(nx/2) ) then
!!$           kx=(m-1)/t1
!!$        else
!!$           kx=(m-1-nx)/t1
!!$        end if
!!$
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$
!!$        !poisson
!!$        !spec1x(m,n)=-spec1x(m,n)/(4.*pi**2*(kx**2+ky**2))
!!$        !if ((kx==0).and.(ky==0)) spec1x(m,n)=0.
!!$        !spec1y(m,n)=-spec1y(m,n)/(4.*pi**2*(kx**2+ky**2))
!!$        !if ((kx==0).and.(ky==0)) spec1y(m,n)=0.
!!$
!!$        !poisson+vitesse
!!$        spec1x(m,n)=-2.*pi*cmplx(0.,1.)*(-kx*spec1y(m,n)/(4.*pi**2*(kx**2+ky**2)))&
!!$                    -2.*pi*cmplx(0.,1.)*(ky*spec1x(m,n)/(4.*pi**2*(kx**2+ky**2)))
!!$        if ((kx==0).and.(ky==0)) spec1x(m,n)=0.
!!$        
!!$        
!!$     end do
!!$  end do
!!$ 
!!$
!!$ 
!!$  print*,"erreur spectre"
!!$  print*,maxval(abs(spec_exa1x-spec1x)),maxloc(abs(spec_exa1x-spec1x))
!!$  !print*,maxval(abs(spec_exa1y-spec1y)),maxloc(abs(spec_exa1y-spec1y))
!!$
!!$
!!$  !fft backward
!!$  fac=1./(nx*ny)
!!$
!!$  !poisson
!!$  !call four2(spec1x,-1)
!!$  !exax=fac*spec1x
!!$  !call four2(spec1y,-1)
!!$  !exay=fac*spec1y
!!$
!!$  !vitesse
!!$  call four2(spec1x,-1)
!!$  psix=fac*spec1x
!!$
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psix-exax)),maxloc(abs(psix-exax))
!!$  !print*,maxval(abs(psiy-exay)),maxloc(abs(psiy-exay))
!!$ 
!!$
!!$  deallocate (psix,exax,fx)
!!$  deallocate(spec1x,spec_exa1x)
!!$  deallocate (psiy,exay,fy)
!!$  deallocate(spec1y,spec_exa1y)
!!$
!!$
!!$
!!$
!!$ 
  !===============================================================
  !test laplacien + champ de vitesse 3D:  utilisation de four3
  !================================================================ 

!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec1x, spec1y, spec1z
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec1xn, spec1yn, spec1zn
!!$  complex(SPC),dimension(:,:),allocatable     :: spec2x, spec2y, spec2z
!!$  complex(SPC),dimension(:,:,:),allocatable   :: spec_exa1x, spec_exa1y, spec_exa1z
!!$  complex(SPC),dimension(:,:),allocatable     :: spec_exa2x, spec_exa2y, spec_exa2z
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz,kx,ky,kz,r2,coeff
!!$  real(SP),dimension(:,:,:),allocatable       :: psix,psiy,psiz,fx,fy,fz,exax,exay,exaz
!!$  
!!$
!!$  nx=4
!!$  ny=4
!!$  nz=4
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$  zd=-1.
!!$  zf=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$  t3=zf-zd
!!$
!!$
!!$  dx=t1/nx
!!$  dy=t2/ny
!!$  dz=t3/nz
!!$
!!$
!!$  allocate (psix(1:nx,1:ny,1:nz),exax(1:nx,1:ny,1:nz),fx(1:nx,1:ny,1:nz))
!!$  allocate (psiy(1:nx,1:ny,1:nz),exay(1:nx,1:ny,1:nz),fy(1:nx,1:ny,1:nz))
!!$  allocate (psiz(1:nx,1:ny,1:nz),exaz(1:nx,1:ny,1:nz),fz(1:nx,1:ny,1:nz))
!!$  allocate (spec1x(1:nx,1:ny,1:nz),spec1xn(1:nx,1:ny,1:nz) )
!!$  allocate (spec1y(1:nx,1:ny,1:nz),spec1yn(1:nx,1:ny,1:nz) )
!!$  allocate (spec1z(1:nx,1:ny,1:nz),spec1zn(1:nx,1:ny,1:nz) )
!!$  allocate (spec_exa1x(1:nx,1:ny,1:nz) )
!!$  allocate (spec_exa1y(1:nx,1:ny,1:nz) )
!!$  allocate (spec_exa1z(1:nx,1:ny,1:nz) )
!!$
!!$
!!$  do k=1,nz
!!$     z=zd+(k-1)*dz
!!$     do j=1,ny
!!$        y=yb+(j-1)*dy
!!$        do i=1,nx
!!$           x=xg+(i-1)*dx
!!$
!!$           !psi
!!$           psix(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
!!$           psiy(i,j,k)=sin(2.*pi*x/t1)*sin(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$           psiz(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$
!!$           !vitesse
!!$           exax(i,j,k)=-2.*pi*sin(2.*pi*y/t2)*(cos(2.*pi*x/t1)*sin(2.*pi*z/t3)*t3+sin(2.*pi*x/t1)*cos(2.*pi*z/t3)*t2)/(t2*t3)
!!$           exay(i,j,k)=-2.*pi*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)*(cos(2.*pi*x/t1)*t1-sin(2.*pi*x/t1)*t3)/(t1*t3)
!!$           exaz(i,j,k)=2.*pi*sin(2.*pi*y/t2)*cos(2.*pi*x/t1)*(sin(2.*pi*z/t3)*t2+cos(2.*pi*z/t3)*t1)/(t2*t1)
!!$
!!$           !-omega
!!$           fx(i,j,k)=-(4.*pi**2*psix(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fy(i,j,k)=-(4.*pi**2*psiy(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fz(i,j,k)=-(4.*pi**2*psiz(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$  spec1x=fx
!!$  spec1y=fy
!!$  spec1z=fz
!!$
!!$  spec_exa1x=exax
!!$  spec_exa1y=exay
!!$  spec_exa1z=exaz
!!$
!!$  !fft forward
!!$  call four3(spec1x,1)
!!$  call four3(spec1y,1)
!!$  call four3(spec1z,1)
!!$
!!$  call four3(spec_exa1x,1)
!!$  call four3(spec_exa1y,1)
!!$  call four3(spec_exa1z,1)
!!$
!!$ 
!!$ !calcul de la solution dans l'espace des frequences 
!!$
!!$  do p=1,nz
!!$     do n=1,ny
!!$        do m=1,nx           
!!$          
!!$           if ( (m-1)<=(nx/2) ) then
!!$              kx=(m-1)/t1
!!$           else
!!$              kx=(m-1-nx)/t1
!!$           end if
!!$           if ( (n-1)<=(ny/2) ) then
!!$              ky=(n-1)/t2
!!$           else
!!$              ky=(n-1-ny)/t2
!!$           end if
!!$           if ( (p-1)<=(nz/2) ) then
!!$              kz=(p-1)/t3
!!$           else
!!$              kz=(p-1-nz)/t3
!!$           end if
!!$       
!!$           r2=kx**2+ky**2+kz**2
!!$
!!$          
!!$           !poisson+vitesse
!!$           spec1xn(m,n,p)=-2.*pi*cmplx(0.,1.)*(-ky*spec1z(m,n,p)/(4.*pi**2*r2))&
!!$                         -2.*pi*cmplx(0.,1.)*(kz*spec1y(m,n,p)/(4.*pi**2*r2))
!!$           if ((r2==0)) spec1xn(m,n,p)=0.
!!$
!!$           spec1yn(m,n,p)=-2.*pi*cmplx(0.,1.)*(-kz*spec1x(m,n,p)/(4.*pi**2*r2))&
!!$                         -2.*pi*cmplx(0.,1.)*(kx*spec1z(m,n,p)/(4.*pi**2*r2))
!!$           if ((r2==0)) spec1yn(m,n,p)=0.
!!$
!!$
!!$           spec1zn(m,n,p)=-2.*pi*cmplx(0.,1.)*(-kx*spec1y(m,n,p)+ky*spec1x(m,n,p))/(4.*pi**2*r2)
!!$           if ((r2==0)) spec1zn(m,n,p)=0.
!!$          
!!$        
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  print*,"erreur spectre"
!!$  print*,maxval(abs(spec_exa1x-spec1xn)),maxloc(abs(spec_exa1x-spec1xn))
!!$  print*,maxval(abs(spec_exa1y-spec1yn)),maxloc(abs(spec_exa1y-spec1yn))
!!$  print*,maxval(abs(spec_exa1z-spec1zn)),maxloc(abs(spec_exa1z-spec1zn))
!!$
!!$
!!$  !fft backward
!!$  fac=1./(nx*ny*nz)
!!$ 
!!$  call four3(spec1xn,-1)
!!$  call four3(spec1yn,-1)
!!$  call four3(spec1zn,-1)
!!$
!!$  psix=fac*spec1xn
!!$  psiy=fac*spec1yn
!!$  psiz=fac*spec1zn
!!$ 
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psix-exax)),maxloc(abs(psix-exax)) 
!!$  print*,maxval(abs(psiy-exay)),maxloc(abs(psiy-exay)) 
!!$  print*,maxval(abs(psiz-exaz)),maxloc(abs(psiz-exaz)) 
!!$ 
!!$
!!$  deallocate (psix,exax,fx)
!!$  deallocate (psiy,exay,fy)
!!$  deallocate (psiz,exaz,fz)
!!$  deallocate(spec1x,spec1xn)
!!$  deallocate(spec1y,spec1yn)
!!$  deallocate(spec1z,spec1zn)
!!$  deallocate(spec_exa1x)
!!$  deallocate(spec_exa1y)
!!$  deallocate(spec_exa1z)
!!$

 !===============================================================
  !test laplacien + champ de vitesse 3D:  utilisation de rlft3
  !================================================================ 
!!$
!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: sf1x, sf1y, sf1z
!!$  complex(SPC),dimension(:,:,:),allocatable   :: su1x, su1y, su1z
!!$  complex(SPC),dimension(:,:),allocatable     :: sf2x, sf2y, sf2z
!!$  complex(SPC),dimension(:,:),allocatable     :: su2x, su2y, su2z 
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz,kx,ky,kz,r2,coeff
!!$  real(SP),dimension(:,:,:),allocatable       :: psix,psiy,psiz,fx,fy,fz,exax,exay,exaz
!!$
!!$
!!$  nx=8
!!$  ny=32
!!$  nz=16
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$  zd=-1.
!!$  zf=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$  t3=zf-zd
!!$
!!$
!!$  dx=t1/nx
!!$  dy=t2/ny
!!$  dz=t3/nz
!!$
!!$
!!$  allocate (psix(1:nx,1:ny,1:nz),exax(1:nx,1:ny,1:nz),fx(1:nx,1:ny,1:nz))
!!$  allocate (psiy(1:nx,1:ny,1:nz),exay(1:nx,1:ny,1:nz),fy(1:nx,1:ny,1:nz))
!!$  allocate (psiz(1:nx,1:ny,1:nz),exaz(1:nx,1:ny,1:nz),fz(1:nx,1:ny,1:nz))
!!$  allocate (sf1x(1:nx/2,1:ny,1:nz),su1x(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf1y(1:nx/2,1:ny,1:nz),su1y(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf1z(1:nx/2,1:ny,1:nz),su1z(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf2x(1:ny,1:nz),su2x(1:ny,1:nz) )
!!$  allocate (sf2y(1:ny,1:nz),su2y(1:ny,1:nz) )
!!$  allocate (sf2z(1:ny,1:nz),su2z(1:ny,1:nz) )
!!$
!!$
!!$  do k=1,nz
!!$     z=zd+(k-1)*dz
!!$     do j=1,ny
!!$        y=yb+(j-1)*dy
!!$        do i=1,nx
!!$           x=xg+(i-1)*dx
!!$
!!$           !psi
!!$           psix(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
!!$           psiy(i,j,k)=sin(2.*pi*x/t1)*sin(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$           psiz(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$
!!$           !vitesse
!!$           exax(i,j,k)=-2.*pi*sin(2.*pi*y/t2)*(cos(2.*pi*x/t1)*sin(2.*pi*z/t3)*t3+sin(2.*pi*x/t1)*cos(2.*pi*z/t3)*t2)/(t2*t3)
!!$           exay(i,j,k)=-2.*pi*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)*(cos(2.*pi*x/t1)*t1-sin(2.*pi*x/t1)*t3)/(t1*t3)
!!$           exaz(i,j,k)=2.*pi*sin(2.*pi*y/t2)*cos(2.*pi*x/t1)*(sin(2.*pi*z/t3)*t2+cos(2.*pi*z/t3)*t1)/(t2*t1)
!!$
!!$           !-omega
!!$           fx(i,j,k)=-(4.*pi**2*psix(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fy(i,j,k)=-(4.*pi**2*psiy(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fz(i,j,k)=-(4.*pi**2*psiz(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft forward
!!$  call rlft3(fx,sf1x,sf2x,1)
!!$  call rlft3(fy,sf1y,sf2y,1)
!!$  call rlft3(fz,sf1z,sf2z,1)
!!$
!!$
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1 
!!$
!!$  !calcul de la solution dans l'espace des frequences 
!!$
!!$  do p=1,nz
!!$     if ( (p-1)<=(nz/2) ) then
!!$        kz=(p-1)/t3
!!$     else
!!$        kz=(p-1-nz)/t3
!!$     end if
!!$     do n=1,ny
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$        do m=1,nx/2           
!!$
!!$           if ( (m-1)<=(nx/2) ) then
!!$              kx=(m-1)/t1
!!$           else
!!$              kx=(m-1-nx)/t1
!!$           end if
!!$
!!$
!!$
!!$           r2=kx**2+ky**2+kz**2
!!$
!!$
!!$           su1x(m,n,p)=cmplx(0.,1.)*(ky*sf1z(m,n,p)-kz*sf1y(m,n,p))/(2.*pi*r2)
!!$           if ((r2==0)) su1x(m,n,p)=0.
!!$
!!$           su1y(m,n,p)=cmplx(0.,1.)*(kz*sf1x(m,n,p)-kx*sf1z(m,n,p))/(2.*pi*r2)              
!!$           if ((r2==0)) su1y(m,n,p)=0.
!!$
!!$           su1z(m,n,p)=cmplx(0.,1.)*(kx*sf1y(m,n,p)-ky*sf1x(m,n,p))/(2.*pi*r2)
!!$           if ((r2==0)) su1z(m,n,p)=0.
!!$
!!$
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$  m=nx/2+1
!!$  kx=(m-1)/t1
!!$  do p=1,nz
!!$     if ( (p-1)<=(nz/2) ) then
!!$        kz=(p-1)/t3
!!$     else
!!$        kz=(p-1-nz)/t3
!!$     end if
!!$     do n=1,ny
!!$
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$
!!$
!!$        r2=kx**2+ky**2+kz**2
!!$
!!$
!!$        !poisson+vitesse
!!$        su2x(n,p)=cmplx(0.,1.)*(ky*sf2z(n,p)-kz*sf2y(n,p))/(2.*pi*r2)            
!!$        if ((r2==0)) su2x(n,p)=0.
!!$
!!$        su2y(n,p)=cmplx(0.,1.)*(kz*sf2x(n,p)-kx*sf2z(n,p))/(2.*pi*r2)           
!!$        if ((r2==0)) su2y(n,p)=0.
!!$
!!$
!!$        su2z(n,p)=cmplx(0.,1.)*(kx*sf2y(n,p)-ky*sf2x(n,p))/(2.*pi*r2)
!!$        if ((r2==0)) su2z(n,p)=0.
!!$
!!$        !su2z(n,p)=-2.*pi*cmplx(0.,1.)*(-kx*sf2y(n,p)+ky*sf2x(n,p))/(4.*pi**2*r2)
!!$        !if ((r2==0)) su2z(n,p)=0.
!!$
!!$
!!$
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny*nz)
!!$
!!$  call rlft3(psix,su1x,su2x,-1)
!!$  call rlft3(psiy,su1y,su2y,-1)
!!$  call rlft3(psiz,su1z,su2z,-1)
!!$
!!$  psix=fac*psix
!!$  psiy=fac*psiy
!!$  psiz=fac*psiz
!!$
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psix-exax)),maxloc(abs(psix-exax)) 
!!$  print*,maxval(abs(psiy-exay)),maxloc(abs(psiy-exay)) 
!!$  print*,maxval(abs(psiz-exaz)),maxloc(abs(psiz-exaz)) 
!!$
!!$
!!$  deallocate (psix,exax,fx)
!!$  deallocate (psiy,exay,fy)
!!$  deallocate (psiz,exaz,fz)
!!$  deallocate(sf1x,su1x)
!!$  deallocate(sf1y,su1y)
!!$  deallocate(sf1z,su1z)
!!$  deallocate(sf2x,su2x)
!!$  deallocate(sf2y,su2y)
!!$  deallocate(sf2z,su2z)

 !===============================================================
  !test laplacien + champ de vitesse 3D:  utilisation de rlft3
  !================================================================ 

  integer                                     :: nx,ny,nz
  real(kind=8),dimension(:,:,:),allocatable       :: donne_init,donne_fin
  complex(kind=8),dimension(:,:,:),allocatable   :: sf1x, sf1y, sf1z
  complex(kind=8),dimension(:,:,:),allocatable   :: su1x, su1y, su1z
  complex(kind=8),dimension(:,:),allocatable     :: sf2x, sf2y, sf2z
  complex(kind=8),dimension(:,:),allocatable     :: su2x, su2y, su2z 

  integer                                     :: i,j,k,m,n,p
  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz,kx,ky,kz,r2,coeff,cpt
  real(kind=8),dimension(:,:,:),allocatable       :: psix,psiy,psiz,fx,fy,fz,exax,exay,exaz


  nx=33
  ny=33
  nz=33

  xg=-1.
  xd=1.
  yb=-1.
  yh=1.
  zd=-1.
  zf=1.

  t1=xd-xg
  t2=yh-yb
  t3=zf-zd


  dx=t1/(nx-1)
  dy=t2/(ny-1)
  dz=t3/(nz-1)

  nx=nx-1
  ny=ny-1
  nz=nz-1



  allocate (psix(1:nx,1:ny,1:nz),exax(1:nx,1:ny,1:nz),fx(1:nx,1:ny,1:nz))
  allocate (psiy(1:nx,1:ny,1:nz),exay(1:nx,1:ny,1:nz),fy(1:nx,1:ny,1:nz))
  allocate (psiz(1:nx,1:ny,1:nz),exaz(1:nx,1:ny,1:nz),fz(1:nx,1:ny,1:nz))
  allocate (sf1x(1:nx/2,1:ny,1:nz),su1x(1:nx/2,1:ny,1:nz) )
  allocate (sf1y(1:nx/2,1:ny,1:nz),su1y(1:nx/2,1:ny,1:nz) )
  allocate (sf1z(1:nx/2,1:ny,1:nz),su1z(1:nx/2,1:ny,1:nz) )
  allocate (sf2x(1:ny,1:nz),su2x(1:ny,1:nz) )
  allocate (sf2y(1:ny,1:nz),su2y(1:ny,1:nz) )
  allocate (sf2z(1:ny,1:nz),su2z(1:ny,1:nz) )



  do k=1,nz
     z=zd+(k-1)*dz
     do j=1,ny
        y=yb+(j-1)*dy
        do i=1,nx
           x=xg+(i-1)*dx

           !psi
           psix(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
           psiy(i,j,k)=sin(2.*pi*x/t1)*sin(2.*pi*y/t2)*sin(2.*pi*z/t3)
           psiz(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)

           !vitesse
           exax(i,j,k)=-2.*pi*sin(2.*pi*y/t2)*(cos(2.*pi*x/t1)*sin(2.*pi*z/t3)*t3+sin(2.*pi*x/t1)*cos(2.*pi*z/t3)*t2)/(t2*t3)
           exay(i,j,k)=-2.*pi*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)*(cos(2.*pi*x/t1)*t1-sin(2.*pi*x/t1)*t3)/(t1*t3)
           exaz(i,j,k)=2.*pi*sin(2.*pi*y/t2)*cos(2.*pi*x/t1)*(sin(2.*pi*z/t3)*t2+cos(2.*pi*z/t3)*t1)/(t2*t1)

           !-omega
           fx(i,j,k)=-(4.*pi**2*psix(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
           fy(i,j,k)=-(4.*pi**2*psiy(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
           fz(i,j,k)=-(4.*pi**2*psiz(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)

        end do
     end do
  end do


  !fft forward
  call rlft3(fx,sf1x,sf2x,1)
  call rlft3(fy,sf1y,sf2y,1)
  call rlft3(fz,sf1z,sf2z,1)


  !frequence=0 : n=0
  !0<f<fc : 1<=n<=N/2-1
  !f=fc=-fc : n=N/2
  !-fc<f<0 : N/2+1<=n<=N-1 

  !calcul de la solution dans l'espace des frequences 

  do p=1,nz
     if ( (p-1)<=(nz/2) ) then
        kz=(p-1)/t3
     else
        kz=(p-1-nz)/t3
     end if
     do n=1,ny
        if ( (n-1)<=(ny/2) ) then
           ky=(n-1)/t2
        else
           ky=(n-1-ny)/t2
        end if
        do m=1,nx/2           

           if ( (m-1)<=(nx/2) ) then
              kx=(m-1)/t1
           else
              kx=(m-1-nx)/t1
           end if



           r2=kx**2+ky**2+kz**2


           su1x(m,n,p)=cmplx(0.,1.)*(ky*sf1z(m,n,p)-kz*sf1y(m,n,p))/(2.*pi*r2)
           if ((r2==0)) su1x(m,n,p)=0.

           su1y(m,n,p)=cmplx(0.,1.)*(kz*sf1x(m,n,p)-kx*sf1z(m,n,p))/(2.*pi*r2)              
           if ((r2==0)) su1y(m,n,p)=0.

           su1z(m,n,p)=cmplx(0.,1.)*(kx*sf1y(m,n,p)-ky*sf1x(m,n,p))/(2.*pi*r2)
           if ((r2==0)) su1z(m,n,p)=0.



        end do
     end do
  end do

  m=nx/2+1
  kx=(m-1)/t1
  do p=1,nz
     if ( (p-1)<=(nz/2) ) then
        kz=(p-1)/t3
     else
        kz=(p-1-nz)/t3
     end if
     do n=1,ny

        if ( (n-1)<=(ny/2) ) then
           ky=(n-1)/t2
        else
           ky=(n-1-ny)/t2
        end if


        r2=kx**2+ky**2+kz**2


        !poisson+vitesse
        su2x(n,p)=cmplx(0.,1.)*(ky*sf2z(n,p)-kz*sf2y(n,p))/(2.*pi*r2)            
        if ((r2==0)) su2x(n,p)=0.

        su2y(n,p)=cmplx(0.,1.)*(kz*sf2x(n,p)-kx*sf2z(n,p))/(2.*pi*r2)           
        if ((r2==0)) su2y(n,p)=0.


        su2z(n,p)=cmplx(0.,1.)*(kx*sf2y(n,p)-ky*sf2x(n,p))/(2.*pi*r2)
        if ((r2==0)) su2z(n,p)=0.

        !su2z(n,p)=-2.*pi*cmplx(0.,1.)*(-kx*sf2y(n,p)+ky*sf2x(n,p))/(4.*pi**2*r2)
        !if ((r2==0)) su2z(n,p)=0.



     end do
  end do


  !fft backward
  fac=2./(nx*ny*nz)

  call rlft3(psix,su1x,su2x,-1)
  call rlft3(psiy,su1y,su2y,-1)
  call rlft3(psiz,su1z,su2z,-1)

  psix=fac*psix
  psiy=fac*psiy
  psiz=fac*psiz


  !exa=f
  !erreur
  print*,"erreur"
  print*,maxval(abs(psix-exax)),maxloc(abs(psix-exax)) 
  print*,maxval(abs(psiy-exay)),maxloc(abs(psiy-exay)) 
  print*,maxval(abs(psiz-exaz)),maxloc(abs(psiz-exaz)) 


  deallocate (psix,exax,fx)
  deallocate (psiy,exay,fy)
  deallocate (psiz,exaz,fz)
  deallocate(sf1x,su1x)
  deallocate(sf1y,su1y)
  deallocate(sf1z,su1z)
  deallocate(sf2x,su2x)
  deallocate(sf2y,su2y)
  deallocate(sf2z,su2z)



!!$  !==========================================================================
!!$  !test laplacien 3D: poisson ordre2 + champ de vitesse  utilisation de rlft3
!!$  !===========================================================================  
!!$  
!!$  integer(I4B)                                :: nx,ny,nz
!!$  real(SP),dimension(:,:,:),allocatable       :: donne_init,donne_fin
!!$  complex(SPC),dimension(:,:,:),allocatable   :: sf1x, sf1y, sf1z ,deb1
!!$  complex(SPC),dimension(:,:,:),allocatable   :: su1x, su1y, su1z
!!$  complex(SPC),dimension(:,:),allocatable     :: sf2x, sf2y, sf2z ,deb2
!!$  complex(SPC),dimension(:,:),allocatable     :: su2x, su2y, su2z 
!!$
!!$  integer                                     :: i,j,k,m,n,p
!!$  real                                        :: fac,x,y,z,xg,xd,yb,yh,zd,zf,t1,t2,t3,dx,dy,dz,kx,ky,kz,r2,coeff,ux,uy,uz
!!$  real(SP),dimension(:,:,:),allocatable       :: psix,psiy,psiz,fx,fy,fz,exax,exay,exaz
!!$
!!$  nx=8
!!$  ny=8
!!$  nz=8
!!$
!!$  xg=-1.
!!$  xd=1.
!!$  yb=-1.
!!$  yh=1.
!!$  zd=-1.
!!$  zf=1.
!!$
!!$  t1=xd-xg
!!$  t2=yh-yb
!!$  t3=zf-zd
!!$
!!$
!!$  dx=t1/nx
!!$  dy=t2/ny
!!$  dz=t3/nz
!!$
!!$ if ((dx/=dy).or.(dx/=dz)) then
!!$     print*,"attention dx=dy=dz"
!!$     stop
!!$  end if
!!$
!!$  allocate (psix(1:nx,1:ny,1:nz),exax(1:nx,1:ny,1:nz),fx(1:nx,1:ny,1:nz))
!!$  allocate (psiy(1:nx,1:ny,1:nz),exay(1:nx,1:ny,1:nz),fy(1:nx,1:ny,1:nz))
!!$  allocate (psiz(1:nx,1:ny,1:nz),exaz(1:nx,1:ny,1:nz),fz(1:nx,1:ny,1:nz))
!!$  allocate (sf1x(1:nx/2,1:ny,1:nz),su1x(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf1y(1:nx/2,1:ny,1:nz),su1y(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf1z(1:nx/2,1:ny,1:nz),su1z(1:nx/2,1:ny,1:nz) )
!!$  allocate (sf2x(1:ny,1:nz),su2x(1:ny,1:nz) )
!!$  allocate (sf2y(1:ny,1:nz),su2y(1:ny,1:nz) )
!!$  allocate (sf2z(1:ny,1:nz),su2z(1:ny,1:nz) )
!!$ 
!!$  allocate (deb1(1:nx/2,1:ny,1:nz),deb2(1:ny,1:nz))
!!$
!!$ do k=1,nz
!!$     z=zd+(k-1)*dz
!!$     do j=1,ny
!!$        y=yb+(j-1)*dy
!!$        do i=1,nx
!!$           x=xg+(i-1)*dx
!!$
!!$           !psi
!!$           psix(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*cos(2.*pi*z/t3)
!!$           psiy(i,j,k)=sin(2.*pi*x/t1)*sin(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$           psiz(i,j,k)=cos(2.*pi*x/t1)*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)
!!$
!!$           !vitesse
!!$           exax(i,j,k)=-2.*pi*sin(2.*pi*y/t2)*(cos(2.*pi*x/t1)*sin(2.*pi*z/t3)*t3+sin(2.*pi*x/t1)*cos(2.*pi*z/t3)*t2)/(t2*t3)
!!$           exay(i,j,k)=-2.*pi*cos(2.*pi*y/t2)*sin(2.*pi*z/t3)*(cos(2.*pi*x/t1)*t1-sin(2.*pi*x/t1)*t3)/(t1*t3)
!!$           exaz(i,j,k)=2.*pi*sin(2.*pi*y/t2)*cos(2.*pi*x/t1)*(sin(2.*pi*z/t3)*t2+cos(2.*pi*z/t3)*t1)/(t2*t1)
!!$
!!$           !-omega
!!$           fx(i,j,k)=-(4.*pi**2*psix(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fy(i,j,k)=-(4.*pi**2*psiy(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$           fz(i,j,k)=-(4.*pi**2*psiz(i,j,k)*(t2**2*t3**2+t1**2*t3**2+t1**2*t2**2))/((t1*t2*t3)**2)
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$  !fft forward
!!$  call rlft3(fx,sf1x,sf2x,1)
!!$  call rlft3(fy,sf1y,sf2y,1)
!!$  call rlft3(fz,sf1z,sf2z,1)
!!$
!!$  call rlft3(exax,deb1,deb2,1)
!!$
!!$  !frequence=0 : n=0
!!$  !0<f<fc : 1<=n<=N/2-1
!!$  !f=fc=-fc : n=N/2
!!$  !-fc<f<0 : N/2+1<=n<=N-1 
!!$
!!$ !calcul de la solution dans l'espace des frequences (discretisation d'ordre2 du laplacien)
!!$  m=nx/2+1 
!!$  kx=(m-1)/t1
!!$  do p=1,nz
!!$     if ( (p-1)<=(nz/2) ) then
!!$        kz=(p-1)/t3
!!$     else
!!$        kz=(p-1-nz)/t3
!!$     end if
!!$     do n=1,ny
!!$
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if 
!!$     
!!$        !su2x(n,p)=0.5*dx**2*sf2x(n,p)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.)    
!!$
!!$        r2=cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.
!!$        !r2=cos(2.*pi*kx*t1/nx)+cos(2.*pi*ky*t2/ny)+cos(2.*pi*kz*t3/nz)-3.
!!$
!!$        ux=0.5*dx**2*sf2x(n,p)/r2
!!$        uy=0.5*dx**2*sf2y(n,p)/r2      
!!$        uz=0.5*dx**2*sf2z(n,p)/r2        
!!$
!!$        su2x(n,p)=-2.*pi*cmplx(0.,1.)*(ky*uz-kz*uy)
!!$        su2y(n,p)=-2.*pi*cmplx(0.,1.)*(kz*ux-kx*uz)
!!$        su2z(n,p)=-2.*pi*cmplx(0.,1.)*(kx*uy-ky*ux)
!!$
!!$
!!$     end do
!!$  end do
!!$
!!$  do p=1,nz
!!$     if ( (p-1)<=(nz/2) ) then
!!$        kz=(p-1)/t3
!!$     else
!!$        kz=(p-1-nz)/t3
!!$     end if
!!$     do n=1,ny
!!$        if ( (n-1)<=(ny/2) ) then
!!$           ky=(n-1)/t2
!!$        else
!!$           ky=(n-1-ny)/t2
!!$        end if
!!$        do m=1,nx/2           
!!$
!!$           if ( (m-1)<=(nx/2) ) then
!!$              kx=(m-1)/t1
!!$           else
!!$              kx=(m-1-nx)/t1
!!$           end if          
!!$           !su1x(m,n,p)=0.5*dx**2*sf1x(m,n,p)/(cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.)
!!$           !if ((n==1).and.(m==1).and.(p==1)) su1x(m,n,p)=0.
!!$
!!$           r2=cos(2.*pi*(m-1)/nx)+cos(2.*pi*(n-1)/ny)+cos(2.*pi*(p-1)/nz)-3.
!!$           !r2=cos(2.*pi*kx*t1/nx)+cos(2.*pi*ky*t2/ny)+cos(2.*pi*kz*t3/nz)-3.
!!$
!!$           ux=0.5*dx**2*sf1x(m,n,p)/r2
!!$           uy=0.5*dx**2*sf1y(m,n,p)/r2      
!!$           uz=0.5*dx**2*sf1z(m,n,p)/r2        
!!$
!!$           su1x(m,n,p)=-2.*pi*cmplx(0.,1.)*(ky*uz-kz*uy)
!!$           su1y(m,n,p)=-2.*pi*cmplx(0.,1.)*(kz*ux-kx*uz)
!!$           su1z(m,n,p)=-2.*pi*cmplx(0.,1.)*(kx*uy-ky*ux)
!!$           
!!$           if(r2==0.) then
!!$              su1x(m,n,p)=0.
!!$              su1y(m,n,p)=0.
!!$              su1z(m,n,p)=0.
!!$           end if
!!$
!!$        end do
!!$     end do
!!$  end do
!!$
!!$
!!$
!!$  !fft backward
!!$  fac=2./(nx*ny*nz)
!!$
!!$  call rlft3(psix,su1x,su2x,-1)
!!$  call rlft3(psiy,su1y,su2y,-1)
!!$  call rlft3(psiz,su1z,su2z,-1)
!!$
!!$  psix=fac*psix
!!$  psiy=fac*psiy
!!$  psiz=fac*psiz
!!$
!!$
!!$  !exa=f
!!$  !erreur
!!$  print*,"erreur"
!!$  print*,maxval(abs(psix-exax)),maxloc(abs(psix-exax)) 
!!$  print*,maxval(abs(psiy-exay)),maxloc(abs(psiy-exay)) 
!!$  print*,maxval(abs(psiz-exaz)),maxloc(abs(psiz-exaz)) 
!!$ 
!!$  print*,"dx**2",dx**2
!!$ 
!!$
!!$
!!$  deallocate (psix,exax,fx)
!!$  deallocate (psiy,exay,fy)
!!$  deallocate (psiz,exaz,fz)
!!$  deallocate(sf1x,su1x)
!!$  deallocate(sf1y,su1y)
!!$  deallocate(sf1z,su1z)
!!$  deallocate(sf2x,su2x)
!!$  deallocate(sf2y,su2y)
!!$  deallocate(sf2z,su2z)




end program test_fft
