module init_mod
  !
  !initialisation des valeurs sur la grille
  !
contains
  subroutine init_grille
    use donnees_mod
    use tab_mod
    implicit none
    integer        :: i,j,k,i_tmp
    real(kind=8)   :: x,y,z, ct,t2
    real           :: romgx,romgy,romgz,r_tmp
    character(len=70):: text_tmp
    

    !---------------
    !       0
    !---------------
!!$    omgx=0.
!!$    omgy=0.
!!$    omgz=0.
    !-------------------------
    !       test poiseuille
    !--------------------------
   
!!$    
!!$    do k=1,nz
!!$       z=ztab(k)
!!$       do j=1,ny       
!!$          do i=1,nx
!!$             omgx(i,j,k)=0.
!!$             omgy(i,j,k)=0.
!!$             if ( (z.ge.-1.).and.(z.le.1.)) then
!!$                omgy(i,j,k)=-3.*z/(4.*0.5*(yh-yb))
!!$             else
!!$                omgy(i,j,k)=0.
!!$             end if
!!$             omgz(i,j,k)=0.
!!$          end do
!!$       end do
!!$    end do

    !---------------------------------
    !       test poiseuille/sphere
    !--------------------------------
      
    do k=1,nz      
       do j=1,ny
          y=ytab(j)
          do i=1,nx
             omgx(i,j,k)=0.
             omgy(i,j,k)=0.
             omgz(i,j,k)=0.
             if ( (y.ge.-(1./0.4844)).and.(y.le.(1./0.4844))) then
                omgz(i,j,k)=3.*y/((1./0.4844)**2)
             end if             
          end do
       end do
    end do

!!$
!!$
!!$    !---------------
!!$    !       1
!!$    !---------------
!!$    omgx=1.
!!$    omgy=1.
!!$    omgz=1.

!!$ !---------------
!!$    !test analytique
!!$    !---------------
!!$    do k=1,nz
!!$       z=ztab(k)
!!$       do j=1,ny
!!$          y=ytab(j)
!!$          do i=1,nx
!!$             x=xtab(i)
!!$                  
!!$             !ct=cos(pi*time)
!!$             ct=1.D0
!!$             
!!$             omgx(i,j,k)=-2.*pi*sin(2.*pi*x)*cos(2.*pi*y)*sin(pi*z)**2*ct &
!!$                         +2.*pi*sin(2.*pi*x)*sin(pi*y)**2*cos(2.*pi*z)*ct
!!$             omgy(i,j,k)=4.*pi*sin(pi*x)**2*sin(2.*pi*y)*cos(2.*pi*z)*ct &
!!$                         +2.*pi*cos(2.*pi*x)*sin(2.*pi*y)*sin(pi*z)**2*ct
!!$             omgz(i,j,k)=-2.*pi*cos(2.*pi*x)*sin(pi*y)**2*sin(2.*pi*z)*ct&
!!$                         -4.*pi*sin(pi*x)**2*cos(2.*pi*y)*sin(2.*pi*z)*ct
!!$
!!$           !  omgx(i,j,k)=1.
!!$           !  omgy(i,j,k)=0.
!!$           !  omgz(i,j,k)=0.
!!$
!!$          end do         
!!$       end do
!!$    end do


!!$    !----------------------------
!!$    !vorticite turbulente de GH
!!$    !-----------------------------
!!$
!!$    allocate (omgxr(1:nx,1:ny,1:nz),omgyr(1:nx,1:ny,1:nz),omgzr(1:nx,1:ny,1:nz))
!!$
!!$    open(20,file='data_gh/datax',form='unformatted',convert='big_endian',status='unknown')             
!!$    read(20)  (((omgxr(i,j,k),i=1,nx),j=1,ny),k=1,nz)             
!!$    close(20)
!!$    
!!$    open(20,file='data_gh/datay',form='unformatted',convert='big_endian',status='unknown')             
!!$    read(20)  (((omgyr(i,j,k),i=1,nx),j=1,ny),k=1,nz)             
!!$    close(20)
!!$    
!!$    open(20,file='data_gh/dataz',form='unformatted',convert='big_endian',status='unknown')             
!!$    read(20)  (((omgzr(i,j,k),i=1,nx),j=1,ny),k=1,nz)             
!!$    close(20)
!!$
!!$    omgx=omgxr
!!$    omgy=omgyr
!!$    omgz=omgzr
!!$
!!$    deallocate (omgxr,omgyr,omgzr)



!!$    if (num_suite==1) then
!!$       open(unit=25,file=trim(name_relance),form="formatted")
!!$
!!$       read(25,'(A26)')text_tmp
!!$      read(25,'(A7)')text_tmp
!!$      read(25,'(A5)')text_tmp
!!$      read(25,'(A25)')text_tmp
!!$      read(25,'(A10,3(i4,1x))')text_tmp,i_tmp,i_tmp,i_tmp
!!$      read(25,'(a6,3(f10.5))')text_tmp,r_tmp,r_tmp,r_tmp
!!$      read(25,'(A7,3(f10.5))')text_tmp,r_tmp,r_tmp,r_tmp
!!$    
!!$    
!!$      read(25,'(A10,i10)') text_tmp,i_tmp
!!$      read(25,'(A21)') text_tmp
!!$
!!$       do k=1,nz
!!$          do j=1,ny
!!$             do i=1,nx              
!!$                read(25,'(3(f20.9))') romgx,romgy,romgz
!!$                omgx(i,j,k)=romgx
!!$                omgy(i,j,k)=romgy
!!$                omgz(i,j,k)=romgz
!!$             end do
!!$          end do
!!$       end do
!!$       close(25)       
!!$    end if





 
!!$
!!$      do k=1,nz
!!$         do j=1,ny
!!$            do i=1,nx              
!!$               write(11,'(3(f20.9))') real(omgx(i,j,k)),real(omgy(i,j,k)),real(omgz(i,j,k))
!!$            end do
!!$         end do
!!$      end do









  end subroutine init_grille



end module init_mod
