module resultats_mod
  use donnees_mod
  use tab_mod
contains 


  
   

    subroutine res_vtk (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A8)')""
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A15)') "VECTORS omg FLOAT"
      write(11,'(A20)') "LOOKUP_TABLE DEFAULT" 


      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(f20.9)') real(omgx(i,j,k)),real(omgy(i,j,k)),real(omgz(i,j,k))
            end do
         end do
      end do

      write(11,'(A21)') ""
      write(11,'(A21)') "VECTORS vitesse FLOAT" 

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(vxg(i,j,k)),real(vyg(i,j,k)),real(vzg(i,j,k))
            end do
         end do
      end do

      close (11)

    end subroutine res_vtk
   

    subroutine res_vtk_test (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A21)') "VECTORS vg FLOAT"

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(vxg(i,j,k)),real(vyg(i,j,k)),real(vzg(i,j,k))
            end do
         end do
      end do

      write(11,'(A21)') "VECTORS omg FLOAT"
      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(sqrt(omgx(i,j,k)**2+omgy(i,j,k)**2+omgz(i,j,k)**2)),real(omgy(i,j,k)),real(omgz(i,j,k))
            end do
         end do
      end do
    
      close (11)
    end subroutine res_vtk_test


    subroutine res_vtk_omgx (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

    open(24,file=nom_fich)
        WRITE(24,'(A)') "# vtk DataFile Version 3.0"
        WRITE(24,'(A)') "Scalar"
        WRITE(24,'(A)') "ASCII"
        WRITE(24,'(A)') "DATASET STRUCTURED_POINTS"
        WRITE(24,'(A,I3,A,I3,A,I3)') "DIMENSIONS ",nx," ",ny," ",nz
        WRITE(24,'(A,A,A,A)') "ORIGIN"," 0"," 0 "," 0"
        WRITE(24,*) "SPACING"," ",dx," ",dy," ",dz
        WRITE(24,*) "POINT_DATA ",nx*ny*nz
        WRITE(24,'(A)') "SCALARS omgx float"
        WRITE(24,'(A)') "LOOKUP_TABLE DEFAULT"
        do k=1,nz
        do j=1,ny
        do i=1,nx
                write(24,*) real(omgx(i,j,k))
        enddo
        enddo
        enddo
	close(24)
end subroutine res_vtk_omgx


  subroutine res_vtk_nite(nom_fich_omg,nom_fich_vit,nombre_ite,t)
       implicit none
       character(len=*),intent(in) :: nom_fich_omg,nom_fich_vit
       integer,intent(in)          :: nombre_ite
       real(kind=8),intent(in)     :: t
       character(len=60)           :: name_vit,name_omg,char_nite

       if (cpt_ite<=20)  then
	  write(char_nite,'(I1)') cpt_ite
  	  write(name_vit,'(A)') trim(nom_fich_vit)//trim(char_nite)//".vtk"
          write(name_omg,'(A)') trim(nom_fich_omg)//trim(char_nite)//".vtk"
          call res_vtk_vit(trim(name_vit))
          call res_vtk_omega(trim(name_omg))
       elseif (mod(cpt_ite,40)==0)  then
!       if (mod(cpt_ite,nombre_ite)==0)  then
!          if (cpt_ite<10) write(char_nite,'(I1)') cpt_ite
          if ((cpt_ite>9).and.(cpt_ite<100)) write(char_nite,'(I2)') cpt_ite
          if ((cpt_ite>99).and.(cpt_ite<1000)) write(char_nite,'(I3)') cpt_ite
          if ((cpt_ite>999).and.(cpt_ite<10000)) write(char_nite,'(I4)') cpt_ite
          if ((cpt_ite>9999).and.(cpt_ite<100000)) write(char_nite,'(I5)') cpt_ite
          if ((cpt_ite>99999).and.(cpt_ite<1000000)) write(char_nite,'(I6)') cpt_ite
          if ((cpt_ite>999999).and.(cpt_ite<10000000)) write(char_nite,'(I7)') cpt_ite
          write(name_vit,'(A)') trim(nom_fich_vit)//trim(char_nite)//".vtk"
          write(name_omg,'(A)') trim(nom_fich_omg)//trim(char_nite)//".vtk"
          call res_vtk_vit(trim(name_vit))
          call res_vtk_omega(trim(name_omg))
       end if

    end subroutine res_vtk_nite

    subroutine res_omg_nite(nom_fich_omg,nom_fich_vit,nombre_ite,t)
       implicit none
       character(len=*),intent(in) :: nom_fich_omg,nom_fich_vit
       integer,intent(in)          :: nombre_ite
       real(kind=8),intent(in)     :: t
       character(len=60)           :: name_vit,name_omg,char_nite

       if (mod(cpt_ite,nombre_ite)==0)  then
          if (cpt_ite<10) write(char_nite,'(I1)') cpt_ite
          if ((cpt_ite>9).and.(cpt_ite<100)) write(char_nite,'(I2)') cpt_ite
          if ((cpt_ite>99).and.(cpt_ite<1000)) write(char_nite,'(I3)') cpt_ite
          if ((cpt_ite>999).and.(cpt_ite<10000)) write(char_nite,'(I4)') cpt_ite
          if ((cpt_ite>9999).and.(cpt_ite<100000)) write(char_nite,'(I5)') cpt_ite
          if ((cpt_ite>99999).and.(cpt_ite<1000000)) write(char_nite,'(I6)') cpt_ite
          if ((cpt_ite>999999).and.(cpt_ite<10000000)) write(char_nite,'(I7)') cpt_ite
          write(name_vit,'(A)') trim(nom_fich_vit)//trim(char_nite)//".vtk"
          write(name_omg,'(A)') trim(nom_fich_omg)//trim(char_nite)//".vtk"        
          call res_vtk_omega(trim(name_omg))
       end if

    end subroutine res_omg_nite

    subroutine res_vtk_vit (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A21)') "VECTORS vg FLOAT"

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(vxg(i,j,k)),real(vyg(i,j,k)),real(vzg(i,j,k))
            end do
         end do
      end do
      close (11)
    end subroutine res_vtk_vit

    subroutine res_vtk_omega (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A21)') "VECTORS omg FLOAT"

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(omgx(i,j,k)),real(omgy(i,j,k)),real(omgz(i,j,k))
            end do
         end do
      end do
      close (11)
    end subroutine res_vtk_omega

    subroutine res_vtk_chi (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A21)') "VECTORS chi FLOAT"

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(chi(i,j,k)),real(chi(i,j,k)),real(chi(i,j,k))
            end do
         end do
      end do
      close (11)
    end subroutine res_vtk_chi

   subroutine res_vtk_lambda (nom_fich)  
      implicit none
      character(len=*),intent(in)  :: nom_fich
      integer                      :: i,j,k
      real(kind=8)                 :: x,y,z

      open(unit=11,file=nom_fich,form="formatted")

      write(11,'(A26)')"# vtk DataFile Version 3.0"
      write(11,'(A7)')"vecteur"
      write(11,'(A5)')"ASCII"
      write(11,'(A25)')"DATASET STRUCTURED_POINTS"
      write(11,'(A10,3(i4,1x))')"DIMENSIONS",nx,ny,nz
      write(11,'(a6,3(f10.5))')"ORIGIN",xg,yb,zd
      write(11,'(A7,3(f10.5))')"SPACING",dx,dy,dz
    
    
      write(11,'(A10,i10)') "POINT_DATA",nx*ny*nz
      write(11,'(A21)') "VECTORS lambda FLOAT"

      do k=1,nz
         do j=1,ny
            do i=1,nx              
               write(11,'(3(f20.9))') real(lambda(i,j,k)),real(lambda(i,j,k)),real(lambda(i,j,k))
            end do
         end do
      end do
      close (11)
    end subroutine res_vtk_lambda




end module resultats_mod

