C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SUBROUTINE  velox_x(npart,j,k)

C
C   Interpolation routine with M'4 
C
c	geometry=unit box, periodic in x and y
c	last ponits in z direction assume extension by continuity
c	that is gg(i,j,0)=gg(i,j,1) gg(i,j,m+1)=gg(i,j,m)


c----------------------------------------------------------------

	include 'param.i'
	include 'param.h'


        COMMON/GRID/     omg1(npgx,npgy,npgz),
     &  omg2(npgx,npgy,npgz),omg3(npgx,npgy,npgz),
     &  gg1(npgx,npgy,npgz),vyg(npgx,npgy,npgz),vzg(npgx,npgy,npgz),
     &  psi1(npgx,npgy,npgz),psi2(npgx,npgy,npgz),psi3(npgx,npgy,npgz),
     &  strg1(npgx,npgy,npgz),strg2(npgx,npgy,npgz),
     &  strg3(npgx,npgy,npgz),ug(npg,npg,npg)
     
             common/remesh/xp0(npg),xp(npg),up(npg),g1(npg)

	do 10 i=1,npart
	g1(i)=0.
10	continue

	ny3=nx3
	nz3=nx3
	dx3=xmax/float(nx3)
        dy3=dx3
        dz3=dx3

        dxinv=1./dx3
 

c-------------------------------------------------------------------- 
c- PART II : Determination of  the  circulation  of each particle
c-------------------------------------------------------------------- 

	x0=xmin
	y0=ymin
	z0=zmin

        yy=+float(j-1)*dx2
        zz=+float(k-1)*dx2

            jp1 = int((yy)/dx3)
            jp2 = jp1 + 1
            kp1 = int((zz)/dx3)
            kp2 = kp1 + 1
           yy1 = (yy-float(jp1)*dx3)/dx3
           yy2=1-yy1
           zz1 = (zz-float(kp1)*dx3)/dx3
           zz2=1-zz1
        b1=yy2
        b2=yy1
        c1=zz2
        c2=zz1
        jp1=mod(jp1+nx3,nx3) +1
        jp2=mod(jp2+nx3,nx3) +1
        kp1=mod(kp1+nx3,nx3) +1
        kp2=mod(kp2+nx3,nx3) +1


	 DO 20 i = 1,npart

            x = XP(i)

            ip1 = int((x-x0)*dxinv) 
            ip2 = ip1 + 1

C get the circulations from the nine neighboring cells

	   xx1 = (x - float(ip1)*dx3-x0)*dxinv
	   xx2=1-xx1
C
C 	on repositionne les points de grille par periodicite
C	entre 0 et m-1, puis on numerote de 1 a m
C
	ip1=mod(ip1+nx3,nx3) +1
	ip2=mod(ip2+nx3,nx3) +1
C
C The M'4 scheme
C
           a1 = xx2
           a2 = xx1
           g1(i)= g1(i) +  gg1(ip1,jp1,kp1)*a1*b1*c1
           g1(i)= g1(i) +  gg1(ip2,jp1,kp1)*a2*b1*c1
           g1(i)= g1(i) +  gg1(ip1,jp2,kp1)*a1*b2*c1
           g1(i)= g1(i) +  gg1(ip2,jp2,kp1)*a2*b2*c1
           g1(i)= g1(i) +  gg1(ip1,jp1,kp2)*a1*b1*c2
           g1(i)= g1(i) +  gg1(ip2,jp1,kp2)*a2*b1*c2
           g1(i)= g1(i) +  gg1(ip1,jp2,kp2)*a1*b2*c2
           g1(i)= g1(i) +  gg1(ip2,jp2,kp2)*a2*b2*c2

	   
20      CONTINUE



	RETURN
	END
