subroutine discretisation3(U1,U2,ns1old,ns2old,ns3old,ns1new,ns2new,ns3new)

     ! fns1new < fns1old

     use solver  
     use parallel

     implicit none

     integer :: ns1old,ns2old,ns3old,ns1new,ns2new,ns3new
     integer :: fns1old,fns2old,fns3old,fns1new,fns2new,fns3new,fs,fe,fsold,feold,yminnew,ymaxnew,yminold,ymaxold
     real(WP) :: U1(ns1old,ns2old,ns3old)
     real(WP) :: U2(ns1new,ns2new,ns3new)
     complex(WP), dimension(:,:,:), allocatable :: U1k, U2k, U1kscloc, U1ksc, tabbuf
     integer ::   sizemess, tag, ierr, status(MPI_STATUS_SIZE), i, j, k, itest
     integer ::   yeloc, ysloc, yelocsc, yslocsc, rank2send1, rank2send2, fs1, fe1, fs2, fe2, fnysrank, fnyerank, cptrank, rank2send

!     print*,ns1old,ns2old,ns3old,ns1new,ns2new,ns3new

     fns1old = ns1old/2+1
     fns2old = ns1old/nproc
     fns3old = ns1old

     fns1new = ns1new/2+1
     fns2new = ns1new/nproc
     fns3new = ns1new

     allocate(U1k(fns1old,fns2old,fns3old))
     call ftran_wrap(U1,U1k,ns1old,ns2old,ns3old,fns1old,fns2old,fns3old)
     U1k = U1k/real(ns1old**3.0,WP)

     allocate(U1ksc(fns1new,fns2new,fns3new))
     U1ksc = 0.

     if (nproc.ne.1) then
  
     allocate(U1kscloc(fns1old,fns2new,fns3old))
     U1kscloc = 0.

	 ! Communication
     do cptrank = 0, nproc-1
     
        fnysrank = 1 + cptrank*fns2new
        fnyerank = (1+cptrank)*fns2new

        ! Envoi
        if (fnyerank.le.ns1new/2+1) then ! envoi j de 1 à <nk
		
           rank2send1 = floor(real(fnyerank-1)/real(fns2old))
           rank2send2 = floor(real(fnysrank-1)/real(fns2old))
           fs1 = max(fnysrank,1+rank2send1*fns2old)
           fe1 = min(fnyerank,(1+rank2send1)*fns2old)
           fs2 = max(fnysrank,1+rank2send2*fns2old)
           fe2 = min(fnyerank,(1+rank2send2)*fns2old)
		   
        else if(fnysrank.gt.ns1new/2+1) then ! envoi j de >nk à nx
		
           rank2send1 = floor(real(fnyerank+ns1old-ns1new-1)/real(fns2old))
           rank2send2 = floor(real(fnysrank+ns1old-ns1new-1)/real(fns2old))
           fs1 = max(fnysrank,1+rank2send1*fns2old+ns1new-ns1old)
           fe1 = min(fnyerank,(1+rank2send1)*fns2old+ns1new-ns1old)
           fs2 = max(fnysrank,1+rank2send2*fns2old+ns1new-ns1old)
           fe2 = min(fnyerank,(1+rank2send2)*fns2old+ns1new-ns1old)
		   
        else if(fnysrank.le.ns1new/2+1.and.fnyerank.gt.ns1new/2+1) then
		
           rank2send1 = floor(real(fnyerank+ns1old-ns1new-1)/real(fns2old))
           rank2send2 = floor(real(fnysrank-1)/real(fns2old))
           fs1 = max(ns1new/2+2,1+rank2send1*fns2old+ns1new-ns1old)
           fe1 = min(fnyerank,(1+rank2send1)*fns2old+ns1new-ns1old)
           fs2 = max(fnysrank,1+rank2send2*fns2old)
           fe2 = min(ns1new/2+1,(1+rank2send2)*fns2old)
		   
        end if
		
		! ENVOIE
		if (rank.eq.rank2send1.and.rank2send1.ne.cptrank) then
		
           fnysrank = 1 + rank*fns2old
           fnyerank = (1+rank)*fns2old
		   
           if (fnyerank.gt.(ns1old-ns1new+ns1new/2+1)) then
               ysloc = fs1 - rank * fns2old + ns1old - ns1new
               yeloc = fe1 - rank * fns2old + ns1old - ns1new
           else
               ysloc = fs1 - rank * fns2old
               yeloc = fe1 - rank * fns2old
           end if
		   
           sizemess = fns1old*fns3old*(yeloc-ysloc+1)
           allocate(tabbuf(fns1old,yeloc-ysloc+1,fns3old))
           tag = fs1+1000*fe1+1000000*1
		   tabbuf(:,:,:) = U1k(:,ysloc:yeloc,:)
		   call MPI_SEND(tabbuf,sizemess,MPI_COMPLEX_WP,cptrank,tag,MPI_COMM_WORLD,ierr)
           deallocate(tabbuf)
		   
        else if (rank.eq.rank2send2.and.rank2send2.ne.cptrank.and.rank2send2.ne.rank2send1) then
		
           fnysrank = 1 + rank*fns2old
           fnyerank = (1+rank)*fns2old
		   
           if (fnyerank.gt.(ns1old-ns1new+ns1new/2+1)) then
               ysloc = fs2 - rank * fns2old + ns1old - ns1new
               yeloc = fe2 - rank * fns2old + ns1old - ns1new
           else
               ysloc = fs2 - rank * fns2old
               yeloc = fe2 - rank * fns2old
           end if
		   
           sizemess = fns1old*fns3old*(yeloc-ysloc+1)
           allocate(tabbuf(fns1old,yeloc-ysloc+1,fns3old))
           tag = fs2+1000*fe2+1000000*1
		   tabbuf(:,:,:) = U1k(:,ysloc:yeloc,:)
           call MPI_SEND(tabbuf,sizemess,MPI_COMPLEX_WP,cptrank,tag,MPI_COMM_WORLD,ierr)
           deallocate(tabbuf)
		   
		! RECEPTION
		else if (rank.eq.cptrank) then
		
		   ysloc = fs1 - rank * fns2new
           yeloc = fe1 - rank * fns2new
		   
		   if(cptrank.ne.rank2send1) then 
		   
              sizemess = fns1old*fns3old*(yeloc-ysloc+1)
              allocate(tabbuf(fns1old,yeloc-ysloc+1,fns3old))
              tag = fs1+1000*fe1+1000000*1
              call MPI_RECV(tabbuf,sizemess,MPI_COMPLEX_WP,rank2send1,tag,MPI_COMM_WORLD,status,ierr)
			  U1kscloc(:,ysloc:yeloc,:) = tabbuf(:,:,:)
              deallocate(tabbuf)
			  
	        else 
			
              if (fnyerank.le.ns1new/2+1) then
                 yslocsc = fs1 - rank * fns2old
                 yelocsc = fe1 - rank * fns2old
              else
                 yslocsc = fs1 - rank * fns2old - ns1new + ns1old
                 yelocsc = fe1 - rank * fns2old - ns1new + ns1old
              end if
			  
              U1kscloc(:,ysloc:yeloc,:) = U1k(:,yslocsc:yelocsc,:) 
			  
           end if
		   
		   if (rank2send1.ne.rank2send2) then
		   
              ysloc = fs2 - rank * fns2new
              yeloc = fe2 - rank * fns2new
			  
              if (cptrank.ne.rank2send2) then 
			  
                 sizemess = fns1old*fns3old*(yeloc-ysloc+1)
                 allocate(tabbuf(fns1old,yeloc-ysloc+1,fns3old))
                 tag = fs2+1000*fe2+1000000*1
                 call MPI_RECV(tabbuf,sizemess,MPI_COMPLEX_WP,rank2send2,tag,MPI_COMM_WORLD,status,ierr)
				 U1kscloc(:,ysloc:yeloc,:) = tabbuf(:,:,:)
                 deallocate(tabbuf)
				 
              else 
			  
                 if (fnyerank.le.ns1new/2+1) then
                    yslocsc = fs2 - rank * fns2old
                    yelocsc = fe2 - rank * fns2old
                 else
                    yslocsc = fs2 - rank * fns2old - ns1new + ns1old
                    yelocsc = fe2 - rank * fns2old - ns1new + ns1old
                 end if
				 
                 U1kscloc(:,ysloc:yeloc,:) = U1k(:,yslocsc:yelocsc,:) 
				 
              end if
			  
           end if
	    
		end if
     
	 end do 
     call MPI_BARRIER(MPI_COMM_WORLD,ierr)


     do i = 1 , ns1new/2 + 1
        do k = 1 , ns1new/2 + 1
           U1ksc(i,:,k) = U1kscloc(i,:,k)
        end do
        do k = ns1new, ns1new-ns1new/2+2, -1
           U1ksc(i,:,k) = U1kscloc(i,:,ns1old-ns1new+k)
        end do
     end do
     deallocate(U1kscloc)

     else

     do i = 1 , ns1new/2 + 1
        do j = 1, ns1new/2 + 1
           do k = 1 , ns1new/2 + 1
              U1ksc(i,j,k) = U1k(i,j,k)
           end do
           do k = ns1new, ns1new-ns1new/2+2, -1
              U1ksc(i,j,k) = U1k(i,j,ns1old-ns1new+k)
           end do
        end do
        do j = ns1new, ns1new-ns1new/2+2, -1
           do k = 1 , ns1new/2 + 1
              U1ksc(i,j,k) = U1k(i,ns1old-ns1new+j,k)
           end do
           do k = ns1new, ns1new-ns1new/2+2, -1
              U1ksc(i,j,k) = U1k(i,ns1old-ns1new+j,ns1old-ns1new+k)
           end do
        end do
     end do     
 
     end if

     call btran_wrap(U1ksc,U2,ns1new,ns2new,ns3new,fns1new,fns2new,fns3new)
  
     deallocate(U1ksc)
     deallocate(U1k)

end subroutine discretisation3

     
