subroutine init_plane_jet

  use parallel
  use data

  implicit none

  real(WP), dimension(:,:,:), pointer :: Ub, Vb, Wb
  real(WP) :: dx, yy, epsil, Htheta, U1, U2, ubm, vbm, wbm
  integer :: j

  call hit_init

  allocate(Ub(ns1,ns2,ns3))
  allocate(Vb(ns1,ns2,ns3))
  allocate(Wb(ns1,ns2,ns3))
  Ub = U
  Vb = V
  Wb = W

  U = 0.0
  V = 0.0
  W = 0.0

  dx = L/(real(nx))

  call parser_read('H/theta',Htheta)
  call parser_read('Jet velocity',U1)
  call parser_read('Co-flow velocity',U2)
  call parser_read('noise level',epsil)

  do j = 1,ns2
     yy = real(j)*dx - L/2.0
     U(:,j,:) = (U1+U2)/2.0 + (U1-U2)/2.0 * tanh( 0.25 * Htheta * (1 - 2*abs(yy) ) )
     SC(:,j,:) = 1.0/2.0 + 1.0/2.0 * tanh( 0.25 * Htheta * (1 - 2*abs(yy) ) )
     if (abs(yy).gt.0.7.or.abs(yy).lt.0.3) then
        Ub(:,j,:) = 0.
        Vb(:,j,:) = 0.
        Wb(:,j,:) = 0.
     end if
     if( rank.eq.0) print*,yy,Ub(1,j,1)
  end do
  ubm = maxval(abs(Ub))
  vbm = maxval(abs(Vb))
  wbm = maxval(abs(Wb))
  Ub = Ub/ubm
  Vb = Vb/vbm
  Wb = Wb/wbm
  U = U + epsil*Ub
  V = V + epsil*Vb
  W = W + epsil*Wb

end subroutine init_plane_jet
