subroutine postprocess
  
  use solver
  use parallel
  use data

  implicit none
  integer :: i,j,k,pas, nxo,nxoz
  character(len=30) :: Filename,pdfufname
  real(WP) :: nd,nut1,nut2,kt1,kt2
  real(WP) :: kk,h,nutm,ktm,Am,Bm,Cm,Dm,scht1,scht2,scht3,scht5,pdfscht5,CAm,DBm
  integer :: ierr,ik,il,jl,kl,iunit
  real(WP) :: pi,kc,eps,buf,epsil,u2,u3,u4,dudx,lambda,u1,epsil2,eta,sch,eta_B,mini,maxi

  real(WP), dimension(:,:,:), pointer :: Rbuf
  real(WP), dimension(:,:,:), pointer :: Usc,Vsc,Wsc,Zsc !vitesses sous maillage du scalaire
  real(WP), dimension(:,:,:), pointer :: T1,T2,T3,diss !flux scalaire
  real(WP), dimension(:,:,:), pointer :: dZdx, dZdy, dZdz, dZdxsc, dZdysc, dZdzsc 
  real(WP), dimension(:,:,:), pointer :: NUT,SCHT,KT
  real(WP), dimension(:,:,:), pointer :: tabA,tabB,tabC,tabD
  real(WP), dimension(:), pointer :: cor,sf2,sf3
  complex(WP), dimension(:,:,:), pointer :: d11,d12,d13,d22,d23,d33
  real(WP), dimension(:,:), pointer :: S1,S2,S3,Sg
  real(WP), dimension(:,:), pointer :: S11,S21,S31,Sg1


  real(WP), dimension(:,:,:), pointer :: z
  real(WP), dimension(:),     pointer :: xx,pdf
  integer :: dime


!!! Uk, Vk, Wk and Zk the three component of velocity and scalar in spectral space

  dime = 200
  allocate(xx(dime))
  allocate(pdf(dime))
  call c_pdf_sca(xx,pdf,SC,dime)
   if(rank.eq.0) then
    open(14,file='pdf_z',form='formatted')
     do i=1,dime-1
     write(14,*) xx(i), pdf(i)
     enddo
    close(14)
  endif
  deallocate(xx)
  deallocate(pdf)


!!! Energy Spectrum
  spfilename = 'spectrum.post'
  spfilename2 = 'spectrum.post.scalar'
  call get_dns_numbers(1)


  if (ns1sc.eq.ns1) then

     call parser_read('Nx filter output',nxo,0)

     nd = real(ns1)/real(nxo)
     !! on 256^3 just cutfilter
     allocate(Usc(ns1,ns2,ns3))
     allocate(Vsc(ns1,ns2,ns3))
     allocate(Wsc(ns1,ns2,ns3))
     allocate(Zsc(ns1,ns2,ns3))
     allocate(T1(ns1,ns2,ns3))
     allocate(T2(ns1,ns2,ns3))
     allocate(T3(ns1,ns2,ns3))
     call speccutfilter(SC,Zsc,nd) 
     call speccutfilter(U,Usc,nd) 
     call speccutfilter(V,Vsc,nd) 
     call speccutfilter(W,Wsc,nd) 
     call speccutfilter(U*SC,T1,nd) 
     call speccutfilter(V*SC,T2,nd) 
     call speccutfilter(W*SC,T3,nd) 
     T1 = T1 - Usc*Zsc
     T2 = T2 - Vsc*Zsc
     T3 = T3 - Wsc*Zsc
     allocate(dZdx(ns1,ns2,ns3))
     allocate(dZdy(ns1,ns2,ns3))
     allocate(dZdz(ns1,ns2,ns3))
     call gradient(Zsc,0.0,dZdx,dZdy,dZdz)

     allocate(diss(ns1,ns2,ns3))
     diss = T1*dZdx + T2*dZdy + T3*dZdz

     T1 = SC
     SC = diss
     file_counter = 1
     call data_write
     SC = T1
     call moyensc(diss,nut1)
     if (rank.eq.0) print*,'mean diss 256-1 :',nut1


     !! on 256^3 cutfilter + cutfilter of product
     call speccutfilter(U*SC,T1,nd)
     call speccutfilter(V*SC,T2,nd)
     call speccutfilter(W*SC,T3,nd)
     call speccutfilter(Usc*Zsc,diss,nd)
     T1 = T1 - diss
     call speccutfilter(Vsc*Zsc,diss,nd)
     T2 = T2 - diss
     call speccutfilter(Wsc*Zsc,diss,nd)
     T3 = T3 - diss
     call speccutfilter(T1*dZdx,Usc,nd)
     call speccutfilter(T2*dZdy,Vsc,nd)
     call speccutfilter(T3*dZdz,Wsc,nd)
     diss = Usc + Vsc + Wsc

     T1 = SC
     SC = diss
     file_counter = 2
     call data_write
     SC = T1
     call moyensc(diss,nut1)
     if (rank.eq.0) print*,'mean diss 256-2 :',nut1

     deallocate(diss)
     deallocate(Usc)
     deallocate(Vsc)
     deallocate(Wsc)
     deallocate(Zsc)
     deallocate(T1)
     deallocate(T2)
     deallocate(T3)

     nxoz = nxo / nproc
     allocate(Usc(nxo,nxo,nxoz))
     allocate(Vsc(nxo,nxo,nxoz))
     allocate(Wsc(nxo,nxo,nxoz))
     allocate(Zsc(nxo,nxo,nxoz))
     allocate(T1(nxo,nxo,nxoz))
     allocate(T2(nxo,nxo,nxoz))
     allocate(T3(nxo,nxo,nxoz))
  
     call discretisation3(SC,Zsc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(U,Usc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(V,Vsc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(W,Wsc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(U*SC,T1,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(v*SC,T2,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(W*SC,T3,ns1,ns2,ns3,nxo,nxo,nxoz) 
     T1 = T1 - Usc*Zsc
     T2 = T2 - Vsc*Zsc
     T3 = T3 - Wsc*Zsc

     allocate(dZdxsc(nxo,nxo,nxoz))
     allocate(dZdysc(nxo,nxo,nxoz))
     allocate(dZdzsc(nxo,nxo,nxoz))
     call gradient(SC,0.0,dZdx,dZdy,dZdz)
     call discretisation3(dZdx,dZdxsc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(dZdy,dZdysc,ns1,ns2,ns3,nxo,nxo,nxoz) 
     call discretisation3(dZdz,dZdzsc,ns1,ns2,ns3,nxo,nxo,nxoz) 
  

     allocate(diss(nxo,nxo,nxoz))
     diss = T1*dZdxsc + T2*dZdysc + T3*dZdzsc

  nxsc = nxo
  nysc = nxsc
  nzsc = nxsc

  if (mod(nzsc,nproc).ne.0) then
     print *,' NXSC should be exactly divided by the number of processors'
     stop
  endif

  nksc = nxsc/2+1

  ns1sc = nxsc
  ns2sc = nysc
  ns3sc = nzsc/nproc

  nxssc = 1
  nxesc = nxsc

  nyssc = 1
  nyesc = nysc

  nzssc = 1 +(rank)*ns3sc
  nzesc = (rank+1)*ns3sc

  fns1sc = nksc
  fns2sc = nysc/nproc
  fns3sc = nzsc

  fnxssc = 1
  fnxesc = nksc

  fnyssc = 1 + (rank)*fns2sc
  fnyesc = (rank+1)*fns2sc

  fnzssc = 1
  fnzesc = fns3sc

  call random_init
  call transform_init
  deallocate(data_storesc)
  call data_init

  SC = diss

     print*,SC(1,1,1)
     print*,SC(ns1sc,ns2sc,ns3sc)

  call moyensc(SC,nut1)
  if (rank.eq.0) print*,'mean diss 64:',nut1

  file_counter = 3
  call data_write

  else if (ns1sc.lt.ns1) then

   print*,'solver_step'
   call solver_step

  end if

end subroutine postprocess
