subroutine postprocess5
!!! FOR SGS STRESS MODEL

  use solver
  use parallel
  use data

  implicit none
  integer :: i,j,k
  real(WP) :: kk,h,nd,nb,ffsize
  integer :: ierr,ik,il,jl,kl,iunit,dime,ndd,m1
  real(WP) :: pi,kc,eps,buf,epsil,u2,u3,u4,dx,cst1,cst2,cst3
  character*13 filexy1,filexy2,filexy3
  character*13 filepdf1,filepdf2,filepdf3
  character*13 filepdf4,filepdf5,filepdf6
 
  real(WP) :: dudx(ns1,ns2,ns3)
  real(WP) :: dudy(ns1,ns2,ns3)
  real(WP) :: dudz(ns1,ns2,ns3)
  real(WP) :: dvdx(ns1,ns2,ns3)
  real(WP) :: dvdy(ns1,ns2,ns3)
  real(WP) :: dvdz(ns1,ns2,ns3)
  real(WP) :: dwdx(ns1,ns2,ns3)
  real(WP) :: dwdy(ns1,ns2,ns3)
  real(WP) :: dwdz(ns1,ns2,ns3)
  real(WP) :: S11(ns1,ns2,ns3)
  real(WP) :: S12(ns1,ns2,ns3)
  real(WP) :: S13(ns1,ns2,ns3)
  real(WP) :: S22(ns1,ns2,ns3)
  real(WP) :: S23(ns1,ns2,ns3)
  real(WP) :: S33(ns1,ns2,ns3)
  real(WP) :: O11(ns1,ns2,ns3)
  real(WP) :: O12(ns1,ns2,ns3)
  real(WP) :: O13(ns1,ns2,ns3)
  real(WP) :: O22(ns1,ns2,ns3)
  real(WP) :: O23(ns1,ns2,ns3)
  real(WP) :: O33(ns1,ns2,ns3)
  real(WP) :: CQ(ns1,ns2,ns3)
  real(WP) :: w1(ns1,ns2,ns3)
  real(WP) :: w2(ns1,ns2,ns3)
  real(WP) :: w3(ns1,ns2,ns3)

  real(WP) :: xx(500), pdf(500) 

  dime = 500

!!! Uk, Vk, Wk and Zk the three component of velocity and scalar in spectral space

!!! All in spatial space

  call gradient(U,0.,dudx,dudy,dudz)
  call gradient(V,0.,dvdx,dvdy,dvdz)
  call gradient(W,0.,dwdx,dwdy,dwdz)

  S11 = dudx
  S22 = dvdy
  S33 = dwdz
  S12 = 0.5* (dudy + dvdx)
  S13 = 0.5* (dudz + dwdx)
  S23 = 0.5* (dvdz + dwdy)
  O11 = 0.
  O22 = 0.
  O33 = 0.
  O12 = 0.5* (dudy - dvdx)
  O13 = 0.5* (dudz - dwdx)
  O23 = 0.5* (dvdz - dwdy)
  CQ = 0.5*(O11*O11 - S11*S11 + O22*O22 - S22*S22 + O33*O33 - S33*S33 + &
     & 2.0*(O12*O12 - S12*S12 + O13*O13 - S13*S13 + O23*O23 - S23*S23))
  w1 = dwdy - dvdz
  w2 = dudz - dwdx
  w3 = dvdx - dudy

  if (rank.eq.0) call dump_geometry
  if (rank.eq.0) call dump_geometry_scalar
  call dump_data(U,'paravie_vel_1')
  call dump_data(V,'paravie_vel_2')
  call dump_data(W,'paravie_vel_3')
  call dump_data(w1,'paravie_vor_1')
  call dump_data(w2,'paravie_vor_2')
  call dump_data(w3,'paravie_vor_3')
  call dump_data(CQ,'paravie_critQ')
  call dump_data_sc(SC,'paravie_scalr')
  O11 = w1*w1 + w2*w2 + w3*w3
  O33 = U*U + V*V + W*W
  call dump_data(O11,'paravie_vor_e')
  call dump_data(O33,'paravie_vel_e')


end subroutine postprocess5	
