subroutine postprocess6
  
  use solver
  use parallel
  use data

  implicit none
  integer :: i,j,k,pas,ns1ne,ns2ne,ns3ne
  character(len=30) :: Filename
  integer :: ierr,ik,il,jl,kl,iunit

  real(WP), dimension(:,:,:), pointer :: Une,Vne,Wne,Zne ! vitesses pour nouveau maillage
  integer :: dime

!!! INTEGER

  call parser_read('New discretisation',ns1ne)
  ns2ne = ns1ne 
  ns3ne = ns1ne/nproc 
  

!!! TRANSFOMATION DE LA DISCRETISATION DE NX^3 EN NXNE^3

  if (rank.eq.0) print*,'allocation des tableaux',ns1ne 
  allocate(Une(ns1ne,ns2ne,ns3ne))
  allocate(Vne(ns1ne,ns2ne,ns3ne))
  allocate(Wne(ns1ne,ns2ne,ns3ne))
  allocate(Zne(ns1ne,ns2ne,ns3ne))
  Une = 0.0
  Vne = 0.0
  Wne = 0.0
  Zne = 0.0
  if (rank.eq.0) print*,'changement de discretisation U' 
  call discretisation2(U,Une,ns1,ns2,ns3,ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'changement de discretisation V' 
  call discretisation2(V,Vne,ns1,ns2,ns3,ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'changement de discretisation W' 
  call discretisation2(W,Wne,ns1,ns2,ns3,ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'changement de discretisation Z' 
  call discretisation2(SC,Zne,ns1sc,ns2sc,ns3sc,ns1ne,ns2ne,ns3ne)

  if (rank.eq.0) print*,'enregistrement tabU' 
  call tab_write_ne(Une,'tabU.out',ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'enregistrement tabV' 
  call tab_write_ne(Vne,'tabV.out',ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'enregistrement tabW' 
  call tab_write_ne(Wne,'tabW.out',ns1ne,ns2ne,ns3ne)
  if (rank.eq.0) print*,'enregistrement tabZ' 
  call tab_write_ne(Zne,'tabZ.out',ns1ne,ns2ne,ns3ne)

  deallocate(Une)
  deallocate(Vne)
  deallocate(Wne)
  deallocate(Zne)

end subroutine postprocess6
