subroutine cc_pdf(xx,pdf,z,in2,value,dime)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr
 real(WP) :: z(ns1,ns2,ns3),umin,umax,umin_recv,umax_recv,delta
 integer ::  in2(ns1,ns2,ns3), value, cpt2, cptt
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)


 umin=1.d33
 umax=-1.d33
 
 Do k =1,ns3
    Do j = 1,ns2
       Do i=1,ns1
          if (in2(i,j,k).eq.value) then 
             umax = max(umax,z(i,j,k))
             umin = min(umin,z(i,j,k))
          end if
        End Do
    End Do
 End Do

 !umax = 5
 !umin = -5

 Call MPI_ALLREDUCE(umin,  umin_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 umin  = umin_recv
 Call MPI_ALLREDUCE(umax,  umax_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 umax  = umax_recv

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3
     do j = 1,ns2
        do i = 1,ns1
           if (in2(i,j,k).eq.value) then
              if (z(i,j,k) .gt. umin+(ll-1)*delta ) then
                 if (z(i,j,k) .le.  umin+ll*delta ) then
                    pdfloc(ll)=pdfloc(ll)+1.
                    cptt = cptt+1
                 end if
              end if
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(cptt,cpt2,1,MPI_INTEGER,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 pdf=pdf/(delta*real(cpt2))
end subroutine cc_pdf

subroutine c_pdf_sca(xx,pdf,z,dime)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr, cpt2, cptt
 real(WP) :: z(ns1sc,ns2sc,ns3sc),umin,umax,umin_recv,umax_recv,delta
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)


 umin=1.d33
 umax=-1.d33
 
 Do k =1,ns3sc
    Do j = 1,ns2sc
       Do i=1,ns1sc
          umax = max(umax,z(i,j,k))
          umin = min(umin,z(i,j,k))
        End Do
    End Do
 End Do

 Call MPI_ALLREDUCE(umin,  umin_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 umin  = umin_recv
 Call MPI_ALLREDUCE(umax,  umax_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 umax  = umax_recv

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3sc
     do j = 1,ns2sc
        do i = 1,ns1sc
           if( z(i,j,k) .gt. umin+(ll-1)*delta ) then
             if( z(i,j,k) .le.  umin+ll*delta ) then
               pdfloc(ll)=pdfloc(ll)+1.
               cptt = cptt + 1
             endif
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(cptt,cpt2,1,MPI_INTEGER,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 pdf=pdf/(delta*real(cpt2))
end subroutine c_pdf_sca

subroutine c_pdf_sca_fix(xx,pdf,z,dime,mini,maxi)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr, cpt2, cptt
 real(WP) :: z(ns1sc,ns2sc,ns3sc),umin,umax,umin_recv,umax_recv,delta,mini,maxi
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)

 
 umin  = mini
 umax  = maxi

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3sc
     do j = 1,ns2sc
        do i = 1,ns1sc
           if( z(i,j,k) .gt. umin+(ll-1)*delta ) then
             if( z(i,j,k) .le.  umin+ll*delta ) then
               pdfloc(ll)=pdfloc(ll)+1.
               cptt = cptt + 1
             endif
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(cptt,cpt2,1,MPI_INTEGER,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
! pdf=pdf/(delta*real(cpt2))
 if(rank.eq.0) print*,'nombre de point dans la pdf avec min =',mini, &
       & ' et max =',maxi, ": ", real(cpt2)/ns1sc**3.*100.," pourcent de points"
end subroutine c_pdf_sca_fix

subroutine c_pdf(xx,pdf,z,dime)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr, cpt2, cptt
 real(WP) :: z(ns1,ns2,ns3),umin,umax,umin_recv,umax_recv,delta
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)


 umin=1.d33
 umax=-1.d33
 
 Do k =1,ns3
    Do j = 1,ns2
       Do i=1,ns1
          umax = max(umax,z(i,j,k))
          umin = min(umin,z(i,j,k))
        End Do
    End Do
 End Do

 Call MPI_ALLREDUCE(umin,  umin_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 umin  = umin_recv
 Call MPI_ALLREDUCE(umax,  umax_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 umax  = umax_recv

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3
     do j = 1,ns2
        do i = 1,ns1
           if( z(i,j,k) .gt. umin+(ll-1)*delta ) then
             if( z(i,j,k) .le.  umin+ll*delta ) then
               pdfloc(ll)=pdfloc(ll)+1.
               cptt = cptt + 1
             endif
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(cptt,cpt2,1,MPI_INTEGER,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 pdf=pdf/(delta*real(cpt2))
end subroutine c_pdf

subroutine cn_pdf(xx,pdf,z,dnsdiss,dime)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr
 real(WP) :: dnsdiss(ns1,ns2,ns3),z(ns1,ns2,ns3),umin,umax,umin_recv,umax_recv,delta,cptt
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)


 umin=1.d33
 umax=-1.d33
 
 Do k =1,ns3
    Do j = 1,ns2
       Do i=1,ns1
          if (dnsdiss(i,j,k).le.0) then
             umax = max(umax,z(i,j,k))
             umin = min(umin,z(i,j,k))
          end if
        End Do
    End Do
 End Do

 Call MPI_ALLREDUCE(umin,  umin_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 umin  = umin_recv
 Call MPI_ALLREDUCE(umax,  umax_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 umax  = umax_recv

 umax = 10.
 umin = -10.

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3
     do j = 1,ns2
        do i = 1,ns1
           if (dnsdiss(i,j,k).le.0) then
              if (z(i,j,k) .gt. umin+(ll-1)*delta ) then
                 if (z(i,j,k) .le.  umin+ll*delta ) then
                    pdfloc(ll)=pdfloc(ll)+1.
                    cptt = cptt + 1 
                 endif
              endif
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 pdf=pdf/(delta*real(cptt))
end subroutine cn_pdf

subroutine cp_pdf(xx,pdf,z,dnsdiss,dime)
 use solver
 use parallel
 use data
 implicit none
 integer  :: dime,i,j,k,ll,ierr
 real(WP) :: dnsdiss(ns1,ns2,ns3),z(ns1,ns2,ns3),umin,umax,umin_recv,umax_recv,delta,cptt
 real(WP) :: xx(dime), pdf(dime), pdfloc(dime)


 umin=1.d33
 umax=-1.d33
 
 Do k =1,ns3
    Do j = 1,ns2
       Do i=1,ns1
          if (dnsdiss(i,j,k).gt.0) then
             umax = max(umax,z(i,j,k))
             umin = min(umin,z(i,j,k))
          end if
        End Do
    End Do
 End Do

 Call MPI_ALLREDUCE(umin,  umin_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 umin  = umin_recv
 Call MPI_ALLREDUCE(umax,  umax_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 umax  = umax_recv

 umax = 10.
 umin = -10.

 pdfloc(:)=0.0
 cptt = 0
 delta=(umax-umin)/(dime-1.)
 if(rank.eq.0)  print*,delta,umin,umax
 do ll = 1,dime-1
  do k = 1,ns3
     do j = 1,ns2
        do i = 1,ns1
           if (dnsdiss(i,j,k).gt.0) then
              if (z(i,j,k) .gt. umin+(ll-1)*delta ) then
                 if (z(i,j,k) .le.  umin+ll*delta ) then
                    pdfloc(ll)=pdfloc(ll)+1.
                    cptt = cptt + 1
                 endif
              endif
           endif
        enddo
     enddo
  enddo
  xx(ll)=umin+(ll-0.5)*delta
 enddo
 call MPI_ALLREDUCE(pdfloc,pdf,dime,MPI_REAL_WP,MPI_SUM,              &
                  &   MPI_COMM_WORLD,ierr)
 pdf=pdf/(delta*real(cpTt))
end subroutine cp_pdf

subroutine var_skew_fla(z,vv,s,f)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: z(ns1,ns2,ns3)
  real(WP) :: test(ns1,ns2,ns3)
  real(WP) :: vv,s,f, buf1, buf2, buf3, buf4
  
  call moyen(z,buf1)
  call moyen(z**2,buf2)
  vv = buf2-buf1**2
  test = (z-buf1)**3
  call moyen(test,buf3)
  test = (z-buf1)**4
  call moyen(test,buf4)
  s = buf3 / (buf2**(3./2.))
  f = buf4 / (buf2**(2.))
end subroutine var_skew_fla

subroutine corre(tab1,tab2,cor)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: cor,moya,moyb
  real(WP) :: varab,vara2,varb2
  real(WP) :: tab1(ns1,ns2,ns3)
  real(WP) :: tab2(ns1,ns2,ns3)
  call moyen(tab1,moya)
  call moyen(tab2,moyb)
  call moyen(tab1*tab2,varab)
  varab = varab - moya*moyb
  call moyen(tab1*tab1,vara2)
  vara2 = vara2 - moya*moya
  call moyen(tab2*tab2,varb2)
  varb2 = varb2 - moyb*moyb
  cor=varab/(sqrt(vara2*varb2));
end subroutine corre

subroutine moyen_reg1(in1,in2,out1,value)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1,out2
 real(WP) :: in1(ns1,ns2,ns3)
 integer :: in2(ns1,ns2,ns3)
 integer :: i,j,k,ierr, value, cptt, cpt2
 out2 =0.
 cpt2 = 0
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         if (in2(i,j,k).eq.value) then
            out2=out2+in1(i,j,k)
            cpt2 = cpt2 + 1
         end if
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(cpt2,cptt,1,MPI_INTEGER,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(out2,out1,1,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 out1=out1/(real(cptt))
end subroutine moyen_reg1

subroutine moyen_reg2(in1,in2,out1,value)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1,out2
 real(WP) :: in1(ns1,ns2,ns3)
 integer :: in2(ns1,ns2,ns3)
 integer :: i,j,k,ierr, value, cptt, cpt2
 out2 =0.
 cpt2 = 0
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         if (in2(i,j,k).eq.value) then
            out2=out2+in1(i,j,k)
            cpt2 = cpt2 + 1
         end if
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(cpt2,cptt,1,MPI_INTEGER,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(out2,out1,1,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 out1=out1/(real(nx**3))
end subroutine moyen_reg2

subroutine moyensc(in1,out1)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1,out2
 real(WP) :: in1(ns1sc,ns2sc,ns3sc)
 integer i,j,k,ierr
 out2 =0.
 do k = 1,ns3sc
   do j = 1,ns2sc
      do i = 1,ns1sc
         out2=out2+in1(i,j,k)
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(out2,out1,1,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 out1=out1/(real(nxsc**3.))
end subroutine moyensc

subroutine moyen(in1,out1)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1,out2
 real(WP) :: in1(ns1,ns2,ns3)
 integer i,j,k,ierr
 out2 =0.
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         out2=out2+in1(i,j,k)
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(out2,out1,1,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 out1=out1/(real(nx**3.))
end subroutine moyen

subroutine moyen_ysc(in1,out1)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1(ns2sc),out2(ns2sc)
 real(WP) :: in1(ns1sc,ns2sc,ns3sc)
 integer i,j,k,ierr
 out2 =0.
 do k = 1,ns3sc
   do j = 1,ns2sc
      do i = 1,ns1sc
         out2(j)=out2(j)+in1(i,j,k)
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(out2,out1,ns2sc,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)

 out1=out1/(real(nxsc**2.))

end subroutine moyen_ysc

subroutine moyen_y(in1,out1)
 use solver
 use parallel
 use data
 implicit none
 real(WP) :: out1(ns2),out2(ns2)
 real(WP) :: in1(ns1,ns2,ns3)
 integer i,j,k,ierr
 out2 =0.
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         out2(j)=out2(j)+in1(i,j,k)
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(out2,out1,ns2,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)

 out1=out1/(real(nx**2.))

end subroutine moyen_y

subroutine mean_cond_2(in,cond,cond2,out,nbr)
 use solver
 use parallel
 use data
 implicit none
 integer :: nbr,i,j,k,jj,kk,ierr
 real(WP) :: minix,maxix,delta
 real(WP) :: minix2,maxix2,delta2
 real(WP) :: minix_recv,maxix_recv,minix2_recv,maxix2_recv
 real(WP) :: value(nbr,nbr),valueloc(nbr,nbr)
 real(WP) :: nombre(nbr,nbr),nombreloc(nbr,nbr)
 real(WP) :: in(ns1,ns2,ns3)
 real(WP) :: cond(ns1,ns2,ns3)
 real(WP) :: cond2(ns1,ns2,ns3)
 real(WP) :: out(ns1,ns2,ns3)
 maxix=-1.d33
 minix=1.d33
 maxix2=-1.d33
 minix2=1.d33

 Do k =1,ns3
    Do j = 1,ns2
       Do i=1,ns1
          maxix = max(maxix,cond(i,j,k))
          minix = min(minix,cond(i,j,k))
          maxix2 = max(maxix2,cond2(i,j,k))
          minix2 = min(minix2,cond2(i,j,k))
        End Do
    End Do
 End Do

 Call MPI_ALLREDUCE(minix,  minix_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 minix  = minix_recv
 Call MPI_ALLREDUCE(minix2,  minix2_recv, 1, MPI_REAL_WP,MPI_MIN, MPI_COMM_WORLD, ierr)
 minix2  = minix2_recv
 Call MPI_ALLREDUCE(maxix,  maxix_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 maxix  = maxix_recv
 Call MPI_ALLREDUCE(maxix2,  maxix2_recv, 1, MPI_REAL_WP,MPI_MAX, MPI_COMM_WORLD, ierr)
 maxix2  = maxix2_recv

 delta = (maxix-minix)/real(nbr);

 delta2 = (maxix2-minix2)/real(nbr);
 nombreloc=0.
 valueloc =0.
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         do jj = 1,nbr
            do kk = 1,nbr
            if(cond(i,j,k)>minix+(jj-1)*delta.and.cond(i,j,k)<=minix+jj*delta &
       &  .and.cond2(i,j,k)>minix2+(kk-1)*delta2.and.cond2(i,j,k)<=minix2+kk*delta2 ) then
               valueloc(jj,kk)=valueloc(jj,kk)+in(i,j,k);
               nombreloc(jj,kk)=nombreloc(jj,kk)+1;
            endif
            enddo
         enddo
      enddo
   enddo
 enddo
 call MPI_ALLREDUCE(valueloc,value,nbr*nbr,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 call MPI_ALLREDUCE(nombreloc,nombre,nbr*nbr,MPI_REAL_WP,MPI_SUM,              &
                 &    MPI_COMM_WORLD,ierr)
 value=value/nombre
 do k = 1,ns3
   do j = 1,ns2
      do i = 1,ns1
         do jj = 1,nbr
            do kk = 1,nbr
            if(cond(i,j,k)>minix+(jj-1)*delta.and.cond(i,j,k)<=minix+jj*delta &
       &  .and.cond2(i,j,k)>minix2+(kk-1)*delta2.and.cond2(i,j,k)<=minix2+kk*delta2 ) then
               out(i,j,k)=value(jj,kk)
            endif
            enddo
         enddo
      enddo
   enddo
 enddo
end subroutine mean_cond_2

subroutine mean_cond(in,cond,out,xx,value,nbr)
  use solver
  use parallel
  use data
  implicit none
  integer :: nbr,i,j,k,jj,ierr
  real(WP) :: minix,maxix,delta,maxixloc,minixloc
  real(WP) :: value(nbr),valueloc(nbr),xx(nbr)
  real(WP) :: nombre(nbr),nombreloc(nbr)
  real(WP) :: in(ns1,ns2,ns3)
  real(WP) :: cond(ns1,ns2,ns3)
  real(WP) :: out(ns1,ns2,ns3)
  maxixloc = maxval(cond)
  call MPI_ALLREDUCE(maxixloc,maxix,1,MPI_REAL_WP,MPI_MAX,              &
                      MPI_COMM_WORLD,ierr)
  minixloc = minval(cond)
  call MPI_ALLREDUCE(minixloc,minix,1,MPI_REAL_WP,MPI_MIN,              &
                      MPI_COMM_WORLD,ierr)
  delta = (maxix-minix)/real(nbr);
!  if(rank.eq.0) print*,maxix
!  if(rank.eq.0) print*,minix
  nombreloc=0.
  valueloc =0.
  do k = 1,ns3
    do j = 1,ns2
       do i = 1,ns1
          do jj = 1,nbr
             if(cond(i,j,k)>minix+(jj-1)*delta.and.cond(i,j,k)<=minix+jj*delta ) then
                valueloc(jj)=valueloc(jj)+in(i,j,k);
                nombreloc(jj)=nombreloc(jj)+1;
             endif
          enddo
       enddo
    enddo
  enddo
  do jj = 1,nbr
     xx(jj) = minix+(jj-0.5)*delta
  enddo
  call MPI_ALLREDUCE(valueloc,value,nbr,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
  call MPI_ALLREDUCE(nombreloc,nombre,nbr,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
  value=value/nombre
  do k = 1,ns3
    do j = 1,ns2
       do i = 1,ns1
          do jj = 1,nbr
             if(cond(i,j,k)>minix+(jj-1)*delta.and.cond(i,j,k)<=minix+jj*delta ) then
                out(i,j,k)=value(jj)
             endif
          enddo
       enddo
    enddo
  enddo
end subroutine mean_cond

subroutine physboxfilter(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  real(WP) :: dist,nd
  integer i,j,k,nd2,number
  integer iii,jj,kk
  integer id,jd,kd

  nd2=int(nd/2)
  do k=1,ns1
    do j=1,ns1
      do i=1,ns1
        out1(i,j,k)=0
        number=0
        do iii = i-nd2,i+nd2
          do jj = j-nd2,j+nd2
            do kk = k-nd2,k+nd2
              dist = sqrt((real(i)-real(iii))**2.+(real(j)-real(jj))**2.+(real(k)-real(kk))**2.)
!              print*,dist,i,iii,j,jj,k,kk,nd2
              if (dist.le.real(nd2)) then
                 if(iii.lt.1) then
                    id = ns1+iii
                 elseif(iii.gt.ns1) then
                    id = iii-ns1
                 else
                    id = iii
                 endif
                 if(jj.lt.1) then
                    jd = ns1+jj
                 elseif(j.gt.ns1) then
                    jd = jj-ns1
                 else
                    jd = jj
                 endif
                 if(kk.lt.1) then
                    kd = ns1+kk
                 elseif(kk.gt.ns1) then
                    kd = kk-ns1
                 else
                    kd = kk
                 endif
                 out1(i,j,k)=out1(i,j,k)+in1(id,jd,kd)
                 number=number+1
              endif
            enddo
          enddo
        enddo
        out1(i,j,k) = out1(i,j,k)/number
      enddo
    enddo
  enddo
  print*,'number of points',number
end subroutine physboxfilter

subroutine specboxfiltersc(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx
  real(WP) :: out1(ns1sc,ns2sc,ns3sc)
  real(WP) :: in1(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k

  dx = L/(real(nxsc))
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(outk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in1,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
  delta = nd*dx 
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          if(kxsc(i).eq.0.and.kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kxsc(i).eq.0.and.kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kxsc(i).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          elseif(kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))
          elseif(kxsc(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          endif
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ink) 
  deallocate(outk) 
end subroutine specboxfiltersc

subroutine specboxfilter(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(outk(fns1,fns2,fns3))
  call ftran_wrap(in1,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
  delta = nd*dx 
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          if(kx(i).eq.0.and.ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kx(i).eq.0.and.ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kx(i).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          elseif(ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))
          elseif(kx(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          endif
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ink) 
  deallocate(outk) 
end subroutine specboxfilter

subroutine speccutboxfilter2sc(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1sc,ns2sc,ns3sc)
  real(WP) :: in1(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(outk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in1,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
  delta = nd*dx
  kc = 2*3.141592654/delta
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          if(kxsc(i).eq.0.and.kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kxsc(i).eq.0.and.kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kxsc(i).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          elseif(kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))
          elseif(kxsc(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          endif
       enddo
    enddo
  enddo
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          kk = sqrt(kxsc(i)**2 + kysc(j)**2 + kzsc(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ink)
  deallocate(outk)
end subroutine speccutboxfilter2sc

subroutine speccutboxfilter2(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(outk(fns1,fns2,fns3))
  call ftran_wrap(in1,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
  delta = nd*dx 
  kc = 2*3.141592654/delta
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          if(kx(i).eq.0.and.ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kx(i).eq.0.and.ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kx(i).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          elseif(ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))
          elseif(kx(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          endif
       enddo
    enddo
  enddo
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          kk = sqrt(kx(i)**2 + ky(j)**2 + kz(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ink) 
  deallocate(outk) 
end subroutine speccutboxfilter2

subroutine speccutboxfilter(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(outk(fns1,fns2,fns3))
  call ftran_wrap(in1,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
  delta = nd*dx 
  kc = 3.141592654/delta
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          if(kx(i).eq.0.and.ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kx(i).eq.0.and.ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kx(i).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          elseif(ky(j).eq.0.and.kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))
          elseif(kx(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(ky(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          elseif(kz(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kx(i))/(0.5*delta*kx(i))*  &
                                 &   sin(0.5*delta*ky(j))/(0.5*delta*ky(j))*  &
                                 &   sin(0.5*delta*kz(k))/(0.5*delta*kz(k))
          endif
       enddo
    enddo
  enddo
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          kk = sqrt(kx(i)**2 + ky(j)**2 + kz(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ink) 
  deallocate(outk) 
end subroutine speccutboxfilter

subroutine speccutboxfiltersc(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1sc,ns2sc,ns3sc)
  real(WP) :: in1(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(outk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in1,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
  delta = nd*dx
  kc = 3.141592654/delta
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          if(kxsc(i).eq.0.and.kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)
          elseif(kxsc(i).eq.0.and.kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kxsc(i).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          elseif(kysc(j).eq.0.and.kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))
          elseif(kxsc(i).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kysc(j).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          elseif(kzsc(k).eq.0) then
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))
          else
            outk(i,j,k) = ink(i,j,k)*sin(0.5*delta*kxsc(i))/(0.5*delta*kxsc(i))*  &
                                 &   sin(0.5*delta*kysc(j))/(0.5*delta*kysc(j))*  &
                                 &   sin(0.5*delta*kzsc(k))/(0.5*delta*kzsc(k))
          endif
       enddo
    enddo
  enddo
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          kk = sqrt(kxsc(i)**2 + kysc(j)**2 + kzsc(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ink)
  deallocate(outk)
end subroutine speccutboxfiltersc



subroutine specgaussfiltersc(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx
  real(WP) :: out1(ns1sc,ns2sc,ns3sc)
  real(WP) :: in1(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nxsc))
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(outk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in1,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
  delta = nd*dx 
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
            kk = (kxsc(i)**2 + kysc(j)**2 + kzsc(k)**2)**(0.5)
            outk(i,j,k) = ink(i,j,k)*exp(-(kk*delta)**2/24.)
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ink) 
  deallocate(outk) 
end subroutine specgaussfiltersc

subroutine specgaussfilter(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(nx))
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(outk(fns1,fns2,fns3))
  call ftran_wrap(in1,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
  delta = nd*dx 
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
            kk = (kx(i)**2 + ky(j)**2 + kz(k)**2)**(0.5)
            outk(i,j,k) = ink(i,j,k)*exp(-(kk*delta)**2/24.)
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ink) 
  deallocate(outk) 
end subroutine specgaussfilter

subroutine curl(inx,iny,inz,curlx,curly,curlz)
  use solver
  use parallel
  use data
  implicit none
  integer :: i,j,k
  real(WP) :: inx(ns1,ns2,ns3),iny(ns1,ns2,ns3),inz(ns1,ns2,ns3)
  real(WP) :: curlx(ns1,ns2,ns3)
  real(WP) :: curly(ns1,ns2,ns3)
  real(WP) :: curlz(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: inxk,inyk,inzk,curlxk,curlyk,curlzk
  ALLOCATE(inxk(fns1,fns2,fns3))
  ALLOCATE(inyk(fns1,fns2,fns3))
  ALLOCATE(inzk(fns1,fns2,fns3))
  ALLOCATE(curlxk(fns1,fns2,fns3))
  ALLOCATE(curlyk(fns1,fns2,fns3))
  ALLOCATE(curlzk(fns1,fns2,fns3))
  call ftran_wrap(inx,inxk,ns1,ns2,ns3,fns1,fns2,fns3)
  call ftran_wrap(iny,inyk,ns1,ns2,ns3,fns1,fns2,fns3)
  call ftran_wrap(inz,inzk,ns1,ns2,ns3,fns1,fns2,fns3)
  inxk=inxk/(real(ns1)**3.)
  inyk=inyk/(real(ns1)**3.)
  inzk=inzk/(real(ns1)**3.)
    do k = 1,fns3
       do j = 1,fns2
          do i = 1,fns1
              curlxk(i,j,k) = ii*ky(j)*inzk(i,j,k) - ii*kz(k)*inyk(i,j,k)
              curlyk(i,j,k) = ii*kz(k)*inxk(i,j,k) - ii*kx(i)*inzk(i,j,k)
              curlzk(i,j,k) = ii*kx(i)*inyk(i,j,k) - ii*ky(j)*inxk(i,j,k)
          enddo
        enddo
    enddo
  call btran_wrap(curlxk,curlx,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(curlyk,curly,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(curlzk,curlz,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(curlxk)
  deallocate(curlyk)
  deallocate(curlzk)
  deallocate(inxk)
  deallocate(inyk)
  deallocate(inzk)
end subroutine curl

subroutine gradntsc(in,nd,ddx,ddy,ddz,nt)
  use solver
  use parallel
  use data
  implicit none
  integer :: i,j,k
  integer :: nd, nt

  real(WP) :: in(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddx(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddy(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddz(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink,ddxk,ddyk,ddzk
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddxk(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddyk(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddzk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
    do k = 1,fns3sc
       do j = 1,fns2sc
          do i = 1,fns1sc
            ddxk(i,j,k)=(ii*kxsc(i))**(real(nt))*ink(i,j,k)
            ddyk(i,j,k)=(ii*kysc(j))**(real(nt))*ink(i,j,k)
            ddzk(i,j,k)=(ii*kzsc(k))**(real(nt))*ink(i,j,k)
          enddo
        enddo
    enddo
  call btran_wrap(ddxk,ddx,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  call btran_wrap(ddyk,ddy,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  call btran_wrap(ddzk,ddz,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ddxk)
  deallocate(ddyk)
  deallocate(ddzk)
  deallocate(ink)
end subroutine gradntsc

subroutine gradientsc(in,nd,ddx,ddy,ddz)
  use solver
  use parallel
  use data
  implicit none
  integer :: i,j,k
  integer :: nd

  real(WP) :: in(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddx(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddy(ns1sc,ns2sc,ns3sc)
  real(WP) :: ddz(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink,ddxk,ddyk,ddzk
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddxk(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddyk(fns1sc,fns2sc,fns3sc))
  ALLOCATE(ddzk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
    do k = 1,fns3sc
       do j = 1,fns2sc
          do i = 1,fns1sc
            ddxk(i,j,k)=ii*kxsc(i)*ink(i,j,k)
            ddyk(i,j,k)=ii*kysc(j)*ink(i,j,k)
            ddzk(i,j,k)=ii*kzsc(k)*ink(i,j,k)
          enddo
        enddo
    enddo
  call btran_wrap(ddxk,ddx,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  call btran_wrap(ddyk,ddy,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  call btran_wrap(ddzk,ddz,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ddxk)
  deallocate(ddyk)
  deallocate(ddzk)
  deallocate(ink)
end subroutine gradientsc

subroutine gradient(in,nd,ddx,ddy,ddz)
  use solver
  use parallel
  use data
  implicit none
  integer :: i,j,k
  integer :: nd

  real(WP) :: in(ns1,ns2,ns3)
  real(WP) :: ddx(ns1,ns2,ns3)
  real(WP) :: ddy(ns1,ns2,ns3)
  real(WP) :: ddz(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink,ddxk,ddyk,ddzk
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(ddxk(fns1,fns2,fns3))
  ALLOCATE(ddyk(fns1,fns2,fns3))
  ALLOCATE(ddzk(fns1,fns2,fns3))
  call ftran_wrap(in,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
    do k = 1,fns3
       do j = 1,fns2
          do i = 1,fns1
            ddxk(i,j,k)=ii*kx(i)*ink(i,j,k)
            ddyk(i,j,k)=ii*ky(j)*ink(i,j,k)
            ddzk(i,j,k)=ii*kz(k)*ink(i,j,k)
          enddo
        enddo
    enddo
  call btran_wrap(ddxk,ddx,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(ddyk,ddy,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(ddzk,ddz,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ddxk)
  deallocate(ddyk)
  deallocate(ddzk)
  deallocate(ink)
end subroutine gradient

subroutine cutgradient(in,nd,ddx,ddy,ddz)
  use solver
  use parallel
  use data
  implicit none
  integer :: i,j,k
  real(WP) :: nd, kc, delta, dx, kk
  real(WP) :: in(ns1,ns2,ns3)
  real(WP) :: ddx(ns1,ns2,ns3)
  real(WP) :: ddy(ns1,ns2,ns3)
  real(WP) :: ddz(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink,ddxk,ddyk,ddzk
  dx = L/(real(nx))
  delta = nd*dx 
  kc = 3.141592654/delta
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(ddxk(fns1,fns2,fns3))
  ALLOCATE(ddyk(fns1,fns2,fns3))
  ALLOCATE(ddzk(fns1,fns2,fns3))
  call ftran_wrap(in,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
    do k = 1,fns3
       do j = 1,fns2
          do i = 1,fns1
            ddxk(i,j,k)=ii*kx(i)*ink(i,j,k)
            ddyk(i,j,k)=ii*ky(j)*ink(i,j,k)
            ddzk(i,j,k)=ii*kz(k)*ink(i,j,k)
            kk = sqrt(kx(i)**2 + ky(j)**2 + kz(k)**2)
            if (kk.gt.kc) then
             ddxk(i,j,k) = 0.0
             ddyk(i,j,k) = 0.0
             ddzk(i,j,k) = 0.0
            end if
          enddo
        enddo
    enddo
  call btran_wrap(ddxk,ddx,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(ddyk,ddy,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(ddzk,ddz,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ddxk)
  deallocate(ddyk)
  deallocate(ddzk)
  deallocate(ink)
end subroutine cutgradient

subroutine speccutfilter(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1,ns2,ns3)
  real(WP) :: in1(ns1,ns2,ns3)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(ns1))
  delta = nd*dx 
  kc = 3.141592654/delta
  ALLOCATE(ink(fns1,fns2,fns3))
  ALLOCATE(outk(fns1,fns2,fns3))
  call ftran_wrap(in1,ink,ns1,ns2,ns3,fns1,fns2,fns3)
  ink=ink/(real(ns1)**3.)
  outk = ink
  do k = 1,fns3
    do j = 1,fns2
       do i = 1,fns1
          kk = sqrt(kx(i)**2 + ky(j)**2 + kz(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1,ns2,ns3,fns1,fns2,fns3)
  deallocate(ink) 
  deallocate(outk) 
end subroutine speccutfilter


subroutine speccutfiltersc(in1,out1,nd)
  use solver
  use parallel
  use data
  implicit none
  real(WP) :: kk,delta,nd,dx,kc
  real(WP) :: out1(ns1sc,ns2sc,ns3sc)
  real(WP) :: in1(ns1sc,ns2sc,ns3sc)
  complex(WP), dimension(:,:,:), pointer :: ink
  complex(WP), dimension(:,:,:), pointer :: outk
  integer i,j,k
  dx = L/(real(ns1sc))
  delta = nd*dx 
  kc = 3.141592654/delta
  ALLOCATE(ink(fns1sc,fns2sc,fns3sc))
  ALLOCATE(outk(fns1sc,fns2sc,fns3sc))
  call ftran_wrap(in1,ink,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  ink=ink/(real(ns1sc)**3.)
  outk = ink
  do k = 1,fns3sc
    do j = 1,fns2sc
       do i = 1,fns1sc
          kk = sqrt(kxsc(i)**2 + kysc(j)**2 + kzsc(k)**2)
          if (kk.gt.kc) then
             outk(i,j,k) = 0.0
          end if
       enddo
    enddo
  enddo
  call btran_wrap(outk,out1,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)
  deallocate(ink) 
  deallocate(outk) 
end subroutine speccutfiltersc

subroutine turbulent_region(t11,t12,t13,t22,t23,t33,ome1,ome2,ome3,out1)
  use solver
  use parallel
  use data
!  use f95_lapack, only: la_syevd
  implicit none

  integer :: out1(ns1,ns2,ns3)
  real(WP) :: t11(ns1,ns2,ns3)
  real(WP) :: t12(ns1,ns2,ns3)
  real(WP) :: t13(ns1,ns2,ns3)
  real(WP) :: t22(ns1,ns2,ns3)
  real(WP) :: t23(ns1,ns2,ns3)
  real(WP) :: t33(ns1,ns2,ns3)
  real(WP) :: ome1(ns1,ns2,ns3)
  real(WP) :: ome2(ns1,ns2,ns3)
  real(WP) :: ome3(ns1,ns2,ns3)
  real(WP) :: tab(3,3)
  real(WP) :: vec(3)
  real(WP) :: norm, sca1, sca2, sca3, scamax, lp, lm

  integer :: i, j, k

  do k = 1, ns3
     do j = 1, ns2
        do i = 1, ns1
           norm = sqrt(ome1(i,j,k)**2.0 + ome2(i,j,k)**2.0 + ome3(i,j,k)**2.0)
           ome1(i,j,k) = ome1(i,j,k) / norm
           ome2(i,j,k) = ome2(i,j,k) / norm
           ome3(i,j,k) = ome3(i,j,k) / norm
           norm = sqrt(ome1(i,j,k)**2.0 + ome2(i,j,k)**2.0 + ome3(i,j,k)**2.0)
           if ( norm.le.0.999.or.norm.ge.1.001) then
              print*,'norm vorticity',sqrt(ome1(i,j,k)**2.0 + ome2(i,j,k)**2.0 + ome3(i,j,k)**2.0),i,j,k
           end if
        end do
     end do
  end do

  out1 = 0.

  do k = 1, ns3
     do j = 1, ns2
        do i = 1, ns1

           tab(1,1) = t11(i,j,k)
           tab(1,2) = t12(i,j,k)
           tab(2,1) = t12(i,j,k)
           tab(1,3) = t13(i,j,k)
           tab(3,1) = t13(i,j,k)
           tab(2,2) = t22(i,j,k)
           tab(2,3) = t23(i,j,k)
           tab(3,2) = t23(i,j,k)
           tab(3,3) = t33(i,j,k)
           vec = 0.

!           call la_syevd(tab,vec,'V')
 
           norm = sqrt( tab(1,1)**2.0 + tab(2,1)**2.0 + tab(3,1)**2.0 )
           if (norm.le.0.999.or.norm.ge.1.001) print*,'norm vec1', norm, i,j,k
           norm = sqrt( tab(1,2)**2.0 + tab(2,2)**2.0 + tab(3,2)**2.0 )
           if (norm.le.0.999.or.norm.ge.1.001) print*,'norm vec2', norm, i,j,k
           norm = sqrt( tab(1,3)**2.0 + tab(2,3)**2.0 + tab(3,3)**2.0 )
           if (norm.le.0.999.or.norm.ge.1.001) print*,'norm vec3', norm, i,j,k
          
           !if (rank.eq.0) then 
           ! print*,'eigenvector (',tab(1,1),tab(2,1),tab(3,1),') of eigenvector: ',vec(1)
           ! print*,'eigenvector (',tab(1,2),tab(2,2),tab(3,2),') of eigenvector: ',vec(2)
           ! print*,'eigenvector (',tab(1,3),tab(2,3),tab(3,3),') of eigenvector: ',vec(3)	
           !end if
           if (vec(2).gt.vec(3).or.vec(2).lt.vec(1)) then
              print*, 'pas le bon ordre pour les valeurs propres', rank,i,j,k
           end if

           sca1 = ome1(i,j,k)*tab(1,1) + ome2(i,j,k)*tab(2,1) + ome3(i,j,k)*tab(3,1)
           sca2 = ome1(i,j,k)*tab(1,2) + ome2(i,j,k)*tab(2,2) + ome3(i,j,k)*tab(3,2)
           sca3 = ome1(i,j,k)*tab(1,3) + ome2(i,j,k)*tab(2,3) + ome3(i,j,k)*tab(3,3)

           scamax = max(abs(sca1),abs(sca2))
           scamax = max(scamax,abs(sca3))
   
           if (scamax.le.0.5.or.scamax.ge.1.001) print*,'SCAMAX',scamax

           if (scamax.eq.sca1) then 
              lp = vec(3) 
              lm = vec(2)
           else if (scamax.eq.sca2) then
              lp = vec(3)
              lm = vec(1)
           else if (scamax.eq.sca3) then
              lp = vec(2)
              lm = vec(1)
           end if

           if (lm.gt.0) out1(i,j,k)=1 ! strain dominated region
           if (lp.ge.0.and.lm.le.0) out1(i,j,k)=2 !strain rate and vorticity comparable
           if (lp.lt.0) out1(i,j,k)=3 ! vorticity dominated region 
       
       end do
    end do
 end do
  
end subroutine turbulent_region
