subroutine dns_stats

  use solver
  use parallel
  use data

  implicit none

  real(WP), dimension(2,nx+1) :: S1,S2,S
  real(WP), dimension(ns1,ns2,ns3) :: tab,tab1
  real(WP), dimension(:,:,:), allocatable :: SCO, SCO2
  real(WP),dimension(ns1sc,ns2sc,ns3sc) :: tabsc
  complex(WP),dimension(fns1,fns2,fns3) :: tabf
!  real(WP),dimension(ns1,ns2,ns3) :: tabx,taby,tabz
!  complex(WP),dimension(fns1,fns2,fns3) :: tabfx,tabfy,tabfz
  real(WP) :: esum, k2sum,lambda_t,Re_lambda,uturb,divumax
  real(WP) :: buf,grms,drms,lambda,buf1

  integer :: k,i,j,ierr,ik,nxo,nxoz
  real(WP) :: kk,umax,vmax,wmax,cos,pi,kc,eps,e_spec,zmax,zstat2,zstat,zstat2o,zstato 

  S = 0.0_WP
  S1 = 0.0_WP
  S2 = 0.0_WP
  call u_compute

  pi = acos(-1.0_WP)
!  dk = 2.0_WP*pi/L
!  kc = pi*nx/L
!  eps = kc/1000000_WP
!
!  do k = 1,fns3
!     do j = 1,fns2
!        do i = 1,fns1
!           kk= sqrt(kx(i)**2.0_WP + ky(j)**2.0_WP + kz(k)**2.0_WP)
!           ik = 1+idint(kk/dk+0.5_WP)
!           if (kk.gt.eps.and.kk.le.kc) then
!              e_spec = (real(Uk(i,j,k)*conjg(Uk(i,j,k))) + &
!                   & real(Vk(i,j,k)*conjg(Vk(i,j,k))) +&
!                   & real(Wk(i,j,k)*conjg(Wk(i,j,k))))
!              S1(2,ik) = S1(2,ik) + e_spec
!              S2(2,ik) = S2(2,ik) + 2*mu*kk**2.0_WP*e_spec
!           endif
!        enddo
!     enddo
!  enddo
!  do i = 1,nx+1
!     S1(1,i) = real(i-1,WP)*dk
!     S2(1,i) = real(i-1,WP)*dk
!  enddo
!  S = S1
!
!  call MPI_ALLREDUCE(S1(2,:),S(2,:),nx+1,MPI_REAL_WP,MPI_SUM,&
!       &MPI_COMM_WORLD,ierr)
!
!  S1 = S
!
!  call MPI_ALLREDUCE(S2(2,:),S(2,:),nx+1,MPI_REAL_WP,MPI_SUM,&
!       &MPI_COMM_WORLD,ierr)
!
!  S2 = S
!
!  esum = 0.0_WP
!  k2sum = 0.0_WP
!  do k = 1,nx+1
!     kk = S(1,k)
!     esum = esum + S1(2,k)
!     k2sum = k2sum + S2(2,k)
!  enddo
!  lambda_t = sqrt(5*esum/k2sum)
!-----urms
  tab=U**2+V**2+W**2
  buf=0.
  do k=1,ns3
     do j=1,ns2
        do i=1,ns1
           buf=buf+tab(i,j,k)
        enddo
     enddo
  enddo
  call MPI_ALLREDUCE(buf,grms,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
!  print*,"U rms =",grms/(ns1**3.)
!-----<dudx^2>+<dvdy^2>+<dwdz^2>
  buf=0.
  tab=0.
  tabf=0.
  do k=1,fns3
     do j=1,fns2
        tabf(:,j,k) = ii*kx(:)*Uk(:,j,k)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  do k=1,ns3
     do j=1,ns2
        do i=1,ns1
           buf=buf+tab(i,j,k)**2.
        enddo
     enddo
  enddo
  tab=0.
  tabf=0.
  do k=1,fns3
     do i=1,fns1
        tabf(i,:,k) = ii*ky(:)*Vk(i,:,k)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  do k=1,ns3
     do j=1,ns2
        do i=1,ns1
           buf=buf+tab(i,j,k)**2.
        enddo
     enddo
  enddo
  tab=0.
  tabf=0.
  do j=1,fns2
     do i=1,fns1
        tabf(i,j,:) = ii*kz(:)*Wk(i,j,:)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  do k=1,ns3
     do j=1,ns2
        do i=1,ns1
           buf=buf+tab(i,j,k)**2.
        enddo
     enddo
  enddo
  call MPI_ALLREDUCE(buf,drms,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
!----
!---divergence
! -- divergences
!- velocity
  tab1=0.
  tab=0.
  tabf=0.
  do k=1,fns3
     do j=1,fns2
        tabf(:,j,k) = ii*kx(:)*Uk(:,j,k)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  tab1 = tab
  tab=0.
  tabf=0.
  do k=1,fns3
     do i=1,fns1
        tabf(i,:,k) = ii*ky(:)*Vk(i,:,k)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  tab1 = tab1 + tab
  tab=0.
  tabf=0.
  do j=1,fns2
     do i=1,fns1
        tabf(i,j,:) = ii*kz(:)*Wk(i,j,:)
     enddo
  enddo
  call btran_wrap(tabf,tab,ns1,ns2,ns3,fns1,fns2,fns3)
  tab1 = tab1 + tab
  call parallel_max(maxval(abs(tab1)),divumax)
!----
  lambda = sqrt(grms/drms)
  uturb = sqrt(grms/(3.*real(nx**3,WP)))
  Re_lambda = uturb*lambda/mu_solver

  call parallel_max(maxval(abs(U)),umax)
  call parallel_max(maxval(abs(V)),vmax)
  call parallel_max(maxval(abs(W)),wmax)
  call parallel_max(maxval(abs(SC)),zmax)
  tabsc=SC**2
  buf=0.
  buf1=0.
  do k=1,ns3sc
     do j=1,ns2sc
        do i=1,ns1sc
           buf=buf+tabsc(i,j,k)
           buf1=buf1+SC(i,j,k)
        enddo
     enddo
  enddo
  call MPI_ALLREDUCE(buf,zstat2,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
  call MPI_ALLREDUCE(buf1,zstat,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
  zstat=zstat/(real(nxsc**3,WP))
  zstat2=zstat2/(real(nxsc**3,WP))
  zstat2 = (zstat2 - zstat**2.)**(0.5)

 call parser_read('Nx filter output',nxo,0)
 if (nxo.lt.ns1sc.and.nxo.ne.0) then
    nxoz = nxo / nproc
    allocate(SCO(nxo,nxo,nxoz))
    allocate(SCO2(nxo,nxo,nxoz))
    call discretisation3(SC,SCO,ns1sc,ns2sc,ns3sc,nxo,nxo,nxoz)
    SCO2=SCO**2.0
    buf=0.
    buf1=0.
    do k=1,nxoz
       do j=1,nxo
          do i=1,nxo
             buf=buf+SCO2(i,j,k)
             buf1=buf1+SCO(i,j,k)
          enddo
       enddo
    enddo
    call MPI_ALLREDUCE(buf,zstat2o,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
    call MPI_ALLREDUCE(buf1,zstato,1,MPI_REAL_WP,MPI_SUM,              &
                      MPI_COMM_WORLD,ierr)
    zstato=zstato/(real(nxo**3,WP))
    zstat2o=zstat2o/(real(nxo**3,WP))
    zstat2o = (zstat2o - zstato**2.)**(0.5)
    deallocate(SCO)
    deallocate(SCO2)
 end if 

  if (rank.eq.0) then
!     print*,grms,drms,lambda,uturb,mu_solver
     write(*,'(A10,8(E12.5,2X))') 'STEP ', sim_time,Re_lambda,uturb,umax,divumax,zmax,zstat2,zstat2o
  endif

  

end subroutine dns_stats

subroutine u_compute

  use solver
  use data
  use parallel

  implicit none

  real(WP) :: Uloc(ns1,ns2,ns3)
  real(WP) :: Vloc(ns1,ns2,ns3)
  real(WP) :: Wloc(ns1,ns2,ns3)
  
  call btran_wrap(Uk,Uloc,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(Vk,Vloc,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(Wk,Wloc,ns1,ns2,ns3,fns1,fns2,fns3)

  U = Uloc
  V = Vloc
  W = Wloc

end subroutine u_compute

subroutine uz_compute

  use solver
  use data
  use parallel

  implicit none

  real(WP) :: Uloc(ns1,ns2,ns3)
  real(WP) :: Vloc(ns1,ns2,ns3)
  real(WP) :: Wloc(ns1,ns2,ns3)
  real(WP) :: SCloc(ns1sc,ns2sc,ns3sc)
  
  call btran_wrap(Uk,Uloc,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(Vk,Vloc,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(Wk,Wloc,ns1,ns2,ns3,fns1,fns2,fns3)
  call btran_wrap(Zk,SCloc,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc)

  U = Uloc
  V = Vloc
  W = Wloc
  SC = SCloc

end subroutine uz_compute


subroutine get_spectrum(Bdummy,nx1,nx2,nx3,fnx1,fnx2,fnx3,L,Sg,Sg1)

  use transform
  use precision
  use parallel

  implicit none
!  include 'fftw3.f'

  integer :: nx1,nx2,nx3
  integer :: fnx1,fnx2,fnx3
  integer :: fn1zs,fn1ze,fn1ys,fn1ye,fn1xs,fn1xe
  real(WP), dimension(2,nx1+1) :: S, Sg, Sg1
  real(WP), dimension(nx1,nx2,nx3) :: Bdummy
  real(WP) :: ke,kd,ks,dk,ksk0ratio,kc,kcksratio,kk,kx,ky,kz,kk2


  real(WP), dimension(:,:,:), pointer :: Rbuf

  real(WP), dimension(:,:,:), pointer :: in
  complex(WP), dimension(:,:,:), pointer :: out
  
  integer :: ierr
  integer :: i,j,k,ik,iunit,gg(3)
  integer :: il,jl,kl,nkk
  complex(WP) :: ii=(0.0_WP,1.0_WP)
  real(WP) :: rand,pi,eps,L,gmax

  integer(KIND=8) :: plan_3d

  real(WP), dimension(nx1+1) :: nnodes
  real(WP) :: node_density




  allocate(Rbuf(fnx1,fnx2,fnx3))
  allocate(A(nx1,nx2,nx3))
  allocate(B(fnx1,fnx2,fnx3))
  allocate(C(fnx1,fnx2,fnx3))
  allocate(D(fnx1,fnx3,fnx2))
  
  
  do k = 1,nx3
     do j = 1,nx2
        do i = 1,nx1
           A(i,j,k) = Bdummy(i,j,k)
        enddo
     enddo
  enddo

  call forward_transform(nx1,nx2,nx3,fnx1,fnx2,fnx3)

 do k = 1,fnx3
     do j = 1,fnx2
        do i = 1,fnx1
           B(i,j,k) = B(i,j,k)/real(nx1**3.0,WP)
           Rbuf(i,j,k) = sqrt(real(B(i,j,k)*conjg(B(i,j,k)),WP))
        enddo
     enddo
  enddo




  Sg = 0.0_WP
  Sg1 = 0.0_WP
  nnodes = 0.0_WP

  ! Create pi
  pi = acos(-1.0_WP)
  
  ! =================
  ! Velocity Spectrum
  
  ! Spectrum computation

  dk = 2.0_WP*pi/L
  kc = pi*nx1/L
  eps=kc/1000000.0_WP

  nkk = nx1/2+1
  fn1zs = 1
  fn1ze = fnx3
  fn1ys = 1 + (rank)*fnx2
  fn1ye = (rank+1)*fnx2
  fn1xs = 1
  fn1xe = nkk

  do k = fn1zs,fn1ze
     do j = fn1ys,fn1ye
        do i = fn1xs,fn1xe
           il = i-fn1xs+1
           jl = j-fn1ys+1
           kl = k-fn1zs+1
           ! Wavenumbers
           kx=real(i-1,WP)*dk
!           if (i.gt.(nkk)) kx=-real(nx1-i+1,WP)*dk
           ky=real(j-1,WP)*dk
           if (j.gt.nkk) ky=-real(nx1-j+1,WP)*dk
           kz=real(k-1,WP)*dk
           if (k.gt.nkk) kz=-real(nx1-k+1,WP)*dk
           kk=sqrt(kx**2+ky**2+kz**2)
           ! Spectrum
           ik=1+idint(kk/dk+0.5_WP)
!!$           nnodes(ik) = nnodes(ik) + 1.0_WP
           if ((kk.gt.eps).and.(kk.le.kc)) then
!!$              if (i.gt.1) then
                 Sg(2,ik)=Sg(2,ik)+(Rbuf(il,jl,kl)**2)
                 Sg1(2,ik) = Sg1(2,ik) + kk**2.0_WP*(Rbuf(il,jl,kl)**2)
!!$              else
!!$                 S(2,ik)=S(2,ik)+0.5_WP*(Rbuf(il,jl,kl)**2)/dk
!!$              endif
           end if
        end do
     end do
  end do


  do ik=1,nx1+1
     Sg(1,ik)=real(dk*(ik-1),WP)
     Sg1(1,ik)=real(dk*(ik-1),WP)
  end do
  

 
  deallocate(Rbuf)


  deallocate(A)
  deallocate(B)
  deallocate(C)
  deallocate(D)

  
end subroutine get_spectrum

subroutine get_dns_numbers(iinfo)

  use parallel
  use data
  implicit none

  real(WP) :: pi
  real(WP) :: ke,mu_cin,dx
  real(WP) :: kcin,epsi,l11,lt,re_turb,tau_epsi,l_k,tau_k

  real(WP) :: keta, L_large,dk,eta,dissipation,tke,Rlambda
  real(WP), dimension(:,:), pointer :: S1,S2,S3,Sg
  real(WP), dimension(:,:), pointer :: S11,S21,S31,Sg1

  

  integer :: i, iunit, ierr, iinfo


  


  allocate(S1(2,nx+1),S2(2,nx+1),S3(2,nx+1),Sg(2,nx+1))
   allocate(S11(2,nx+1),S21(2,nx+1),S31(2,nx+1),Sg1(2,nx+1))
  
  Sg = 0.0_WP

  S1 = 0.0_WP
  S2 = 0.0_WP
  S3 = 0.0_WP


  call get_spectrum(V,ns1,ns2,ns3,fns1,fns2,fns3,L,S1,S11)
  call get_spectrum(U,ns1,ns2,ns3,fns1,fns2,fns3,L,S2,S21)
  call get_spectrum(W,ns1,ns2,ns3,fns1,fns2,fns3,L,S3,S31)
   
  Sg(1,:) = S1(1,:)
  Sg(1,:) = S11(1,:)
  
  S1 = S1 + S2 + S3
  S11 = S11 + S21 + S31

  call MPI_ALLREDUCE(S1(2,:),Sg(2,:),nx+1,MPI_REAL_WP,MPI_SUM,&
       &MPI_COMM_WORLD,ierr)

  call MPI_ALLREDUCE(S11(2,:),Sg1(2,:),nx+1,MPI_REAL_WP,MPI_SUM,&
       &MPI_COMM_WORLD,ierr)

  if (rank.eq.0) then
     iunit = iopen()
     open(iunit,file=trim(adjustl(spfilename)),form='formatted')
    
     do i = 1,nx+1
        if ((Sg(1,i).ne.0.0_WP).and.(Sg(2,i).ne.0.0_WP)) then
           write(11,*) Sg(1,i), Sg(2,i)
        endif
     enddo
     close(iclose(iunit))
  endif

  call parser_read('Kmax eta', keta)



  pi = acos(-1.0_WP)
  dx = L/real(nx,WP) 
  tke = 0.0_WP
  dissipation = 0.0_WP

  do i = 1,nx+1
     tke = tke + Sg(2,i)
     dissipation = dissipation + 2*mu*Sg1(2,i)
  enddo

  Ut = sqrt(tke/1.5_WP)
  eta = (2.0_WP*keta)/real(nx,WP)
  re_turb  = tke**2.0/(dissipation*mu) 
  Rlambda = sqrt(20.0_WP/3.0_WP*re_turb)

  lt = eta*(3.0_WP/20.0_WP*Rlambda*Rlambda)**(3.0/4.0)
  L11 = lt*0.43
 

  ke = 1.3_WP/L11
  dk = 2.0_WP*pi/L

  tau_epsi = tke/dissipation
  tau_k = sqrt(mu/dissipation)
  


  if (rank.eq.0.and.iinfo.eq.1) then

     write(*,*)  
     write(*,*) ' ======================================== '
     write(*,*)' Debugging turbulent values               '
     write(*,*)' ---------------------------------------- '
     if (trim(spectrum).eq.'PP') then
        write(*,*)' -Spectrum type ----------> Passot-Pouquet'
     else if (trim(spectrum).eq.'VKP') then
        write(*,*)' -Spectrum type ----------> Von Karman-Pao'
     end if
     write(*,*)' Viscosity '
     write(*,*)' mu ------->', mu
     write(*,*)' -Turbulent Reynolds '
     write(*,*)'   Re_t --------> ', re_turb
     write(*,*)' -Turbulent kinetic energy '
     write(*,*)'   k -----------> ', tke
     write(*,*)' -Turbulent dissipation rate '
     write(*,*)'   epsilon -----> ', dissipation
     write(*,*)' -Size of the biggest eddy '
     write(*,*)'   l_t ---------> ', lt
     write(*,*)'   C1 ----------> ', L/lt
     write(*,*)' -Eddy turn over time '
     write(*,*)'   tau ---------> ', tau_epsi
     write(*,*)' -Kolmogorov scale '
     write(*,*)'   l_k ---------> ', eta
     write(*,*)'   C2 ----------> ', eta/dx
     write(*,*)' -Kolmogorov time scale '
     write(*,*)'   tau_k -------> ', tau_k
     write(*,*)' -Reynolds lambda '
     write(*,*)'   Re_lambda ---> ', Rlambda
     if (trim(spectrum).eq.'PP') then
        write(*,*)' -Integral length scale '
        write(*,*)'   Lii --------> ', l11
        write(*,*)' -Turbulent Reynolds based on Lii '
        write(*,*)'   Re_Lii -----> ', Ut*l11/mu
     end if
     write(*,*)' ======================================== '

  endif

  deallocate(S1,S2,S3,Sg)
  deallocate(S11,S21,S31,Sg1)
  allocate(S3(2,nxsc+1),Sg(2,nxsc+1))
  allocate(S31(2,nxsc+1),Sg1(2,nxsc+1))
  S3 = 0.0
  S31 = 0.0
  call get_spectrum(SC,ns1sc,ns2sc,ns3sc,fns1sc,fns2sc,fns3sc,L,S3,S31)
  Sg(1,:) = S3(1,:)
  Sg(1,:) = S31(1,:)
  call MPI_ALLREDUCE(S3(2,:),Sg(2,:),nxsc+1,MPI_REAL_WP,MPI_SUM,&
       &MPI_COMM_WORLD,ierr)

  call MPI_ALLREDUCE(S31(2,:),Sg1(2,:),nxsc+1,MPI_REAL_WP,MPI_SUM,&
       &MPI_COMM_WORLD,ierr)


  if (rank.eq.0) then
     iunit = iopen()
     open(iunit,file=trim(adjustl(spfilename2)),form='formatted')

     do i = 1,nxsc+1
        if ((Sg(1,i).ne.0.0_WP).and.(Sg(2,i).ne.0.0_WP)) then
           write(11,*) Sg(1,i), Sg(2,i)
        endif
     enddo
     close(iclose(iunit))
  endif
  deallocate(S3,Sg)
  deallocate(S31,Sg1)


end subroutine get_dns_numbers


subroutine tg_stats

  use solver
  use parallel
  use data

  implicit none

  real(WP) :: umax,vmax,wmax,nmax
  real(WP),dimension(2,nx+1) :: S1,S
  real(WP) :: esum, k2sum,lambda_t,Re_lambda,uturb

  integer :: k,ierr
  real(WP) :: kk



  S = 0.0_WP
  S1 = 0.0_WP

  call u_compute
  call get_spectrum(U,ns1,ns2,ns3,L,S1)
  S = S1
  call get_spectrum(V,ns1,ns2,ns3,L,S1)
  S = S + S1
  call get_spectrum(W,ns1,ns2,ns3,L,S1)
  S = S + S1
  
  S(1,:) = S1(1,:)
  S1 = S

  call MPI_ALLREDUCE(S1(2,:),S(2,:),nx+1,MPI_REAL_WP,MPI_SUM,&
       &MPI_COMM_WORLD,ierr)

  esum = 0.0_WP
  k2sum = 0.0_WP
  do k = 1,nx+1
     kk = S1(1,k)
     esum = esum + S(2,k)
     k2sum = k2sum + S(2,k)*S1(1,k)**2.0
  enddo
  lambda_t = sqrt(5*esum/k2sum)
  uturb = sqrt(2.0_WP/3.0_Wp*esum)
  if (mu.gt.0.0_WP) then
     Re_lambda = lambda_t*uturb/mu
  else
     Re_lambda = 0.0_WP
  endif
  

  call parallel_max(maxval(abs(U)),umax)
  call parallel_max(maxval(abs(V)),vmax)
  call parallel_max(maxval(abs(W)),wmax)

  if (rank.eq.0) then
     write(*,'(A7,4(E12.5,3X),2E15.8)') 'STEP ', sim_time, umax, vmax,wmax,k2sum,esum
  endif

  
  
end subroutine tg_stats


real(WP) function spec(ka,kb,ke)

  use precision
  
  implicit none
  real(WP) :: e,dk,ka,kb,ke,integ,k
  integer :: i,n

  n = 1000
  
  dk = (kb-ka)/real(n,WP)

  integ = 0.0_WP
  k = ka
  do i =1,n
     k = k + dk
     integ = integ + (k/ke)**4.0_WP*exp(-2.0_WP*(k/ke)**2.0_WP)*dk
  enddo
  spec = integ/(kb-ka)

end function spec

  
  
