import parmepy as pp
import numpy as np
import mpi4py.MPI as MPI
import math
import parmepy.f2py 

pi = math.pi
ppfft = parmepy.f2py.fftw2py

# Start MPI and get informations
rank = MPI.COMM_WORLD.Get_rank()
print "Mpi process number ", rank

# Physical Domain description (geometry and boundary conditions)
myDomain = pp.Box(dimension=3,length=[1.,1.,1.],origin=[0.,-0.5,-0.5])

# Continuous fields declaration
scalar = pp.ContinuousField(domain=myDomain,name="scalar3D")
velocity = pp.ContinuousField(domain=myDomain,name="velocity3D")
vorticity = pp.ContinuousField(domain=myDomain,name="vorticity3D")

# Build operators/problems
poisson = pp.Poisson(vorticity,velocity)

# Set and initialize a solving method for this problem
poisson.setSolvingMethod("fftw-cpu")
# Set one (or more) global resolution.
globalResolution =  [65,65,65]
poisson.initialize_solver(globalResolution) # ---> call localRes,localOffset = ppfft.init_poisson_solver(globalResolution,myDomain.length)
# this will create a topology, a local discretisation for vel and vort and will allocate memory for those fields 

# initialize data
vorticity.discretize(topoFFT)

# Solve ...

poisson.solve() ## call velx,vely,velz = ppfft.solve_poisson_3d(omx,omy,omz)





# Build some mpi topologies on the current domain

#topo3D = pp.CartesianTopology(domain=myDomain,resolution=globalResolution,dim=3)

#resol2D = [1, 12, 12]
#topo2D = pp.CartesianTopology(domain=myDomain,resolution=resol2D,dims=[1,2])
# Discretize a field on these topologies
#scalar.discretize(topo3D)
#scalD,idScalD = scalar.discretize(topo2D)

#print scalar

#print scalD

#velocity.discretize(topo3D)

## scalarD.tofile("toto")

## print velo
