__kernel void initScalar(__global float* scalar,
			 float4 minPos,
			 float4 size)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float r;
  float2 pos;
  for(i=gidX; i<WIDTH; i+=WGN)
    {
      pos = (float2)(i*size.x + minPos.x, gidY*size.y + minPos.x);
      r = length(pos);
      scalar[i+gidY*(WIDTH)] = ((r<1.0f) ? pown(1.0f - r*r,6) : 0.0f);
    }
}


__kernel void initVelocity(__global float* veloX,__global float* veloY,
		       float4 minPos,
		       float4 size)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float v,r;
  float2 pos;
  for(i=gidX; i<WIDTH; i+=WGN)
    {
      pos = (float2)(i*size.x + minPos.x, gidY*size.y + minPos.x);
      r = length(pos);
      v = pos.y*cos(3.0f*M_PI_2_F*r);
      veloX[i+gidY*(WIDTH)] = -v; // = Vx(x,y)
      veloY[i+gidY*(WIDTH)] = v;// = Vy(y,x) = -Vx(x,y)
    }
}
