#define PI (float) acos(-1.0)

__kernel void analyticVelocity(__global float* veloX,__global float* veloY,
			       float4 minPos,
			       float4 size,
			       float t)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float pix, piy, time_term = cos(t*PI/3.0);
  piy = (minPos.y + gidY*size.y) * PI;
  for(i=gidX; i<NB_X; i+=WI_NB)
    {
      pix = (minPos.x + i*size.x) * PI;
      veloX[i+gidY*(NB_X)] =  -sin(pix) * sin(pix) * sin(piy * 2) * time_term;
      veloY[i*NB_Y+gidY] = sin(piy) *sin(piy) * sin(pix * 2) * time_term;
    }
}
