__kernel void initScalar(__global float* scalar,
			 float4 minPos,
			 float4 size,
			 float t)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float2 pos, center=(float2)(0.5, 0.75);
  for(i=gidX; i<NB_X; i+=WI_NB)
    {
      pos = minPos.xy + (float2)(i*size.x, gidY*size.y);
      scalar[i+gidY*NB_X] = ((distance(pos, center)<0.15) ? 1.0 : 0.0);
    }
}

#define PI (float) acos(-1.0)
__kernel void initVelocity(__global float* veloX,__global float* veloY,
			       float4 minPos,
			       float4 size,
			       float t)
{
  uint gidX = get_global_id(0);
  uint gidY = get_global_id(1);
  uint i;
  float pix, piy;
  /** Time dependant field */
  float time_term = cos(t*PI/3.0);
  /** Constant field
      float time_term = cos(t*PI/3.0); */

  piy = (minPos.y + gidY*size.y) * PI;
  for(i=gidX; i<V_NB_X; i+=V_WI_NB)
    {
      pix = (minPos.x + i*size.x) * PI;
      veloX[i+gidY*(V_NB_X)] = -sin(pix) * sin(pix) * sin(piy * 2) * time_term;
      veloY[i*V_NB_Y+gidY] = sin(piy) *sin(piy) * sin(pix * 2) * time_term;
    }
}

