import scitools.filetable as ft
import matplotlib.pyplot as plt


def plotEnergyEnstrophy(filename):
    ff = open(filename)
    data = ft.read(ff)
    time = data[:, 0]
    energy = data[:, 1]
    enstrophy = data[:, 2]
    plt.subplot(211)
    plt.plot(time, energy, '+-', label='energy')
    plt.xlabel('time')
    plt.subplot(212)
    plt.plot(time, enstrophy, '+-', label='enstrophy')
    plt.xlabel('time')
    plt.legend()
    plt.suptitle('Results from simu in:' + filename)
    plt.show()


def plotDragAndLift(filename):
    ff = open(filename)
    data = ft.read(ff)
    time = data[:, 0]
    drag = data[:, 1]
    lift = data[:, 2:]
    plt.subplot(211)
    plt.plot(time, drag, '+-', label='drag')
    plt.xlabel('time')
    plt.subplot(212)
    for i in xrange(lift.shape[1]):
        plt.plot(time, lift[:, i], '+-', label='lift' + str(i))
    plt.xlabel('time')
    plt.legend()
    plt.suptitle('Results from simu in:' + filename)
    plt.show()


def plotReprojection(filename):
    ff = open(filename)
    data = ft.read(ff)
    time = data[:, 0]
    crit = data[:, 1]
    counter = data[:, 2]
    d1 = data[:, 3]
    d2 = data[:, 4]
    plt.subplot(221)
    plt.plot(time, crit, '+-', label='criterion')
    plt.xlabel('time')
    plt.subplot(222)
    plt.plot(time, d1, '+-', label='d1')
    plt.xlabel('time')
    plt.subplot(223)
    plt.plot(time, d2, '+-', label='d2')
    plt.xlabel('time')
    plt.legend()
    plt.suptitle('Results from simu in:' + filename)
    plt.show()

plt.ioff()
direc = 'NSDebug'
nprocs = 8
fileroot = direc + '/p' + str(nprocs) + '/'
plotEnergyEnstrophy(fileroot + 'energy_enstrophy')
plotDragAndLift(fileroot + 'drag_and_lift')

