## This is an example of usage for a bridge between two operators.
## Todo : move this to non-regr. tests.
import parmepy as pp
import math
from parmepy.fields.continuous import Field
from parmepy.operator.analytic import Analytic
from parmepy.operator.stretching import Stretching
from parmepy.operator.poisson import Poisson
from parmepy.operator.redistribute import Redistribute
from parmepy.mpi import main_rank, main_comm
pi = math.pi


def vitesse(x, y, z, t, dt, ite):
    vx = x
    vy = y
    vz = z
    return vx, vy, vz


# Physical Domain description
Lx = Ly = Lz = 2 * pi
dom = pp.Box(dimension=3, length=[Lx, Ly, Lz])
resol1 = [9, 9, 9]
resol2 = [5, 5, 5]

## Fields
scal = Field(domain=dom, name='Scalar')
velo = Field(domain=dom, name='Velocity', isVector=True)
vort = Field(domain=dom, name='Vorticity', isVector=True)

## First operator
velocity = Analytic(velo, formula=vitesse,
                    resolutions={velo: resol1})

## Second operator
op2 = Analytic(velo, formula=vitesse,
               resolutions={velo: resol2})


op3 = Stretching(velo, vort, resolutions={velo: resol2, vort: resol2})
op4 = Poisson(velo, vort, resolutions={velo: resol2, vort: resol2})
op4.setUp()

distr = Redistribute(velo, op2, op4)
distr2 = Redistribute(velo, op4,  op3)

#velocity.setUp()
op2.setUp()
op3.setUp()
distr2.setUp()
distr.setUp()

## print main_rank, "send ...",  distr2.bridges[velo].sendTo
## print main_rank, "recv ...", distr2.bridges[velo].recvFrom


#for v in velo.discreteFields.values():
#    if main_rank == 3:
#        print v.topology


## for topo in velo.discreteFields.keys():
##     print velo.discreteFields[topo].data

op2.apply(1, 1, 1)

#op2.apply(0, 0, 0)

for topo in velo.discreteFields.keys():
    a = velo.norm(topo)
    if main_rank == 0:
        print "pre :", a

## #print " compute ..."
distr.apply()

distr.wait()

distr2.apply()
distr2.wait()
for topo in velo.discreteFields.keys():
    a = velo.norm(topo)
    if main_rank == 0:
        print "post :", a


