## @package parmepy.f2py
# f2py interfaces to fortran files.
#
# Driver routines to generate python functions
# from fortran routines using f2py.
#
# Available interfaces :
# - fftw : driver for fftw-mpi (fortran) routines.
#   Poisson and Diffusion solvers.
# - scales : advection solver (only 3D).
#
# Usage :
# \code
# import parmepy.f2py
# ppfft = parmepy.f2py.fftw2py
# scales = parmepy.f2py.scales2py
# ...
# ppfft.init_fftw_solver(...)
# scales.init_advection_solver(...)
# # List of functionnalities and help :
# dir(scales)
# dir(ppfft)
# print ppfft.init_fftw_solver.__doc__
# \endcode
