## @package parmepy.operator
# Operators on continuous fields.
#
# An operator is an abstract object that handles a set of continuous variables
# and has an 'apply' function that modifies some of these variables.
#
# Example:
# To define and apply the advection of a scalar rho at velocity v:
#\code
# advec = parmepy.operator.advection(v, rho, ...)
# advec.setUp()
# ...
# advec.apply()
# \endcode
#
# \section aboutmeth About 'method' arg in operator init
#
# Method argument must be a dictionnary with some of the following keys/values:
#
# Methods have default values, taken from parmepy.default_methods
# preset dictionnaries.
#
# Keys in methods dict are given in parmepy.method_keys.
