"""
@file test_simulation.py
tests simulation incr and io_utils writer
"""
from parmepy.problem.simulation import Simulation
from parmepy.tools.io_utils import Writer

simu = Simulation(tinit=0.0, tend=1.0, nbIter=10)


def test_simu_incr():
    wr = Writer({'frequency': 2})
    assert wr.doWrite(simu.currentIteration)

    simu.initialize()

    assert not wr.doWrite(simu.currentIteration)

    count = 1
    while not simu.isOver:
        if count % 2 == 0:
            assert wr.doWrite(simu.currentIteration)
        else:
            assert not wr.doWrite(simu.currentIteration)
        simu.printState()
        simu.advance()
        count += 1
    assert simu.currentIteration == 10
    simu.finalize()
    assert wr.doWrite(simu.currentIteration)


def test_simu_incr2():
    wr = Writer({'frequency': 3})
    assert wr.doWrite(simu.currentIteration)
    simu.timeStep = 0.10000000001
    simu.initialize()

    assert not wr.doWrite(simu.currentIteration)

    count = 1
    while not simu.isOver:
        if count % 3 == 0:
            assert wr.doWrite(simu.currentIteration)
        else:
            assert not wr.doWrite(simu.currentIteration)
        simu.printState()
        simu.advance()
        count += 1
    assert simu.currentIteration == 10
    simu.finalize()
    assert wr.doWrite(simu.currentIteration)
