"""
@file transport.py
"""
from parmepy.problem.problem import Problem
from parmepy.operator.advection import Advection
from parmepy.operator.analytic import Analytic


class TransportProblem(Problem):
    """
    Transport problem description.
    """
    def __init__(self, operators, simulation, monitors=None,
                 dumpFreq=100, name=None):
        Problem.__init__(self, operators, simulation, monitors,
                         dumpFreq, name="Transport Problem")
        self.advection, self.velocity = None, None
        for op in self.operators:
            if isinstance(op, Advection):
                self.advection = op
            if isinstance(op, Analytic):
                self.velocity = op
        if self.advection is None:
            raise ValueError("Transport problem with no Advection operator")
