"""
Launch tests for parmepy
"""
import unittest
import doctest
import sys
import os
# Insert parmepy sources path to sys.path from sys.path[0] (i.e. absolute path to __file__)
# This file is desined to be launched after calling: setup.py build
# Then this file is located in ./build/lib._platform_dependent_directory/parmepy/test
# Tests are run on parmepy sources located in ./build/lib._platform_dependent_directory
if sys.path[0].find("build/lib.") >= 0:
    sys.path.insert(1, os.path.split(os.path.split(sys.path[0])[0])[0])
import parmepy

# Automatic recursive finding unittest.TestCase implemetations in package 'test'
suite = unittest.TestLoader().discover(sys.path[0], pattern='test*.py')

# Add doctests from python files
suite.addTest(doctest.DocFileSuite('domain/box.py', package=parmepy))

runner = unittest.TextTestRunner(verbosity=2).run(suite)

if sys.path[0].find("build/lib.") >= 0:
    if not runner.wasSuccessful():
        fails = "\nFAILURES in " + __file__ + " : (" + str(len(runner.failures)) + ")\n"
        for fail in runner.failures:
            fails += fail[1]
        log_failures = open('Testing/Temporary/PythonFailures.log', 'w')
        log_failures.write(fails)
        log_failures.close()
        raise Exception("FAILED")
