!> temp module to call and test ppm functions.
module testPPM

  !-------------------------------------------------------------------------
  !  Modules 
  !-------------------------------------------------------------------------
!!$  USE ppm_module_map
!!$  USE ppm_module_topo
!!$  USE ppm_module_loadbal
!!$  USE ppm_module_neighlist
!!$  USE ppm_module_ode
!!$  USE ppm_module_user_util
!!$  USE pse_global
!!$  USE pse_module_io
!!$  USE pse_module_comp

  use ppm_module_init
  use ppm_module_substart
  use ppm_module_substop
  use ppm_module_finalize
  use ppm_module_data
  use mpi

  implicit none

contains

  subroutine mult(A,x,sizeA)
    real, dimension(:) :: A
    real :: x
    integer :: sizeA,j
    
    real*8, dimension(sizeA) :: B
    
    x = 3
   print *, "otot"
   print *, A(1)
   print *, "titi"

    do j=1,sizeA
       B(j) =j
       !! do i=1,sizeA
   !!       print *, A(i,j)
!!$          A(i,j) = x*A(i,j)
       !!print *, A(j)
       !!print *,'toto', B(j)
       !!end do
    end do
  end subroutine mult

  subroutine init()

    real(8) :: t0
    integer :: info,size
    integer :: ndim, tolexp, comm, debug, ppm_log_unit
    integer, parameter :: MK = KIND(1.0D0)

    ndim = 3
    tolexp = -15
    comm = MPI_COMM_WORLD
    debug = 2
    ppm_log_unit  = 99

    call MPI_Init(info)
    if(info.ne.0) then 
       write(*,*) 'FAILED TO INITIALIZE MPI. ABORTING!'
    end if
    call MPI_COMM_SIZE(comm,size,info)

    ! PPM init.
    !! This will:
    !! - init the stdout, stderr, stdlog outputs
    !! - check if MPI has been properly initialized
    !! - fill comm, ppm_rank, ppm_nb_procs ... and MPI/ppm related values
    !! - check and set dimension of the problem, precision and tolerance
    !! - set MPI_PREC --> ppm_mpi_kind
    !! - init proc speed array (ppm_proc_speed)
    !! - reset topology counter
    call ppm_init(ndim,MK,tolexp,comm,debug,info,ppm_log_unit,98,97)

    print *, "debug ", debug, " module debug", ppm_debug

    !! Display ...
    call substart('testPPM',t0,info)

    !! Warning : display elapsed time since t0. 
    call substop ('testPPM', t0, info)

    !! Finalize
    !! - deallocate lots of arrays ...
    !! - call ppm_mesh_finalize --> deallocate mesh structures
    call ppm_finalize(info)

    call MPI_FINALIZE(info)

  end subroutine init
end module testPPM

