module WrapFort

  use  iso_c_binding

  implicit none

  public aliasF2C
  
  real(kind=8) :: ref
  integer, parameter :: real_kind = kind(ref)
  
  !> A structure to bind C and fortran pointers 
  type, bind(C), public :: C2FPtr
      integer (c_int) :: length
      type (c_ptr) :: elements
   end type C2FPtr

   logical, parameter :: NDEBUG = .TRUE.

contains

  subroutine aliasF2C(vectorC, vectorF, length)
    type(c_ptr),intent(inout) :: vectorC
    integer(c_int), intent(out) :: length
    real(kind=real_kind), pointer, dimension(:) :: vectorF

    if(.not.associated(vectorF) ) then
       stop 'Error, input Fortran vector is not associated'
    end if
    length = size(vectorF)
    vectorC = c_loc(vectorF(1))
    
  end subroutine aliasF2C
  
end module WrapFort
