!> Fortran 2003 interface to ppm routines related to topologies
module wrap_ppm_topologies

  use ppm_module_mktopo
  use WrapFort
  use ppm_module_data

  implicit none
  
contains
  
  !> Purely geometry-based decompositions
  subroutine create_topology_geom(dimPb, topoid, decomp, minPhys, maxPhys, bc, ghostsize) bind(C, name='createTopoG')
    
    integer(kind=c_int), intent(in) :: dimPb
    integer(kind=c_int), intent(inout) :: topoid
    integer(kind=c_int), intent(inout) :: decomp
    !integer(kind=c_int), intent(in) :: assig
    type(c_Ptr), intent(in), VALUE :: minPhys
    type(c_Ptr), intent(in), VALUE :: maxPhys
    type(c_Ptr), intent(in), VALUE :: bc
    real(kind=real_kind), intent(in) :: ghostsize ! ghostsize is a real in ppm subroutine ... strange ...
!    type(c_ptr), intent(inout) :: costPerProc

    
    ! Local vars
    integer :: info
    !    integer :: nbProcs = 3 ! TODO : input arg
    integer :: assig = ppm_param_assign_internal
    real(kind=real_kind), pointer, dimension(:) :: cost => NULL()
    real(kind=real_kind), pointer, dimension(:) ::min_phys => NULL(), max_phys => NULL()
    integer, pointer, dimension(:) :: bcdef => NULL()
    ! Wrap C pointers
    call c_f_pointer (minPhys, min_phys, (/dimPb/))
    call c_f_pointer(maxPhys, max_phys, (/dimPb/))
    call c_f_pointer(bc, bcdef, (/dimPb/))
    decomp = ppm_param_decomp_cuboid

    ! If cost is already allocated
 !   if(c_associated(costPerProc)) then
  !     call c_f_pointer(costPerProc, cost, (/nbProcs/))
   ! end if

    ! We skip optional vars for the moment ...
    call ppm_topo_mkgeom_d(topoid, decomp,assig, min_phys, max_phys, bcdef, ghostsize, cost, info)
    
    !call aliasF2C(costPerProc, cost, nbProcs)    

    print *, "topoid ", topoid

  end subroutine create_topology_geom


end module wrap_ppm_topologies
