!> Poisson Solver on the grid
!
! Notes Franck concerning multigrid solver :
! - the old (before jan 2012) version of this solver was bugged in ppm. I let the Parmes routines calling this solver 
! in the present file for future debugs, but they are not (really not ...) usable.

module Solver

  use client_data, only: mk, dime,rank
!!!!!!! Comment to remove ppm  use ppm_module_numerics_data, only: ppm_param_eq_poisson, ppm_param_smooth_rbsor
!!!!!!! Comment to remove ppm  use ppm_module_poisson, only: ppm_poisson_init, ppm_poisson_plan, ppm_poisson_grn_pois_per, ppm_poisson_solve, &
!!!!!!! Comment to remove ppm  ppm_poisson_drv_curl_fd2, ppm_poisson_drv_curl_fd4, ppm_poisson_drv_none
!!!!!!! Comment to remove ppm  use client_topology
!!!!!!! Comment to remove ppm  use ppm_module_typedef, only : ppm_param_mesh_coarsen
!!!!!!! Comment to remove ppm  use ppm_module_mesh_derive, only: ppm_mesh_derive
!  use ppmljk_poisson
  
  !! All multigrid stuff ...
  !!use ppm_module_mg_init
  !!use ppm_module_mg_solv

  implicit none

  private

  public :: init_poisson_solver, solve_poisson!!!, ppm_poisson_drv_curl_fd2, ppm_poisson_drv_curl_fd4, ppm_poisson_drv_none

  type(ppm_poisson_plan),pointer :: fftwplanForppm => NULL()

  ! Interface to poisson solver initialisation. Only fft at the time
  interface init_poisson_solver
     module procedure init_fftw
  end interface

  interface solve_poisson
     module procedure solve_poisson_fftw
  end interface

contains
  
  !> Do not work, bug in ppm numerics ...
!!$  subroutine init_multigrid(topoid, meshid, ghostsize, bc)
!!$    
!!$    integer, intent(in) :: topoid
!!$    integer, intent(in) :: meshid
!!$    integer, dimension(:), pointer :: ghostsize
!!$    integer, dimension(:), pointer :: bc
!!$
!!$    integer,  dimension(dime,2*dime):: ibcdef
!!$    real(mk), dimension(dime,1,1,1,1):: ibcvalue
!!$
!!$    logical :: with_w_cycles, dump_info
!!$    real(mk) :: omega
!!$    integer :: limlev ! Number of mg levels
!!$    integer :: info
!!$
!!$    info = -1
!!$    limlev = 2 ! Warning, limlev must cope with grid resolution ...
!!$    omega = 1.15_mk ! Relaxation param
!!$    with_w_cycles = .FALSE.
!!$    dump_info = .TRUE.
!!$    ibcvalue(:,:,:,:,:)=0.0_mk
!!$    ibcdef(1,:)=bc(:)
!!$    ibcdef(2,:)=bc(:)
!!$    ibcdef(3,:)=bc(:)
!!$    ! Initialize the solver
!!$    !! ppm_param_eq_poisson : equation type. Poisson is the only possible type ...
!!$    !! ppm_param_smooth_rbsor : Gauss Seidel, only possible type
!!$    ! Anyway, at the time the two parameters above are not used in ppm routine. 
!!$    !! maxlev : number of levels in multigrid
!!$    !! 
!!$    
!!$    call ppm_mg_init(topoid, ppm_param_eq_poisson,ghostsize, ppm_param_smooth_rbsor,dime,ibcdef,&
!!$         ibcvalue,meshid,limlev,with_w_cycles,dump_info,omega,info)
!!$   
!!$    if(info.ne.0) stop 'Init_multigrid failed ...'
!!$    
!!$  end subroutine init_multigrid
!!$
!!$  !> Do not work
!!$  subroutine solve_poisson_multigrid(topoid, field, rhs)
!!$    integer, intent(in) :: topoid
!!$    real(mk), dimension(:,:,:,:,:), pointer :: field
!!$    real(mk), dimension(:,:,:,:,:), pointer :: rhs
!!$
!!$    integer :: itera, iterf, iter1, iter2, info
!!$    real(mk) :: Eu
!!$    
!!$    itera = 3
!!$    iterf = 3
!!$    iter1 = 10
!!$    iter2 = 4
!!$    print *, 'solve ...', topoid
!!$
!!$    ! Bug inside ...
!!$    call ppm_mg_solv(topoid, field, rhs, dime, itera, iterf, iter1, iter2, Eu, info)
!!$
!!$  end subroutine solve_poisson_multigrid

  !> Init fftw through ppm routines
  subroutine init_fftw(fieldin,fieldout,topoid,meshid,deriveValue)
    
    real(mk), dimension(:,:,:,:,:), pointer :: fieldin, fieldout
    integer, intent(in) :: topoid, meshid
    integer, intent(in), optional :: deriveValue
    
    ! Parameters for ppm poisson routine
    integer :: info
    
    ! Flag to select built-in Green functions (...)
    integer :: green
    integer :: der
    
    if (present(deriveValue)) then
       der = deriveValue
    else
       der = ppm_poisson_drv_curl_fd4
    end if
    
    green = ppm_poisson_grn_pois_per ! periodic boundaries
    info = -1
    allocate(fftwplanForppm)
    ! Call ppm routine to initialize fftw plan. 
    call ppm_poisson_init(topoid,meshid,fftwplanForppm,fieldin,fieldout,green,info,derive=ppm_poisson_drv_curl_fd4)
    !call mypoisson_init(topoid,meshid,fftwplanForppm,fieldin,fieldout,info)
    
    if(info.NE.0) stop 'PPM Poisson solver init failed.'
  end subroutine init_fftw

  !> Interface to ppm poisson solver with fftw
  subroutine solve_poisson_fftw(fieldin,fieldout,topoid,meshid,ghostsize)
    
    real(mk), dimension(:,:,:,:,:), pointer ::  fieldin, fieldout
    integer, intent(in) :: meshid, topoid
    integer, dimension(:),pointer::ghostsize

    integer :: info
    ! Finite diff scheme used to compute curl
    !integer :: dtype

    info = -1
    
    ! Solves laplacian(fieldout) = - fieldin
    call ppm_poisson_solve(topoid,meshid,fftwplanForppm,fieldin,fieldout,ghostsize,info)
    !call mypoisson_solve(topoid,meshid,fftwplanForppm,fieldin,fieldout,ghostsize,info)
    if(info.NE.0) stop 'PPM Poisson solver failed.'
    
    ! info = -1
    ! Computes fieldout = curl(fieldout) using finite differences, 2nd order (dtype = ppm_poisson_drv_curl_fd2), 
    ! or 4th order (dtype = ppm_poisson_drv_curl_fd4). Last one is untested according to ppm doc ...
    ! According to Johannes, not needed if I set derive in poisson_init
    !call ppm_poisson_fd(topoid,meshid,fieldout,fieldout,dtype,info)
    !if(info.NE.0) stop 'PPM Poisson, curl computation failed.'

  end subroutine solve_poisson_fftw

  subroutine finalize_poisson_fftw()
    ! TODO ...
    ! In ppm nothing is done to free fftw plan or other temp. buffers. 
  end subroutine finalize_poisson_fftw
  
end module Solver


