!> \file callCharFunc.f90 Wrapper to fortran functions that have a char-type input argument.

!> \brief Module to wrap fortran functions with char arg.
module charFunctions

  use ppm_module_substart
  use ppm_module_substop
  
  implicit none

contains

  !> Wrapper to ppm substart function
  !! @param[in,out]  cpu time when this function is called
  !! @param[in] error status
  !! @param[in] Name of the calling-function
  subroutine start(t0,info,msg)

    real(8) :: t0
    character(len=*) :: msg
    integer :: info
    call substart(msg,t0,info)
  end subroutine start
  
  !> Wrapper to ppm substop function : print caller name and cpu time elasped since start call (for the same caller)
  !! @param[in]  cpu time, value returned during substart call
  !! @param[in] error status
  !! @param[in] Name of the calling-function
  subroutine stop(t0,info,msg)

    real(8) :: t0
    character(len=*) :: msg
    integer :: info

    call substop(msg,t0,info)
  end subroutine stop

end module charFunctions

