/** \file testNullPtr.cxx 
    Test F2003 C interoperability 

    Send a null pointer to Fortran : must send back a properly allocated vector
    
 */
#include<iostream>
#include <string>
#include "WrapC.hpp"

using namespace std ;

extern "C" {

  void wrapC2F_NULLPtr(C2FPtr*);
  void wrapC2F_NULLPtrBis(double**, int*);
 
}

int main(int argc, char* argv[])
{
  double * toto = 0;
  int ntoto;
  std::cout << "Fortran 2003 wrapper ..." << std::endl;
  
  // 
  C2FPtr * myVector = new C2FPtr;
  
  wrapC2F_NULLPtr(myVector);
  
  for(int i =0; i<myVector->length; ++i)
    cout << myVector->elements[i] << endl;
  
  wrapC2F_NULLPtrBis(&toto, &ntoto);
  
  cout << ntoto << endl;
  for(int i = 0; i<ntoto ;++i)
    cout << toto[i] << endl;
  
  delete(myVector);
  
}

