
__kernel void copy(__global const float* in,
		   __global float* out)
{
  uint xIndex = (get_group_id(0) * TILE_DIM_COPY + get_local_id(0)*2);
  uint yIndex = get_group_id(1) * TILE_DIM_COPY + get_local_id(1);
  uint index = xIndex + yIndex * WIDTH;
  float x,y;

  for(uint i=0; i<TILE_DIM_COPY; i+=BLOCK_ROWS_COPY)
    {
      x = in[index + i*WIDTH];
      y = in[index + 1 + i*WIDTH];
      out[index + i*WIDTH] = x;
      out[index + 1 + i*WIDTH] = y;
    }
}
