
__kernel void copy(__global const float* in,
		   __global float* out)
{
  uint xIndex = (get_group_id(0) * TILE_DIM_COPY + get_local_id(0)*4);
  uint yIndex = get_group_id(1) * TILE_DIM_COPY + get_local_id(1);
  uint zIndex = get_global_id(2);
  uint index = xIndex + yIndex * WIDTH + zIndex*WIDTH*WIDTH;
  float x,y,z,w;

  for(uint i=0; i<TILE_DIM_COPY; i+=BLOCK_ROWS_COPY)
    {
      x = in[index + i*WIDTH];
      y = in[index + 1 + i*WIDTH];
      z = in[index + 2 + i*WIDTH];
      w = in[index + 3 + i*WIDTH];
      out[index + i*WIDTH] = x;
      out[index + 1 + i*WIDTH] = y;
      out[index + 2 + i*WIDTH] = z;
      out[index + 3 + i*WIDTH] = w;
    }
}
