/**
 * M6prime weights.
 *
 * @param y Distance between the particle and left-hand grid point
 * @param s Scalar of the particle
 *
 * @return weights
 */
inline float alpha(float y, float s){
  return (y * (y * (y * (y * (13.0 - 5.0 * y) - 9.0) - 1.0) + 2.0) / 24.0) * s;}
inline float beta(float y, float s){
  return (y * (y * (y * (y * (25.0 * y - 64.0) + 39.0) + 16.0) - 16.0) / 24.0)*s;}
inline float gamma(float y, float s){
  return (y * y * (y * (y * (126.0 - 50.0 * y) - 70.0) - 30.0) / 24.0 + 1.0)*s;}
inline float delta(float y, float s){
  return (y * (y * (y * (y * (50.0 * y - 124.0) + 66.0) + 16.0) + 16.0) / 24.0)*s;}
inline float eta(float y, float s){
  return (y * (y * (y * (y * (61.0 - 25.0 * y) - 33.0) - 1.0) - 2.0) / 24.0)*s;}
inline float zeta(float y, float s){
  return (y * y * y * (y * (5.0 * y - 12.0) + 7.0) / 24.0)*s;}
