/**
 * M8prime weights.
 *
 * @param y Distance between the particle and left-hand grid point
 * @param s Scalar of the particle
 *
 * @return weights
 */
inline float alpha(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(-10.0*y + 21.0) + 28.0) - 105.0) + 70.0) + 35.0) - 56.0) + 17.0) / 3360.0) * s;}

inline float beta(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(70.0*y - 175.0) - 140.0) + 770.0) - 560.0) - 350.0) + 504.0) - 102.0) / 3360.0)*s;}

inline float gamma(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(-210.0*y + 609.0) + 224.0) - 2135.0) + 910.0) + 2765.0) - 2520.0) + 255.0) / 3360.0)*s;}

inline float delta(float y, float s){
  return ((y*y*(y*y*(y*y*(70.0*y - 231.0) + 588.0) - 980.0) + 604.0) / 672.0)*s;}

inline float eta(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(-70.0*y + 259.0) - 84.0) - 427.0) - 182.0) + 553.0) + 504.0) + 51.0) / 672.0)*s;}

inline float zeta(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(210.0*y - 861.0) + 532.0) + 770.0) + 560.0) - 350.0) - 504.0) - 102.0) / 3360.0)*s;}

inline float theta(float y, float s){
  return ((y*(y*(y*(y*(y*(y*(-70.0*y + 315.0) - 280.0) - 105.0) - 70.0) + 35.0) + 56.0) + 17.0) / 3360.0)*s;}

inline float iota(float y, float s){
  return ((y*y*y*y*y*(y*(10.*y - 49.) + 56.))/3360.)*s;}
