# -*- coding: utf-8 -*-
"""
@package Utils
InterpolationMethod interface.
"""


class InterpolationMethod:
    """
    Interpolation method interface.
    """
    def __init__(self):
        """
        Constructor.
        """
        ## Grid
        self.grid = None
        ## Values to interpolate
        self.gvalues = None

    def interpolate(self, ppos, grid, gvelo):
        """
        Abstract method, apply operaton on a variable.
        Must be implemented by sub-class.

        @param ppos : particle position.
        @param grid : grid points.
        @param gvelo : grid velocity field.
        @return particle velocity, velocity at position ppos.
        """
        raise NotImplementedError("Need to override method in a subclass of " + providedClass)

if __name__ == "__main__":
    print __doc__
    print "- Provided class : " + providedClass
    print eval(providedClass).__doc__
