# -*- coding: utf-8 -*-
"""
@package Utils
RemeshingMethod interface.
"""


class RemeshingMethod:
    """
    Remeshing method interface.
    """
    def __init__(self, grid, gvalues):
        """
        Constructor.
        """
        ## Grid
        self.grid = grid
        ## Values to remesh
        self.gvalues = gvalues

    def remesh(self, ppos, pscal, grid, gscal):
        """
        Abstract method, apply operaton on a variable.
        Must be implemented by sub-class.

        @param ppos : particle position.
        @param pscal : particle scalar.
        @param grid : grid points.
        @param gscal : grid scalar field.
        """
        raise NotImplementedError("Need to override method in a subclass of " + providedClass)

if __name__ == "__main__":
    print __doc__
    print "- Provided class : RemeshingMethod"
    print RemeshingMethod.__doc__
