"""
@package parmepy.particular_solvers.solver

Solver class interface.
"""
from abc import ABCMeta, abstractmethod


class Solver:
    """
    Solver interface.
    """

    __metaclass__ = ABCMeta

    @abstractmethod
    def __init__(self, problem):
        """
        Abstract constructor.
        @param : the problem associated with this solver.
        """
        ## Problem to solve
        self.problem = problem

    @abstractmethod
    def initialize(self):
        """
        Solver initialisation for a given DiscreteProblem.DiscreteProblem.
        Abstract method, apply operaton on a variable.
        Must be implemented by sub-class.
        """

if __name__ == "__main__":
    print __doc__
    print "- Provided class : Solver (abstract)"
    print Solver.__doc__
