MODULE MeshModule
  
  implicit none


  PUBLIC  initMesh, initMesh2, getGrid, deleteMesh, aliasGrid, getPtr, alias
  PRIVATE

  INTEGER :: nx, ny, nz
  REAL*8, pointer :: grid(:,:,:)
  real(kind =8), pointer :: fptr(:)

CONTAINS

  SUBROUTINE initMesh(L,M,N,g)
    INTEGER :: L,M,N
    REAL*8 :: g(4)
    CALL cinitmesh(L,M,N,g)
  end SUBROUTINE initMesh

  SUBROUTINE initMesh2(L,M,N,g)
    INTEGER :: L,M,N
    REAL*8 :: g(4)
    CALL cinitmesh(g)
  end SUBROUTINE initMesh2
  
  SUBROUTINE aliasGrid(n1,n2,n3,a)
    INTEGER :: n1,n2,n3
    REAL*8, TARGET :: a(n1,n2,n3)
    nx = n1
    ny = n2
    ny = n3
    print *, 'alias ... ', a(2,1,1)
    grid => a(1:nx,1:ny,1:nz)
    print *, grid(2,1,1)
    print *, 'end alias '
  end SUBROUTINE aliasGrid

  SUBROUTINE alias(n1,a)
    INTEGER :: n1
    REAL(kind=8), TARGET :: a(n1)
    nx = n1
    print *, 'alias ... '
    fptr => a(1:nx)
    print *, 'end alias '
  end SUBROUTINE alias
     
  SUBROUTINE deleteMesh() 
    CALL cdeleteMesh()
  END SUBROUTINE deleteMesh

  
  FUNCTION getGrid() result(p)
    REAL*8, POINTER :: p(:,:,:)
    CALL cgetGrid()
    p => grid(1:nx,1:ny,1:nz)
  end FUNCTION getGrid

  function getPtr() result(p)
    real(kind=8), pointer :: p(:)
    call cgetptr()
    p=>fptr(1:nx)
  end function getPtr

  


end MODULE MeshModule
