module modTest

implicit none

contains
  
  subroutine testglob()
    
    real(kind=8), dimension(:), pointer :: vec
    allocate(vec(4))
    vec = 3.4

    call cas6(vec)
    print *, ' test ....', vec

    if(associated(vec)) then
       print *, 'free '
       deallocate(vec)
       nullify(vec)
    end if
    
  end subroutine testglob

  subroutine cas1(x)
    
    real*8, dimension(2) :: x

    x(2) = x(2) +1.65
    print *, 'cas 1', x(1), ' ', x(2)
    
  end subroutine cas1

  subroutine cas2(x)

    real*8, dimension(*), intent(inout) :: x
    
    
    print *, 'cas2a', x(1), ' ', x(2)

    x(2) = x(2) +1.65
    print *, 'cas 2b', x(1), ' ', x(2)
    
  end subroutine cas2

  subroutine cas3(x)
    
    real(kind=8), dimension(:),  intent(in) :: x
    
    
    print *, 'cas3a', x(1), ' ', x(2)

  end subroutine cas3
  subroutine cas4(x)
    
    real(kind=8), dimension(:),  intent(inout) :: x
    
    
    print *, 'cas3a', x(1), ' ', x(2)

    x(2) = x(2) +1.65
    print *, 'cas 3b', x(1), ' ', x(2)
    
  end subroutine cas4

  subroutine cas5(x)
    
    !!   integer, intent(in) :: size
    real(kind=8), pointer, dimension(:) :: x
    
    allocate(x(2))
    x(1) =12
    x(2) = 8
    print *, 'cas5a', x(1), ' ', x(2)

    x(2) = 1.65
    print *, 'cas 5b', x(1), ' ', x(2)
    print * , x
  end subroutine cas5
  
  subroutine cas6(x)
    
    !!   integer, intent(in) :: size
    real(kind=8), pointer, dimension(:) :: x
    
    x(1) =12
    x(2) = 8
    !print *, 'cas6a', shape(x), ' ', x(1), ' ', x(2)
    
    x(2) = 1.65
    print *, 'cas 6b', x(1), ' ', x(2)
    print * , x
    
  end subroutine cas6


  subroutine Application()
    USE MeshModule, ONLY : initMesh, getGrid, deleteMesh 

    INTEGER :: n1, n2, n3
    REAL*8 :: geometry(3,3)
    REAL*8, pointer :: grid(:,:,:)
    print *, 'start applic ...'
    READ(*,*)n1, n2, n3, geometry(1:2,1:2)
    CALL initMesh(n1, n2, n3, geometry)
    
    grid => getGrid()
    print *, 'shape ', shape(grid)
    print *, 'grid : ', grid(2,1,1)
    print *, 'end appli ...'
    CALL deleteMesh()
    
  end subroutine Application
  subroutine Application2()
    USE MeshModule, ONLY : initMesh2, getGrid, deleteMesh 

    INTEGER :: n1, n2, n3
    REAL*8 :: geometry(3,3)
    REAL*8, pointer :: grid(:,:,:)
    print *, 'start applic2 ...'
    !!READ(*,*)n1, n2, n3, geometry(1:2,1:2)
    geometry = 12
    n1 = 2
    n2 = 3
    n3 = 4
    CALL initMesh2(n1, n2, n3, geometry)
    
    grid => getGrid()
    allocate(grid(n1,n2,n3))
    grid(2,1,1) = 12.4
    print *, 'shape ', shape(grid)
    print *, 'grid : ', grid(2,1,1)
    print *, 'end appli2 ...'
    CALL deleteMesh()
    
  end subroutine Application2
  subroutine Application3()
    USE MeshModule, ONLY :  getPtr, deleteMesh 
    
    INTEGER :: nx
    REAL(kind=8), pointer :: xp(:)
    print *, 'start applic3 ...'

    nx = 4
    xp => getPtr()
    allocate(xp(nx))
    xp = 12.4
    print *, 'shape ', shape(xp)
    print *, 'xp : ', xp(1:nx)
    print *, 'end appli3 ...'
    !!    CALL deleteMesh()
    
  end subroutine Application3

  SUBROUTINE bridge(nx, ny, nz, a)
    USE MeshModule, only: aliasGrid
    INTEGER, INTENT(IN) :: nx,ny,nz
    REAL*8, INTENT(IN) :: a(nx*ny*nz)

    print *, "BRIDGE ", a(2)

    CALL aliasGrid(nx, ny, nz, a)

    print *, 'end bridge'
  END SUBROUTINE bridge

  SUBROUTINE bridge2(nx, a)
    USE MeshModule, only: alias
    INTEGER, INTENT(IN) :: nx
    REAL*8, INTENT(IN) :: a(nx)

    print *, "BRIDGE 2"

    CALL alias(nx,a)

    print *, 'end bridge2 '
  END SUBROUTINE bridge2
  

end module modTest
