subroutine tg_init

  use parallel
  use data


  implicit none

  integer :: i,j,k,tgdim
  real(WP) :: dx,per,acos,yj,zk,xi,factor


  call parser_read('Length of domain',L)
  call parser_read('Number of points', nx)
  call parser_read('TG dimensions',tgdim,1)
  
  
  dx = L/real(nx-1,WP)
  per = 0.5*L/acos(-1.0)

  if (tgdim.eq.1) then
     do k = 1,ns3
        do j = 1,ns2
           do i = 1,ns1
              yj = real(j+nys-1,WP)*dx
              zk = real(k+nzs-1,WP)*dx
              U(i,j,k) = 0.0_WP
              V(i,j,k) = cos(yj/per)*sin(zk/per)
              W(i,j,k) = -sin(yj/per)*cos(zk/per)
           enddo
        enddo
     enddo
  else
     do k = 1,ns3
        do j = 1,ns2
           do i = 1,ns1
              xi = real(i+nxs-1,WP)*dx
              yj = real(j+nys-1,WP)*dx
              zk = real(k+nzs-1,WP)*dx
              U(i,j,k) = sin(xi)*cos(yj)*cos(zk)
              V(i,j,k) = -cos(xi)*sin(yj)*cos(zk)
              W(i,j,k) = 0.0
           enddo
        enddo
     enddo
  endif
  
end subroutine tg_init
